/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var fe=["require","exports","vs/base/common/path","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/network","vs/nls","vs/nls!vs/server/remoteExtensionHostAgent","vs/base/common/types","vs/base/common/errors","vs/base/common/async","vs/base/common/strings","fs","vs/base/common/arrays","vs/platform/log/common/log","vs/base/common/buffer","vs/base/common/objects","vs/base/node/pfs","vs/base/common/resources","os","vs/base/common/uuid","vs/platform/files/common/files","vs/base/common/map","vs/platform/product/common/product","vs/base/common/cancellation","vs/base/common/extpath","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/registry/common/platform","child_process","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/configuration/common/configuration","vs/base/common/json","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/server/remoteUriTransformer","vs/base/common/stream","vs/base/common/errorMessage","vs/platform/extensions/common/extensions","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetry","vs/base/common/glob","vs/base/common/marshalling","vs/base/common/performance","vs/platform/contextkey/common/contextkey","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/base/parts/ipc/node/ipc.net","vs/base/common/iterator","vs/base/common/labels","vs/base/common/uriIpc","vs/editor/common/core/range","vs/platform/environment/node/argv","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","crypto","vs/platform/request/common/request","url","vs/platform/telemetry/common/telemetryUtils","vs/server/serverEnvironmentService","vs/workbench/services/editor/common/editorService","vs/base/node/zip","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/codicons","vs/base/common/severity","vs/base/common/htmlContent","vs/base/common/normalization","vs/base/node/decoder","vs/base/node/id","net","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/position","vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/files/common/fileService","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/workspace/common/workspace","vs/server/remoteExtensionManagement","vs/server/remoteLanguagePacks","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/remote/common/remoteAgentService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/extensionHostConnection","vs/base/common/assert","vs/base/common/decorators","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/amd","vs/base/common/console","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/mime","vs/base/node/languagePacks","path","vs/base/node/macAddress","vs/base/node/extpath","vs/base/node/ports","vs/base/node/powershell","vs/base/node/userDataPath","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/editor/common/modes/languageSelector","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/node/terminalProcess","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/server/remoteAgentEnvironmentImpl","vs/nls!vs/server/serverEnvironmentService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/terminal/common/terminal","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/node/extensionPoints","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/editor/common/editor","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/editor/common/modes","vs/platform/diagnostics/common/diagnostics","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/label/common/label","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","util","vs/platform/log/common/logIpc","vs/platform/markers/common/markers","vs/platform/notification/common/notification","vs/platform/environment/node/environmentService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/errorTelemetry","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProcess","vs/platform/workspaces/common/workspaces","vs/server/remoteAgentFileSystemImpl","vs/server/webClientServer","vs/workbench/api/common/extHostRpcService","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminal","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/api/common/extHostTypeConverters","vs/workbench/common/editor","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionPoints","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/extensions/node/extensionPoints","vs/server/remoteAgentEnvironmentImpl","vs/workbench/services/remote/common/remoteAgentFileSystemChannel","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","zlib","vs/server/remoteExtensionHostAgentCli","vs/workbench/api/node/extHostCLIServer","vs/server/remoteTerminalChannel","vs/server/remoteExtensionHostAgentServer","perf_hooks","string_decoder","minimist","assert","cookie","vs/base/common/marked/marked","yauzl","yazl","http","vs/server/remoteExtensionHostAgent"],he=function(Q){for(var e=[],S=0,d=Q.length;S<d;S++)e[S]=fe[Q[S]];return e};define(fe[105],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function S(d,P){if(!d)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}e.ok=S}),define(fe[106],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function S(h){return(n,D,b)=>{let I=null,E=null;if(typeof b.value=="function"?(I="value",E=b.value):typeof b.get=="function"&&(I="get",E=b.get),!E)throw new Error("not supported");b[I]=h(E,D)}}e.createDecorator=S;let d=0;function P(){const h=`$memoize${d++}`;let n;const D=function(I,E,u){let v=null,_=null;if(typeof u.value=="function"?(v="value",_=u.value,_.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(v="get",_=u.get),!_)throw new Error("not supported");const w=`${h}:${E}`;u[v]=function(...m){return n=this,this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!0,enumerable:!1,writable:!0,value:_.apply(this,m)}),this[w]}};return D.clear=()=>{typeof n!="undefined"&&Object.getOwnPropertyNames(n).forEach(b=>{b.indexOf(h)===0&&delete n[b]})},D}e.createMemoizer=P;function y(h,n,D){return P()(h,n,D)}e.memoize=y;function k(h,n,D){return S((b,I)=>{const E=`$debounce$${I}`,u=`$debounce$result$${I}`;return function(...v){this[u]||(this[u]=D?D():void 0),clearTimeout(this[E]),n&&(this[u]=n(this[u],...v),v=[this[u]]),this[E]=setTimeout(()=>{b.apply(this,v),this[u]=D?D():void 0},h)}})}e.debounce=k;function L(h,n,D){return S((b,I)=>{const E=`$throttle$timer$${I}`,u=`$throttle$result$${I}`,v=`$throttle$lastRun$${I}`,_=`$throttle$pending$${I}`;return function(...w){if(this[u]||(this[u]=D?D():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),n&&(this[u]=n(this[u],...w)),!this[_]){const m=this[v]+h;m<=Date.now()?(this[v]=Date.now(),b.apply(this,[this[u]]),this[u]=D?D():void 0):(this[_]=!0,this[E]=setTimeout(()=>{this[_]=!1,this[v]=Date.now(),b.apply(this,[this[u]]),this[u]=D?D():void 0},m-Date.now()))}}})}e.throttle=L}),define(fe[12],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class S{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=S,e.errorHandler=new S;function d(r){e.errorHandler.setUnexpectedErrorHandler(r)}e.setUnexpectedErrorHandler=d;function P(r){h(r)||e.errorHandler.onUnexpectedError(r)}e.onUnexpectedError=P;function y(r){h(r)||e.errorHandler.onUnexpectedExternalError(r)}e.onUnexpectedExternalError=y;function k(r){if(r instanceof Error){let{name:t,message:i}=r;const o=r.stacktrace||r.stack;return{$isError:!0,name:t,message:i,stack:o}}return r}e.transformErrorForSerialization=k;const L="Canceled";function h(r){return r instanceof Error&&r.name===L&&r.message===L}e.isPromiseCanceledError=h;class n extends Error{constructor(){super(L);this.name=this.message}}e.CancellationError=n;function D(){const r=new Error(L);return r.name=r.message,r}e.canceled=D;function b(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}e.illegalArgument=b;function I(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}e.illegalState=I;function E(r){return r?new Error(`readonly property '${r} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=E;function u(r){const t=new Error(`${r} has been disposed`);return t.name="DISPOSED",t}e.disposed=u;function v(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}e.getErrorMessage=v;class _ extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=_;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class m extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=m;function l(r){const t=r;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=l;function c(r,t=Object.create(null)){const i=new Error(r);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=c}),define(fe[16],he([0,1,12]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.mergeSort=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function d(F,A=0){return F[F.length-(1+A)]}e.tail=d;function P(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=P;function y(F,A,M=(U,W)=>U===W){if(F===A)return!0;if(!F||!A||F.length!==A.length)return!1;for(let U=0,W=F.length;U<W;U++)if(!M(F[U],A[U]))return!1;return!0}e.equals=y;function k(F,A,M){let U=0,W=F.length-1;for(;U<=W;){const ne=(U+W)/2|0,ae=M(F[ne],A);if(ae<0)U=ne+1;else if(ae>0)W=ne-1;else return ne}return-(U+1)}e.binarySearch=k;function L(F,A){let M=0,U=F.length;if(U===0)return 0;for(;M<U;){const W=Math.floor((M+U)/2);A(F[W])?U=W:M=W+1}return M}e.findFirstInSorted=L;function h(F,A,M){if(F=F|0,F>=A.length)throw new TypeError("invalid index");let U=A[Math.floor(A.length*Math.random())],W=[],ne=[],ae=[];for(let ce of A){const de=M(ce,U);de<0?W.push(ce):de>0?ne.push(ce):ae.push(ce)}return F<W.length?h(F,W,M):F<W.length+ae.length?ae[0]:h(F-(W.length+ae.length),ne,M)}e.quickSelect=h;function n(F,A){return b(F,A,0,F.length-1,[]),F}e.mergeSort=n;function D(F,A,M,U,W,ne){let ae=M,ce=U+1;for(let de=M;de<=W;de++)ne[de]=F[de];for(let de=M;de<=W;de++)ae>U?F[de]=ne[ce++]:ce>W?F[de]=ne[ae++]:A(ne[ce],ne[ae])<0?F[de]=ne[ce++]:F[de]=ne[ae++]}function b(F,A,M,U,W){if(!(U<=M)){const ne=M+(U-M)/2|0;b(F,A,M,ne,W),b(F,A,ne+1,U,W),!(A(F[ne],F[ne+1])<=0)&&D(F,A,M,ne,U,W)}}function I(F,A){const M=[];let U;for(const W of n(F.slice(0),A))!U||A(U[0],W)!==0?(U=[W],M.push(U)):U.push(W);return M}e.groupBy=I;function E(F,A,M){const U=[];function W(ce,de,Pe){if(!(de===0&&Pe.length===0)){const Te=U[U.length-1];Te&&Te.start+Te.deleteCount===ce?(Te.deleteCount+=de,Te.toInsert.push(...Pe)):U.push({start:ce,deleteCount:de,toInsert:Pe})}}let ne=0,ae=0;for(;;){if(ne===F.length){W(ne,0,A.slice(ae));break}if(ae===A.length){W(ne,F.length-ne,[]);break}const ce=F[ne],de=A[ae],Pe=M(ce,de);Pe===0?(ne+=1,ae+=1):Pe<0?(W(ne,1,[]),ne+=1):Pe>0&&(W(ne,0,[de]),ae+=1)}return U}e.sortedDiff=E;function u(F,A,M){const U=E(F,A,M),W=[],ne=[];for(const ae of U)W.push(...F.slice(ae.start,ae.start+ae.deleteCount)),ne.push(...ae.toInsert);return{removed:W,added:ne}}e.delta=u;function v(F,A,M){if(M===0)return[];const U=F.slice(0,M).sort(A);return w(F,A,U,M,F.length),U}e.top=v;function _(F,A,M,U,W){return M===0?Promise.resolve([]):new Promise((ne,ae)=>{(async()=>{const ce=F.length,de=F.slice(0,M).sort(A);for(let Pe=M,Te=Math.min(M+U,ce);Pe<ce;Pe=Te,Te=Math.min(Te+U,ce)){if(Pe>M&&await new Promise(Me=>setTimeout(Me)),W&&W.isCancellationRequested)throw S.canceled();w(F,A,de,Pe,Te)}return de})().then(ne,ae)})}e.topAsync=_;function w(F,A,M,U,W){for(const ne=M.length;U<W;U++){const ae=F[U];if(A(ae,M[ne-1])<0){M.pop();const ce=L(M,de=>A(ae,de)<0);M.splice(ce,0,ae)}}}function m(F){return F.filter(A=>!!A)}e.coalesce=m;function l(F){let A=0;for(let M=0;M<F.length;M++)F[M]&&(F[A]=F[M],A+=1);F.length=A}e.coalesceInPlace=l;function c(F,A,M){F.splice(M,0,F.splice(A,1)[0])}e.move=c;function r(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=r;function t(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=t;function i(F,A){if(!A)return F.filter((U,W)=>F.indexOf(U)===W);const M=Object.create(null);return F.filter(U=>{const W=A(U);return M[W]?!1:(M[W]=!0,!0)})}e.distinct=i;function o(F){const A=new Set;return F.filter(M=>A.has(M)?!1:(A.add(M),!0))}e.distinctES6=o;function a(F){const A=Object.create(null);return M=>{const U=F(M);return A[U]?!1:(A[U]=!0,!0)}}e.uniqueFilter=a;function s(F,A){for(let M=F.length-1;M>=0;M--){const U=F[M];if(A(U))return M}return-1}e.lastIndex=s;function g(F,A){return F.length>0?F[0]:A}e.firstOrDefault=g;function C(F,A,M=(U,W)=>U===W){let U=0;for(let W=0,ne=Math.min(F.length,A.length);W<ne&&M(F[W],A[W]);W++)U++;return U}e.commonPrefixLength=C;function R(F){return[].concat(...F)}e.flatten=R;function p(F,A){let M=typeof A=="number"?F:0;typeof A=="number"?M=F:(M=0,A=F);const U=[];if(M<=A)for(let W=M;W<A;W++)U.push(W);else for(let W=M;W>A;W--)U.push(W);return U}e.range=p;function f(F,A,M){return F.reduce((U,W)=>(U[A(W)]=M?M(W):W,U),Object.create(null))}e.index=f;function T(F,A){return F.push(A),()=>O(F,A)}e.insert=T;function O(F,A){const M=F.indexOf(A);if(M>-1)return F.splice(M,1),A}e.remove=O;function H(F,A,M){const U=F.slice(0,A),W=F.slice(A);return U.concat(M,W)}e.arrayInsert=H;function $(F,A){let M;if(typeof A=="number"){let U=A;M=()=>{const W=Math.sin(U++)*179426549;return W-Math.floor(W)}}else M=Math.random;for(let U=F.length-1;U>0;U-=1){const W=Math.floor(M()*(U+1)),ne=F[U];F[U]=F[W],F[W]=ne}}e.shuffle=$;function x(F,A){const M=F.indexOf(A);M>-1&&(F.splice(M,1),F.unshift(A))}e.pushToStart=x;function J(F,A){const M=F.indexOf(A);M>-1&&(F.splice(M,1),F.push(A))}e.pushToEnd=J;function Ee(F,A){return Array.isArray(F)?F.map(A):A(F)}e.mapArrayOrNot=Ee;function ve(F){return Array.isArray(F)?F:[F]}e.asArray=ve;function q(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=q;function j(F,A){for(const M of F){const U=A(M);if(U!==void 0)return U}}e.mapFind=j}),define(fe[68],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function S(d){const P=this;let y=!1,k;return function(){return y||(y=!0,k=d.apply(P,arguments)),k}}e.once=S}),define(fe[52],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(d){function P(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}d.is=P;const y=Object.freeze([]);function k(){return y}d.empty=k;function*L(r){yield r}d.single=L;function h(r){return r||y}d.from=h;function n(r){return!r||r[Symbol.iterator]().next().done===!0}d.isEmpty=n;function D(r){return r[Symbol.iterator]().next().value}d.first=D;function b(r,t){for(const i of r)if(t(i))return!0;return!1}d.some=b;function I(r,t){for(const i of r)if(t(i))return i}d.find=I;function*E(r,t){for(const i of r)t(i)&&(yield i)}d.filter=E;function*u(r,t){for(const i of r)yield t(i)}d.map=u;function*v(...r){for(const t of r)for(const i of t)yield i}d.concat=v;function*_(r){for(const t of r)for(const i of t)yield i}d.concatNested=_;function w(r,t,i){let o=i;for(const a of r)o=t(o,a);return o}d.reduce=w;function*m(r,t,i=r.length){for(t<0&&(t+=r.length),i<0?i+=r.length:i>r.length&&(i=r.length);t<i;t++)yield r[t]}d.slice=m;function l(r,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,r];const o=r[Symbol.iterator]();for(let a=0;a<t;a++){const s=o.next();if(s.done)return[i,d.empty()];i.push(s.value)}return[i,{[Symbol.iterator](){return o}}]}d.consume=l;function c(r,t,i=(o,a)=>o===a){const o=r[Symbol.iterator](),a=t[Symbol.iterator]();for(;;){const s=o.next(),g=a.next();if(s.done!==g.done)return!1;if(s.done)return!0;if(!i(s.value,g.value))return!1}}d.equals=c})(S=e.Iterable||(e.Iterable={}))}),define(fe[35],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S=e.ScanError||(e.ScanError={}));var d;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(d=e.SyntaxKind||(e.SyntaxKind={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P=e.ParseErrorCode||(e.ParseErrorCode={}));var y;(function(t){t.DEFAULT={allowTrailingComma:!0}})(y=e.ParseOptions||(e.ParseOptions={}));function k(t,i=!1){let o=0,a=t.length,s="",g=0,C=16,R=0;function p(J){let Ee=0,ve=0;for(;Ee<J;){const q=t.charCodeAt(o);if(q>=48&&q<=57)ve=ve*16+q-48;else if(q>=65&&q<=70)ve=ve*16+q-65+10;else if(q>=97&&q<=102)ve=ve*16+q-97+10;else break;o++,Ee++}return Ee<J&&(ve=-1),ve}function f(J){o=J,s="",g=0,C=16,R=0}function T(){const J=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&n(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&n(t.charCodeAt(o)))for(o++;o<t.length&&n(t.charCodeAt(o));)o++;else return R=3,t.substring(J,o);let Ee=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&n(t.charCodeAt(o))){for(o++;o<t.length&&n(t.charCodeAt(o));)o++;Ee=o}else R=3;return t.substring(J,Ee)}function O(){let J="",Ee=o;for(;;){if(o>=a){J+=t.substring(Ee,o),R=2;break}const ve=t.charCodeAt(o);if(ve===34){J+=t.substring(Ee,o),o++;break}if(ve===92){if(J+=t.substring(Ee,o),o++,o>=a){R=2;break}switch(t.charCodeAt(o++)){case 34:J+='"';break;case 92:J+="\\";break;case 47:J+="/";break;case 98:J+="\b";break;case 102:J+="\f";break;case 110:J+=`
`;break;case 114:J+="\r";break;case 116:J+="	";break;case 117:const j=p(4);j>=0?J+=String.fromCharCode(j):R=4;break;default:R=5}Ee=o;continue}if(ve>=0&&ve<=31)if(h(ve)){J+=t.substring(Ee,o),R=2;break}else R=6;o++}return J}function H(){if(s="",R=0,g=o,o>=a)return g=a,C=17;let J=t.charCodeAt(o);if(L(J)){do o++,s+=String.fromCharCode(J),J=t.charCodeAt(o);while(L(J));return C=15}if(h(J))return o++,s+=String.fromCharCode(J),J===13&&t.charCodeAt(o)===10&&(o++,s+=`
`),C=14;switch(J){case 123:return o++,C=1;case 125:return o++,C=2;case 91:return o++,C=3;case 93:return o++,C=4;case 58:return o++,C=6;case 44:return o++,C=5;case 34:return o++,s=O(),C=10;case 47:const Ee=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<a&&!h(t.charCodeAt(o));)o++;return s=t.substring(Ee,o),C=12}if(t.charCodeAt(o+1)===42){o+=2;const ve=a-1;let q=!1;for(;o<ve;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,q=!0;break}o++}return q||(o++,R=1),s=t.substring(Ee,o),C=13}return s+=String.fromCharCode(J),o++,C=16;case 45:if(s+=String.fromCharCode(J),o++,o===a||!n(t.charCodeAt(o)))return C=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=T(),C=11;default:for(;o<a&&$(J);)o++,J=t.charCodeAt(o);if(g!==o){switch(s=t.substring(g,o),s){case"true":return C=8;case"false":return C=9;case"null":return C=7}return C=16}return s+=String.fromCharCode(J),o++,C=16}}function $(J){if(L(J)||h(J))return!1;switch(J){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let J;do J=H();while(J>=12&&J<=15);return J}return{setPosition:f,getPosition:()=>o,scan:i?x:H,getToken:()=>C,getTokenValue:()=>s,getTokenOffset:()=>g,getTokenLength:()=>o-g,getTokenError:()=>R}}e.createScanner=k;function L(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function n(t){return t>=48&&t<=57}var D;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(D||(D={}));function b(t,i){const o=[],a=new Object;let s;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let C=!1;function R(p,f,T,O){g.value=p,g.offset=f,g.length=T,g.type=O,g.colonOffset=void 0,s=g}try{l(t,{onObjectBegin:(p,f)=>{if(i<=p)throw a;s=void 0,C=i>p,o.push("")},onObjectProperty:(p,f,T)=>{if(i<f||(R(p,f,T,"property"),o[o.length-1]=p,i<=f+T))throw a},onObjectEnd:(p,f)=>{if(i<=p)throw a;s=void 0,o.pop()},onArrayBegin:(p,f)=>{if(i<=p)throw a;s=void 0,o.push(0)},onArrayEnd:(p,f)=>{if(i<=p)throw a;s=void 0,o.pop()},onLiteralValue:(p,f,T)=>{if(i<f||(R(p,f,T,r(p)),i<=f+T))throw a},onSeparator:(p,f,T)=>{if(i<=f)throw a;if(p===":"&&s&&s.type==="property")s.colonOffset=f,C=!1,s=void 0;else if(p===","){const O=o[o.length-1];typeof O=="number"?o[o.length-1]=O+1:(C=!0,o[o.length-1]=""),s=void 0}}})}catch(p){if(p!==a)throw p}return{path:o,previousNode:s,isAtPropertyKey:C,matches:p=>{let f=0;for(let T=0;f<p.length&&T<o.length;T++)if(p[f]===o[T]||p[f]==="*")f++;else if(p[f]!=="**")return!1;return f===p.length}}}e.getLocation=b;function I(t,i=[],o=y.DEFAULT){let a=null,s=[];const g=[];function C(p){Array.isArray(s)?s.push(p):a!==null&&(s[a]=p)}return l(t,{onObjectBegin:()=>{const p={};C(p),g.push(s),s=p,a=null},onObjectProperty:p=>{a=p},onObjectEnd:()=>{s=g.pop()},onArrayBegin:()=>{const p=[];C(p),g.push(s),s=p,a=null},onArrayEnd:()=>{s=g.pop()},onLiteralValue:C,onError:(p,f,T)=>{i.push({error:p,offset:f,length:T})}},o),s[0]}e.parse=I;function E(t,i=[],o=y.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(p){a.type==="property"&&(a.length=p-a.offset,a=a.parent)}function g(p){return a.children.push(p),p}l(t,{onObjectBegin:p=>{a=g({type:"object",offset:p,length:-1,parent:a,children:[]})},onObjectProperty:(p,f,T)=>{a=g({type:"property",offset:f,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:p,offset:f,length:T,parent:a})},onObjectEnd:(p,f)=>{a.length=p+f-a.offset,a=a.parent,s(p+f)},onArrayBegin:(p,f)=>{a=g({type:"array",offset:p,length:-1,parent:a,children:[]})},onArrayEnd:(p,f)=>{a.length=p+f-a.offset,a=a.parent,s(p+f)},onLiteralValue:(p,f,T)=>{g({type:r(p),offset:f,length:T,parent:a,value:p}),s(f+T)},onSeparator:(p,f,T)=>{a.type==="property"&&(p===":"?a.colonOffset=f:p===","&&s(f))},onError:(p,f,T)=>{i.push({error:p,offset:f,length:T})}},o);const R=a.children[0];return R&&delete R.parent,R}e.parseTree=E;function u(t,i){if(!!t){let o=t;for(let a of i)if(typeof a=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let s=!1;for(const g of o.children)if(Array.isArray(g.children)&&g.children[0].value===a){o=g.children[1],s=!0;break}if(!s)return}else{const s=a;if(o.type!=="array"||s<0||!Array.isArray(o.children)||s>=o.children.length)return;o=o.children[s]}return o}}e.findNodeAtLocation=u;function v(t){if(!t.parent||!t.parent.children)return[];const i=v(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;i.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&i.push(o)}return i}e.getNodePath=v;function _(t){switch(t.type){case"array":return t.children.map(_);case"object":const i=Object.create(null);for(let o of t.children){const a=o.children[1];a&&(i[o.children[0].value]=_(a))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=_;function w(t,i,o=!1){return i>=t.offset&&i<t.offset+t.length||o&&i===t.offset+t.length}e.contains=w;function m(t,i,o=!1){if(w(t,i,o)){const a=t.children;if(Array.isArray(a))for(let s=0;s<a.length&&a[s].offset<=i;s++){const g=m(a[s],i,o);if(g)return g}return t}}e.findNodeAtOffset=m;function l(t,i,o=y.DEFAULT){const a=k(t,!1);function s(ne){return ne?()=>ne(a.getTokenOffset(),a.getTokenLength()):()=>!0}function g(ne){return ne?ae=>ne(ae,a.getTokenOffset(),a.getTokenLength()):()=>!0}const C=s(i.onObjectBegin),R=g(i.onObjectProperty),p=s(i.onObjectEnd),f=s(i.onArrayBegin),T=s(i.onArrayEnd),O=g(i.onLiteralValue),H=g(i.onSeparator),$=s(i.onComment),x=g(i.onError),J=o&&o.disallowComments,Ee=o&&o.allowTrailingComma;function ve(){for(;;){const ne=a.scan();switch(a.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:J||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(ne){case 12:case 13:J?q(10):$();break;case 16:q(1);break;case 15:case 14:break;default:return ne}}}function q(ne,ae=[],ce=[]){if(x(ne),ae.length+ce.length>0){let de=a.getToken();for(;de!==17;){if(ae.indexOf(de)!==-1){ve();break}else if(ce.indexOf(de)!==-1)break;de=ve()}}}function j(ne){const ae=a.getTokenValue();return ne?O(ae):R(ae),ve(),!0}function F(){switch(a.getToken()){case 11:let ne=0;try{ne=JSON.parse(a.getTokenValue()),typeof ne!="number"&&(q(2),ne=0)}catch(ae){q(2)}O(ne);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return ve(),!0}function A(){return a.getToken()!==10?(q(3,[],[2,5]),!1):(j(!1),a.getToken()===6?(H(":"),ve(),W()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function M(){C(),ve();let ne=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(ne||q(4,[],[]),H(","),ve(),a.getToken()===2&&Ee)break}else ne&&q(6,[],[]);A()||q(4,[],[2,5]),ne=!0}return p(),a.getToken()!==2?q(7,[2],[]):ve(),!0}function U(){f(),ve();let ne=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(ne||q(4,[],[]),H(","),ve(),a.getToken()===4&&Ee)break}else ne&&q(6,[],[]);W()||q(4,[],[4,5]),ne=!0}return T(),a.getToken()!==4?q(8,[4],[]):ve(),!0}function W(){switch(a.getToken()){case 3:return U();case 1:return M();case 10:return j(!0);default:return F()}}return ve(),a.getToken()===17?o.allowEmptyContent?!0:(q(4,[],[]),!1):W()?(a.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.visit=l;function c(t,i){let o=k(t),a=[],s,g=0,C;do switch(C=o.getPosition(),s=o.scan(),s){case 12:case 13:case 17:g!==C&&a.push(t.substring(g,C)),i!==void 0&&a.push(o.getTokenValue().replace(/[^\r\n]/g,i)),g=o.getPosition();break}while(s!==17);return a.join("")}e.stripComments=c;function r(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=r}),define(fe[107],he([0,1,35]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function d(h,n,D){let b,I,E,u,v;if(n){for(u=n.offset,v=u+n.length,E=u;E>0&&!L(h,E-1);)E--;let g=v;for(;g<h.length&&!L(h,g);)g++;I=h.substring(E,g),b=y(I,D)}else I=h,b=0,E=0,u=0,v=h.length;const _=k(D,h);let w=!1,m=0,l;D.insertSpaces?l=P(" ",D.tabSize||4):l="	";const c=S.createScanner(I,!1);let r=!1;function t(){return _+P(l,b+m)}function i(){let g=c.scan();for(w=!1;g===15||g===14;)w=w||g===14,g=c.scan();return r=g===16||c.getTokenError()!==0,g}const o=[];function a(g,C,R){!r&&C<v&&R>u&&h.substring(C,R)!==g&&o.push({offset:C,length:R-C,content:g})}let s=i();if(s!==17){const g=c.getTokenOffset()+E,C=P(l,b);a(C,E,g)}for(;s!==17;){let g=c.getTokenOffset()+c.getTokenLength()+E,C=i(),R="";for(;!w&&(C===12||C===13);){const f=c.getTokenOffset()+E;a(" ",g,f),g=c.getTokenOffset()+c.getTokenLength()+E,R=C===12?t():"",C=i()}if(C===2)s!==1&&(m--,R=t());else if(C===4)s!==3&&(m--,R=t());else{switch(s){case 3:case 1:m++,R=t();break;case 5:case 12:R=t();break;case 13:w?R=t():R=" ";break;case 6:R=" ";break;case 10:if(C===6){R="";break}case 7:case 8:case 9:case 11:case 2:case 4:C===12||C===13?R=" ":C!==5&&C!==17&&(r=!0);break;case 16:r=!0;break}w&&(C===12||C===13)&&(R=t())}const p=c.getTokenOffset()+E;a(R,g,p),s=C}return o}e.format=d;function P(h,n){let D="";for(let b=0;b<n;b++)D+=h;return D}function y(h,n){let D=0,b=0;const I=n.tabSize||4;for(;D<h.length;){const E=h.charAt(D);if(E===" ")b++;else if(E==="	")b+=I;else break;D++}return Math.floor(b/I)}function k(h,n){for(let D=0;D<n.length;D++){const b=n.charAt(D);if(b==="\r")return D+1<n.length&&n.charAt(D+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return h&&h.eol||`
`}e.getEOL=k;function L(h,n){return`\r
`.indexOf(h.charAt(n))!==-1}e.isEOL=L}),define(fe[108],he([0,1,35,107,16]),function(Q,e,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function y(D,b,I){return k(D,b,void 0,I)}e.removeProperty=y;function k(D,b,I,E,u){const v=b.slice(),_=[],w=S.parseTree(D,_);let m,l;for(;v.length>0&&(l=v.pop(),m=S.findNodeAtLocation(w,v),m===void 0&&I!==void 0);)typeof l=="string"?I={[l]:I}:I=[I];if(m)if(m.type==="object"&&typeof l=="string"&&Array.isArray(m.children)){const c=S.findNodeAtLocation(m,[l]);if(c!==void 0)if(I===void 0){if(!c.parent)throw new Error("Malformed AST");const r=m.children.indexOf(c.parent);let t,i=c.parent.offset+c.parent.length;if(r>0){const o=m.children[r-1];t=o.offset+o.length}else t=m.offset+1,m.children.length>1&&(i=m.children[1].offset);return L(D,{offset:t,length:i-t,content:""},E)}else return L(D,{offset:c.offset,length:c.length,content:JSON.stringify(I)},E);else{if(I===void 0)return[];const r=`${JSON.stringify(l)}: ${JSON.stringify(I)}`,t=u?u(m.children.map(o=>o.children[0].value)):m.children.length;let i;if(t>0){const o=m.children[t-1];i={offset:o.offset+o.length,length:0,content:","+r}}else m.children.length===0?i={offset:m.offset+1,length:0,content:r}:i={offset:m.offset+1,length:0,content:r+","};return L(D,i,E)}}else if(m.type==="array"&&typeof l=="number"&&Array.isArray(m.children))if(I!==void 0){const c=`${JSON.stringify(I)}`;let r;if(m.children.length===0||l===0)r={offset:m.offset+1,length:0,content:m.children.length===0?c:c+","};else{const t=l===-1||l>m.children.length?m.children.length:l,i=m.children[t-1];r={offset:i.offset+i.length,length:0,content:","+c}}return L(D,r,E)}else{const c=l,r=m.children[c];let t;if(m.children.length===1)t={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===c){const i=m.children[c-1],o=i.offset+i.length,a=m.offset+m.length;t={offset:o,length:a-2-o,content:""}}else t={offset:r.offset,length:m.children[c+1].offset-r.offset,content:""};return L(D,t,E)}else throw new Error(`Can not add ${typeof l!="number"?"index":"property"} to parent of type ${m.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return L(D,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(I)},E)}}e.setProperty=k;function L(D,b,I){let E=h(D,b),u=b.offset,v=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;u>0&&!d.isEOL(E,u-1);)u--;for(;v<E.length&&!d.isEOL(E,v);)v++}const _=d.format(E,{offset:u,length:v-u},I);for(let m=_.length-1;m>=0;m--){const l=_[m];E=h(E,l),u=Math.min(u,l.offset),v=Math.max(v,l.offset+l.length),v+=l.content.length-l.length}const w=D.length-(E.length-v)-u;return[{offset:u,length:w,content:E.substring(u,v)}]}e.withFormatting=L;function h(D,b){return D.substring(0,b.offset)+b.content+D.substring(b.offset+b.length)}e.applyEdit=h;function n(D,b){let I=P.mergeSort(b,(u,v)=>{const _=u.offset-v.offset;return _===0?u.length-v.length:_}),E=D.length;for(let u=I.length-1;u>=0;u--){let v=I[u];if(v.offset+v.length<=E)D=h(D,v);else throw new Error("Overlapping edit");E=v.offset}return D}e.applyEdits=n}),define(fe[4],he([0,1,68,52]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const P=!1;let y=null;function k(l){y=l}if(e.setDisposableTracker=k,P){const l="__is_disposable_tracked__";y=new class{trackDisposable(c){const r=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[l]||console.log(r)},3e3)}markTracked(c){if(c&&c!==v.None)try{c[l]=!0}catch(r){}}}}function L(l){!y||y.markTracked(l)}function h(l){return y&&y.trackDisposable(l),l}e.trackDisposable=h;class n extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}e.MultiDisposeError=n;function D(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=D;function b(l){if(d.Iterable.is(l)){let c=[];for(const r of l)if(r){L(r);try{r.dispose()}catch(t){c.push(t)}}if(c.length===1)throw c[0];if(c.length>1)throw new n(c);return Array.isArray(l)?[]:l}else if(l)return L(l),l.dispose(),l}e.dispose=b;function I(...l){return l.forEach(L),E(()=>b(l))}e.combinedDisposable=I;function E(l){const c=h({dispose:()=>{L(c),l()}});return c}e.toDisposable=E;class u{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(L(this),this._isDisposed=!0,this.clear())}clear(){try{b(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return L(c),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new u,h(this)}dispose(){L(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class _{constructor(){this._isDisposed=!1,h(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){var r;this._isDisposed||c===this._value||((r=this._value)===null||r===void 0||r.dispose(),c&&L(c),this._value=c)}clear(){this.value=void 0}dispose(){var c;this._isDisposed=!0,L(this),(c=this._value)===null||c===void 0||c.dispose(),this._value=void 0}}e.MutableDisposable=_;class w{constructor(){this.references=new Map}acquire(c,...r){let t=this.references.get(c);t||(t={counter:0,object:this.createReferencedObject(c,...r)},this.references.set(c,t));const{object:i}=t,o=S.once(()=>{--t.counter==0&&(this.destroyReferencedObject(c,t.object),this.references.delete(c))});return t.counter++,{object:i,dispose:o}}}e.ReferenceCollection=w;class m{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=m}),define(fe[69],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class S{constructor(y){this.element=y,this.next=S.Undefined,this.prev=S.Undefined}}S.Undefined=new S(void 0);class d{constructor(){this._first=S.Undefined,this._last=S.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===S.Undefined}clear(){this._first=S.Undefined,this._last=S.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,k){const L=new S(y);if(this._first===S.Undefined)this._first=L,this._last=L;else if(k){const n=this._last;this._last=L,L.prev=n,n.next=L}else{const n=this._first;this._first=L,L.next=n,n.prev=L}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(L))}}shift(){if(this._first!==S.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==S.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==S.Undefined&&y.next!==S.Undefined){const k=y.prev;k.next=y.next,y.next.prev=k}else y.prev===S.Undefined&&y.next===S.Undefined?(this._first=S.Undefined,this._last=S.Undefined):y.next===S.Undefined?(this._last=this._last.prev,this._last.next=S.Undefined):y.prev===S.Undefined&&(this._first=this._first.next,this._first.prev=S.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==S.Undefined;)yield y.element,y=y.next}}e.LinkedList=d}),function(Q,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Q=typeof globalThis!="undefined"?globalThis:Q||self,Q.marked=e())}(this,function(){"use strict";function Q(z,X){for(var ee=0;ee<X.length;ee++){var V=X[ee];V.enumerable=V.enumerable||!1,V.configurable=!0,"value"in V&&(V.writable=!0),Object.defineProperty(z,V.key,V)}}function e(z,X,ee){return X&&Q(z.prototype,X),ee&&Q(z,ee),z}function S(z,X){if(!!z){if(typeof z=="string")return d(z,X);var ee=Object.prototype.toString.call(z).slice(8,-1);if(ee==="Object"&&z.constructor&&(ee=z.constructor.name),ee==="Map"||ee==="Set")return Array.from(z);if(ee==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ee))return d(z,X)}}function d(z,X){(X==null||X>z.length)&&(X=z.length);for(var ee=0,V=new Array(X);ee<X;ee++)V[ee]=z[ee];return V}function P(z,X){var ee;if(typeof Symbol=="undefined"||z[Symbol.iterator]==null){if(Array.isArray(z)||(ee=S(z))||X&&z&&typeof z.length=="number"){ee&&(z=ee);var V=0;return function(){return V>=z.length?{done:!0}:{done:!1,value:z[V++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return ee=z[Symbol.iterator](),ee.next.bind(ee)}function y(z){var X={exports:{}};return z(X,X.exports),X.exports}var k=y(function(z){function X(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function ee(V){z.exports.defaults=V}z.exports={defaults:X(),getDefaults:X,changeDefaults:ee}}),L=/[&<>"']/,h=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,b={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},I=function(X){return b[X]};function E(z,X){if(X){if(L.test(z))return z.replace(h,I)}else if(n.test(z))return z.replace(D,I);return z}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(z){return z.replace(u,function(X,ee){return ee=ee.toLowerCase(),ee==="colon"?":":ee.charAt(0)==="#"?ee.charAt(1)==="x"?String.fromCharCode(parseInt(ee.substring(2),16)):String.fromCharCode(+ee.substring(1)):""})}var _=/(^|[^\[])\^/g;function w(z,X){z=z.source||z,X=X||"";var ee={replace:function(K,te){return te=te.source||te,te=te.replace(_,"$1"),z=z.replace(K,te),ee},getRegex:function(){return new RegExp(z,X)}};return ee}var m=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(z,X,ee){if(z){var V;try{V=decodeURIComponent(v(ee)).replace(m,"").toLowerCase()}catch(K){return null}if(V.indexOf("javascript:")===0||V.indexOf("vbscript:")===0||V.indexOf("data:")===0)return null}X&&!l.test(ee)&&(ee=a(X,ee));try{ee=encodeURI(ee).replace(/%25/g,"%")}catch(K){return null}return ee}var r={},t=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(z,X){r[" "+z]||(t.test(z)?r[" "+z]=z+"/":r[" "+z]=R(z,"/",!0)),z=r[" "+z];var ee=z.indexOf(":")===-1;return X.substring(0,2)==="//"?ee?X:z.replace(i,"$1")+X:X.charAt(0)==="/"?ee?X:z.replace(o,"$1")+X:z+X}var s={exec:function(){}};function g(z){for(var X=1,ee,V;X<arguments.length;X++){ee=arguments[X];for(V in ee)Object.prototype.hasOwnProperty.call(ee,V)&&(z[V]=ee[V])}return z}function C(z,X){var ee=z.replace(/\|/g,function(te,ie,ue){for(var De=!1,le=ie;--le>=0&&ue[le]==="\\";)De=!De;return De?"|":" |"}),V=ee.split(/ \|/),K=0;if(V.length>X)V.splice(X);else for(;V.length<X;)V.push("");for(;K<V.length;K++)V[K]=V[K].trim().replace(/\\\|/g,"|");return V}function R(z,X,ee){var V=z.length;if(V===0)return"";for(var K=0;K<V;){var te=z.charAt(V-K-1);if(te===X&&!ee)K++;else if(te!==X&&ee)K++;else break}return z.substr(0,V-K)}function p(z,X){if(z.indexOf(X[1])===-1)return-1;for(var ee=z.length,V=0,K=0;K<ee;K++)if(z[K]==="\\")K++;else if(z[K]===X[0])V++;else if(z[K]===X[1]&&(V--,V<0))return K;return-1}function f(z){z&&z.sanitize&&!z.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function T(z,X){if(X<1)return"";for(var ee="";X>1;)X&1&&(ee+=z),X>>=1,z+=z;return ee+z}var O={escape:E,unescape:v,edit:w,cleanUrl:c,resolveUrl:a,noopTest:s,merge:g,splitCells:C,rtrim:R,findClosingBracket:p,checkSanitizeDeprecation:f,repeatString:T},H=k.defaults,$=O.rtrim,x=O.splitCells,J=O.escape,Ee=O.findClosingBracket;function ve(z,X,ee){var V=X.href,K=X.title?J(X.title):null,te=z[1].replace(/\\([\[\]])/g,"$1");return z[0].charAt(0)!=="!"?{type:"link",raw:ee,href:V,title:K,text:te}:{type:"image",raw:ee,href:V,title:K,text:J(te)}}function q(z,X){var ee=z.match(/^(\s+)(?:```)/);if(ee===null)return X;var V=ee[1];return X.split(`
`).map(function(K){var te=K.match(/^\s+/);if(te===null)return K;var ie=te[0];return ie.length>=V.length?K.slice(V.length):K}).join(`
`)}var j=function(){function z(ee){this.options=ee||H}var X=z.prototype;return X.space=function(V){var K=this.rules.block.newline.exec(V);if(K)return K[0].length>1?{type:"space",raw:K[0]}:{raw:`
`}},X.code=function(V){var K=this.rules.block.code.exec(V);if(K){var te=K[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:K[0],codeBlockStyle:"indented",text:this.options.pedantic?te:$(te,`
`)}}},X.fences=function(V){var K=this.rules.block.fences.exec(V);if(K){var te=K[0],ie=q(te,K[3]||"");return{type:"code",raw:te,lang:K[2]?K[2].trim():K[2],text:ie}}},X.heading=function(V){var K=this.rules.block.heading.exec(V);if(K){var te=K[2].trim();if(/#$/.test(te)){var ie=$(te,"#");(this.options.pedantic||!ie||/ $/.test(ie))&&(te=ie.trim())}return{type:"heading",raw:K[0],depth:K[1].length,text:te}}},X.nptable=function(V){var K=this.rules.block.nptable.exec(V);if(K){var te={type:"table",header:x(K[1].replace(/^ *| *\| *$/g,"")),align:K[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:K[3]?K[3].replace(/\n$/,"").split(`
`):[],raw:K[0]};if(te.header.length===te.align.length){var ie=te.align.length,ue;for(ue=0;ue<ie;ue++)/^ *-+: *$/.test(te.align[ue])?te.align[ue]="right":/^ *:-+: *$/.test(te.align[ue])?te.align[ue]="center":/^ *:-+ *$/.test(te.align[ue])?te.align[ue]="left":te.align[ue]=null;for(ie=te.cells.length,ue=0;ue<ie;ue++)te.cells[ue]=x(te.cells[ue],te.header.length);return te}}},X.hr=function(V){var K=this.rules.block.hr.exec(V);if(K)return{type:"hr",raw:K[0]}},X.blockquote=function(V){var K=this.rules.block.blockquote.exec(V);if(K){var te=K[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:K[0],text:te}}},X.list=function(V){var K=this.rules.block.list.exec(V);if(K){var te=K[0],ie=K[2],ue=ie.length>1,De={type:"list",raw:te,ordered:ue,start:ue?+ie.slice(0,-1):"",loose:!1,items:[]},le=K[0].match(this.rules.block.item),ye=!1,be,Ae,se,oe,Y,G,_e,Ie,Be=le.length;se=this.rules.block.listItemStart.exec(le[0]);for(var Re=0;Re<Be;Re++){if(be=le[Re],te=be,Re!==Be-1){if(oe=this.rules.block.listItemStart.exec(le[Re+1]),this.options.pedantic?oe[1].length>se[1].length:oe[1].length>se[0].length||oe[1].length>3){le.splice(Re,2,le[Re]+`
`+le[Re+1]),Re--,Be--;continue}else(!this.options.pedantic||this.options.smartLists?oe[2][oe[2].length-1]!==ie[ie.length-1]:ue===(oe[2].length===1))&&(Y=le.slice(Re+1).join(`
`),De.raw=De.raw.substring(0,De.raw.length-Y.length),Re=Be-1);se=oe}Ae=be.length,be=be.replace(/^ *([*+-]|\d+[.)]) ?/,""),~be.indexOf(`
 `)&&(Ae-=be.length,be=this.options.pedantic?be.replace(/^ {1,4}/gm,""):be.replace(new RegExp("^ {1,"+Ae+"}","gm"),"")),G=ye||/\n\n(?!\s*$)/.test(be),Re!==Be-1&&(ye=be.charAt(be.length-1)===`
`,G||(G=ye)),G&&(De.loose=!0),this.options.gfm&&(_e=/^\[[ xX]\] /.test(be),Ie=void 0,_e&&(Ie=be[1]!==" ",be=be.replace(/^\[[ xX]\] +/,""))),De.items.push({type:"list_item",raw:te,task:_e,checked:Ie,loose:G,text:be})}return De}},X.html=function(V){var K=this.rules.block.html.exec(V);if(K)return{type:this.options.sanitize?"paragraph":"html",raw:K[0],pre:!this.options.sanitizer&&(K[1]==="pre"||K[1]==="script"||K[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(K[0]):J(K[0]):K[0]}},X.def=function(V){var K=this.rules.block.def.exec(V);if(K){K[3]&&(K[3]=K[3].substring(1,K[3].length-1));var te=K[1].toLowerCase().replace(/\s+/g," ");return{tag:te,raw:K[0],href:K[2],title:K[3]}}},X.table=function(V){var K=this.rules.block.table.exec(V);if(K){var te={type:"table",header:x(K[1].replace(/^ *| *\| *$/g,"")),align:K[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:K[3]?K[3].replace(/\n$/,"").split(`
`):[]};if(te.header.length===te.align.length){te.raw=K[0];var ie=te.align.length,ue;for(ue=0;ue<ie;ue++)/^ *-+: *$/.test(te.align[ue])?te.align[ue]="right":/^ *:-+: *$/.test(te.align[ue])?te.align[ue]="center":/^ *:-+ *$/.test(te.align[ue])?te.align[ue]="left":te.align[ue]=null;for(ie=te.cells.length,ue=0;ue<ie;ue++)te.cells[ue]=x(te.cells[ue].replace(/^ *\| *| *\| *$/g,""),te.header.length);return te}}},X.lheading=function(V){var K=this.rules.block.lheading.exec(V);if(K)return{type:"heading",raw:K[0],depth:K[2].charAt(0)==="="?1:2,text:K[1]}},X.paragraph=function(V){var K=this.rules.block.paragraph.exec(V);if(K)return{type:"paragraph",raw:K[0],text:K[1].charAt(K[1].length-1)===`
`?K[1].slice(0,-1):K[1]}},X.text=function(V){var K=this.rules.block.text.exec(V);if(K)return{type:"text",raw:K[0],text:K[0]}},X.escape=function(V){var K=this.rules.inline.escape.exec(V);if(K)return{type:"escape",raw:K[0],text:J(K[1])}},X.tag=function(V,K,te){var ie=this.rules.inline.tag.exec(V);if(ie)return!K&&/^<a /i.test(ie[0])?K=!0:K&&/^<\/a>/i.test(ie[0])&&(K=!1),!te&&/^<(pre|code|kbd|script)(\s|>)/i.test(ie[0])?te=!0:te&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ie[0])&&(te=!1),{type:this.options.sanitize?"text":"html",raw:ie[0],inLink:K,inRawBlock:te,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):J(ie[0]):ie[0]}},X.link=function(V){var K=this.rules.inline.link.exec(V);if(K){var te=K[2].trim();if(!this.options.pedantic&&/^</.test(te)){if(!/>$/.test(te))return;var ie=$(te.slice(0,-1),"\\");if((te.length-ie.length)%2==0)return}else{var ue=Ee(K[2],"()");if(ue>-1){var De=K[0].indexOf("!")===0?5:4,le=De+K[1].length+ue;K[2]=K[2].substring(0,ue),K[0]=K[0].substring(0,le).trim(),K[3]=""}}var ye=K[2],be="";if(this.options.pedantic){var Ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ye);Ae&&(ye=Ae[1],be=Ae[3])}else be=K[3]?K[3].slice(1,-1):"";return ye=ye.trim(),/^</.test(ye)&&(this.options.pedantic&&!/>$/.test(te)?ye=ye.slice(1):ye=ye.slice(1,-1)),ve(K,{href:ye&&ye.replace(this.rules.inline._escapes,"$1"),title:be&&be.replace(this.rules.inline._escapes,"$1")},K[0])}},X.reflink=function(V,K){var te;if((te=this.rules.inline.reflink.exec(V))||(te=this.rules.inline.nolink.exec(V))){var ie=(te[2]||te[1]).replace(/\s+/g," ");if(ie=K[ie.toLowerCase()],!ie||!ie.href){var ue=te[0].charAt(0);return{type:"text",raw:ue,text:ue}}return ve(te,ie,te[0])}},X.emStrong=function(V,K,te){te===void 0&&(te="");var ie=this.rules.inline.emStrong.lDelim.exec(V);if(!!ie&&!(ie[3]&&te.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ue=ie[1]||ie[2]||"";if(!ue||ue&&(te===""||this.rules.inline.punctuation.exec(te))){var De=ie[0].length-1,le,ye,be=De,Ae=0,se=ie[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(se.lastIndex=0,K=K.slice(-1*V.length+De);(ie=se.exec(K))!=null;)if(le=ie[1]||ie[2]||ie[3]||ie[4]||ie[5]||ie[6],!!le){if(ye=le.length,ie[3]||ie[4]){be+=ye;continue}else if((ie[5]||ie[6])&&De%3&&!((De+ye)%3)){Ae+=ye;continue}if(be-=ye,!(be>0)){if(be+Ae-ye<=0&&!K.slice(se.lastIndex).match(se)&&(ye=Math.min(ye,ye+be+Ae)),Math.min(De,ye)%2)return{type:"em",raw:V.slice(0,De+ie.index+ye+1),text:V.slice(1,De+ie.index+ye)};if(Math.min(De,ye)%2==0)return{type:"strong",raw:V.slice(0,De+ie.index+ye+1),text:V.slice(2,De+ie.index+ye-1)}}}}}},X.codespan=function(V){var K=this.rules.inline.code.exec(V);if(K){var te=K[2].replace(/\n/g," "),ie=/[^ ]/.test(te),ue=/^ /.test(te)&&/ $/.test(te);return ie&&ue&&(te=te.substring(1,te.length-1)),te=J(te,!0),{type:"codespan",raw:K[0],text:te}}},X.br=function(V){var K=this.rules.inline.br.exec(V);if(K)return{type:"br",raw:K[0]}},X.del=function(V){var K=this.rules.inline.del.exec(V);if(K)return{type:"del",raw:K[0],text:K[2]}},X.autolink=function(V,K){var te=this.rules.inline.autolink.exec(V);if(te){var ie,ue;return te[2]==="@"?(ie=J(this.options.mangle?K(te[1]):te[1]),ue="mailto:"+ie):(ie=J(te[1]),ue=ie),{type:"link",raw:te[0],text:ie,href:ue,tokens:[{type:"text",raw:ie,text:ie}]}}},X.url=function(V,K){var te;if(te=this.rules.inline.url.exec(V)){var ie,ue;if(te[2]==="@")ie=J(this.options.mangle?K(te[0]):te[0]),ue="mailto:"+ie;else{var De;do De=te[0],te[0]=this.rules.inline._backpedal.exec(te[0])[0];while(De!==te[0]);ie=J(te[0]),te[1]==="www."?ue="http://"+ie:ue=ie}return{type:"link",raw:te[0],text:ie,href:ue,tokens:[{type:"text",raw:ie,text:ie}]}}},X.inlineText=function(V,K,te){var ie=this.rules.inline.text.exec(V);if(ie){var ue;return K?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):J(ie[0]):ie[0]:ue=J(this.options.smartypants?te(ie[0]):ie[0]),{type:"text",raw:ie[0],text:ue}}},z}(),F=O.noopTest,A=O.edit,M=O.merge,U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:F,table:F,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=A(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,U.item=A(U.item,"gm").replace(/bull/g,U.bullet).getRegex(),U.listItemStart=A(/^( *)(bull)/).replace("bull",U.bullet).getRegex(),U.list=A(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=A(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=A(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",U._tag).getRegex(),U.blockquote=A(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=M({},U),U.gfm=M({},U.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.nptable=A(U.gfm.nptable).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",U._tag).getRegex(),U.gfm.table=A(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",U._tag).getRegex(),U.pedantic=M({},U.normal,{html:A(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:F,paragraph:A(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var W={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:F,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:F,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};W._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",W.punctuation=A(W.punctuation).replace(/punctuation/g,W._punctuation).getRegex(),W.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,W.escapedEmSt=/\\\*|\\_/g,W._comment=A(U._comment).replace("(?:-->|$)","-->").getRegex(),W.emStrong.lDelim=A(W.emStrong.lDelim).replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimAst=A(W.emStrong.rDelimAst,"g").replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimUnd=A(W.emStrong.rDelimUnd,"g").replace(/punct/g,W._punctuation).getRegex(),W._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,W._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,W._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,W.autolink=A(W.autolink).replace("scheme",W._scheme).replace("email",W._email).getRegex(),W._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,W.tag=A(W.tag).replace("comment",W._comment).replace("attribute",W._attribute).getRegex(),W._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,W._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,W._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,W.link=A(W.link).replace("label",W._label).replace("href",W._href).replace("title",W._title).getRegex(),W.reflink=A(W.reflink).replace("label",W._label).getRegex(),W.reflinkSearch=A(W.reflinkSearch,"g").replace("reflink",W.reflink).replace("nolink",W.nolink).getRegex(),W.normal=M({},W),W.pedantic=M({},W.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:A(/^!?\[(label)\]\((.*?)\)/).replace("label",W._label).getRegex(),reflink:A(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",W._label).getRegex()}),W.gfm=M({},W.normal,{escape:A(W.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),W.gfm.url=A(W.gfm.url,"i").replace("email",W.gfm._extended_email).getRegex(),W.breaks=M({},W.gfm,{br:A(W.br).replace("{2,}","*").getRegex(),text:A(W.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ne={block:U,inline:W},ae=k.defaults,ce=ne.block,de=ne.inline,Pe=O.repeatString;function Te(z){return z.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Me(z){var X="",ee,V,K=z.length;for(ee=0;ee<K;ee++)V=z.charCodeAt(ee),Math.random()>.5&&(V="x"+V.toString(16)),X+="&#"+V+";";return X}var je=function(){function z(ee){this.tokens=[],this.tokens.links=Object.create(null),this.options=ee||ae,this.options.tokenizer=this.options.tokenizer||new j,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var V={block:ce.normal,inline:de.normal};this.options.pedantic?(V.block=ce.pedantic,V.inline=de.pedantic):this.options.gfm&&(V.block=ce.gfm,this.options.breaks?V.inline=de.breaks:V.inline=de.gfm),this.tokenizer.rules=V}z.lex=function(V,K){var te=new z(K);return te.lex(V)},z.lexInline=function(V,K){var te=new z(K);return te.inlineTokens(V)};var X=z.prototype;return X.lex=function(V){return V=V.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(V,this.tokens,!0),this.inline(this.tokens),this.tokens},X.blockTokens=function(V,K,te){K===void 0&&(K=[]),te===void 0&&(te=!0),this.options.pedantic&&(V=V.replace(/^ +$/gm,""));for(var ie,ue,De,le;V;){if(ie=this.tokenizer.space(V)){V=V.substring(ie.raw.length),ie.type&&K.push(ie);continue}if(ie=this.tokenizer.code(V)){V=V.substring(ie.raw.length),le=K[K.length-1],le&&le.type==="paragraph"?(le.raw+=`
`+ie.raw,le.text+=`
`+ie.text):K.push(ie);continue}if(ie=this.tokenizer.fences(V)){V=V.substring(ie.raw.length),K.push(ie);continue}if(ie=this.tokenizer.heading(V)){V=V.substring(ie.raw.length),K.push(ie);continue}if(ie=this.tokenizer.nptable(V)){V=V.substring(ie.raw.length),K.push(ie);continue}if(ie=this.tokenizer.hr(V)){V=V.substring(ie.raw.length),K.push(ie);continue}if(ie=this.tokenizer.blockquote(V)){V=V.substring(ie.raw.length),ie.tokens=this.blockTokens(ie.text,[],te),K.push(ie);continue}if(ie=this.tokenizer.list(V)){for(V=V.substring(ie.raw.length),De=ie.items.length,ue=0;ue<De;ue++)ie.items[ue].tokens=this.blockTokens(ie.items[ue].text,[],!1);K.push(ie);continue}if(ie=this.tokenizer.html(V)){V=V.substring(ie.raw.length),K.push(ie);continue}if(te&&(ie=this.tokenizer.def(V))){V=V.substring(ie.raw.length),this.tokens.links[ie.tag]||(this.tokens.links[ie.tag]={href:ie.href,title:ie.title});continue}if(ie=this.tokenizer.table(V)){V=V.substring(ie.raw.length),K.push(ie);continue}if(ie=this.tokenizer.lheading(V)){V=V.substring(ie.raw.length),K.push(ie);continue}if(te&&(ie=this.tokenizer.paragraph(V))){V=V.substring(ie.raw.length),K.push(ie);continue}if(ie=this.tokenizer.text(V)){V=V.substring(ie.raw.length),le=K[K.length-1],le&&le.type==="text"?(le.raw+=`
`+ie.raw,le.text+=`
`+ie.text):K.push(ie);continue}if(V){var ye="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(ye);break}else throw new Error(ye)}}return K},X.inline=function(V){var K,te,ie,ue,De,le,ye=V.length;for(K=0;K<ye;K++)switch(le=V[K],le.type){case"paragraph":case"text":case"heading":{le.tokens=[],this.inlineTokens(le.text,le.tokens);break}case"table":{for(le.tokens={header:[],cells:[]},ue=le.header.length,te=0;te<ue;te++)le.tokens.header[te]=[],this.inlineTokens(le.header[te],le.tokens.header[te]);for(ue=le.cells.length,te=0;te<ue;te++)for(De=le.cells[te],le.tokens.cells[te]=[],ie=0;ie<De.length;ie++)le.tokens.cells[te][ie]=[],this.inlineTokens(De[ie],le.tokens.cells[te][ie]);break}case"blockquote":{this.inline(le.tokens);break}case"list":{for(ue=le.items.length,te=0;te<ue;te++)this.inline(le.items[te].tokens);break}}return V},X.inlineTokens=function(V,K,te,ie){K===void 0&&(K=[]),te===void 0&&(te=!1),ie===void 0&&(ie=!1);var ue,De,le=V,ye,be,Ae;if(this.tokens.links){var se=Object.keys(this.tokens.links);if(se.length>0)for(;(ye=this.tokenizer.rules.inline.reflinkSearch.exec(le))!=null;)se.includes(ye[0].slice(ye[0].lastIndexOf("[")+1,-1))&&(le=le.slice(0,ye.index)+"["+Pe("a",ye[0].length-2)+"]"+le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ye=this.tokenizer.rules.inline.blockSkip.exec(le))!=null;)le=le.slice(0,ye.index)+"["+Pe("a",ye[0].length-2)+"]"+le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ye=this.tokenizer.rules.inline.escapedEmSt.exec(le))!=null;)le=le.slice(0,ye.index)+"++"+le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;V;){if(be||(Ae=""),be=!1,ue=this.tokenizer.escape(V)){V=V.substring(ue.raw.length),K.push(ue);continue}if(ue=this.tokenizer.tag(V,te,ie)){V=V.substring(ue.raw.length),te=ue.inLink,ie=ue.inRawBlock;var oe=K[K.length-1];oe&&ue.type==="text"&&oe.type==="text"?(oe.raw+=ue.raw,oe.text+=ue.text):K.push(ue);continue}if(ue=this.tokenizer.link(V)){V=V.substring(ue.raw.length),ue.type==="link"&&(ue.tokens=this.inlineTokens(ue.text,[],!0,ie)),K.push(ue);continue}if(ue=this.tokenizer.reflink(V,this.tokens.links)){V=V.substring(ue.raw.length);var Y=K[K.length-1];ue.type==="link"?(ue.tokens=this.inlineTokens(ue.text,[],!0,ie),K.push(ue)):Y&&ue.type==="text"&&Y.type==="text"?(Y.raw+=ue.raw,Y.text+=ue.text):K.push(ue);continue}if(ue=this.tokenizer.emStrong(V,le,Ae)){V=V.substring(ue.raw.length),ue.tokens=this.inlineTokens(ue.text,[],te,ie),K.push(ue);continue}if(ue=this.tokenizer.codespan(V)){V=V.substring(ue.raw.length),K.push(ue);continue}if(ue=this.tokenizer.br(V)){V=V.substring(ue.raw.length),K.push(ue);continue}if(ue=this.tokenizer.del(V)){V=V.substring(ue.raw.length),ue.tokens=this.inlineTokens(ue.text,[],te,ie),K.push(ue);continue}if(ue=this.tokenizer.autolink(V,Me)){V=V.substring(ue.raw.length),K.push(ue);continue}if(!te&&(ue=this.tokenizer.url(V,Me))){V=V.substring(ue.raw.length),K.push(ue);continue}if(ue=this.tokenizer.inlineText(V,ie,Te)){V=V.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(Ae=ue.raw.slice(-1)),be=!0,De=K[K.length-1],De&&De.type==="text"?(De.raw+=ue.raw,De.text+=ue.text):K.push(ue);continue}if(V){var G="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return K},e(z,null,[{key:"rules",get:function(){return{block:ce,inline:de}}}]),z}(),$e=k.defaults,Ye=O.cleanUrl,et=O.escape,Je=function(){function z(ee){this.options=ee||$e}var X=z.prototype;return X.code=function(V,K,te){var ie=(K||"").match(/\S*/)[0];if(this.options.highlight){var ue=this.options.highlight(V,ie);ue!=null&&ue!==V&&(te=!0,V=ue)}return V=V.replace(/\n$/,"")+`
`,ie?'<pre><code class="'+this.options.langPrefix+et(ie,!0)+'">'+(te?V:et(V,!0))+`</code></pre>
`:"<pre><code>"+(te?V:et(V,!0))+`</code></pre>
`},X.blockquote=function(V){return`<blockquote>
`+V+`</blockquote>
`},X.html=function(V){return V},X.heading=function(V,K,te,ie){return this.options.headerIds?"<h"+K+' id="'+this.options.headerPrefix+ie.slug(te)+'">'+V+"</h"+K+`>
`:"<h"+K+">"+V+"</h"+K+`>
`},X.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},X.list=function(V,K,te){var ie=K?"ol":"ul",ue=K&&te!==1?' start="'+te+'"':"";return"<"+ie+ue+`>
`+V+"</"+ie+`>
`},X.listitem=function(V){return"<li>"+V+`</li>
`},X.checkbox=function(V){return"<input "+(V?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},X.paragraph=function(V){return"<p>"+V+`</p>
`},X.table=function(V,K){return K&&(K="<tbody>"+K+"</tbody>"),`<table>
<thead>
`+V+`</thead>
`+K+`</table>
`},X.tablerow=function(V){return`<tr>
`+V+`</tr>
`},X.tablecell=function(V,K){var te=K.header?"th":"td",ie=K.align?"<"+te+' align="'+K.align+'">':"<"+te+">";return ie+V+"</"+te+`>
`},X.strong=function(V){return"<strong>"+V+"</strong>"},X.em=function(V){return"<em>"+V+"</em>"},X.codespan=function(V){return"<code>"+V+"</code>"},X.br=function(){return this.options.xhtml?"<br/>":"<br>"},X.del=function(V){return"<del>"+V+"</del>"},X.link=function(V,K,te){if(V=Ye(this.options.sanitize,this.options.baseUrl,V),V===null)return te;var ie='<a href="'+et(V)+'"';return K&&(ie+=' title="'+K+'"'),ie+=">"+te+"</a>",ie},X.image=function(V,K,te){if(V=Ye(this.options.sanitize,this.options.baseUrl,V),V===null)return te;var ie='<img src="'+V+'" alt="'+te+'"';return K&&(ie+=' title="'+K+'"'),ie+=this.options.xhtml?"/>":">",ie},X.text=function(V){return V},z}(),we=function(){function z(){}var X=z.prototype;return X.strong=function(V){return V},X.em=function(V){return V},X.codespan=function(V){return V},X.del=function(V){return V},X.html=function(V){return V},X.text=function(V){return V},X.link=function(V,K,te){return""+te},X.image=function(V,K,te){return""+te},X.br=function(){return""},z}(),Se=function(){function z(){this.seen={}}var X=z.prototype;return X.serialize=function(V){return V.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},X.getNextSafeSlug=function(V,K){var te=V,ie=0;if(this.seen.hasOwnProperty(te)){ie=this.seen[V];do ie++,te=V+"-"+ie;while(this.seen.hasOwnProperty(te))}return K||(this.seen[V]=ie,this.seen[te]=0),te},X.slug=function(V,K){K===void 0&&(K={});var te=this.serialize(V);return this.getNextSafeSlug(te,K.dryrun)},z}(),Ce=k.defaults,ke=O.unescape,Le=function(){function z(ee){this.options=ee||Ce,this.options.renderer=this.options.renderer||new Je,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new we,this.slugger=new Se}z.parse=function(V,K){var te=new z(K);return te.parse(V)},z.parseInline=function(V,K){var te=new z(K);return te.parseInline(V)};var X=z.prototype;return X.parse=function(V,K){K===void 0&&(K=!0);var te="",ie,ue,De,le,ye,be,Ae,se,oe,Y,G,_e,Ie,Be,Re,qe,Xe,Ue,tt=V.length;for(ie=0;ie<tt;ie++)switch(Y=V[ie],Y.type){case"space":continue;case"hr":{te+=this.renderer.hr();continue}case"heading":{te+=this.renderer.heading(this.parseInline(Y.tokens),Y.depth,ke(this.parseInline(Y.tokens,this.textRenderer)),this.slugger);continue}case"code":{te+=this.renderer.code(Y.text,Y.lang,Y.escaped);continue}case"table":{for(se="",Ae="",le=Y.header.length,ue=0;ue<le;ue++)Ae+=this.renderer.tablecell(this.parseInline(Y.tokens.header[ue]),{header:!0,align:Y.align[ue]});for(se+=this.renderer.tablerow(Ae),oe="",le=Y.cells.length,ue=0;ue<le;ue++){for(be=Y.tokens.cells[ue],Ae="",ye=be.length,De=0;De<ye;De++)Ae+=this.renderer.tablecell(this.parseInline(be[De]),{header:!1,align:Y.align[De]});oe+=this.renderer.tablerow(Ae)}te+=this.renderer.table(se,oe);continue}case"blockquote":{oe=this.parse(Y.tokens),te+=this.renderer.blockquote(oe);continue}case"list":{for(G=Y.ordered,_e=Y.start,Ie=Y.loose,le=Y.items.length,oe="",ue=0;ue<le;ue++)Re=Y.items[ue],qe=Re.checked,Xe=Re.task,Be="",Re.task&&(Ue=this.renderer.checkbox(qe),Ie?Re.tokens.length>0&&Re.tokens[0].type==="text"?(Re.tokens[0].text=Ue+" "+Re.tokens[0].text,Re.tokens[0].tokens&&Re.tokens[0].tokens.length>0&&Re.tokens[0].tokens[0].type==="text"&&(Re.tokens[0].tokens[0].text=Ue+" "+Re.tokens[0].tokens[0].text)):Re.tokens.unshift({type:"text",text:Ue}):Be+=Ue),Be+=this.parse(Re.tokens,Ie),oe+=this.renderer.listitem(Be,Xe,qe);te+=this.renderer.list(oe,G,_e);continue}case"html":{te+=this.renderer.html(Y.text);continue}case"paragraph":{te+=this.renderer.paragraph(this.parseInline(Y.tokens));continue}case"text":{for(oe=Y.tokens?this.parseInline(Y.tokens):Y.text;ie+1<tt&&V[ie+1].type==="text";)Y=V[++ie],oe+=`
`+(Y.tokens?this.parseInline(Y.tokens):Y.text);te+=K?this.renderer.paragraph(oe):oe;continue}default:{var it='Token with "'+Y.type+'" type was not found.';if(this.options.silent){console.error(it);return}else throw new Error(it)}}return te},X.parseInline=function(V,K){K=K||this.renderer;var te="",ie,ue,De=V.length;for(ie=0;ie<De;ie++)switch(ue=V[ie],ue.type){case"escape":{te+=K.text(ue.text);break}case"html":{te+=K.html(ue.text);break}case"link":{te+=K.link(ue.href,ue.title,this.parseInline(ue.tokens,K));break}case"image":{te+=K.image(ue.href,ue.title,ue.text);break}case"strong":{te+=K.strong(this.parseInline(ue.tokens,K));break}case"em":{te+=K.em(this.parseInline(ue.tokens,K));break}case"codespan":{te+=K.codespan(ue.text);break}case"br":{te+=K.br();break}case"del":{te+=K.del(this.parseInline(ue.tokens,K));break}case"text":{te+=K.text(ue.text);break}default:{var le='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(le);return}else throw new Error(le)}}return te},z}(),ze=O.merge,He=O.checkSanitizeDeprecation,Ve=O.escape,Qe=k.getDefaults,re=k.changeDefaults,ge=k.defaults;function me(z,X,ee){if(typeof z=="undefined"||z===null)throw new Error("marked(): input parameter is undefined or null");if(typeof z!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(z)+", string expected");if(typeof X=="function"&&(ee=X,X=null),X=ze({},me.defaults,X||{}),He(X),ee){var V=X.highlight,K;try{K=je.lex(z,X)}catch(De){return ee(De)}var te=function(le){var ye;if(!le)try{ye=Le.parse(K,X)}catch(be){le=be}return X.highlight=V,le?ee(le):ee(null,ye)};if(!V||V.length<3||(delete X.highlight,!K.length))return te();var ie=0;me.walkTokens(K,function(De){De.type==="code"&&(ie++,setTimeout(function(){V(De.text,De.lang,function(le,ye){if(le)return te(le);ye!=null&&ye!==De.text&&(De.text=ye,De.escaped=!0),ie--,ie===0&&te()})},0))}),ie===0&&te();return}try{var ue=je.lex(z,X);return X.walkTokens&&me.walkTokens(ue,X.walkTokens),Le.parse(ue,X)}catch(De){if(De.message+=`
Please report this to https://github.com/markedjs/marked.`,X.silent)return"<p>An error occurred:</p><pre>"+Ve(De.message+"",!0)+"</pre>";throw De}}me.options=me.setOptions=function(z){return ze(me.defaults,z),re(me.defaults),me},me.getDefaults=Qe,me.defaults=ge,me.use=function(z){var X=ze({},z);if(z.renderer&&function(){var V=me.defaults.renderer||new Je,K=function(ue){var De=V[ue];V[ue]=function(){for(var le=arguments.length,ye=new Array(le),be=0;be<le;be++)ye[be]=arguments[be];var Ae=z.renderer[ue].apply(V,ye);return Ae===!1&&(Ae=De.apply(V,ye)),Ae}};for(var te in z.renderer)K(te);X.renderer=V}(),z.tokenizer&&function(){var V=me.defaults.tokenizer||new j,K=function(ue){var De=V[ue];V[ue]=function(){for(var le=arguments.length,ye=new Array(le),be=0;be<le;be++)ye[be]=arguments[be];var Ae=z.tokenizer[ue].apply(V,ye);return Ae===!1&&(Ae=De.apply(V,ye)),Ae}};for(var te in z.tokenizer)K(te);X.tokenizer=V}(),z.walkTokens){var ee=me.defaults.walkTokens;X.walkTokens=function(V){z.walkTokens(V),ee&&ee(V)}}me.setOptions(X)},me.walkTokens=function(z,X){for(var ee=P(z),V;!(V=ee()).done;){var K=V.value;switch(X(K),K.type){case"table":{for(var te=P(K.tokens.header),ie;!(ie=te()).done;){var ue=ie.value;me.walkTokens(ue,X)}for(var De=P(K.tokens.cells),le;!(le=De()).done;)for(var ye=le.value,be=P(ye),Ae;!(Ae=be()).done;){var se=Ae.value;me.walkTokens(se,X)}break}case"list":{me.walkTokens(K.items,X);break}default:K.tokens&&me.walkTokens(K.tokens,X)}}},me.parseInline=function(z,X){if(typeof z=="undefined"||z===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof z!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(z)+", string expected");X=ze({},me.defaults,X||{}),He(X);try{var ee=je.lexInline(z,X);return X.walkTokens&&me.walkTokens(ee,X.walkTokens),Le.parseInline(ee,X)}catch(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,X.silent)return"<p>An error occurred:</p><pre>"+Ve(V.message+"",!0)+"</pre>";throw V}},me.Parser=Le,me.parser=Le.parse,me.Renderer=Je,me.TextRenderer=we,me.Lexer=je,me.lexer=je.lex,me.Tokenizer=j,me.Slugger=Se,me.parse=me;var Fe=me;return Fe}),define(fe[109],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function S(k,L,h){return Math.min(Math.max(k,L),h)}e.clamp=S;function d(k,L){return(L+k%L)%L}e.rot=d;class P{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=P;class y{constructor(){this._n=1,this._val=0}update(L){return this._val=this._val+(L-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=y});"use strict";function pt(Q){const e=[];typeof Q=="number"&&e.push("code/timeOrigin",Q);function S(P){e.push(P,Date.now())}function d(){const P=[];for(let y=0;y<e.length;y+=2)P.push({name:e[y],startTime:e[y+1]});return P}return{mark:S,getMarks:d}}function Gt(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?pt():{mark(Q){performance.mark(Q)},getMarks(){let Q=performance.timeOrigin;typeof Q!="number"&&(Q=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const e=[{name:"code/timeOrigin",startTime:Math.round(Q)}];for(const S of performance.getEntriesByType("mark"))e.push({name:S.name,startTime:Math.round(Q+S.startTime)});return e}};if(typeof process=="object"){const Q=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return pt(Q)}else return console.trace("perf-util loaded in UNKNOWN environment"),pt()}function wt(Q){return Q.MonacoPerformanceMarks||(Q.MonacoPerformanceMarks=Gt()),Q.MonacoPerformanceMarks}var ht;typeof global=="object"?ht=global:typeof self=="object"?ht=self:ht={},typeof define=="function"?define("vs/base/common/performance",[],function(){return wt(ht)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=wt(ht):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),ht.perf=wt(ht)),define(fe[5],he([0,1]),function(Q,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.globals=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=void 0;const d="en";let P=!1,y=!1,k=!1,L=!1,h=!1,n=!1,D=!1,b,I=d,E,u;const v=typeof self=="object"?self:typeof global=="object"?global:{};let _;typeof process!="undefined"?_=process:typeof v.vscode!="undefined"&&(_=v.vscode.process);const w=typeof((S=_==null?void 0:_.versions)===null||S===void 0?void 0:S.electron)=="string"&&_.type==="renderer";if(e.isElectronSandboxed=w&&(_==null?void 0:_.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const s=_==null?void 0:_.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof s=="string")return s==="none"||s==="code"||s==="bypassHeatCheck"||s==="bypassHeatCheckAndEagerCompile"?s:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!w)u=navigator.userAgent,P=u.indexOf("Windows")>=0,y=u.indexOf("Macintosh")>=0,D=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=u.indexOf("Linux")>=0,n=!0,b=navigator.language,I=b;else if(typeof _=="object"){P=_.platform==="win32",y=_.platform==="darwin",k=_.platform==="linux",L=k&&!!_.env.SNAP&&!!_.env.SNAP_REVISION,b=d,I=d;const s=_.env.VSCODE_NLS_CONFIG;if(s)try{const g=JSON.parse(s),C=g.availableLanguages["*"];b=g.locale,I=C||d,E=g._translationsConfigFile}catch(g){}h=!0}else console.error("Unable to resolve platform.");var m;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(m=e.Platform||(e.Platform={}));function l(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let c=0;y?c=1:P?c=3:k&&(c=2),e.isWindows=P,e.isMacintosh=y,e.isLinux=k,e.isLinuxSnap=L,e.isNative=h,e.isWeb=n,e.isIOS=D,e.platform=c,e.userAgent=u,e.language=I;var r;(function(s){function g(){return e.language}s.value=g;function C(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=C;function R(){return e.language==="en"}s.isDefault=R})(r=e.Language||(e.Language={})),e.locale=b,e.translationsConfigFile=E,e.globals=v,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let C=[];e.globals.addEventListener("message",p=>{if(p.data&&p.data.vscodeSetImmediateId)for(let f=0,T=C.length;f<T;f++){const O=C[f];if(O.id===p.data.vscodeSetImmediateId){C.splice(f,1),O.callback();return}}});let R=0;return p=>{const f=++R;C.push({id:f,callback:p}),e.globals.postMessage({vscodeSetImmediateId:f},"*")}}if(_&&typeof _.nextTick=="function")return _.nextTick.bind(_);const g=Promise.resolve();return C=>g.then(C)}();var t;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=y||D?2:P?1:3;let i=!0,o=!1;function a(){if(!o){o=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,i=new Uint16Array(s.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=a}),define(fe[36],he([0,1,5]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let d;typeof process!="undefined"?d=process:typeof S.globals.vscode!="undefined"?d={get platform(){return S.globals.vscode.process.platform},get env(){return S.globals.vscode.process.env},nextTick(P){return S.setImmediate(P)},cwd(){return S.globals.vscode.process.env.VSCODE_CWD||S.globals.vscode.process.execPath.substr(0,S.globals.vscode.process.execPath.lastIndexOf(S.globals.vscode.process.platform==="win32"?"\\":"/"))}}:d={get platform(){return S.isWindows?"win32":S.isMacintosh?"darwin":"linux"},nextTick(P){return S.setImmediate(P)},get env(){return Object.create(null)},cwd(){return"/"}},e.cwd=d.cwd,e.env=d.env,e.platform=d.platform,e.nextTick=d.nextTick}),define(fe[2],he([0,1,36]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const d=65,P=97,y=90,k=122,L=46,h=47,n=92,D=58,b=63;class I extends Error{constructor(c,r,t){let i;typeof r=="string"&&r.indexOf("not ")===0?(i="must not be",r=r.replace(/^not /,"")):i="must be";const o=c.indexOf(".")!==-1?"property":"argument";let a=`The "${c}" ${o} ${i} of type ${r}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function E(l,c){if(typeof l!="string")throw new I(c,"string",l)}function u(l){return l===h||l===n}function v(l){return l===h}function _(l){return l>=d&&l<=y||l>=P&&l<=k}function w(l,c,r,t){let i="",o=0,a=-1,s=0,g=0;for(let C=0;C<=l.length;++C){if(C<l.length)g=l.charCodeAt(C);else{if(t(g))break;g=h}if(t(g)){if(!(a===C-1||s===1))if(s===2){if(i.length<2||o!==2||i.charCodeAt(i.length-1)!==L||i.charCodeAt(i.length-2)!==L){if(i.length>2){const R=i.lastIndexOf(r);R===-1?(i="",o=0):(i=i.slice(0,R),o=i.length-1-i.lastIndexOf(r)),a=C,s=0;continue}else if(i.length!==0){i="",o=0,a=C,s=0;continue}}c&&(i+=i.length>0?`${r}..`:"..",o=2)}else i.length>0?i+=`${r}${l.slice(a+1,C)}`:i=l.slice(a+1,C),o=C-a-1;a=C,s=0}else g===L&&s!==-1?++s:s=-1}return i}function m(l,c){if(c===null||typeof c!="object")throw new I("pathObject","Object",c);const r=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return r?r===c.root?`${r}${t}`:`${r}${l}${t}`:t}e.win32={resolve(...l){let c="",r="",t=!1;for(let i=l.length-1;i>=-1;i--){let o;if(i>=0){if(o=l[i],E(o,"path"),o.length===0)continue}else c.length===0?o=S.cwd():(o=S.env[`=${c}`]||S.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==c.toLowerCase()&&o.charCodeAt(2)===n)&&(o=`${c}\\`));const a=o.length;let s=0,g="",C=!1;const R=o.charCodeAt(0);if(a===1)u(R)&&(s=1,C=!0);else if(u(R))if(C=!0,u(o.charCodeAt(1))){let p=2,f=p;for(;p<a&&!u(o.charCodeAt(p));)p++;if(p<a&&p!==f){const T=o.slice(f,p);for(f=p;p<a&&u(o.charCodeAt(p));)p++;if(p<a&&p!==f){for(f=p;p<a&&!u(o.charCodeAt(p));)p++;(p===a||p!==f)&&(g=`\\\\${T}\\${o.slice(f,p)}`,s=p)}}}else s=1;else _(R)&&o.charCodeAt(1)===D&&(g=o.slice(0,2),s=2,a>2&&u(o.charCodeAt(2))&&(C=!0,s=3));if(g.length>0)if(c.length>0){if(g.toLowerCase()!==c.toLowerCase())continue}else c=g;if(t){if(c.length>0)break}else if(r=`${o.slice(s)}\\${r}`,t=C,C&&c.length>0)break}return r=w(r,!t,"\\",u),t?`${c}\\${r}`:`${c}${r}`||"."},normalize(l){E(l,"path");const c=l.length;if(c===0)return".";let r=0,t,i=!1;const o=l.charCodeAt(0);if(c===1)return v(o)?"\\":l;if(u(o))if(i=!0,u(l.charCodeAt(1))){let s=2,g=s;for(;s<c&&!u(l.charCodeAt(s));)s++;if(s<c&&s!==g){const C=l.slice(g,s);for(g=s;s<c&&u(l.charCodeAt(s));)s++;if(s<c&&s!==g){for(g=s;s<c&&!u(l.charCodeAt(s));)s++;if(s===c)return`\\\\${C}\\${l.slice(g)}\\`;s!==g&&(t=`\\\\${C}\\${l.slice(g,s)}`,r=s)}}}else r=1;else _(o)&&l.charCodeAt(1)===D&&(t=l.slice(0,2),r=2,c>2&&u(l.charCodeAt(2))&&(i=!0,r=3));let a=r<c?w(l.slice(r),!i,"\\",u):"";return a.length===0&&!i&&(a="."),a.length>0&&u(l.charCodeAt(c-1))&&(a+="\\"),t===void 0?i?`\\${a}`:a:i?`${t}\\${a}`:`${t}${a}`},isAbsolute(l){E(l,"path");const c=l.length;if(c===0)return!1;const r=l.charCodeAt(0);return u(r)||c>2&&_(r)&&l.charCodeAt(1)===D&&u(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let c,r;for(let o=0;o<l.length;++o){const a=l[o];E(a,"path"),a.length>0&&(c===void 0?c=r=a:c+=`\\${a}`)}if(c===void 0)return".";let t=!0,i=0;if(typeof r=="string"&&u(r.charCodeAt(0))){++i;const o=r.length;o>1&&u(r.charCodeAt(1))&&(++i,o>2&&(u(r.charCodeAt(2))?++i:t=!1))}if(t){for(;i<c.length&&u(c.charCodeAt(i));)i++;i>=2&&(c=`\\${c.slice(i)}`)}return e.win32.normalize(c)},relative(l,c){if(E(l,"from"),E(c,"to"),l===c)return"";const r=e.win32.resolve(l),t=e.win32.resolve(c);if(r===t||(l=r.toLowerCase(),c=t.toLowerCase(),l===c))return"";let i=0;for(;i<l.length&&l.charCodeAt(i)===n;)i++;let o=l.length;for(;o-1>i&&l.charCodeAt(o-1)===n;)o--;const a=o-i;let s=0;for(;s<c.length&&c.charCodeAt(s)===n;)s++;let g=c.length;for(;g-1>s&&c.charCodeAt(g-1)===n;)g--;const C=g-s,R=a<C?a:C;let p=-1,f=0;for(;f<R;f++){const O=l.charCodeAt(i+f);if(O!==c.charCodeAt(s+f))break;O===n&&(p=f)}if(f!==R){if(p===-1)return t}else{if(C>R){if(c.charCodeAt(s+f)===n)return t.slice(s+f+1);if(f===2)return t.slice(s+f)}a>R&&(l.charCodeAt(i+f)===n?p=f:f===2&&(p=3)),p===-1&&(p=0)}let T="";for(f=i+p+1;f<=o;++f)(f===o||l.charCodeAt(f)===n)&&(T+=T.length===0?"..":"\\..");return s+=p,T.length>0?`${T}${t.slice(s,g)}`:(t.charCodeAt(s)===n&&++s,t.slice(s,g))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const c=e.win32.resolve(l);if(c.length<=2)return l;if(c.charCodeAt(0)===n){if(c.charCodeAt(1)===n){const r=c.charCodeAt(2);if(r!==b&&r!==L)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(_(c.charCodeAt(0))&&c.charCodeAt(1)===D&&c.charCodeAt(2)===n)return`\\\\?\\${c}`;return l},dirname(l){E(l,"path");const c=l.length;if(c===0)return".";let r=-1,t=0;const i=l.charCodeAt(0);if(c===1)return u(i)?l:".";if(u(i)){if(r=t=1,u(l.charCodeAt(1))){let s=2,g=s;for(;s<c&&!u(l.charCodeAt(s));)s++;if(s<c&&s!==g){for(g=s;s<c&&u(l.charCodeAt(s));)s++;if(s<c&&s!==g){for(g=s;s<c&&!u(l.charCodeAt(s));)s++;if(s===c)return l;s!==g&&(r=t=s+1)}}}}else _(i)&&l.charCodeAt(1)===D&&(r=c>2&&u(l.charCodeAt(2))?3:2,t=r);let o=-1,a=!0;for(let s=c-1;s>=t;--s)if(u(l.charCodeAt(s))){if(!a){o=s;break}}else a=!1;if(o===-1){if(r===-1)return".";o=r}return l.slice(0,o)},basename(l,c){c!==void 0&&E(c,"ext"),E(l,"path");let r=0,t=-1,i=!0,o;if(l.length>=2&&_(l.charCodeAt(0))&&l.charCodeAt(1)===D&&(r=2),c!==void 0&&c.length>0&&c.length<=l.length){if(c===l)return"";let a=c.length-1,s=-1;for(o=l.length-1;o>=r;--o){const g=l.charCodeAt(o);if(u(g)){if(!i){r=o+1;break}}else s===-1&&(i=!1,s=o+1),a>=0&&(g===c.charCodeAt(a)?--a==-1&&(t=o):(a=-1,t=s))}return r===t?t=s:t===-1&&(t=l.length),l.slice(r,t)}for(o=l.length-1;o>=r;--o)if(u(l.charCodeAt(o))){if(!i){r=o+1;break}}else t===-1&&(i=!1,t=o+1);return t===-1?"":l.slice(r,t)},extname(l){E(l,"path");let c=0,r=-1,t=0,i=-1,o=!0,a=0;l.length>=2&&l.charCodeAt(1)===D&&_(l.charCodeAt(0))&&(c=t=2);for(let s=l.length-1;s>=c;--s){const g=l.charCodeAt(s);if(u(g)){if(!o){t=s+1;break}continue}i===-1&&(o=!1,i=s+1),g===L?r===-1?r=s:a!==1&&(a=1):r!==-1&&(a=-1)}return r===-1||i===-1||a===0||a===1&&r===i-1&&r===t+1?"":l.slice(r,i)},format:m.bind(null,"\\"),parse(l){E(l,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return c;const r=l.length;let t=0,i=l.charCodeAt(0);if(r===1)return u(i)?(c.root=c.dir=l,c):(c.base=c.name=l,c);if(u(i)){if(t=1,u(l.charCodeAt(1))){let p=2,f=p;for(;p<r&&!u(l.charCodeAt(p));)p++;if(p<r&&p!==f){for(f=p;p<r&&u(l.charCodeAt(p));)p++;if(p<r&&p!==f){for(f=p;p<r&&!u(l.charCodeAt(p));)p++;p===r?t=p:p!==f&&(t=p+1)}}}}else if(_(i)&&l.charCodeAt(1)===D){if(r<=2)return c.root=c.dir=l,c;if(t=2,u(l.charCodeAt(2))){if(r===3)return c.root=c.dir=l,c;t=3}}t>0&&(c.root=l.slice(0,t));let o=-1,a=t,s=-1,g=!0,C=l.length-1,R=0;for(;C>=t;--C){if(i=l.charCodeAt(C),u(i)){if(!g){a=C+1;break}continue}s===-1&&(g=!1,s=C+1),i===L?o===-1?o=C:R!==1&&(R=1):o!==-1&&(R=-1)}return s!==-1&&(o===-1||R===0||R===1&&o===s-1&&o===a+1?c.base=c.name=l.slice(a,s):(c.name=l.slice(a,o),c.base=l.slice(a,s),c.ext=l.slice(o,s))),a>0&&a!==t?c.dir=l.slice(0,a-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let c="",r=!1;for(let t=l.length-1;t>=-1&&!r;t--){const i=t>=0?l[t]:S.cwd();E(i,"path"),i.length!==0&&(c=`${i}/${c}`,r=i.charCodeAt(0)===h)}return c=w(c,!r,"/",v),r?`/${c}`:c.length>0?c:"."},normalize(l){if(E(l,"path"),l.length===0)return".";const c=l.charCodeAt(0)===h,r=l.charCodeAt(l.length-1)===h;return l=w(l,!c,"/",v),l.length===0?c?"/":r?"./":".":(r&&(l+="/"),c?`/${l}`:l)},isAbsolute(l){return E(l,"path"),l.length>0&&l.charCodeAt(0)===h},join(...l){if(l.length===0)return".";let c;for(let r=0;r<l.length;++r){const t=l[r];E(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(l,c){if(E(l,"from"),E(c,"to"),l===c||(l=e.posix.resolve(l),c=e.posix.resolve(c),l===c))return"";const r=1,t=l.length,i=t-r,o=1,a=c.length-o,s=i<a?i:a;let g=-1,C=0;for(;C<s;C++){const p=l.charCodeAt(r+C);if(p!==c.charCodeAt(o+C))break;p===h&&(g=C)}if(C===s)if(a>s){if(c.charCodeAt(o+C)===h)return c.slice(o+C+1);if(C===0)return c.slice(o+C)}else i>s&&(l.charCodeAt(r+C)===h?g=C:C===0&&(g=0));let R="";for(C=r+g+1;C<=t;++C)(C===t||l.charCodeAt(C)===h)&&(R+=R.length===0?"..":"/..");return`${R}${c.slice(o+g)}`},toNamespacedPath(l){return l},dirname(l){if(E(l,"path"),l.length===0)return".";const c=l.charCodeAt(0)===h;let r=-1,t=!0;for(let i=l.length-1;i>=1;--i)if(l.charCodeAt(i)===h){if(!t){r=i;break}}else t=!1;return r===-1?c?"/":".":c&&r===1?"//":l.slice(0,r)},basename(l,c){c!==void 0&&E(c,"ext"),E(l,"path");let r=0,t=-1,i=!0,o;if(c!==void 0&&c.length>0&&c.length<=l.length){if(c===l)return"";let a=c.length-1,s=-1;for(o=l.length-1;o>=0;--o){const g=l.charCodeAt(o);if(g===h){if(!i){r=o+1;break}}else s===-1&&(i=!1,s=o+1),a>=0&&(g===c.charCodeAt(a)?--a==-1&&(t=o):(a=-1,t=s))}return r===t?t=s:t===-1&&(t=l.length),l.slice(r,t)}for(o=l.length-1;o>=0;--o)if(l.charCodeAt(o)===h){if(!i){r=o+1;break}}else t===-1&&(i=!1,t=o+1);return t===-1?"":l.slice(r,t)},extname(l){E(l,"path");let c=-1,r=0,t=-1,i=!0,o=0;for(let a=l.length-1;a>=0;--a){const s=l.charCodeAt(a);if(s===h){if(!i){r=a+1;break}continue}t===-1&&(i=!1,t=a+1),s===L?c===-1?c=a:o!==1&&(o=1):c!==-1&&(o=-1)}return c===-1||t===-1||o===0||o===1&&c===t-1&&c===r+1?"":l.slice(c,t)},format:m.bind(null,"/"),parse(l){E(l,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return c;const r=l.charCodeAt(0)===h;let t;r?(c.root="/",t=1):t=0;let i=-1,o=0,a=-1,s=!0,g=l.length-1,C=0;for(;g>=t;--g){const R=l.charCodeAt(g);if(R===h){if(!s){o=g+1;break}continue}a===-1&&(s=!1,a=g+1),R===L?i===-1?i=g:C!==1&&(C=1):i!==-1&&(C=-1)}if(a!==-1){const R=o===0&&r?1:o;i===-1||C===0||C===1&&i===a-1&&i===o+1?c.base=c.name=l.slice(R,a):(c.name=l.slice(R,i),c.base=l.slice(R,a),c.ext=l.slice(i,a))}return o>0?c.dir=l.slice(0,o-1):r&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=S.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=S.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=S.platform==="win32"?e.win32.join:e.posix.join,e.resolve=S.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=S.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=S.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=S.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=S.platform==="win32"?e.win32.extname:e.posix.extname,e.format=S.platform==="win32"?e.win32.format:e.posix.format,e.parse=S.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=S.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=S.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=S.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(fe[110],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var S;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(S=e.Source||(e.Source={}));var d;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(d=e.TerminateResponseCode||(e.TerminateResponseCode={}));function P(y,...k){const L=k.reduce((D,b)=>(D[b]=!0,D),{}),h=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(D=>!L[D]).forEach(D=>{for(let b=0;b<h.length;b++)if(D.search(h[b])!==-1){delete y[D];break}})}e.sanitizeProcessEnvironment=P}),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var d in S)(typeof exports=="object"?exports:Q)[d]=S[d]}}(typeof self!="undefined"?self:this,function(){return function(Q){var e={};function S(d){if(e[d])return e[d].exports;var P=e[d]={i:d,l:!1,exports:{}};return Q[d].call(P.exports,P,P.exports,S),P.l=!0,P.exports}return S.m=Q,S.c=e,S.d=function(d,P,y){S.o(d,P)||Object.defineProperty(d,P,{enumerable:!0,get:y})},S.r=function(d){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(d,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(d,"__esModule",{value:!0})},S.t=function(d,P){if(1&P&&(d=S(d)),8&P||4&P&&typeof d=="object"&&d&&d.__esModule)return d;var y=Object.create(null);if(S.r(y),Object.defineProperty(y,"default",{enumerable:!0,value:d}),2&P&&typeof d!="string")for(var k in d)S.d(y,k,function(L){return d[L]}.bind(null,k));return y},S.n=function(d){var P=d&&d.__esModule?function(){return d.default}:function(){return d};return S.d(P,"a",P),P},S.o=function(d,P){return Object.prototype.hasOwnProperty.call(d,P)},S.p="",S(S.s=0)}([function(Q,e,S){(function(d){var P;e=Q.exports=ce,P=typeof d=="object"&&d.env&&d.env.NODE_DEBUG&&/\bsemver\b/i.test(d.env.NODE_DEBUG)?function(){var re=Array.prototype.slice.call(arguments,0);re.unshift("SEMVER"),console.log.apply(console,re)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var y=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,L=e.re=[],h=e.src=[],n=0,D=n++;h[D]="0|[1-9]\\d*";var b=n++;h[b]="[0-9]+";var I=n++;h[I]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=n++;h[E]="("+h[D]+")\\.("+h[D]+")\\.("+h[D]+")";var u=n++;h[u]="("+h[b]+")\\.("+h[b]+")\\.("+h[b]+")";var v=n++;h[v]="(?:"+h[D]+"|"+h[I]+")";var _=n++;h[_]="(?:"+h[b]+"|"+h[I]+")";var w=n++;h[w]="(?:-("+h[v]+"(?:\\."+h[v]+")*))";var m=n++;h[m]="(?:-?("+h[_]+"(?:\\."+h[_]+")*))";var l=n++;h[l]="[0-9A-Za-z-]+";var c=n++;h[c]="(?:\\+("+h[l]+"(?:\\."+h[l]+")*))";var r=n++,t="v?"+h[E]+h[w]+"?"+h[c]+"?";h[r]="^"+t+"$";var i="[v=\\s]*"+h[u]+h[m]+"?"+h[c]+"?",o=n++;h[o]="^"+i+"$";var a=n++;h[a]="((?:<|>)?=?)";var s=n++;h[s]=h[b]+"|x|X|\\*";var g=n++;h[g]=h[D]+"|x|X|\\*";var C=n++;h[C]="[v=\\s]*("+h[g]+")(?:\\.("+h[g]+")(?:\\.("+h[g]+")(?:"+h[w]+")?"+h[c]+"?)?)?";var R=n++;h[R]="[v=\\s]*("+h[s]+")(?:\\.("+h[s]+")(?:\\.("+h[s]+")(?:"+h[m]+")?"+h[c]+"?)?)?";var p=n++;h[p]="^"+h[a]+"\\s*"+h[C]+"$";var f=n++;h[f]="^"+h[a]+"\\s*"+h[R]+"$";var T=n++;h[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=n++;h[O]="(?:~>?)";var H=n++;h[H]="(\\s*)"+h[O]+"\\s+",L[H]=new RegExp(h[H],"g");var $=n++;h[$]="^"+h[O]+h[C]+"$";var x=n++;h[x]="^"+h[O]+h[R]+"$";var J=n++;h[J]="(?:\\^)";var Ee=n++;h[Ee]="(\\s*)"+h[J]+"\\s+",L[Ee]=new RegExp(h[Ee],"g");var ve=n++;h[ve]="^"+h[J]+h[C]+"$";var q=n++;h[q]="^"+h[J]+h[R]+"$";var j=n++;h[j]="^"+h[a]+"\\s*("+i+")$|^$";var F=n++;h[F]="^"+h[a]+"\\s*("+t+")$|^$";var A=n++;h[A]="(\\s*)"+h[a]+"\\s*("+i+"|"+h[C]+")",L[A]=new RegExp(h[A],"g");var M=n++;h[M]="^\\s*("+h[C]+")\\s+-\\s+("+h[C]+")\\s*$";var U=n++;h[U]="^\\s*("+h[R]+")\\s+-\\s+("+h[R]+")\\s*$";var W=n++;h[W]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)P(ne,h[ne]),L[ne]||(L[ne]=new RegExp(h[ne]));function ae(re,ge){if(re instanceof ce)return re;if(typeof re!="string"||re.length>y||!(ge?L[o]:L[r]).test(re))return null;try{return new ce(re,ge)}catch(me){return null}}function ce(re,ge){if(re instanceof ce){if(re.loose===ge)return re;re=re.version}else if(typeof re!="string")throw new TypeError("Invalid Version: "+re);if(re.length>y)throw new TypeError("version is longer than "+y+" characters");if(!(this instanceof ce))return new ce(re,ge);P("SemVer",re,ge),this.loose=ge;var me=re.trim().match(ge?L[o]:L[r]);if(!me)throw new TypeError("Invalid Version: "+re);if(this.raw=re,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Fe){if(/^[0-9]+$/.test(Fe)){var z=+Fe;if(z>=0&&z<k)return z}return Fe}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=ae,e.valid=function(re,ge){var me=ae(re,ge);return me?me.version:null},e.clean=function(re,ge){var me=ae(re.trim().replace(/^[=v]+/,""),ge);return me?me.version:null},e.SemVer=ce,ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ce.prototype.toString=function(){return this.version},ce.prototype.compare=function(re){return P("SemVer.compare",this.version,this.loose,re),re instanceof ce||(re=new ce(re,this.loose)),this.compareMain(re)||this.comparePre(re)},ce.prototype.compareMain=function(re){return re instanceof ce||(re=new ce(re,this.loose)),Pe(this.major,re.major)||Pe(this.minor,re.minor)||Pe(this.patch,re.patch)},ce.prototype.comparePre=function(re){if(re instanceof ce||(re=new ce(re,this.loose)),this.prerelease.length&&!re.prerelease.length)return-1;if(!this.prerelease.length&&re.prerelease.length)return 1;if(!this.prerelease.length&&!re.prerelease.length)return 0;var ge=0;do{var me=this.prerelease[ge],Fe=re.prerelease[ge];if(P("prerelease compare",ge,me,Fe),me===void 0&&Fe===void 0)return 0;if(Fe===void 0)return 1;if(me===void 0)return-1;if(me!==Fe)return Pe(me,Fe)}while(++ge)},ce.prototype.inc=function(re,ge){switch(re){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+re)}return this.format(),this.raw=this.version,this},e.inc=function(re,ge,me,Fe){typeof me=="string"&&(Fe=me,me=void 0);try{return new ce(re,me).inc(ge,Fe).version}catch(z){return null}},e.diff=function(re,ge){if($e(re,ge))return null;var me=ae(re),Fe=ae(ge);if(me.prerelease.length||Fe.prerelease.length){for(var z in me)if((z==="major"||z==="minor"||z==="patch")&&me[z]!==Fe[z])return"pre"+z;return"prerelease"}for(var z in me)if((z==="major"||z==="minor"||z==="patch")&&me[z]!==Fe[z])return z},e.compareIdentifiers=Pe;var de=/^[0-9]+$/;function Pe(re,ge){var me=de.test(re),Fe=de.test(ge);return me&&Fe&&(re=+re,ge=+ge),me&&!Fe?-1:Fe&&!me?1:re<ge?-1:re>ge?1:0}function Te(re,ge,me){return new ce(re,me).compare(new ce(ge,me))}function Me(re,ge,me){return Te(re,ge,me)>0}function je(re,ge,me){return Te(re,ge,me)<0}function $e(re,ge,me){return Te(re,ge,me)===0}function Ye(re,ge,me){return Te(re,ge,me)!==0}function et(re,ge,me){return Te(re,ge,me)>=0}function Je(re,ge,me){return Te(re,ge,me)<=0}function we(re,ge,me,Fe){var z;switch(ge){case"===":typeof re=="object"&&(re=re.version),typeof me=="object"&&(me=me.version),z=re===me;break;case"!==":typeof re=="object"&&(re=re.version),typeof me=="object"&&(me=me.version),z=re!==me;break;case"":case"=":case"==":z=$e(re,me,Fe);break;case"!=":z=Ye(re,me,Fe);break;case">":z=Me(re,me,Fe);break;case">=":z=et(re,me,Fe);break;case"<":z=je(re,me,Fe);break;case"<=":z=Je(re,me,Fe);break;default:throw new TypeError("Invalid operator: "+ge)}return z}function Se(re,ge){if(re instanceof Se){if(re.loose===ge)return re;re=re.value}if(!(this instanceof Se))return new Se(re,ge);P("comparator",re,ge),this.loose=ge,this.parse(re),this.semver===Ce?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(re,ge){return Pe(ge,re)},e.major=function(re,ge){return new ce(re,ge).major},e.minor=function(re,ge){return new ce(re,ge).minor},e.patch=function(re,ge){return new ce(re,ge).patch},e.compare=Te,e.compareLoose=function(re,ge){return Te(re,ge,!0)},e.rcompare=function(re,ge,me){return Te(ge,re,me)},e.sort=function(re,ge){return re.sort(function(me,Fe){return e.compare(me,Fe,ge)})},e.rsort=function(re,ge){return re.sort(function(me,Fe){return e.rcompare(me,Fe,ge)})},e.gt=Me,e.lt=je,e.eq=$e,e.neq=Ye,e.gte=et,e.lte=Je,e.cmp=we,e.Comparator=Se;var Ce={};function ke(re,ge){if(re instanceof ke)return re.loose===ge?re:new ke(re.raw,ge);if(re instanceof Se)return new ke(re.value,ge);if(!(this instanceof ke))return new ke(re,ge);if(this.loose=ge,this.raw=re,this.set=re.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+re);this.format()}function Le(re){return!re||re.toLowerCase()==="x"||re==="*"}function ze(re,ge,me,Fe,z,X,ee,V,K,te,ie,ue,De){return((ge=Le(me)?"":Le(Fe)?">="+me+".0.0":Le(z)?">="+me+"."+Fe+".0":">="+ge)+" "+(V=Le(K)?"":Le(te)?"<"+(+K+1)+".0.0":Le(ie)?"<"+K+"."+(+te+1)+".0":ue?"<="+K+"."+te+"."+ie+"-"+ue:"<="+V)).trim()}function He(re,ge){for(var me=0;me<re.length;me++)if(!re[me].test(ge))return!1;if(ge.prerelease.length){for(me=0;me<re.length;me++)if(P(re[me].semver),re[me].semver!==Ce&&re[me].semver.prerelease.length>0){var Fe=re[me].semver;if(Fe.major===ge.major&&Fe.minor===ge.minor&&Fe.patch===ge.patch)return!0}return!1}return!0}function Ve(re,ge,me){try{ge=new ke(ge,me)}catch(Fe){return!1}return ge.test(re)}function Qe(re,ge,me,Fe){var z,X,ee,V,K;switch(re=new ce(re,Fe),ge=new ke(ge,Fe),me){case">":z=Me,X=Je,ee=je,V=">",K=">=";break;case"<":z=je,X=et,ee=Me,V="<",K="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ve(re,ge,Fe))return!1;for(var te=0;te<ge.set.length;++te){var ie=ge.set[te],ue=null,De=null;if(ie.forEach(function(le){le.semver===Ce&&(le=new Se(">=0.0.0")),ue=ue||le,De=De||le,z(le.semver,ue.semver,Fe)?ue=le:ee(le.semver,De.semver,Fe)&&(De=le)}),ue.operator===V||ue.operator===K||(!De.operator||De.operator===V)&&X(re,De.semver)||De.operator===K&&ee(re,De.semver))return!1}return!0}Se.prototype.parse=function(re){var ge=this.loose?L[j]:L[F],me=re.match(ge);if(!me)throw new TypeError("Invalid comparator: "+re);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new ce(me[2],this.loose):this.semver=Ce},Se.prototype.toString=function(){return this.value},Se.prototype.test=function(re){return P("Comparator.test",re,this.loose),this.semver===Ce||(typeof re=="string"&&(re=new ce(re,this.loose)),we(re,this.operator,this.semver,this.loose))},Se.prototype.intersects=function(re,ge){if(!(re instanceof Se))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new ke(re.value,ge),Ve(this.value,me,ge);if(re.operator==="")return me=new ke(this.value,ge),Ve(re.semver,me,ge);var Fe=!(this.operator!==">="&&this.operator!==">"||re.operator!==">="&&re.operator!==">"),z=!(this.operator!=="<="&&this.operator!=="<"||re.operator!=="<="&&re.operator!=="<"),X=this.semver.version===re.semver.version,ee=!(this.operator!==">="&&this.operator!=="<="||re.operator!==">="&&re.operator!=="<="),V=we(this.semver,"<",re.semver,ge)&&(this.operator===">="||this.operator===">")&&(re.operator==="<="||re.operator==="<"),K=we(this.semver,">",re.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(re.operator===">="||re.operator===">");return Fe||z||X&&ee||V||K},e.Range=ke,ke.prototype.format=function(){return this.range=this.set.map(function(re){return re.join(" ").trim()}).join("||").trim(),this.range},ke.prototype.toString=function(){return this.range},ke.prototype.parseRange=function(re){var ge=this.loose;re=re.trim(),P("range",re,ge);var me=ge?L[U]:L[M];re=re.replace(me,ze),P("hyphen replace",re),re=re.replace(L[A],"$1$2$3"),P("comparator trim",re,L[A]),re=(re=(re=re.replace(L[H],"$1~")).replace(L[Ee],"$1^")).split(/\s+/).join(" ");var Fe=ge?L[j]:L[F],z=re.split(" ").map(function(X){return function(ee,V){return P("comp",ee),ee=function(K,te){return K.trim().split(/\s+/).map(function(ie){return function(ue,De){P("caret",ue,De);var le=De?L[q]:L[ve];return ue.replace(le,function(ye,be,Ae,se,oe){var Y;return P("caret",ue,ye,be,Ae,se,oe),Le(be)?Y="":Le(Ae)?Y=">="+be+".0.0 <"+(+be+1)+".0.0":Le(se)?Y=be==="0"?">="+be+"."+Ae+".0 <"+be+"."+(+Ae+1)+".0":">="+be+"."+Ae+".0 <"+(+be+1)+".0.0":oe?(P("replaceCaret pr",oe),oe.charAt(0)!=="-"&&(oe="-"+oe),Y=be==="0"?Ae==="0"?">="+be+"."+Ae+"."+se+oe+" <"+be+"."+Ae+"."+(+se+1):">="+be+"."+Ae+"."+se+oe+" <"+be+"."+(+Ae+1)+".0":">="+be+"."+Ae+"."+se+oe+" <"+(+be+1)+".0.0"):(P("no pr"),Y=be==="0"?Ae==="0"?">="+be+"."+Ae+"."+se+" <"+be+"."+Ae+"."+(+se+1):">="+be+"."+Ae+"."+se+" <"+be+"."+(+Ae+1)+".0":">="+be+"."+Ae+"."+se+" <"+(+be+1)+".0.0"),P("caret return",Y),Y})}(ie,te)}).join(" ")}(ee,V),P("caret",ee),ee=function(K,te){return K.trim().split(/\s+/).map(function(ie){return function(ue,De){var le=De?L[x]:L[$];return ue.replace(le,function(ye,be,Ae,se,oe){var Y;return P("tilde",ue,ye,be,Ae,se,oe),Le(be)?Y="":Le(Ae)?Y=">="+be+".0.0 <"+(+be+1)+".0.0":Le(se)?Y=">="+be+"."+Ae+".0 <"+be+"."+(+Ae+1)+".0":oe?(P("replaceTilde pr",oe),oe.charAt(0)!=="-"&&(oe="-"+oe),Y=">="+be+"."+Ae+"."+se+oe+" <"+be+"."+(+Ae+1)+".0"):Y=">="+be+"."+Ae+"."+se+" <"+be+"."+(+Ae+1)+".0",P("tilde return",Y),Y})}(ie,te)}).join(" ")}(ee,V),P("tildes",ee),ee=function(K,te){return P("replaceXRanges",K,te),K.split(/\s+/).map(function(ie){return function(ue,De){ue=ue.trim();var le=De?L[f]:L[p];return ue.replace(le,function(ye,be,Ae,se,oe,Y){P("xRange",ue,ye,be,Ae,se,oe,Y);var G=Le(Ae),_e=G||Le(se),Ie=_e||Le(oe);return be==="="&&Ie&&(be=""),G?ye=be===">"||be==="<"?"<0.0.0":"*":be&&Ie?(_e&&(se=0),Ie&&(oe=0),be===">"?(be=">=",_e?(Ae=+Ae+1,se=0,oe=0):Ie&&(se=+se+1,oe=0)):be==="<="&&(be="<",_e?Ae=+Ae+1:se=+se+1),ye=be+Ae+"."+se+"."+oe):_e?ye=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":Ie&&(ye=">="+Ae+"."+se+".0 <"+Ae+"."+(+se+1)+".0"),P("xRange return",ye),ye})}(ie,te)}).join(" ")}(ee,V),P("xrange",ee),ee=function(K,te){return P("replaceStars",K,te),K.trim().replace(L[W],"")}(ee,V),P("stars",ee),ee}(X,ge)}).join(" ").split(/\s+/);return this.loose&&(z=z.filter(function(X){return!!X.match(Fe)})),z=z.map(function(X){return new Se(X,ge)})},ke.prototype.intersects=function(re,ge){if(!(re instanceof ke))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Fe){return re.set.some(function(z){return z.every(function(X){return Fe.intersects(X,ge)})})})})},e.toComparators=function(re,ge){return new ke(re,ge).set.map(function(me){return me.map(function(Fe){return Fe.value}).join(" ").trim().split(" ")})},ke.prototype.test=function(re){if(!re)return!1;typeof re=="string"&&(re=new ce(re,this.loose));for(var ge=0;ge<this.set.length;ge++)if(He(this.set[ge],re))return!0;return!1},e.satisfies=Ve,e.maxSatisfying=function(re,ge,me){var Fe=null,z=null;try{var X=new ke(ge,me)}catch(ee){return null}return re.forEach(function(ee){X.test(ee)&&(Fe&&z.compare(ee)!==-1||(z=new ce(Fe=ee,me)))}),Fe},e.minSatisfying=function(re,ge,me){var Fe=null,z=null;try{var X=new ke(ge,me)}catch(ee){return null}return re.forEach(function(ee){X.test(ee)&&(Fe&&z.compare(ee)!==1||(z=new ce(Fe=ee,me)))}),Fe},e.validRange=function(re,ge){try{return new ke(re,ge).range||"*"}catch(me){return null}},e.ltr=function(re,ge,me){return Qe(re,ge,"<",me)},e.gtr=function(re,ge,me){return Qe(re,ge,">",me)},e.outside=Qe,e.prerelease=function(re,ge){var me=ae(re,ge);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(re,ge,me){return re=new ke(re,me),ge=new ke(ge,me),re.intersects(ge)},e.coerce=function(re){if(re instanceof ce)return re;if(typeof re!="string")return null;var ge=re.match(L[T]);return ge==null?null:ae((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,S(1))},function(Q,e){var S,d,P=Q.exports={};function y(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function L(_){if(S===setTimeout)return setTimeout(_,0);if((S===y||!S)&&setTimeout)return S=setTimeout,setTimeout(_,0);try{return S(_,0)}catch(w){try{return S.call(null,_,0)}catch(m){return S.call(this,_,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:y}catch(_){S=y}try{d=typeof clearTimeout=="function"?clearTimeout:k}catch(_){d=k}})();var h,n=[],D=!1,b=-1;function I(){D&&h&&(D=!1,h.length?n=h.concat(n):b=-1,n.length&&E())}function E(){if(!D){var _=L(I);D=!0;for(var w=n.length;w;){for(h=n,n=[];++b<w;)h&&h[b].run();b=-1,w=n.length}h=null,D=!1,function(m){if(d===clearTimeout)return clearTimeout(m);if((d===k||!d)&&clearTimeout)return d=clearTimeout,clearTimeout(m);try{d(m)}catch(l){try{return d.call(null,m)}catch(c){return d.call(this,m)}}}(_)}}function u(_,w){this.fun=_,this.array=w}function v(){}P.nextTick=function(_){var w=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)w[m-1]=arguments[m];n.push(new u(_,w)),n.length!==1||D||L(E)},u.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=v,P.addListener=v,P.once=v,P.off=v,P.removeListener=v,P.removeAllListeners=v,P.emit=v,P.prependListener=v,P.prependOnceListener=v,P.listeners=function(_){return[]},P.binding=function(_){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(_){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(fe[111],he([0,1,5]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const d=S.globals.performance&&typeof S.globals.performance.now=="function";class P{constructor(k){this._highResolution=d&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new P(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?S.globals.performance.now():Date.now()}}e.StopWatch=P}),define(fe[6],he([0,1,12,68,4,69,111]),function(Q,e,S,d,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var L;(function(w){w.None=()=>P.Disposable.None;function m(x){return(J,Ee=null,ve)=>{let q=!1,j;return j=x(F=>{if(!q)return j?j.dispose():q=!0,J.call(Ee,F)},null,ve),q&&j.dispose(),j}}w.once=m;function l(x,J){return a((Ee,ve=null,q)=>x(j=>Ee.call(ve,J(j)),null,q))}w.map=l;function c(x,J){return a((Ee,ve=null,q)=>x(j=>{J(j),Ee.call(ve,j)},null,q))}w.forEach=c;function r(x,J){return a((Ee,ve=null,q)=>x(j=>J(j)&&Ee.call(ve,j),null,q))}w.filter=r;function t(x){return x}w.signal=t;function i(...x){return(J,Ee=null,ve)=>P.combinedDisposable(...x.map(q=>q(j=>J.call(Ee,j),null,ve)))}w.any=i;function o(x,J,Ee){let ve=Ee;return l(x,q=>(ve=J(ve,q),ve))}w.reduce=o;function a(x){let J;const Ee=new I({onFirstListenerAdd(){J=x(Ee.fire,Ee)},onLastListenerRemove(){J.dispose()}});return Ee.event}w.snapshot=a;function s(x,J,Ee=100,ve=!1,q){let j,F,A,M=0;const U=new I({leakWarningThreshold:q,onFirstListenerAdd(){j=x(W=>{M++,F=J(F,W),ve&&!A&&(U.fire(F),F=void 0),clearTimeout(A),A=setTimeout(()=>{const ne=F;F=void 0,A=void 0,(!ve||M>1)&&U.fire(ne),M=0},Ee)})},onLastListenerRemove(){j.dispose()}});return U.event}w.debounce=s;function g(x){const J=new Date().getTime();return l(m(x),Ee=>new Date().getTime()-J)}w.stopwatch=g;function C(x){let J=!0,Ee;return r(x,ve=>{const q=J||ve!==Ee;return J=!1,Ee=ve,q})}w.latch=C;function R(x,J=!1,Ee=[]){let ve=Ee.slice(),q=x(A=>{ve?ve.push(A):F.fire(A)});const j=()=>{ve&&ve.forEach(A=>F.fire(A)),ve=null},F=new I({onFirstListenerAdd(){q||(q=x(A=>F.fire(A)))},onFirstListenerDidAdd(){ve&&(J?setTimeout(j):j())},onLastListenerRemove(){q&&q.dispose(),q=null}});return F.event}w.buffer=R;class p{constructor(J){this.event=J}map(J){return new p(l(this.event,J))}forEach(J){return new p(c(this.event,J))}filter(J){return new p(r(this.event,J))}reduce(J,Ee){return new p(o(this.event,J,Ee))}latch(){return new p(C(this.event))}debounce(J,Ee=100,ve=!1,q){return new p(s(this.event,J,Ee,ve,q))}on(J,Ee,ve){return this.event(J,Ee,ve)}once(J,Ee,ve){return m(this.event)(J,Ee,ve)}}function f(x){return new p(x)}w.chain=f;function T(x,J,Ee=ve=>ve){const ve=(...A)=>F.fire(Ee(...A)),q=()=>x.on(J,ve),j=()=>x.removeListener(J,ve),F=new I({onFirstListenerAdd:q,onLastListenerRemove:j});return F.event}w.fromNodeEventEmitter=T;function O(x,J,Ee=ve=>ve){const ve=(...A)=>F.fire(Ee(...A)),q=()=>x.addEventListener(J,ve),j=()=>x.removeEventListener(J,ve),F=new I({onFirstListenerAdd:q,onLastListenerRemove:j});return F.event}w.fromDOMEventEmitter=O;function H(x){const J=new I;let Ee=!1;return x.then(void 0,()=>null).then(()=>{Ee?J.fire(void 0):setTimeout(()=>J.fire(void 0),0)}),Ee=!0,J.event}w.fromPromise=H;function $(x){return new Promise(J=>m(x)(J))}w.toPromise=$})(L=e.Event||(e.Event={}));class h{constructor(m){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${m}_${h._idPool++}`}start(m){this._stopWatch=new k.StopWatch(!0),this._listenerCount=m}stop(){if(this._stopWatch){const m=this._stopWatch.elapsed();this._elapsedOverall+=m,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${m.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}h._idPool=0;let n=-1;function D(w){const m=n;return n=w,{dispose(){n=m}}}e.setGlobalLeakWarningThreshold=D;class b{constructor(m,l=Math.random().toString(18).slice(2,5)){this.customThreshold=m,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(m){let l=n;if(typeof this.customThreshold=="number"&&(l=this.customThreshold),!(l<=0||m<l)){this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(c)||0;if(this._stacks.set(c,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=l*.5;let t,i=0;for(const[o,a]of this._stacks)(!t||i<a)&&(t=o,i=a);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(c)||0;this._stacks.set(c,t-1)}}}}class I{constructor(m){var l;this._disposed=!1,this._options=m,this._leakageMon=n>0?new b(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((l=this._options)===null||l===void 0?void 0:l._profName)?new h(this._options._profName):void 0}get event(){return this._event||(this._event=(m,l,c)=>{var r;this._listeners||(this._listeners=new y.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(l?[m,l]:m);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,m,l);const o=(r=this._leakageMon)===null||r===void 0?void 0:r.check(this._listeners.size);let a;return a={dispose:()=>{o&&o(),a.dispose=I._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},c instanceof P.DisposableStore?c.add(a):Array.isArray(c)&&c.push(a),a}),this._event}fire(m){var l,c;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,m]);for((l=this._perfMon)===null||l===void 0||l.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,t]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,t):r[0].call(r[1],t)}catch(i){S.onUnexpectedError(i)}}(c=this._perfMon)===null||c===void 0||c.stop()}}dispose(){var m,l,c;(m=this._listeners)===null||m===void 0||m.clear(),(l=this._deliveryQueue)===null||l===void 0||l.clear(),(c=this._leakageMon)===null||c===void 0||c.dispose(),this._disposed=!0}}e.Emitter=I,I._noop=function(){};class E extends I{constructor(m){super(m);this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=m==null?void 0:m.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const m=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(m))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(m){this._listeners&&(this._isPaused!==0?this._eventQueue.push(m):super.fire(m))}}e.PauseableEmitter=E;class u{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new I({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(m){const l={event:m,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const c=()=>{this.hasListeners&&this.unhook(l);const r=this.events.indexOf(l);this.events.splice(r,1)};return P.toDisposable(d.once(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(m=>this.hook(m))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(m=>this.unhook(m))}hook(m){m.listener=m.event(l=>this.emitter.fire(l))}unhook(m){m.listener&&m.listener.dispose(),m.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=u;class v{constructor(){this.buffers=[]}wrapEvent(m){return(l,c,r)=>m(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>l.call(c,t)):l.call(c,t)},void 0,r)}bufferEvents(m){const l=[];this.buffers.push(l);const c=m();return this.buffers.pop(),l.forEach(r=>r()),c}}e.EventBufferer=v;class _{constructor(){this.listening=!1,this.inputEvent=L.None,this.inputEventListener=P.Disposable.None,this.emitter=new I({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(m){this.inputEvent=m,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=m(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=_}),define(fe[27],he([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const d=Object.freeze(function(L,h){const n=setTimeout(L.bind(h),0);return{dispose(){clearTimeout(n)}}});var P;(function(L){function h(n){return n===L.None||n===L.Cancelled||n instanceof y?!0:!n||typeof n!="object"?!1:typeof n.isCancellationRequested=="boolean"&&typeof n.onCancellationRequested=="function"}L.isCancellationToken=h,L.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),L.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:d})})(P=e.CancellationToken||(e.CancellationToken={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?d:(this._emitter||(this._emitter=new S.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(h){this._token=void 0,this._parentListener=void 0,this._parentListener=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=P.Cancelled}dispose(h=!1){h&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=P.None}}e.CancellationTokenSource=k}),define(fe[13],he([0,1,27,12,6,4,69]),function(Q,e,S,d,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function L(q){return!!q&&typeof q.then=="function"}e.isThenable=L;function h(q){const j=new S.CancellationTokenSource,F=q(j.token),A=new Promise((M,U)=>{j.token.onCancellationRequested(()=>{U(d.canceled())}),Promise.resolve(F).then(W=>{j.dispose(),M(W)},W=>{j.dispose(),U(W)})});return new class{cancel(){j.cancel()}then(M,U){return A.then(M,U)}catch(M){return this.then(void 0,M)}finally(M){return A.finally(M)}}}e.createCancelablePromise=h;function n(q,j,F){return Promise.race([q,new Promise(A=>j.onCancellationRequested(()=>A(F)))])}e.raceCancellation=n;async function D(q){let j=-1;const F=q.map((M,U)=>M.then(W=>(j=U,W))),A=await Promise.race(F);return q.forEach((M,U)=>{U!==j&&M.cancel()}),A}e.raceCancellablePromises=D;function b(q,j,F){let A;const M=setTimeout(()=>{A==null||A(void 0),F==null||F()},j);return Promise.race([q.finally(()=>clearTimeout(M)),new Promise(U=>A=U)])}e.raceTimeout=b;function I(q){return new Promise((j,F)=>{const A=q();L(A)?A.then(j,F):j(A)})}e.asPromise=I;class E{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(j){if(this.activePromise){if(this.queuedPromiseFactory=j,!this.queuedPromise){const F=()=>{this.queuedPromise=null;const A=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,A};this.queuedPromise=new Promise(A=>{this.activePromise.then(F,F).then(A)})}return new Promise((F,A)=>{this.queuedPromise.then(F,A)})}return this.activePromise=j(),new Promise((F,A)=>{this.activePromise.then(M=>{this.activePromise=null,F(M)},M=>{this.activePromise=null,A(M)})})}}e.Throttler=E;class u{constructor(){this.current=Promise.resolve(null)}queue(j){return this.current=this.current.then(()=>j(),()=>j())}}e.Sequencer=u;class v{constructor(){this.promiseMap=new Map}queue(j,F){var A;const U=((A=this.promiseMap.get(j))!==null&&A!==void 0?A:Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.promiseMap.get(j)===U&&this.promiseMap.delete(j)});return this.promiseMap.set(j,U),U}}e.SequencerByKey=v;class _{constructor(j){this.defaultDelay=j,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(j,F=this.defaultDelay){return this.task=j,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((A,M)=>{this.doResolve=A,this.doReject=M}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const A=this.task;return this.task=null,A()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},F),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(d.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=_;class w{constructor(j){this.delayer=new _(j),this.throttler=new E}trigger(j,F){return this.delayer.trigger(()=>this.throttler.queue(j),F)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class m{constructor(){this._isOpen=!1,this._promise=new Promise((j,F)=>{this._completePromise=j})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=m;class l extends m{constructor(j){super();this._timeout=setTimeout(()=>this.open(),j)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function c(q,j){return j?new Promise((F,A)=>{const M=setTimeout(F,q);j.onCancellationRequested(()=>{clearTimeout(M),A(d.canceled())})}):h(F=>c(q,F))}e.timeout=c;function r(q,j=0){const F=setTimeout(q,j);return y.toDisposable(()=>clearTimeout(F))}e.disposableTimeout=r;function t(q){return q.then(void 0,j=>{})}e.ignoreErrors=t;function i(q){const j=[];let F=0;const A=q.length;function M(){return F<A?q[F++]():null}function U(W){W!=null&&j.push(W);const ne=M();return ne?ne.then(U):Promise.resolve(j)}return Promise.resolve(null).then(U)}e.sequence=i;function o(q,j=A=>!!A,F=null){let A=0;const M=q.length,U=()=>{if(A>=M)return Promise.resolve(F);const W=q[A++];return Promise.resolve(W()).then(ae=>j(ae)?Promise.resolve(ae):U())};return U()}e.first=o;function a(q,j=A=>!!A,F=null){if(q.length===0)return Promise.resolve(F);let A=q.length;const M=()=>{var U,W;A=-1;for(const ne of q)(W=(U=ne).cancel)===null||W===void 0||W.call(U)};return new Promise((U,W)=>{for(const ne of q)ne.then(ae=>{--A>=0&&j(ae)?(M(),U(ae)):A===0&&U(F)}).catch(ae=>{--A>=0&&(M(),W(ae))})})}e.firstParallel=a;class s{constructor(j){this._size=0,this.maxDegreeOfParalellism=j,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new P.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(j){return this._size++,new Promise((F,A)=>{this.outstandingPromises.push({factory:j,c:F,e:A}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const j=this.outstandingPromises.shift();this.runningPromises++;const F=j.factory();F.then(j.c,j.e),F.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class g extends s{constructor(){super(1)}}e.Queue=g;class C{constructor(){this.queues=new Map}queueFor(j){const F=j.toString();if(!this.queues.has(F)){const A=new g;A.onFinished(()=>{A.dispose(),this.queues.delete(F)}),this.queues.set(F,A)}return this.queues.get(F)}dispose(){this.queues.forEach(j=>j.dispose()),this.queues.clear()}}e.ResourceQueue=C;class R{constructor(j,F){this._token=-1,typeof j=="function"&&typeof F=="number"&&this.setIfNotSet(j,F)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(j,F){this.cancel(),this._token=setTimeout(()=>{this._token=-1,j()},F)}setIfNotSet(j,F){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,j()},F))}}e.TimeoutTimer=R;class p{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(j,F){this.cancel(),this._token=setInterval(()=>{j()},F)}}e.IntervalTimer=p;class f{constructor(j,F){this.timeoutToken=-1,this.runner=j,this.timeout=F,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(j=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,j)}get delay(){return this.timeout}set delay(j){this.timeout=j}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=f;class T extends f{constructor(j,F){super(j,F);this.units=[]}work(j){this.units.push(j),this.isScheduled()||this.schedule()}doRun(){const j=this.units;this.units=[],this.runner&&this.runner(j)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=T,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const q=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=j=>{const F=setTimeout(()=>j(q));let A=!1;return{dispose(){A||(A=!0,clearTimeout(F))}}}}else e.runWhenIdle=(q,j)=>{const F=requestIdleCallback(q,typeof j=="number"?{timeout:j}:void 0);let A=!1;return{dispose(){A||(A=!0,cancelIdleCallback(F))}}}}();class O{constructor(j){this._didRun=!1,this._executor=()=>{try{this._value=j()}catch(F){this._error=F}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=O;async function H(q,j,F){let A;for(let M=0;M<F;M++)try{return await q()}catch(U){A=U,await c(j)}throw A}e.retry=H;class ${hasPending(j){return this._pending?typeof j=="number"?this._pending.taskId===j:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var j;(j=this._pending)===null||j===void 0||j.cancel()}setPending(j,F,A){return this._pending={taskId:j,cancel:()=>A==null?void 0:A(),promise:F},F.then(()=>this.donePending(j),()=>this.donePending(j)),F}donePending(j){this._pending&&j===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const j=this._next;this._next=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}setNext(j){if(this._next)this._next.run=j;else{let F,A;const M=new Promise((U,W)=>{F=U,A=W});this._next={run:j,promise:M,promiseResolve:F,promiseReject:A}}return this._next.promise}}e.TaskSequentializer=$;class x{constructor(j){this.interval=j,this.lastIncrementTime=0,this.value=0}increment(){const j=Date.now();return j-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=j,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class J{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((j,F)=>{this.completeCallback=j,this.errorCallback=F})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(j){return new Promise(F=>{this.completeCallback(j),this.resolved=!0,F()})}error(j){return new Promise(F=>{this.errorCallback(j),this.rejected=!0,F()})}cancel(){new Promise(j=>{this.errorCallback(d.canceled()),this.rejected=!0,j()})}}e.DeferredPromise=J;class Ee extends P.Emitter{async fireAsync(j,F,A){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const M of this._listeners)this._asyncDeliveryQueue.push([M,j]);for(;this._asyncDeliveryQueue.size>0&&!F.isCancellationRequested;){const[M,U]=this._asyncDeliveryQueue.shift(),W=[],ne=Object.assign(Object.assign({},U),{waitUntil:ae=>{if(Object.isFrozen(W))throw new Error("waitUntil can NOT be called asynchronous");A&&(ae=A(ae,typeof M=="function"?M:M[0])),W.push(ae)}});try{typeof M=="function"?M.call(void 0,ne):M[0].call(M[1],ne)}catch(ae){d.onUnexpectedError(ae);continue}Object.freeze(W),await ve.settled(W).catch(ae=>d.onUnexpectedError(ae))}}}}e.AsyncEmitter=Ee;var ve;(function(q){async function j(U){return typeof Promise.allSettled=="function"?F(U):A(U)}q.allSettled=j;async function F(U){return Promise.allSettled(U)}async function A(U){return Promise.all(U.map(W=>W.then(ne=>({status:"fulfilled",value:ne}),ne=>({status:"rejected",reason:ne}))))}async function M(U){let W;const ne=await Promise.all(U.map(ae=>ae.then(ce=>ce,ce=>{W||(W=ce)})));if(typeof W!="undefined")throw W;return ne}q.settled=M})(ve=e.Promises||(e.Promises={}))}),define(fe[70],he([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class d{constructor(){this._icons=new Map,this._onDidRegister=new S.Emitter}add(D){const b=this._icons.get(D.id);b?D.description?b.description=D.description:console.error(`Duplicate registration of codicon ${D.id}`):(this._icons.set(D.id,D),this._onDidRegister.fire(D))}get(D){return this._icons.get(D)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const P=new d;e.iconRegistry=P;function y(n,D){return new k(n,D)}e.registerCodicon=y;class k{constructor(D,b,I){this.id=D,this.definition=b,this.description=I,P.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=k;function L(n,D){const b=["codicon","codicon-"+n];return D&&b.push("codicon-modifier-"+D),b}e.getClassNamesArray=L;var h;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const D=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function b(u){if(u instanceof k)return["codicon","codicon-"+u.id];const v=D.exec(u.id);if(!v)return b(k.error);let[,_,w]=v;const m=["codicon","codicon-"+_];return w&&m.push("codicon-modifier-"+w.substr(1)),m}n.asClassNameArray=b;function I(u){return b(u).join(" ")}n.asClassName=I;function E(u){return"."+b(u).join(".")}n.asCSSSelector=E})(h=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personAdd=new n("person-add",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(k=e.Codicon||(e.Codicon={}))}),define(fe[39],he([0,1,12,4]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function P(_){const w=_;return w&&[w.on,w.pause,w.resume,w.destroy].every(m=>typeof m=="function")}e.isReadableStream=P;function y(_){const w=_;return w&&P(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean"}e.isReadableBufferedStream=y;function k(_,w){return new L(_,w)}e.newWriteableStream=k;class L{constructor(w,m){this.reducer=w,this.options=m,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){var m;if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof((m=this.options)===null||m===void 0?void 0:m.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(w instanceof Error?this.error(w):typeof w!="undefined"&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(m=>m(w))}emitError(w){this.listeners.error.length===0?S.onUnexpectedError(w):this.listeners.error.slice(0).forEach(m=>m(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,m){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(m),this.resume();break;case"end":this.listeners.end.push(m),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(m),this.state.flowing&&this.flowErrors();break}}removeListener(w,m){if(!this.state.destroyed){let l;switch(w){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const c=l.indexOf(m);c>=0&&l.splice(c,1)}}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const m=[...this.pendingWritePromises];this.pendingWritePromises.length=0,m.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function h(_,w){const m=[];let l;for(;(l=_.read())!==null;)m.push(l);return w(m)}e.consumeReadable=h;function n(_,w,m){const l=[];let c;for(;(c=_.read())!==null&&l.length<m;)l.push(c);return c===null&&l.length>0?w(l):{read:()=>{if(l.length>0)return l.shift();if(typeof c!="undefined"){const r=c;return c=void 0,r}return _.read()}}}e.peekReadable=n;function D(_,w){return new Promise((m,l)=>{const c=[];b(_,{onData:r=>{w&&c.push(r)},onError:r=>{w?l(r):m(void 0)},onEnd:()=>{m(w?w(c):void 0)}})})}e.consumeStream=D;function b(_,w){_.on("error",m=>w.onError(m)),_.on("end",()=>w.onEnd()),_.on("data",m=>w.onData(m))}e.listenStream=b;function I(_,w){return new Promise((m,l)=>{const c=new d.DisposableStore,r=[],t=a=>{if(r.push(a),r.length>w)return c.dispose(),_.pause(),m({stream:_,buffer:r,ended:!1})},i=a=>l(a),o=()=>m({stream:_,buffer:r,ended:!0});c.add(d.toDisposable(()=>_.removeListener("error",i))),_.on("error",i),c.add(d.toDisposable(()=>_.removeListener("end",o))),_.on("end",o),c.add(d.toDisposable(()=>_.removeListener("data",t))),_.on("data",t)})}e.peekStream=I;function E(_,w){const m=k(w);return m.end(_),m}e.toStream=E;function u(_){let w=!1;return{read:()=>w?null:(w=!0,_)}}e.toReadable=u;function v(_,w,m){const l=k(m);return b(_,{onData:c=>l.write(w.data(c)),onError:c=>l.error(w.error?w.error(c):c),onEnd:()=>l.end()}),l}e.transform=v}),define(fe[14],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function S(z){return!z||typeof z!="string"?!0:z.trim().length===0}e.isFalsyOrWhitespace=S;const d=/{(\d+)}/g;function P(z,...X){return X.length===0?z:z.replace(d,function(ee,V){const K=parseInt(V,10);return isNaN(K)||K<0||K>=X.length?ee:X[K]})}e.format=P;function y(z){return z.replace(/[<>&]/g,function(X){switch(X){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return X}})}e.escape=y;function k(z){return z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function L(z,X){let ee=0;const V=X.charCodeAt(0);for(let K=z.length-1;K>=0;K--)z.charCodeAt(K)===V&&ee++;return ee}e.count=L;function h(z,X,ee="\u2026"){return z.length<=X?z:`${z.substr(0,X)}${ee}`}e.truncate=h;function n(z,X=" "){const ee=D(z,X);return b(ee,X)}e.trim=n;function D(z,X){if(!z||!X)return z;const ee=X.length;if(ee===0||z.length===0)return z;let V=0;for(;z.indexOf(X,V)===V;)V=V+ee;return z.substring(V)}e.ltrim=D;function b(z,X){if(!z||!X)return z;const ee=X.length,V=z.length;if(ee===0||V===0)return z;let K=V,te=-1;for(;te=z.lastIndexOf(X,K-1),!(te===-1||te+ee!==K);){if(te===0)return"";K=te}return z.substring(0,K)}e.rtrim=b;function I(z){return z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=I;function E(z){return z.replace(/\*/g,"")}e.stripWildcards=E;function u(z,X,ee={}){if(!z)throw new Error("Cannot create regex from empty string");X||(z=k(z)),ee.wholeWord&&(/\B/.test(z.charAt(0))||(z="\\b"+z),/\B/.test(z.charAt(z.length-1))||(z=z+"\\b"));let V="";return ee.global&&(V+="g"),ee.matchCase||(V+="i"),ee.multiline&&(V+="m"),ee.unicode&&(V+="u"),new RegExp(z,V)}e.createRegExp=u;function v(z){return z.source==="^"||z.source==="^$"||z.source==="$"||z.source==="^\\s*$"?!1:!!(z.exec("")&&z.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function _(z){return!!z.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=_;function w(z){return(z.global?"g":"")+(z.ignoreCase?"i":"")+(z.multiline?"m":"")+(z.unicode?"u":"")}e.regExpFlags=w;function m(z){return z.split(/\r\n|\r|\n/)}e.splitLines=m;function l(z){for(let X=0,ee=z.length;X<ee;X++){const V=z.charCodeAt(X);if(V!==32&&V!==9)return X}return-1}e.firstNonWhitespaceIndex=l;function c(z,X=0,ee=z.length){for(let V=X;V<ee;V++){const K=z.charCodeAt(V);if(K!==32&&K!==9)return z.substring(X,V)}return z.substring(X,ee)}e.getLeadingWhitespace=c;function r(z,X=z.length-1){for(let ee=X;ee>=0;ee--){const V=z.charCodeAt(ee);if(V!==32&&V!==9)return ee}return-1}e.lastNonWhitespaceIndex=r;function t(z,X){return z<X?-1:z>X?1:0}e.compare=t;function i(z,X,ee=0,V=z.length,K=0,te=X.length){for(;ee<V&&K<te;ee++,K++){let De=z.charCodeAt(ee),le=X.charCodeAt(K);if(De<le)return-1;if(De>le)return 1}const ie=V-ee,ue=te-K;return ie<ue?-1:ie>ue?1:0}e.compareSubstring=i;function o(z,X){return a(z,X,0,z.length,0,X.length)}e.compareIgnoreCase=o;function a(z,X,ee=0,V=z.length,K=0,te=X.length){for(;ee<V&&K<te;ee++,K++){let De=z.charCodeAt(ee),le=X.charCodeAt(K);if(De!==le){const ye=De-le;if(!(ye===32&&g(le))&&!(ye===-32&&g(De)))return s(De)&&s(le)?ye:i(z.toLowerCase(),X.toLowerCase(),ee,V,K,te)}}const ie=V-ee,ue=te-K;return ie<ue?-1:ie>ue?1:0}e.compareSubstringIgnoreCase=a;function s(z){return z>=97&&z<=122}e.isLowerAsciiLetter=s;function g(z){return z>=65&&z<=90}e.isUpperAsciiLetter=g;function C(z){return s(z)||g(z)}function R(z,X){return z.length===X.length&&p(z,X)}e.equalsIgnoreCase=R;function p(z,X,ee=z.length){for(let V=0;V<ee;V++){const K=z.charCodeAt(V),te=X.charCodeAt(V);if(K!==te){if(C(K)&&C(te)){const ie=Math.abs(K-te);if(ie!==0&&ie!==32)return!1}else if(String.fromCharCode(K).toLowerCase()!==String.fromCharCode(te).toLowerCase())return!1}}return!0}function f(z,X){const ee=X.length;return X.length>z.length?!1:p(z,X,ee)}e.startsWithIgnoreCase=f;function T(z,X){let ee,V=Math.min(z.length,X.length);for(ee=0;ee<V;ee++)if(z.charCodeAt(ee)!==X.charCodeAt(ee))return ee;return V}e.commonPrefixLength=T;function O(z,X){let ee,V=Math.min(z.length,X.length);const K=z.length-1,te=X.length-1;for(ee=0;ee<V;ee++)if(z.charCodeAt(K-ee)!==X.charCodeAt(te-ee))return ee;return V}e.commonSuffixLength=O;function H(z){return 55296<=z&&z<=56319}e.isHighSurrogate=H;function $(z){return 56320<=z&&z<=57343}e.isLowSurrogate=$;function x(z,X){return(z-55296<<10)+(X-56320)+65536}e.computeCodePoint=x;function J(z,X,ee){const V=z.charCodeAt(ee);if(H(V)&&ee+1<X){const K=z.charCodeAt(ee+1);if($(K))return x(V,K)}return V}e.getNextCodePoint=J;function Ee(z,X){const ee=z.charCodeAt(X-1);if($(ee)&&X>1){const V=z.charCodeAt(X-2);if(H(V))return x(V,ee)}return ee}function ve(z,X){const ee=me.getInstance(),V=X,K=z.length,te=J(z,K,X);X+=te>=65536?2:1;let ie=ee.getGraphemeBreakType(te);for(;X<K;){const ue=J(z,K,X),De=ee.getGraphemeBreakType(ue);if(re(ie,De))break;X+=ue>=65536?2:1,ie=De}return X-V}e.nextCharLength=ve;function q(z,X){const ee=me.getInstance(),V=X,K=Ee(z,X);X-=K>=65536?2:1;let te=ee.getGraphemeBreakType(K);for(;X>0;){const ie=Ee(z,X),ue=ee.getGraphemeBreakType(ie);if(re(ue,te))break;X-=ie>=65536?2:1,te=ue}return V-X}e.prevCharLength=q;function j(z,X){const ee=me.getInstance(),V=z.length,K=X,te=J(z,V,X),ie=ee.getGraphemeBreakType(te);X+=te>=65536?2:1;let ue=ie;for(;X<V;){const le=J(z,V,X),ye=ee.getGraphemeBreakType(le);if(re(ue,ye))break;X+=le>=65536?2:1,ue=ye}const De=X;for(X=K,ue=ie;X>0;){const le=Ee(z,X),ye=ee.getGraphemeBreakType(le);if(re(ye,ue))break;X-=le>=65536?2:1,ue=ye}return[X,De]}function F(z,X){return X>0&&$(z.charCodeAt(X))?j(z,X-1):j(z,X)}e.getCharContainingOffset=F;function A(z){const X=z.length;let ee=0,V=0;for(;V<X;){const ie=J(z,X,V);V+=ie>=65536?2:1,ie<128?ee+=1:ie<2048?ee+=2:ie<65536?ee+=3:ee+=4}const K=new Uint8Array(ee);V=0;let te=0;for(;V<X;){const ie=J(z,X,V);V+=ie>=65536?2:1,ie<128?K[te++]=ie:ie<2048?(K[te++]=192|(ie&1984)>>>6,K[te++]=128|(ie&63)>>>0):ie<65536?(K[te++]=224|(ie&61440)>>>12,K[te++]=128|(ie&4032)>>>6,K[te++]=128|(ie&63)>>>0):(K[te++]=240|(ie&1835008)>>>18,K[te++]=128|(ie&258048)>>>12,K[te++]=128|(ie&4032)>>>6,K[te++]=128|(ie&63)>>>0)}return K}e.encodeUTF8=A;function M(z){const X=z.byteLength,ee=[];let V=0;for(;V<X;){const K=z[V];let te;if(K>=240&&V+3<X?te=(z[V++]&7)<<18>>>0|(z[V++]&63)<<12>>>0|(z[V++]&63)<<6>>>0|(z[V++]&63)<<0>>>0:K>=224&&V+2<X?te=(z[V++]&15)<<12>>>0|(z[V++]&63)<<6>>>0|(z[V++]&63)<<0>>>0:K>=192&&V+1<X?te=(z[V++]&31)<<6>>>0|(z[V++]&63)<<0>>>0:te=z[V++],te>=0&&te<=55295||te>=57344&&te<=65535)ee.push(String.fromCharCode(te));else if(te>=65536&&te<=1114111){const ie=te-65536,ue=55296+((ie&1047552)>>>10),De=56320+((ie&1023)>>>0);ee.push(String.fromCharCode(ue)),ee.push(String.fromCharCode(De))}else ee.push(String.fromCharCode(65533))}return ee.join("")}e.decodeUTF8=M;const U=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(z){return U.test(z)}e.containsRTL=W;const ne=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ae(z){return ne.test(z)}e.containsEmoji=ae;const ce=/^[\t\n\r\x20-\x7E]*$/;function de(z){return ce.test(z)}e.isBasicASCII=de,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Pe(z){return e.UNUSUAL_LINE_TERMINATORS.test(z)}e.containsUnusualLineTerminators=Pe;function Te(z){for(let X=0,ee=z.length;X<ee;X++)if(Me(z.charCodeAt(X)))return!0;return!1}e.containsFullWidthCharacter=Te;function Me(z){return z=+z,z>=11904&&z<=55215||z>=63744&&z<=64255||z>=65281&&z<=65374}e.isFullWidthCharacter=Me;function je(z){return z>=127462&&z<=127487||z===8986||z===8987||z===9200||z===9203||z>=9728&&z<=10175||z===11088||z===11093||z>=127744&&z<=128591||z>=128640&&z<=128764||z>=128992&&z<=129003||z>=129280&&z<=129535||z>=129648&&z<=129750}e.isEmojiImprecise=je;function $e(z,X){if(z.length<X)return z;const ee=/\b/g;let V=0;for(;ee.test(z)&&!(z.length-ee.lastIndex<X);)V=ee.lastIndex,ee.lastIndex+=1;return z.substring(V).replace(/^\s/,"")}e.lcut=$e;const Ye=/\x1B\x5B[12]?K/g,et=/\x1b\[\d+m/g,Je=/\x1b\[0?m/g;function we(z){return z&&(z=z.replace(Ye,""),z=z.replace(et,""),z=z.replace(Je,"")),z}e.removeAnsiEscapeCodes=we,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Se(z){return!!(z&&z.length>0&&z.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Se;function Ce(z){return Se(z)?z.substr(1):z}e.stripUTF8BOM=Ce;function ke(z,X){if(!z||!X||z.length<X.length)return!1;const ee=X.length,V=z.toLowerCase();let K=0,te=-1;for(;K<ee;){const ie=V.indexOf(X[K],te+1);if(ie<0)return!1;te=ie,K++}return!0}e.fuzzyContains=ke;function Le(z,X=!1){return z?(X&&(z=z.replace(/\\./g,"")),z.toLowerCase()!==z):!1}e.containsUppercaseCharacter=Le;function ze(z){return z.charAt(0).toUpperCase()+z.slice(1)}e.uppercaseFirstLetter=ze;function He(z,X=1){if(X===0)return"";let ee=-1;do ee=z.indexOf(`
`,ee+1),X--;while(X>0&&ee>=0);return ee===-1?z:(z[ee-1]==="\r"&&ee--,z.substr(0,ee))}e.getNLines=He;function Ve(z){const X=90-65+1;return z=z%(2*X),z<X?String.fromCharCode(97+z):String.fromCharCode(65+z-X)}e.singleLetterHash=Ve;function Qe(z){return me.getInstance().getGraphemeBreakType(z)}e.getGraphemeBreakType=Qe;function re(z,X){return z===0?X!==5&&X!==7:z===2&&X===3?!1:z===4||z===2||z===3||X===4||X===2||X===3?!0:!(z===8&&(X===8||X===9||X===11||X===12)||(z===11||z===9)&&(X===9||X===10)||(z===12||z===10)&&X===10||X===5||X===13||X===7||z===1||z===13&&X===14||z===6&&X===6)}e.breakBetweenGraphemeBreakType=re;var ge;(function(z){z[z.Other=0]="Other",z[z.Prepend=1]="Prepend",z[z.CR=2]="CR",z[z.LF=3]="LF",z[z.Control=4]="Control",z[z.Extend=5]="Extend",z[z.Regional_Indicator=6]="Regional_Indicator",z[z.SpacingMark=7]="SpacingMark",z[z.L=8]="L",z[z.V=9]="V",z[z.T=10]="T",z[z.LV=11]="LV",z[z.LVT=12]="LVT",z[z.ZWJ=13]="ZWJ",z[z.Extended_Pictographic=14]="Extended_Pictographic"})(ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class me{constructor(){this._data=Fe()}static getInstance(){return me._INSTANCE||(me._INSTANCE=new me),me._INSTANCE}getGraphemeBreakType(X){if(X<32)return X===10?3:X===13?2:4;if(X<127)return 0;const ee=this._data,V=ee.length/3;let K=1;for(;K<=V;)if(X<ee[3*K])K=2*K;else if(X>ee[3*K+1])K=2*K+1;else return ee[3*K+2];return 0}}me._INSTANCE=null;function Fe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(fe[18],he([0,1,14,39]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const P=typeof Buffer!="undefined",y=typeof TextEncoder!="undefined",k=typeof TextDecoder!="undefined";let L,h;class n{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return P?new n(Buffer.allocUnsafe(s)):new n(new Uint8Array(s))}static wrap(s){return P&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new n(s)}static fromString(s,g){return!((g==null?void 0:g.dontUseNodeBuffer)||!1)&&P?new n(Buffer.from(s)):y?(L||(L=new TextEncoder),new n(L.encode(s))):new n(S.encodeUTF8(s))}static concat(s,g){if(typeof g=="undefined"){g=0;for(let p=0,f=s.length;p<f;p++)g+=s[p].byteLength}const C=n.alloc(g);let R=0;for(let p=0,f=s.length;p<f;p++){const T=s[p];C.set(T,R),R+=T.byteLength}return C}toString(){return P?this.buffer.toString():k?(h||(h=new TextDecoder),h.decode(this.buffer)):S.decodeUTF8(this.buffer)}slice(s,g){return new n(this.buffer.subarray(s,g))}set(s,g){s instanceof n?this.buffer.set(s.buffer,g):this.buffer.set(s,g)}readUInt32BE(s){return I(this.buffer,s)}writeUInt32BE(s,g){E(this.buffer,s,g)}readUInt32LE(s){return u(this.buffer,s)}writeUInt32LE(s,g){v(this.buffer,s,g)}readUInt8(s){return _(this.buffer,s)}writeUInt8(s,g){w(this.buffer,s,g)}}e.VSBuffer=n;function D(a,s){return a[s+0]<<0>>>0|a[s+1]<<8>>>0}e.readUInt16LE=D;function b(a,s,g){a[g+0]=s&255,s=s>>>8,a[g+1]=s&255}e.writeUInt16LE=b;function I(a,s){return a[s]*2**24+a[s+1]*2**16+a[s+2]*2**8+a[s+3]}e.readUInt32BE=I;function E(a,s,g){a[g+3]=s,s=s>>>8,a[g+2]=s,s=s>>>8,a[g+1]=s,s=s>>>8,a[g]=s}e.writeUInt32BE=E;function u(a,s){return a[s+0]<<0>>>0|a[s+1]<<8>>>0|a[s+2]<<16>>>0|a[s+3]<<24>>>0}e.readUInt32LE=u;function v(a,s,g){a[g+0]=s&255,s=s>>>8,a[g+1]=s&255,s=s>>>8,a[g+2]=s&255,s=s>>>8,a[g+3]=s&255}e.writeUInt32LE=v;function _(a,s){return a[s]}e.readUInt8=_;function w(a,s,g){a[g]=s}e.writeUInt8=w;function m(a){return d.consumeReadable(a,s=>n.concat(s))}e.readableToBuffer=m;function l(a){return d.toReadable(a)}e.bufferToReadable=l;function c(a){return d.consumeStream(a,s=>n.concat(s))}e.streamToBuffer=c;async function r(a){return a.ended?n.concat(a.buffer):n.concat([...a.buffer,await c(a.stream)])}e.bufferedStreamToBuffer=r;function t(a){return d.toStream(a,s=>n.concat(s))}e.bufferToStream=t;function i(a){return d.transform(a,{data:s=>typeof s=="string"?n.fromString(s):n.wrap(s)},s=>n.concat(s))}e.streamToBufferReadableStream=i;function o(a){return d.newWriteableStream(s=>n.concat(s),a)}e.newWriteableBufferStream=o}),define(fe[112],he([0,1,14]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function d(w){return P(w,0)}e.hash=d;function P(w,m){switch(typeof w){case"object":return w===null?y(349,m):Array.isArray(w)?h(w,m):n(w,m);case"string":return L(w,m);case"boolean":return k(w,m);case"number":return y(w,m);case"undefined":return y(937,m);default:return y(617,m)}}e.doHash=P;function y(w,m){return(m<<5)-m+w|0}function k(w,m){return y(w?433:863,m)}function L(w,m){m=y(149417,m);for(let l=0,c=w.length;l<c;l++)m=y(w.charCodeAt(l),m);return m}e.stringHash=L;function h(w,m){return m=y(104579,m),w.reduce((l,c)=>P(c,l),m)}function n(w,m){return m=y(181387,m),Object.keys(w).sort().reduce((l,c)=>(l=L(c,l),P(w[c],l)),m)}class D{constructor(){this._value=0}get value(){return this._value}hash(m){return this._value=P(m,this._value),this._value}}e.Hasher=D;var b;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function I(w,m,l=32){const c=l-m,r=~((1<<c)-1);return(w<<m|(r&w)>>>c)>>>0}function E(w,m=0,l=w.byteLength,c=0){for(let r=0;r<l;r++)w[m+r]=c}function u(w,m,l="0"){for(;w.length<m;)w=l+w;return w}function v(w,m=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(l=>l.toString(16).padStart(2,"0")).join(""):u((w>>>0).toString(16),m/4)}e.toHexString=v;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(m){const l=m.length;if(l!==0){const c=this._buff;let r=this._buffLen,t=this._leftoverHighSurrogate,i,o;for(t!==0?(i=t,o=-1,t=0):(i=m.charCodeAt(0),o=0);;){let a=i;if(S.isHighSurrogate(i))if(o+1<l){const s=m.charCodeAt(o+1);S.isLowSurrogate(s)?(o++,a=S.computeCodePoint(i,s)):a=65533}else{t=i;break}else S.isLowSurrogate(i)&&(a=65533);if(r=this._push(c,r,a),o++,o<l)i=m.charCodeAt(o);else break}this._buffLen=r,this._leftoverHighSurrogate=t}}_push(m,l,c){return c<128?m[l++]=c:c<2048?(m[l++]=192|(c&1984)>>>6,m[l++]=128|(c&63)>>>0):c<65536?(m[l++]=224|(c&61440)>>>12,m[l++]=128|(c&4032)>>>6,m[l++]=128|(c&63)>>>0):(m[l++]=240|(c&1835008)>>>18,m[l++]=128|(c&258048)>>>12,m[l++]=128|(c&4032)>>>6,m[l++]=128|(c&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,E(this._buff,this._buffLen),this._buffLen>56&&(this._step(),E(this._buff));const m=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(m/4294967296),!1),this._buffDV.setUint32(60,m%4294967296,!1),this._step()}_step(){const m=_._bigBlock32,l=this._buffDV;for(let C=0;C<64;C+=4)m.setUint32(C,l.getUint32(C,!1),!1);for(let C=64;C<320;C+=4)m.setUint32(C,I(m.getUint32(C-12,!1)^m.getUint32(C-32,!1)^m.getUint32(C-56,!1)^m.getUint32(C-64,!1),1),!1);let c=this._h0,r=this._h1,t=this._h2,i=this._h3,o=this._h4,a,s,g;for(let C=0;C<80;C++)C<20?(a=r&t|~r&i,s=1518500249):C<40?(a=r^t^i,s=1859775393):C<60?(a=r&t|r&i|t&i,s=2400959708):(a=r^t^i,s=3395469782),g=I(c,5)+a+o+s+m.getUint32(C*4,!1)&4294967295,o=i,i=t,t=I(r,30),r=c,c=g;this._h0=this._h0+c&4294967295,this._h1=this._h1+r&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))}),define(fe[71],he([0,1,14]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var d;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(d||(d={})),function(P){const y="error",k="warning",L="warn",h="info";function n(D){return D?S.equalsIgnoreCase(y,D)?P.Error:S.equalsIgnoreCase(k,D)||S.equalsIgnoreCase(L,D)?P.Warning:S.equalsIgnoreCase(h,D)?P.Info:P.Ignore:P.Ignore}P.fromValue=n}(d||(d={})),e.default=d}),define(fe[11],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function S(s){return Array.isArray(s)}e.isArray=S;function d(s){return typeof s=="string"}e.isString=d;function P(s){return Array.isArray(s)&&s.every(g=>d(g))}e.isStringArray=P;function y(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=y;function k(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=k;function L(s){return s===!0||s===!1}e.isBoolean=L;function h(s){return typeof s=="undefined"}e.isUndefined=h;function n(s){return!D(s)}e.isDefined=n;function D(s){return h(s)||s===null}e.isUndefinedOrNull=D;function b(s,g){if(!s)throw new Error(g?`Unexpected type, expected '${g}'`:"Unexpected type")}e.assertType=b;function I(s){if(D(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=I;function E(...s){const g=[];for(let C=0;C<s.length;C++){const R=s[C];if(D(R))throw new Error(`Assertion Failed: argument at index ${C} is undefined or null`);g.push(R)}return g}e.assertAllDefined=E;const u=Object.prototype.hasOwnProperty;function v(s){if(!y(s))return!1;for(let g in s)if(u.call(s,g))return!1;return!0}e.isEmptyObject=v;function _(s){return typeof s=="function"}e.isFunction=_;function w(...s){return s.length>0&&s.every(_)}e.areFunctions=w;function m(s,g){const C=Math.min(s.length,g.length);for(let R=0;R<C;R++)l(s[R],g[R])}e.validateConstraints=m;function l(s,g){if(d(g)){if(typeof s!==g)throw new Error(`argument does not match constraint: typeof ${g}`)}else if(_(g)){try{if(s instanceof g)return}catch(C){}if(!D(s)&&s.constructor===g||g.length===1&&g.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function c(s){let g=[],C=Object.getPrototypeOf(s);for(;Object.prototype!==C;)g=g.concat(Object.getOwnPropertyNames(C)),C=Object.getPrototypeOf(C);return g}e.getAllPropertyNames=c;function r(s){const g=[];for(const C of c(s))typeof s[C]=="function"&&g.push(C);return g}e.getAllMethodNames=r;function t(s,g){const C=p=>function(){const f=Array.prototype.slice.call(arguments,0);return g(p,f)};let R={};for(const p of s)R[p]=C(p);return R}e.createProxyObject=t;function i(s){return s===null?void 0:s}e.withNullAsUndefined=i;function o(s){return typeof s=="undefined"?null:s}e.withUndefinedAsNull=o;function a(s){return class{constructor(){return new Proxy({},{get(g,C){if(g[C])return g[C];throw new Error(`Not Implemented: ${s}->${String(C)}`)}})}}}e.NotImplementedProxy=a}),define(fe[28],he([0,1,5,14,2,11]),function(Q,e,S,d,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function k(i){return i===47||i===92}e.isPathSeparator=k;function L(i){return i.replace(/[\\/]/g,P.posix.sep)}e.toSlashes=L;function h(i,o=P.posix.sep){if(!i)return"";const a=i.length,s=i.charCodeAt(0);if(k(s)){if(k(i.charCodeAt(1))&&!k(i.charCodeAt(2))){let C=3;const R=C;for(;C<a&&!k(i.charCodeAt(C));C++);if(R!==C&&!k(i.charCodeAt(C+1))){for(C+=1;C<a;C++)if(k(i.charCodeAt(C)))return i.slice(0,C+1).replace(/[\\/]/g,o)}}return o}else if(_(s)&&i.charCodeAt(1)===58)return k(i.charCodeAt(2))?i.slice(0,2)+o:i.slice(0,2);let g=i.indexOf("://");if(g!==-1){for(g+=3;g<a;g++)if(k(i.charCodeAt(g)))return i.slice(0,g+1)}return""}e.getRoot=h;function n(i){if(!S.isWindows||!i||i.length<5)return!1;let o=i.charCodeAt(0);if(o!==92||(o=i.charCodeAt(1),o!==92))return!1;let a=2;const s=a;for(;a<i.length&&(o=i.charCodeAt(a),o!==92);a++);return!(s===a||(o=i.charCodeAt(a+1),isNaN(o)||o===92))}e.isUNC=n;const D=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,I=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function E(i,o=S.isWindows){const a=o?D:b;return!(!i||i.length===0||/^\s+$/.test(i)||(a.lastIndex=0,a.test(i))||o&&I.test(i)||i==="."||i===".."||o&&i[i.length-1]==="."||o&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=E;function u(i,o,a){const s=i===o;return!a||s?s:!i||!o?!1:d.equalsIgnoreCase(i,o)}e.isEqual=u;function v(i,o,a,s=P.sep){if(i===o)return!0;if(!i||!o||o.length>i.length)return!1;if(a){if(!d.startsWithIgnoreCase(i,o))return!1;if(o.length===i.length)return!0;let C=o.length;return o.charAt(o.length-1)===s&&C--,i.charAt(C)===s}return o.charAt(o.length-1)!==s&&(o+=s),i.indexOf(o)===0}e.isEqualOrParent=v;function _(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=_;function w(i,o){return S.isWindows&&i.endsWith(":")&&(i+=P.sep),P.isAbsolute(i)||(i=P.join(o,i)),i=P.normalize(i),S.isWindows?(i=d.rtrim(i,P.sep),i.endsWith(":")&&(i+=P.sep)):(i=d.rtrim(i,P.sep),i||(i=P.sep)),i}e.sanitizeFilePath=w;function m(i){const o=P.normalize(i);return S.isWindows?i.length>3?!1:l(o)&&(i.length===2||o.charCodeAt(2)===92):o===P.posix.sep}e.isRootOrDriveLetter=m;function l(i){return S.isWindows?_(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function c(i){return l(i)?i[0]:void 0}e.getDriveLetter=c;function r(i,o,a){return o.length>i.length?-1:i===o?0:(a&&(i=i.toLowerCase(),o=o.toLowerCase()),i.indexOf(o))}e.indexOfPath=r;function t(i){const o=i.split(":");let a,s,g;if(o.forEach(C=>{const R=Number(C);y.isNumber(R)?s===void 0?s=R:g===void 0&&(g=R):a=a?[a,C].join(":"):C}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:s!==void 0?s:void 0,column:g!==void 0?g:s!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(fe[19],he([0,1,11]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function d(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const v=Array.isArray(u)?[]:{};return Object.keys(u).forEach(_=>{u[_]&&typeof u[_]=="object"?v[_]=d(u[_]):v[_]=u[_]}),v}e.deepClone=d;function P(u){if(!u||typeof u!="object")return u;const v=[u];for(;v.length>0;){const _=v.shift();Object.freeze(_);for(const w in _)if(y.call(_,w)){const m=_[w];typeof m=="object"&&!Object.isFrozen(m)&&v.push(m)}}return u}e.deepFreeze=P;const y=Object.prototype.hasOwnProperty;function k(u,v){return L(u,v,new Set)}e.cloneAndChange=k;function L(u,v,_){if(S.isUndefinedOrNull(u))return u;const w=v(u);if(typeof w!="undefined")return w;if(S.isArray(u)){const m=[];for(const l of u)m.push(L(l,v,_));return m}if(S.isObject(u)){if(_.has(u))throw new Error("Cannot clone recursive data-structure");_.add(u);const m={};for(let l in u)y.call(u,l)&&(m[l]=L(u[l],v,_));return _.delete(u),m}return u}function h(u,v,_=!0){return S.isObject(u)?(S.isObject(v)&&Object.keys(v).forEach(w=>{w in u?_&&(S.isObject(u[w])&&S.isObject(v[w])?h(u[w],v[w],_):u[w]=v[w]):u[w]=v[w]}),u):v}e.mixin=h;function n(u,v){if(u===v)return!0;if(u==null||v===null||v===void 0||typeof u!=typeof v||typeof u!="object"||Array.isArray(u)!==Array.isArray(v))return!1;let _,w;if(Array.isArray(u)){if(u.length!==v.length)return!1;for(_=0;_<u.length;_++)if(!n(u[_],v[_]))return!1}else{const m=[];for(w in u)m.push(w);m.sort();const l=[];for(w in v)l.push(w);if(l.sort(),!n(m,l))return!1;for(_=0;_<m.length;_++)if(!n(u[m[_]],v[m[_]]))return!1}return!0}e.equals=n;function D(u){const v=new Set;return JSON.stringify(u,(_,w)=>{if(S.isObject(w)||Array.isArray(w)){if(v.has(w))return"[Circular]";v.add(w)}return w})}e.safeStringify=D;function b(u,v,_){const w=v(u);return typeof w=="undefined"?_:w}e.getOrDefault=b;function I(u,v){const _=Object.create(null);return!u||!v||Object.keys(v).forEach(m=>{const l=u[m],c=v[m];n(l,c)||(_[m]=c)}),_}e.distinct=I;function E(u,v){const _=v.toLowerCase(),w=Object.keys(u).find(m=>m.toLowerCase()===_);return w?u[w]:u[v]}e.getCaseInsensitive=E}),define(fe[3],he([0,1,5,2]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const P=/^\w[\w\d+.-]*$/,y=/^\//,k=/^\/\//;function L(o,a){if(!o.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!P.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!y.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(o,a){return!o&&!a?"file":o}function n(o,a){switch(o){case"https":case"http":case"file":a?a[0]!==b&&(a=b+a):a=b;break}return a}const D="",b="/",I=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{constructor(a,s,g,C,R,p=!1){typeof a=="object"?(this.scheme=a.scheme||D,this.authority=a.authority||D,this.path=a.path||D,this.query=a.query||D,this.fragment=a.fragment||D):(this.scheme=h(a,p),this.authority=s||D,this.path=n(this.scheme,g||D),this.query=C||D,this.fragment=R||D,L(this,p))}static isUri(a){return a instanceof E?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return l(this,!1)}with(a){if(!a)return this;let{scheme:s,authority:g,path:C,query:R,fragment:p}=a;return s===void 0?s=this.scheme:s===null&&(s=D),g===void 0?g=this.authority:g===null&&(g=D),C===void 0?C=this.path:C===null&&(C=D),R===void 0?R=this.query:R===null&&(R=D),p===void 0?p=this.fragment:p===null&&(p=D),s===this.scheme&&g===this.authority&&C===this.path&&R===this.query&&p===this.fragment?this:new v(s,g,C,R,p)}static parse(a,s=!1){const g=I.exec(a);return g?new v(g[2]||D,i(g[4]||D),i(g[5]||D),i(g[7]||D),i(g[9]||D),s):new v(D,D,D,D,D)}static file(a){let s=D;if(S.isWindows&&(a=a.replace(/\\/g,b)),a[0]===b&&a[1]===b){const g=a.indexOf(b,2);g===-1?(s=a.substring(2),a=b):(s=a.substring(2,g),a=a.substring(g)||b)}return new v("file",s,a,D,D)}static from(a){return new v(a.scheme,a.authority,a.path,a.query,a.fragment)}static joinPath(a,...s){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return S.isWindows&&a.scheme==="file"?g=E.file(d.win32.join(l(a,!0),...s)).path:g=d.posix.join(a.path,...s),a.with({path:g})}toString(a=!1){return c(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof E)return a;{const s=new v(a);return s._formatted=a.external,s._fsPath=a._sep===u?a.fsPath:null,s}}else return a}}e.URI=E;const u=S.isWindows?1:void 0;class v extends E{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(a=!1){return a?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=u),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(o,a){let s,g=-1;for(let C=0;C<o.length;C++){const R=o.charCodeAt(C);if(R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57||R===45||R===46||R===95||R===126||a&&R===47)g!==-1&&(s+=encodeURIComponent(o.substring(g,C)),g=-1),s!==void 0&&(s+=o.charAt(C));else{s===void 0&&(s=o.substr(0,C));const p=_[R];p!==void 0?(g!==-1&&(s+=encodeURIComponent(o.substring(g,C)),g=-1),s+=p):g===-1&&(g=C)}}return g!==-1&&(s+=encodeURIComponent(o.substring(g))),s!==void 0?s:o}function m(o){let a;for(let s=0;s<o.length;s++){const g=o.charCodeAt(s);g===35||g===63?(a===void 0&&(a=o.substr(0,s)),a+=_[g]):a!==void 0&&(a+=o[s])}return a!==void 0?a:o}function l(o,a){let s;return o.authority&&o.path.length>1&&o.scheme==="file"?s=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?a?s=o.path.substr(1):s=o.path[1].toLowerCase()+o.path.substr(2):s=o.path,S.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=l;function c(o,a){const s=a?m:w;let g="",{scheme:C,authority:R,path:p,query:f,fragment:T}=o;if(C&&(g+=C,g+=":"),(R||C==="file")&&(g+=b,g+=b),R){let O=R.indexOf("@");if(O!==-1){const H=R.substr(0,O);R=R.substr(O+1),O=H.indexOf(":"),O===-1?g+=s(H,!1):(g+=s(H.substr(0,O),!1),g+=":",g+=s(H.substr(O+1),!1)),g+="@"}R=R.toLowerCase(),O=R.indexOf(":"),O===-1?g+=s(R,!1):(g+=s(R.substr(0,O),!1),g+=R.substr(O))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const O=p.charCodeAt(1);O>=65&&O<=90&&(p=`/${String.fromCharCode(O+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const O=p.charCodeAt(0);O>=65&&O<=90&&(p=`${String.fromCharCode(O+32)}:${p.substr(2)}`)}g+=s(p,!0)}return f&&(g+="?",g+=s(f,!1)),T&&(g+="#",g+=a?T:w(T,!1)),g}function r(o){try{return decodeURIComponent(o)}catch(a){return o.length>3?o.substr(0,3)+r(o.substr(3)):o}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(o){return o.match(t)?o.replace(t,a=>r(a)):o}}),define(fe[113],he([0,1,16,3]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.getUriFromAmdModule=e.getPathFromAmdModule=void 0;function P(L,h){return y(L,h).fsPath}e.getPathFromAmdModule=P;function y(L,h){return d.URI.parse(L.toUrl(h))}e.getUriFromAmdModule=y;class k{static get(){const h=new Map,n=new Map,D=new Map,b=new Map;function I(w,m){w.has(m.detail)||w.set(m.detail,-m.timestamp)}function E(w,m){let l=w.get(m.detail);!l||l>=0||w.set(m.detail,l+m.timestamp)}const u=S.mergeSort(Q.getStats().slice(0),(w,m)=>w.timestamp-m.timestamp);for(const w of u)switch(w.type){case 10:I(h,w);break;case 11:case 12:E(h,w);break;case 21:I(n,w);break;case 22:E(n,w);break;case 33:I(D,w);break;case 34:E(D,w);break;case 31:I(b,w);break;case 32:E(b,w);break}let v=0;D.forEach(w=>v+=w);function _(w){let m=[];return w.forEach((l,c)=>m.push([c,l])),m}return{amdLoad:_(h),amdInvoke:_(n),nodeRequire:_(D),nodeEval:_(b),nodeRequireTotal:v}}static toMarkdownTable(h,n){let D="",b=[];return h.forEach((I,E)=>{b[E]=I.length}),n.forEach(I=>{I.forEach((E,u)=>{typeof E=="undefined"&&(E=I[u]="-");const v=E.toString().length;b[u]=Math.max(v,b[u])})}),h.forEach((I,E)=>{D+=`| ${I+" ".repeat(b[E]-I.toString().length)} `}),D+=`|
`,h.forEach((I,E)=>{D+=`| ${"-".repeat(b[E])} `}),D+=`|
`,n.forEach(I=>{I.forEach((E,u)=>{typeof E!="undefined"&&(D+=`| ${E+" ".repeat(b[u]-E.toString().length)} `)}),D+=`|
`}),D}}e.LoaderStats=k}),define(fe[114],he([0,1,3]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function d(n){const D=n;return D&&typeof D.type=="string"&&typeof D.severity=="string"}e.isRemoteConsoleLog=d;function P(n){const D=[];let b;try{const I=JSON.parse(n.arguments),E=I[I.length-1];E&&E.__$stack&&(I.pop(),b=E.__$stack),D.push(...I)}catch(I){D.push("Unable to log remote console arguments",n.arguments)}return{args:D,stack:b}}e.parse=P;function y(n){if(typeof n!="string")return y(P(n).stack);const D=n;if(D){const b=k(D),I=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(I&&I.length===4)return{uri:S.URI.file(I[1]),line:Number(I[2]),column:Number(I[3])}}}e.getFirstFrame=y;function k(n){if(!n)return n;const D=n.indexOf(`
`);return D===-1?n:n.substring(0,D)}function L(n,D){const{args:b,stack:I}=P(n),E=typeof b[0]=="string"&&b.length===1;let u=k(I);u&&(u=`(${u.trim()})`);let v=[];if(typeof b[0]=="string"?u&&E?v=[`%c[${D}] %c${b[0]} %c${u}`,h("blue"),h(""),h("grey")]:v=[`%c[${D}] %c${b[0]}`,h("blue"),h(""),...b.slice(1)]:v=[`%c[${D}]%`,h("blue"),...b],u&&!E&&v.push(u),typeof console[n.severity]!="function")throw new Error("Unknown console method");console[n.severity].apply(console,v)}e.log=L;function h(n){return`color: ${n}`}}),define(fe[25],he([0,1,3,14]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(m,l,c){let r=m.get(l);return r===void 0&&(r=c,m.set(l,r)),r}e.getOrSet=P;function y(m){const l=[];return m.forEach((c,r)=>{l.push(`${r} => ${c}`)}),`Map(${m.size}) {${l.join(", ")}}`}e.mapToString=y;function k(m){const l=[];return m.forEach(c=>{l.push(c)}),`Set(${m.size}) {${l.join(", ")}}`}e.setToString=k;class L{constructor(){this._value="",this._pos=0}reset(l){return this._value=l,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(l){const c=l.charCodeAt(0),r=this._value.charCodeAt(this._pos);return c-r}value(){return this._value[this._pos]}}e.StringIterator=L;class h{constructor(l=!0){this._caseSensitive=l}reset(l){return this._value=l,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let l=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(l)this._from++;else break;else l=!1;return this}cmp(l){return this._caseSensitive?d.compareSubstring(l,this._value,0,l.length,this._from,this._to):d.compareSubstringIgnoreCase(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=h;class n{constructor(l=!0,c=!0){this._splitOnBackslash=l,this._caseSensitive=c}reset(l){return this._value=l.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let l=!0;for(;this._to<this._value.length;this._to++){const c=this._value.charCodeAt(this._to);if(c===47||this._splitOnBackslash&&c===92)if(l)this._from++;else break;else l=!1}return this}cmp(l){return this._caseSensitive?d.compareSubstring(l,this._value,0,l.length,this._from,this._to):d.compareSubstringIgnoreCase(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=n;var D;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(D||(D={}));class b{constructor(l){this._ignorePathCasing=l,this._states=[],this._stateIdx=0}reset(l){return this._value=l,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new n(!1,!this._ignorePathCasing(l)),this._pathIterator.reset(l.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(l){if(this._states[this._stateIdx]===1)return d.compareIgnoreCase(l,this._value.scheme);if(this._states[this._stateIdx]===2)return d.compareIgnoreCase(l,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(l);if(this._states[this._stateIdx]===4)return d.compare(l,this._value.query);if(this._states[this._stateIdx]===5)return d.compare(l,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=b;class I{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class E{constructor(l){this._iter=l}static forUris(l=()=>!1){return new E(new b(l))}static forPaths(){return new E(new n)}static forStrings(){return new E(new L)}static forConfigKeys(){return new E(new h)}clear(){this._root=void 0}set(l,c){const r=this._iter.reset(l);let t;for(this._root||(this._root=new I,this._root.segment=r.value()),t=this._root;;){const o=r.cmp(t.segment);if(o>0)t.left||(t.left=new I,t.left.segment=r.value()),t=t.left;else if(o<0)t.right||(t.right=new I,t.right.segment=r.value()),t=t.right;else if(r.hasNext())r.next(),t.mid||(t.mid=new I,t.mid.segment=r.value()),t=t.mid;else break}const i=t.value;return t.value=c,t.key=l,i}get(l){var c;return(c=this._getNode(l))===null||c===void 0?void 0:c.value}_getNode(l){const c=this._iter.reset(l);let r=this._root;for(;r;){const t=c.cmp(r.segment);if(t>0)r=r.left;else if(t<0)r=r.right;else if(c.hasNext())c.next(),r=r.mid;else break}return r}has(l){const c=this._getNode(l);return!((c==null?void 0:c.value)===void 0&&(c==null?void 0:c.mid)===void 0)}delete(l){return this._delete(l,!1)}deleteSuperstr(l){return this._delete(l,!0)}_delete(l,c){const r=this._iter.reset(l),t=[];let i=this._root;for(;i;){const o=r.cmp(i.segment);if(o>0)t.push([1,i]),i=i.left;else if(o<0)t.push([-1,i]),i=i.right;else if(r.hasNext())r.next(),t.push([0,i]),i=i.mid;else{for(c?(i.left=void 0,i.mid=void 0,i.right=void 0):i.value=void 0;t.length>0&&i.isEmpty();){let[a,s]=t.pop();switch(a){case 1:s.left=void 0;break;case 0:s.mid=void 0;break;case-1:s.right=void 0;break}i=s}break}}}findSubstr(l){const c=this._iter.reset(l);let r=this._root,t;for(;r;){const i=c.cmp(r.segment);if(i>0)r=r.left;else if(i<0)r=r.right;else if(c.hasNext())c.next(),t=r.value||t,r=r.mid;else break}return r&&r.value||t}findSuperstr(l){const c=this._iter.reset(l);let r=this._root;for(;r;){const t=c.cmp(r.segment);if(t>0)r=r.left;else if(t<0)r=r.right;else if(c.hasNext())c.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(l){for(const[c,r]of this)l(r,c)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(l){l&&(yield*this._entries(l.left),l.value&&(yield[l.key,l.value]),yield*this._entries(l.mid),yield*this._entries(l.right))}}e.TernarySearchTree=E;class u{constructor(l,c){this[Symbol.toStringTag]="ResourceMap",l instanceof u?(this.map=new Map(l.map),this.toKey=c!=null?c:u.defaultToKey):(this.map=new Map,this.toKey=l!=null?l:u.defaultToKey)}set(l,c){return this.map.set(this.toKey(l),c),this}get(l){return this.map.get(this.toKey(l))}has(l){return this.map.has(this.toKey(l))}get size(){return this.map.size}clear(){this.map.clear()}delete(l){return this.map.delete(this.toKey(l))}forEach(l,c){typeof c!="undefined"&&(l=l.bind(c));for(let[r,t]of this.map)l(t,S.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let l of this.map.keys())yield S.URI.parse(l)}*entries(){for(let l of this.map.entries())yield[S.URI.parse(l[0]),l[1]]}*[Symbol.iterator](){for(let l of this.map)yield[S.URI.parse(l[0]),l[1]]}}e.ResourceMap=u,u.defaultToKey=m=>m.toString();var v;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class _{constructor(){this[Symbol.toStringTag]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var l;return(l=this._head)===null||l===void 0?void 0:l.value}get last(){var l;return(l=this._tail)===null||l===void 0?void 0:l.value}has(l){return this._map.has(l)}get(l,c=0){const r=this._map.get(l);if(!!r)return c!==0&&this.touch(r,c),r.value}set(l,c,r=0){let t=this._map.get(l);if(t)t.value=c,r!==0&&this.touch(t,r);else{switch(t={key:l,value:c,next:void 0,previous:void 0},r){case 0:this.addItemLast(t);break;case 1:this.addItemFirst(t);break;case 2:this.addItemLast(t);break;default:this.addItemLast(t);break}this._map.set(l,t),this._size++}return this}delete(l){return!!this.remove(l)}remove(l){const c=this._map.get(l);if(!!c)return this._map.delete(l),this.removeItem(c),this._size--,c.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const l=this._head;return this._map.delete(l.key),this.removeItem(l),this._size--,l.value}}forEach(l,c){const r=this._state;let t=this._head;for(;t;){if(c?l.bind(c)(t.value,t.key,this):l(t.value,t.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const l=this,c=this._state;let r=this._head;const t={[Symbol.iterator](){return t},next(){if(l._state!==c)throw new Error("LinkedMap got modified during iteration.");if(r){const i={value:r.key,done:!1};return r=r.next,i}else return{value:void 0,done:!0}}};return t}values(){const l=this,c=this._state;let r=this._head;const t={[Symbol.iterator](){return t},next(){if(l._state!==c)throw new Error("LinkedMap got modified during iteration.");if(r){const i={value:r.value,done:!1};return r=r.next,i}else return{value:void 0,done:!0}}};return t}entries(){const l=this,c=this._state;let r=this._head;const t={[Symbol.iterator](){return t},next(){if(l._state!==c)throw new Error("LinkedMap got modified during iteration.");if(r){const i={value:[r.key,r.value],done:!1};return r=r.next,i}else return{value:void 0,done:!0}}};return t}[Symbol.iterator](){return this.entries()}trimOld(l){if(!(l>=this.size)){if(l===0){this.clear();return}let c=this._head,r=this.size;for(;c&&r>l;)this._map.delete(c.key),c=c.next,r--;this._head=c,this._size=r,c&&(c.previous=void 0),this._state++}}addItemFirst(l){if(!this._head&&!this._tail)this._tail=l;else if(this._head)l.next=this._head,this._head.previous=l;else throw new Error("Invalid list");this._head=l,this._state++}addItemLast(l){if(!this._head&&!this._tail)this._head=l;else if(this._tail)l.previous=this._tail,this._tail.next=l;else throw new Error("Invalid list");this._tail=l,this._state++}removeItem(l){if(l===this._head&&l===this._tail)this._head=void 0,this._tail=void 0;else if(l===this._head){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this._head=l.next}else if(l===this._tail){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this._tail=l.previous}else{const c=l.next,r=l.previous;if(!c||!r)throw new Error("Invalid list");c.previous=r,r.next=c}l.next=void 0,l.previous=void 0,this._state++}touch(l,c){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(l===this._head)return;const r=l.next,t=l.previous;l===this._tail?(t.next=void 0,this._tail=t):(r.previous=t,t.next=r),l.previous=void 0,l.next=this._head,this._head.previous=l,this._head=l,this._state++}else if(c===2){if(l===this._tail)return;const r=l.next,t=l.previous;l===this._head?(r.previous=void 0,this._head=r):(r.previous=t,t.next=r),l.next=void 0,l.previous=this._tail,this._tail.next=l,this._tail=l,this._state++}}}toJSON(){const l=[];return this.forEach((c,r)=>{l.push([r,c])}),l}fromJSON(l){this.clear();for(const[c,r]of l)this.set(c,r)}}e.LinkedMap=_;class w extends _{constructor(l,c=1){super();this._limit=l,this._ratio=Math.min(Math.max(0,c),1)}get limit(){return this._limit}set limit(l){this._limit=l,this.checkTrim()}get ratio(){return this._ratio}set ratio(l){this._ratio=Math.min(Math.max(0,l),1),this.checkTrim()}get(l,c=2){return super.get(l,c)}peek(l){return super.get(l,0)}set(l,c){return super.set(l,c,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=w}),define(fe[115],he([0,1,25,14]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function P(...we){return function(Se,Ce){for(let ke=0,Le=we.length;ke<Le;ke++){const ze=we[ke](Se,Ce);if(ze)return ze}return null}}e.or=P,e.matchesStrictPrefix=y.bind(void 0,!1),e.matchesPrefix=y.bind(void 0,!0);function y(we,Se,Ce){if(!Ce||Ce.length<Se.length)return null;let ke;return we?ke=d.startsWithIgnoreCase(Ce,Se):ke=Ce.indexOf(Se)===0,ke?Se.length>0?[{start:0,end:Se.length}]:[]:null}function k(we,Se){const Ce=Se.toLowerCase().indexOf(we.toLowerCase());return Ce===-1?null:[{start:Ce,end:Ce+we.length}]}e.matchesContiguousSubString=k;function L(we,Se){return h(we.toLowerCase(),Se.toLowerCase(),0,0)}e.matchesSubString=L;function h(we,Se,Ce,ke){if(Ce===we.length)return[];if(ke===Se.length)return null;if(we[Ce]===Se[ke]){let Le=null;return(Le=h(we,Se,Ce+1,ke+1))?w({start:ke,end:ke+1},Le):null}return h(we,Se,Ce,ke+1)}function n(we){return 97<=we&&we<=122}function D(we){return 65<=we&&we<=90}e.isUpper=D;function b(we){return 48<=we&&we<=57}function I(we){return we===32||we===9||we===10||we===13}const E=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(we=>E.add(we.charCodeAt(0)));function u(we){return I(we)||E.has(we)}function v(we,Se){return we===Se||u(we)&&u(Se)}function _(we){return n(we)||D(we)||b(we)}function w(we,Se){return Se.length===0?Se=[we]:we.end===Se[0].start?Se[0].start=we.start:Se.unshift(we),Se}function m(we,Se){for(let Ce=Se;Ce<we.length;Ce++){const ke=we.charCodeAt(Ce);if(D(ke)||b(ke)||Ce>0&&!_(we.charCodeAt(Ce-1)))return Ce}return we.length}function l(we,Se,Ce,ke){if(Ce===we.length)return[];if(ke===Se.length)return null;if(we[Ce]!==Se[ke].toLowerCase())return null;{let Le=null,ze=ke+1;for(Le=l(we,Se,Ce+1,ke+1);!Le&&(ze=m(Se,ze))<Se.length;)Le=l(we,Se,Ce+1,ze),ze++;return Le===null?null:w({start:ke,end:ke+1},Le)}}function c(we){let Se=0,Ce=0,ke=0,Le=0,ze=0;for(let ge=0;ge<we.length;ge++)ze=we.charCodeAt(ge),D(ze)&&Se++,n(ze)&&Ce++,_(ze)&&ke++,b(ze)&&Le++;const He=Se/we.length,Ve=Ce/we.length,Qe=ke/we.length,re=Le/we.length;return{upperPercent:He,lowerPercent:Ve,alphaPercent:Qe,numericPercent:re}}function r(we){const{upperPercent:Se,lowerPercent:Ce}=we;return Ce===0&&Se>.6}function t(we){const{upperPercent:Se,lowerPercent:Ce,alphaPercent:ke,numericPercent:Le}=we;return Ce>.2&&Se<.8&&ke>.6&&Le<.2}function i(we){let Se=0,Ce=0,ke=0,Le=0;for(let ze=0;ze<we.length;ze++)ke=we.charCodeAt(ze),D(ke)&&Se++,n(ke)&&Ce++,I(ke)&&Le++;return(Se===0||Ce===0)&&Le===0?we.length<=30:Se<=5}function o(we,Se){if(!Se||(Se=Se.trim(),Se.length===0)||!i(we)||Se.length>60)return null;const Ce=c(Se);if(!t(Ce)){if(!r(Ce))return null;Se=Se.toLowerCase()}let ke=null,Le=0;for(we=we.toLowerCase();Le<Se.length&&(ke=l(we,Se,0,Le))===null;)Le=m(Se,Le+1);return ke}e.matchesCamelCase=o;function a(we,Se,Ce=!1){if(!Se||Se.length===0)return null;let ke=null,Le=0;for(we=we.toLowerCase(),Se=Se.toLowerCase();Le<Se.length&&(ke=s(we,Se,0,Le,Ce))===null;)Le=g(Se,Le+1);return ke}e.matchesWords=a;function s(we,Se,Ce,ke,Le){if(Ce===we.length)return[];if(ke===Se.length)return null;if(v(we.charCodeAt(Ce),Se.charCodeAt(ke))){let ze=null,He=ke+1;if(ze=s(we,Se,Ce+1,ke+1,Le),!Le)for(;!ze&&(He=g(Se,He))<Se.length;)ze=s(we,Se,Ce+1,He,Le),He++;return ze===null?null:w({start:ke,end:ke+1},ze)}else return null}function g(we,Se){for(let Ce=Se;Ce<we.length;Ce++)if(u(we.charCodeAt(Ce))||Ce>0&&u(we.charCodeAt(Ce-1)))return Ce;return we.length}const C=P(e.matchesPrefix,o,k),R=P(e.matchesPrefix,o,L),p=new S.LRUCache(1e4);function f(we,Se,Ce=!1){if(typeof we!="string"||typeof Se!="string")return null;let ke=p.get(we);ke||(ke=new RegExp(d.convertSimple2RegExpPattern(we),"i"),p.set(we,ke));const Le=ke.exec(Se);return Le?[{start:Le.index,end:Le.index+Le[0].length}]:Ce?R(we,Se):C(we,Se)}e.matchesFuzzy=f;function T(we,Se){const Ce=Te(we,we.toLowerCase(),0,Se,Se.toLowerCase(),0,!0);return Ce?H(Ce):null}e.matchesFuzzy2=T;function O(we,Se,Ce,ke,Le,ze){const He=Te(we,Se,0,ke,Le,0,!0);if(He)return He;let Ve=[],Qe=0,re=ze;for(let ge=0;ge<Se.length&&ge<$;++ge){const me=Le.indexOf(Se.charAt(ge),re);if(me>=0)Qe+=1,Ve.unshift(me),re=me+1;else if(Ve.length>0)break}return[Qe,ze,...Ve]}e.anyScore=O;function H(we){if(typeof we=="undefined")return[];const Se=[],Ce=we[1];for(let ke=we.length-1;ke>1;ke--){const Le=we[ke]+Ce,ze=Se[Se.length-1];ze&&ze.end===Le?ze.end=Le+1:Se.push({start:Le,end:Le+1})}return Se}e.createMatches=H;const $=128;function x(){const we=[],Se=[];for(let Ce=0;Ce<=$;Ce++)Se[Ce]=0;for(let Ce=0;Ce<=$;Ce++)we.push(Se.slice(0));return we}function J(we){const Se=[];for(let Ce=0;Ce<=we;Ce++)Se[Ce]=0;return Se}const Ee=J(2*$),ve=J(2*$),q=x(),j=x(),F=x(),A=!1;function M(we,Se,Ce,ke,Le){function ze(Ve,Qe,re=" "){for(;Ve.length<Qe;)Ve=re+Ve;return Ve}let He=` |   |${ke.split("").map(Ve=>ze(Ve,3)).join("|")}
`;for(let Ve=0;Ve<=Ce;Ve++)Ve===0?He+=" |":He+=`${Se[Ve-1]}|`,He+=we[Ve].slice(0,Le+1).map(Qe=>ze(Qe.toString(),3)).join("|")+`
`;return He}function U(we,Se,Ce,ke){we=we.substr(Se),Ce=Ce.substr(ke),console.log(M(j,we,we.length,Ce,Ce.length)),console.log(M(F,we,we.length,Ce,Ce.length)),console.log(M(q,we,we.length,Ce,Ce.length))}function W(we,Se){if(Se<0||Se>=we.length)return!1;const Ce=we.codePointAt(Se);switch(Ce){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!d.isEmojiImprecise(Ce)}}function ne(we,Se){if(Se<0||Se>=we.length)return!1;switch(we.charCodeAt(Se)){case 32:case 9:return!0;default:return!1}}function ae(we,Se,Ce){return Se[we]!==Ce[we]}function ce(we,Se,Ce,ke,Le,ze,He=!1){for(;Se<Ce&&Le<ze;)we[Se]===ke[Le]&&(He&&(Ee[Se]=Le),Se+=1),Le+=1;return Se===Ce}e.isPatternInWord=ce;var de;(function(we){we[we.Diag=1]="Diag",we[we.Left=2]="Left",we[we.LeftLeft=3]="LeftLeft"})(de||(de={}));var Pe;(function(we){we.Default=[-100,0];function Se(Ce){return!Ce||Ce.length===2&&Ce[0]===-100&&Ce[1]===0}we.isDefault=Se})(Pe=e.FuzzyScore||(e.FuzzyScore={}));function Te(we,Se,Ce,ke,Le,ze,He){const Ve=we.length>$?$:we.length,Qe=ke.length>$?$:ke.length;if(!(Ce>=Ve||ze>=Qe||Ve-Ce>Qe-ze)&&!!ce(Se,Ce,Ve,Le,ze,Qe,!0)){Me(Ve,Qe,Ce,ze,Se,Le);let re=1,ge=1,me=Ce,Fe=ze;const z=[!1];for(re=1,me=Ce;me<Ve;re++,me++){const te=Ee[me],ie=ve[me],ue=me+1<Ve?ve[me+1]:Qe;for(ge=te-ze+1,Fe=te;Fe<ue;ge++,Fe++){let De=Number.MIN_SAFE_INTEGER,le=!1;Fe<=ie&&(De=je(we,Se,me,Ce,ke,Le,Fe,Qe,ze,q[re-1][ge-1]===0,z));let ye=0;De!==Number.MAX_SAFE_INTEGER&&(le=!0,ye=De+j[re-1][ge-1]);const be=Fe>te,Ae=be?j[re][ge-1]+(q[re][ge-1]>0?-5:0):0,se=Fe>te+1&&q[re][ge-1]>0,oe=se?j[re][ge-2]+(q[re][ge-2]>0?-5:0):0;if(se&&(!be||oe>=Ae)&&(!le||oe>=ye))j[re][ge]=oe,F[re][ge]=3,q[re][ge]=0;else if(be&&(!le||Ae>=ye))j[re][ge]=Ae,F[re][ge]=2,q[re][ge]=0;else if(le)j[re][ge]=ye,F[re][ge]=1,q[re][ge]=q[re-1][ge-1]+1;else throw new Error("not possible")}}if(A&&U(we,Ce,ke,ze),!(!z[0]&&!He)){re--,ge--;const X=[j[re][ge],ze];let ee=0,V=0;for(;re>=1;){let te=ge;do{const ie=F[re][te];if(ie===3)te=te-2;else if(ie===2)te=te-1;else break}while(te>=1);ee>1&&Se[Ce+re-1]===Le[ze+ge-1]&&!ae(te+ze-1,ke,Le)&&ee+1>q[re][te]&&(te=ge),te===ge?ee++:ee=1,V||(V=te),re--,ge=te-1,X.push(ge)}Qe===Ve&&(X[0]+=2);const K=V-Ve;return X[0]-=K,X}}}e.fuzzyScore=Te;function Me(we,Se,Ce,ke,Le,ze){let He=we-1,Ve=Se-1;for(;He>=Ce&&Ve>=ke;)Le[He]===ze[Ve]&&(ve[He]=Ve,He--),Ve--}function je(we,Se,Ce,ke,Le,ze,He,Ve,Qe,re,ge){if(Se[Ce]!==ze[He])return Number.MIN_SAFE_INTEGER;let me=1,Fe=!1;return He===Ce-ke?me=we[Ce]===Le[He]?7:5:ae(He,Le,ze)&&(He===0||!ae(He-1,Le,ze))?(me=we[Ce]===Le[He]?7:5,Fe=!0):W(ze,He)&&(He===0||!W(ze,He-1))?me=5:(W(ze,He-1)||ne(ze,He-1))&&(me=5,Fe=!0),me>1&&Ce===ke&&(ge[0]=!0),Fe||(Fe=ae(He,Le,ze)||W(ze,He-1)||ne(ze,He-1)),Ce===ke?He>Qe&&(me-=Fe?3:5):re?me+=Fe?2:0:me+=Fe?0:1,He+1===Ve&&(me-=Fe?3:5),me}function $e(we,Se,Ce,ke,Le,ze,He){return et(we,Se,Ce,ke,Le,ze,!0,He)}e.fuzzyScoreGracefulAggressive=$e;function Ye(we,Se,Ce,ke,Le,ze,He){return et(we,Se,Ce,ke,Le,ze,!1,He)}e.fuzzyScoreGraceful=Ye;function et(we,Se,Ce,ke,Le,ze,He,Ve){let Qe=Te(we,Se,Ce,ke,Le,ze,Ve);if(Qe&&!He)return Qe;if(we.length>=3){const re=Math.min(7,we.length-1);for(let ge=Ce+1;ge<re;ge++){const me=Je(we,ge);if(me){const Fe=Te(me,me.toLowerCase(),Ce,ke,Le,ze,Ve);Fe&&(Fe[0]-=3,(!Qe||Fe[0]>Qe[0])&&(Qe=Fe))}}}return Qe}function Je(we,Se){if(!(Se+1>=we.length)){const Ce=we[Se],ke=we[Se+1];if(Ce!==ke)return we.slice(0,Se)+ke+Ce+we.slice(Se+2)}}}),define(fe[44],he([0,1,14,28,2,25,13]),function(Q,e,S,d,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function L(){return Object.create(null)}e.getEmptyExpression=L;const h="**",n="/",D="[/\\\\]",b="[^/\\\\]",I=/\//g;function E(A){switch(A){case 0:return"";case 1:return`${b}*?`;default:return`(?:${D}|${b}+${D}|${D}${b}+)*?`}}function u(A,M){if(!A)return[];const U=[];let W=!1,ne=!1,ae="";for(const ce of A){switch(ce){case M:if(!W&&!ne){U.push(ae),ae="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}ae+=ce}return ae&&U.push(ae),U}e.splitGlobAware=u;function v(A){if(!A)return"";let M="";const U=u(A,n);if(U.every(W=>W===h))M=".*";else{let W=!1;U.forEach((ne,ae)=>{if(ne===h){W||(M+=E(2),W=!0);return}let ce=!1,de="",Pe=!1,Te="";for(const Me of ne){if(Me!=="}"&&ce){de+=Me;continue}if(Pe&&(Me!=="]"||!Te)){let je;Me==="-"?je=Me:(Me==="^"||Me==="!")&&!Te?je="^":Me===n?je="":je=S.escapeRegExpCharacters(Me),Te+=je;continue}switch(Me){case"{":ce=!0;continue;case"[":Pe=!0;continue;case"}":M+=`(?:${u(de,",").map(Ye=>v(Ye)).join("|")})`,ce=!1,de="";break;case"]":M+="["+Te+"]",Pe=!1,Te="";break;case"?":M+=b;continue;case"*":M+=E(1);continue;default:M+=S.escapeRegExpCharacters(Me)}}ae<U.length-1&&(U[ae+1]!==h||ae+2<U.length)&&(M+=D),W=!1})}return M}const _=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new y.LRUCache(1e4),i=function(){return!1},o=function(){return null};function a(A,M){if(!A)return o;let U;typeof A!="string"?U=A.pattern:U=A,U=U.trim();const W=`${U}_${!!M.trimForExclusions}`;let ne=t.get(W);if(ne)return s(ne,A);let ae;if(_.test(U)){const ce=U.substr(4);ne=function(de,Pe){return typeof de=="string"&&de.endsWith(ce)?U:null}}else(ae=w.exec(g(U,M)))?ne=C(ae[1],U):(M.trimForExclusions?l:m).test(U)?ne=R(U,M):(ae=c.exec(g(U,M)))?ne=p(ae[1].substr(1),U,!0):(ae=r.exec(g(U,M)))?ne=p(ae[1],U,!1):ne=f(U);return t.set(W,ne),s(ne,A)}function s(A,M){return typeof M=="string"?A:function(U,W){return d.isEqualOrParent(U,M.base)?A(P.relative(M.base,U),W):null}}function g(A,M){return M.trimForExclusions&&A.endsWith("/**")?A.substr(0,A.length-2):A}function C(A,M){const U=`/${A}`,W=`\\${A}`,ne=function(ce,de){return typeof ce!="string"?null:de?de===A?M:null:ce===A||ce.endsWith(U)||ce.endsWith(W)?M:null},ae=[A];return ne.basenames=ae,ne.patterns=[M],ne.allBasenames=ae,ne}function R(A,M){const U=F(A.slice(1,-1).split(",").map(de=>a(de,M)).filter(de=>de!==o),A),W=U.length;if(!W)return o;if(W===1)return U[0];const ne=function(de,Pe){for(let Te=0,Me=U.length;Te<Me;Te++)if(U[Te](de,Pe))return A;return null},ae=U.find(de=>!!de.allBasenames);ae&&(ne.allBasenames=ae.allBasenames);const ce=U.reduce((de,Pe)=>Pe.allPaths?de.concat(Pe.allPaths):de,[]);return ce.length&&(ne.allPaths=ce),ne}function p(A,M,U){const W=P.sep===P.posix.sep,ne=W?A:A.replace(I,P.sep),ae=P.sep+ne,ce=P.posix.sep+A,de=U?function(Pe,Te){return typeof Pe=="string"&&(Pe===ne||Pe.endsWith(ae)||!W&&(Pe===A||Pe.endsWith(ce)))?M:null}:function(Pe,Te){return typeof Pe=="string"&&(Pe===ne||!W&&Pe===A)?M:null};return de.allPaths=[(U?"*/":"./")+A],de}function f(A){try{const M=new RegExp(`^${v(A)}$`);return function(U){return M.lastIndex=0,typeof U=="string"&&M.test(U)?A:null}}catch(M){return o}}function T(A,M,U){return!A||typeof M!="string"?!1:O(A)(M,void 0,U)}e.match=T;function O(A,M={}){if(!A)return i;if(typeof A=="string"||J(A)){const U=a(A,M);if(U===o)return i;const W=function(ne,ae){return!!U(ne,ae)};return U.allBasenames&&(W.allBasenames=U.allBasenames),U.allPaths&&(W.allPaths=U.allPaths),W}return q(A,M)}e.parse=O;function H(A){if(!!A){let M;return U=>(M||(M=(A()||Promise.resolve([])).then(W=>W?x(W):{})),M.then(W=>!!W[U]))}}e.hasSiblingPromiseFn=H;function $(A){if(!!A){let M;return U=>{if(!M){const W=A();M=W?x(W):{}}return!!M[U]}}}e.hasSiblingFn=$;function x(A){const M={};for(const U of A)M[U]=!0;return M}function J(A){const M=A;return M&&typeof M.base=="string"&&typeof M.pattern=="string"}e.isRelativePattern=J;function Ee(A){return A.allBasenames||[]}e.getBasenameTerms=Ee;function ve(A){return A.allPaths||[]}e.getPathTerms=ve;function q(A,M){const U=F(Object.getOwnPropertyNames(A).map(de=>j(de,A[de],M)).filter(de=>de!==o)),W=U.length;if(!W)return o;if(!U.some(de=>!!de.requiresSiblings)){if(W===1)return U[0];const de=function(Me,je){for(let $e=0,Ye=U.length;$e<Ye;$e++){const et=U[$e](Me,je);if(et)return et}return null},Pe=U.find(Me=>!!Me.allBasenames);Pe&&(de.allBasenames=Pe.allBasenames);const Te=U.reduce((Me,je)=>je.allPaths?Me.concat(je.allPaths):Me,[]);return Te.length&&(de.allPaths=Te),de}const ne=function(de,Pe,Te){let Me;for(let je=0,$e=U.length;je<$e;je++){const Ye=U[je];Ye.requiresSiblings&&Te&&(Pe||(Pe=P.basename(de)),Me||(Me=Pe.substr(0,Pe.length-P.extname(de).length)));const et=Ye(de,Pe,Me,Te);if(et)return et}return null},ae=U.find(de=>!!de.allBasenames);ae&&(ne.allBasenames=ae.allBasenames);const ce=U.reduce((de,Pe)=>Pe.allPaths?de.concat(Pe.allPaths):de,[]);return ce.length&&(ne.allPaths=ce),ne}function j(A,M,U){if(M===!1)return o;const W=a(A,U);if(W===o)return o;if(typeof M=="boolean")return W;if(M){const ne=M.when;if(typeof ne=="string"){const ae=(ce,de,Pe,Te)=>{if(!Te||!W(ce,de))return null;const Me=ne.replace("$(basename)",Pe),je=Te(Me);return k.isThenable(je)?je.then($e=>$e?A:null):je?A:null};return ae.requiresSiblings=!0,ae}}return W}function F(A,M){const U=A.filter(de=>!!de.basenames);if(U.length<2)return A;const W=U.reduce((de,Pe)=>{const Te=Pe.basenames;return Te?de.concat(Te):de},[]);let ne;if(M){ne=[];for(let de=0,Pe=W.length;de<Pe;de++)ne.push(M)}else ne=U.reduce((de,Pe)=>{const Te=Pe.patterns;return Te?de.concat(Te):de},[]);const ae=function(de,Pe){if(typeof de!="string")return null;if(!Pe){let Me;for(Me=de.length;Me>0;Me--){const je=de.charCodeAt(Me-1);if(je===47||je===92)break}Pe=de.substr(Me)}const Te=W.indexOf(Pe);return Te!==-1?ne[Te]:null};ae.basenames=W,ae.patterns=ne,ae.allBasenames=W;const ce=A.filter(de=>!de.basenames);return ce.push(ae),ce}}),define(fe[116],he([0,1,70,115,14]),function(Q,e,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const y=new RegExp(`\\$\\(${S.CSSIcon.iconNameExpression}(?:${S.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(`(\\\\)?${y.source}`,"g");function L(v){return v.replace(k,(_,w)=>w?_:`\\${_}`)}e.escapeIcons=L;const h=new RegExp(`\\\\${y.source}`,"g");function n(v){return v.replace(h,_=>`\\${_}`)}e.markdownEscapeEscapedIcons=n;const D=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function b(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(D,(_,w,m,l)=>m?_:w||l||"")}e.stripIcons=b;function I(v){const _=v.indexOf(e.iconStartMarker);return _===-1?{text:v}:E(v,_)}e.parseLabelWithIcons=I;function E(v,_){const w=[];let m="";function l(g){if(g){m+=g;for(const C of g)w.push(t)}}let c=-1,r="",t=0,i,o,a=_;const s=v.length;for(l(v.substr(0,_));a<s;)i=v[a],o=v[a+1],i===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(c=a,l(r),r=e.iconStartMarker,a++):i===")"&&c!==-1?(t+=a-c+1,c=-1,r=""):c!==-1?/^[a-z0-9\-]$/i.test(i)?r+=i:(l(r),c=-1,r=""):l(i),a++;return l(r),{text:m,iconOffsets:w}}function u(v,_,w=!1){const{text:m,iconOffsets:l}=_;if(!l||l.length===0)return d.matchesFuzzy(v,m,w);const c=P.ltrim(m," "),r=m.length-c.length,t=d.matchesFuzzy(v,c,w);if(t)for(const i of t){const o=l[i.start+r]+r;i.start+=o,i.end+=o}return t}e.matchesFuzzyIconAware=u}),define(fe[72],he([0,1,16,116,12]),function(Q,e,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var y;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(y=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class k{constructor(v="",_=!1){var w,m;if(this.value=v,typeof this.value!="string")throw P.illegalArgument("value");typeof _=="boolean"?(this.isTrusted=_,this.supportThemeIcons=!1):(this.isTrusted=(w=_.isTrusted)!==null&&w!==void 0?w:void 0,this.supportThemeIcons=(m=_.supportThemeIcons)!==null&&m!==void 0?m:!1)}appendText(v,_=0){return this.value+=b(this.supportThemeIcons?d.escapeIcons(v):v).replace(/([ \t]+)/g,(w,m)=>"&nbsp;".repeat(m.length)).replace(/^>/gm,"\\>").replace(/\n/g,_===1?`\\
`:`

`),this}appendMarkdown(v){return this.value+=v,this}appendCodeblock(v,_){return this.value+="\n```",this.value+=v,this.value+=`
`,this.value+=_,this.value+="\n```\n",this}}e.MarkdownString=k;function L(u){return h(u)?!u.value:Array.isArray(u)?u.every(L):!0}e.isEmptyMarkdownString=L;function h(u){return u instanceof k?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.isMarkdownString=h;function n(u,v){return!u&&!v?!0:!u||!v?!1:Array.isArray(u)&&Array.isArray(v)?S.equals(u,v,D):h(u)&&h(v)?D(u,v):!1}e.markedStringsEquals=n;function D(u,v){return u===v?!0:!u||!v?!1:u.value===v.value&&u.isTrusted===v.isTrusted&&u.supportThemeIcons===v.supportThemeIcons}function b(u){return u.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=b;function I(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=I;function E(u){const v=[],_=u.split("|").map(m=>m.trim());u=_[0];const w=_[1];if(w){const m=/height=(\d+)/.exec(w),l=/width=(\d+)/.exec(w),c=m?m[1]:"",r=l?l[1]:"",t=isFinite(parseInt(r)),i=isFinite(parseInt(c));t&&v.push(`width="${r}"`),i&&v.push(`height="${c}"`)}return{href:u,dimensions:v}}e.parseHrefAndDimensions=E}),define(fe[45],he([0,1,18,14,3]),function(Q,e,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function y(n){return JSON.stringify(n,L)}e.stringify=y;function k(n){let D=JSON.parse(n);return D=h(D),D}e.parse=k;function L(n,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:d.regExpFlags(D)}:D}function h(n,D=0){if(!n||D>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return P.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof S.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let b=0;b<n.length;++b)n[b]=h(n[b],D+1);else for(const b in n)Object.hasOwnProperty.call(n,b)&&(n[b]=h(n[b],D+1))}return n}e.revive=h}),define(fe[8],he([0,1,3,5]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var P;(function(L){L.inMemory="inmemory",L.vscode="vscode",L.internal="private",L.walkThrough="walkThrough",L.walkThroughSnippet="walkThroughSnippet",L.http="http",L.https="https",L.file="file",L.mailto="mailto",L.untitled="untitled",L.data="data",L.command="command",L.vscodeRemote="vscode-remote",L.vscodeRemoteResource="vscode-remote-resource",L.userData="vscode-userdata",L.vscodeCustomEditor="vscode-custom-editor",L.vscodeNotebook="vscode-notebook",L.vscodeNotebookCell="vscode-notebook-cell",L.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",L.vscodeSettings="vscode-settings",L.vscodeWorkspaceTrust="vscode-workspace-trust",L.webviewPanel="webview-panel",L.vscodeWebview="vscode-webview",L.vscodeWebviewResource="vscode-webview-resource",L.extension="extension",L.vscodeFileResource="vscode-file"})(P=e.Schemas||(e.Schemas={}));class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(h){this._preferredWebSchema=h}setDelegate(h){this._delegate=h}set(h,n,D){this._hosts[h]=n,this._ports[h]=D}setConnectionToken(h,n){this._connectionTokens[h]=n}rewrite(h){if(this._delegate)return this._delegate(h);const n=h.authority;let D=this._hosts[n];D&&D.indexOf(":")!==-1&&(D=`[${D}]`);const b=this._ports[n],I=this._connectionTokens[n];let E=`path=${encodeURIComponent(h.path)}`;return typeof I=="string"&&(E+=`&tkn=${encodeURIComponent(I)}`),S.URI.from({scheme:d.isWeb?this._preferredWebSchema:P.vscodeRemoteResource,authority:`${D}:${b}`,path:"/vscode-remote-resource",query:E})}}e.RemoteAuthorities=new y;class k{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(h,n,D){const b=this.toUri(h,n);return b.scheme===P.vscodeRemote?e.RemoteAuthorities.rewrite(b):d.isNative&&(D||d.isPreferringBrowserCodeLoad)&&b.scheme===P.file?b.with({scheme:P.vscodeFileResource,authority:b.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):b}asFileUri(h,n){const D=this.toUri(h,n);return D.scheme===P.vscodeFileResource?D.with({scheme:P.file,authority:D.authority!==this.FALLBACK_AUTHORITY?D.authority:null,query:null,fragment:null}):D}toUri(h,n){return S.URI.isUri(h)?h:S.URI.parse(n.toUrl(h))}}e.FileAccess=new k}),define(fe[73],he([0,1,25]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const d=new S.LRUCache(1e4);function P(n){return h(n,"NFC",d)}e.normalizeNFC=P;const y=new S.LRUCache(1e4);function k(n){return h(n,"NFD",y)}e.normalizeNFD=k;const L=/[^\u0000-\u0080]/;function h(n,D,b){if(!e.canNormalize||!n)return n;const I=b.get(n);if(I)return I;let E;return L.test(n)?E=n.normalize(D):E=n,b.set(n,E),E}e.removeAccents=function(){if(e.canNormalize){const n=/[\u0300-\u036f]/g;return function(D){return k(D).replace(n,"")}}else return function(n){return n}}()}),define(fe[21],he([0,1,28,2,3,14,8,5]),function(Q,e,S,d,P,y,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function h(E){return P.uriToFsPath(E,!0)}e.originalFSPath=h;class n{constructor(u){this._ignorePathCasing=u}compare(u,v,_=!1){return u===v?0:y.compare(this.getComparisonKey(u,_),this.getComparisonKey(v,_))}isEqual(u,v,_=!1){return u===v?!0:!u||!v?!1:this.getComparisonKey(u,_)===this.getComparisonKey(v,_)}getComparisonKey(u,v=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,v,_=!1){if(u.scheme===v.scheme){if(u.scheme===k.Schemas.file)return S.isEqualOrParent(h(u),h(v),this._ignorePathCasing(u))&&u.query===v.query&&(_||u.fragment===v.fragment);if(e.isEqualAuthority(u.authority,v.authority))return S.isEqualOrParent(u.path,v.path,this._ignorePathCasing(u),"/")&&u.query===v.query&&(_||u.fragment===v.fragment)}return!1}joinPath(u,...v){return P.URI.joinPath(u,...v)}basenameOrAuthority(u){return e.basename(u)||u.authority}basename(u){return d.posix.basename(u.path)}extname(u){return d.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let v;return u.scheme===k.Schemas.file?v=P.URI.file(d.dirname(h(u))).path:(v=d.posix.dirname(u.path),u.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),v="/")),u.with({path:v})}normalizePath(u){if(!u.path.length)return u;let v;return u.scheme===k.Schemas.file?v=P.URI.file(d.normalize(h(u))).path:v=d.posix.normalize(u.path),u.with({path:v})}relativePath(u,v){if(!(u.scheme!==v.scheme||!e.isEqualAuthority(u.authority,v.authority))){if(u.scheme===k.Schemas.file){const m=d.relative(h(u),h(v));return L.isWindows?S.toSlashes(m):m}let _=u.path||"/",w=v.path||"/";if(this._ignorePathCasing(u)){let m=0;for(const l=Math.min(_.length,w.length);m<l&&!(_.charCodeAt(m)!==w.charCodeAt(m)&&_.charAt(m).toLowerCase()!==w.charAt(m).toLowerCase());m++);_=w.substr(0,m)+_.substr(m)}return d.posix.relative(_,w)}}resolvePath(u,v){if(u.scheme===k.Schemas.file){const _=P.URI.file(d.resolve(h(u),v));return u.with({authority:_.authority,path:_.path})}return v.indexOf("/")===-1&&(v=S.toSlashes(v),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v)),u.with({path:d.posix.resolve(u.path,v)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,v){return u===v||y.equalsIgnoreCase(u,v)}hasTrailingPathSeparator(u,v=d.sep){if(u.scheme===k.Schemas.file){const _=h(u);return _.length>S.getRoot(_).length&&_[_.length-1]===v}else{const _=u.path;return _.length>1&&_.charCodeAt(_.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,v=d.sep){return e.hasTrailingPathSeparator(u,v)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,v=d.sep){let _=!1;if(u.scheme===k.Schemas.file){const w=h(u);_=w!==void 0&&w.length===S.getRoot(w).length&&w[w.length-1]===v}else{v="/";const w=u.path;_=w.length===1&&w.charCodeAt(w.length-1)===47}return!_&&!e.hasTrailingPathSeparator(u,v)?u.with({path:u.path+"/"}):u}}e.ExtUri=n,e.extUri=new n(()=>!1),e.extUriBiasedIgnorePathCase=new n(E=>E.scheme===k.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new n(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function D(E,u){const v=[];for(let _=0;_<E.length;_++){const w=u(E[_]);E.some((m,l)=>l===_?!1:e.isEqualOrParent(w,u(m)))||v.push(E[_])}return v}e.distinctParents=D;var b;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function u(v){const _=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(l=>{const[c,r]=l.split(":");c&&r&&_.set(c,r)});const m=v.path.substring(0,v.path.indexOf(";"));return m&&_.set(E.META_DATA_MIME,m),_}E.parseMetaData=u})(b=e.DataUri||(e.DataUri={}));function I(E,u,v){if(u){let _=E.path;return _&&_[0]!==d.posix.sep&&(_=d.posix.sep+_),E.with({scheme:v,authority:u,path:_})}return E.with({scheme:v})}e.toLocalResource=I}),define(fe[53],he([0,1,3,2,14,8,5,21,28]),function(Q,e,S,d,P,y,k,L,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function n(a,s,g){if(typeof a=="string"&&(a=S.URI.file(a)),g){const R=g.getWorkspaceFolder(a);if(R){const p=g.getWorkspace().folders.length>1;let f;if(L.isEqual(R.uri,a)?f="":f=L.relativePath(R.uri,a),p){const T=R.name?R.name:L.basename(R.uri);f=f?T+" \u2022 "+f:T}return f}}if(a.scheme!==y.Schemas.file&&a.scheme!==y.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if(h.hasDriveLetter(a.fsPath))return d.normalize(b(a.fsPath));let C=d.normalize(a.fsPath);return!k.isWindows&&(s==null?void 0:s.userHome)&&(C=E(C,s.userHome.fsPath)),C}e.getPathLabel=n;function D(a){if(!!a){typeof a=="string"&&(a=S.URI.file(a));const s=L.basename(a)||(a.scheme===y.Schemas.file?a.fsPath:a.path);return k.isWindows&&h.isRootOrDriveLetter(s)?b(s):s}}e.getBaseLabel=D;function b(a){return h.hasDriveLetter(a)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=b;let I=Object.create(null);function E(a,s){if(k.isWindows||!a||!s)return a;let g=I.original===s?I.normalized:void 0;return g||(g=`${P.rtrim(s,d.posix.sep)}${d.posix.sep}`,I={original:s,normalized:g}),(k.isLinux?a.startsWith(g):P.startsWithIgnoreCase(a,g))&&(a=`~/${a.substr(g.length)}`),a}e.tildify=E;function u(a,s){return a.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=u;const v="\u2026",_="\\\\",w="~";function m(a,s=d.sep){const g=new Array(a.length);let C=!1;for(let R=0;R<a.length;R++){let p=a[R];if(p===""){g[R]=`.${s}`;continue}if(!p){g[R]=p;continue}C=!0;let f="";p.indexOf(_)===0?(f=p.substr(0,p.indexOf(_)+_.length),p=p.substr(p.indexOf(_)+_.length)):p.indexOf(s)===0?(f=p.substr(0,p.indexOf(s)+s.length),p=p.substr(p.indexOf(s)+s.length)):p.indexOf(w)===0&&(f=p.substr(0,p.indexOf(w)+w.length),p=p.substr(p.indexOf(w)+w.length));const T=p.split(s);for(let O=1;C&&O<=T.length;O++)for(let H=T.length-O;C&&H>=0;H--){C=!1;let $=T.slice(H,H+O).join(s);for(let x=0;!C&&x<a.length;x++)if(x!==R&&a[x]&&a[x].indexOf($)>-1){const J=H+O===T.length,Ee=H>0&&a[x].indexOf(s)>-1?s+$:$,ve=a[x].endsWith(Ee);C=!J||ve}if(!C){let x="";(T[0].endsWith(":")||f!=="")&&(H===1&&(H=0,O++,$=T[0]+s+$),H>0&&(x=T[0]+s),x=f+x),H>0&&(x=x+v+s),x=x+$,H+O<T.length&&(x=x+s+v),g[R]=x}}C&&(g[R]=p)}return g}e.shorten=m;var l;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function c(a,s=Object.create(null)){const g=[];let C=!1,R="";for(const p of a)if(p==="$"||C&&p==="{")R&&g.push({value:R,type:l.TEXT}),R="",C=!0;else if(p==="}"&&C){const f=s[R];if(typeof f=="string")f.length&&g.push({value:f,type:l.VARIABLE});else if(f){const T=g[g.length-1];(!T||T.type!==l.SEPARATOR)&&g.push({value:f.label,type:l.SEPARATOR})}R="",C=!1}else R+=p;return R&&!C&&g.push({value:R,type:l.TEXT}),g.filter((p,f)=>{if(p.type===l.SEPARATOR){const T=g[f-1],O=g[f+1];return[T,O].every(H=>H&&(H.type===l.VARIABLE||H.type===l.TEXT)&&H.value.length>0)}return!0}).map(p=>p.value).join("")}e.template=c;function r(a,s){return k.isMacintosh||s?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):a.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.mnemonicMenuLabel=r;function t(a,s){return k.isMacintosh||s?a.replace(/\(&&\w\)|&&/g,""):k.isWindows?a.replace(/&&|&/g,g=>g==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=i;function o(a){const s=a.indexOf("/")!==-1?d.posix:d.win32,g=s.basename(a),C=s.dirname(a);return g.length?{name:g,parentPath:C}:{name:C,parentPath:""}}e.splitName=o}),define(fe[117],he([0,1,2,14,44,8,21]),function(Q,e,S,d,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.MIME_UNKNOWN=e.MIME_BINARY=e.MIME_TEXT=void 0,e.MIME_TEXT="text/plain",e.MIME_BINARY="application/octet-stream",e.MIME_UNKNOWN="application/unknown";let L=[],h=[],n=[];function D(c,r=!1){const t=b(c);L.push(t),t.userConfigured?n.push(t):h.push(t),r&&!t.userConfigured&&L.forEach(i=>{i.mime===t.mime||i.userConfigured||(t.extension&&i.extension===t.extension&&console.warn(`Overwriting extension <<${t.extension}>> to now point to mime <<${t.mime}>>`),t.filename&&i.filename===t.filename&&console.warn(`Overwriting filename <<${t.filename}>> to now point to mime <<${t.mime}>>`),t.filepattern&&i.filepattern===t.filepattern&&console.warn(`Overwriting filepattern <<${t.filepattern}>> to now point to mime <<${t.mime}>>`),t.firstline&&i.firstline===t.firstline&&console.warn(`Overwriting firstline <<${t.firstline}>> to now point to mime <<${t.mime}>>`))})}e.registerTextMime=D;function b(c){return{id:c.id,mime:c.mime,filename:c.filename,extension:c.extension,filepattern:c.filepattern,firstline:c.firstline,userConfigured:c.userConfigured,filenameLowercase:c.filename?c.filename.toLowerCase():void 0,extensionLowercase:c.extension?c.extension.toLowerCase():void 0,filepatternLowercase:c.filepattern?c.filepattern.toLowerCase():void 0,filepatternOnPath:c.filepattern?c.filepattern.indexOf(S.posix.sep)>=0:!1}}function I(c){c?(L=L.filter(r=>!r.userConfigured),n=[]):(L=[],h=[],n=[])}e.clearTextMimes=I;function E(c,r){let t;if(c)switch(c.scheme){case y.Schemas.file:t=c.fsPath;break;case y.Schemas.data:t=k.DataUri.parseMetaData(c).get(k.DataUri.META_DATA_LABEL);break;default:t=c.path}if(!t)return[e.MIME_UNKNOWN];t=t.toLowerCase();const i=S.basename(t),o=u(t,i,n);if(o)return[o,e.MIME_TEXT];const a=u(t,i,h);if(a)return[a,e.MIME_TEXT];if(r){const s=v(r);if(s)return[s,e.MIME_TEXT]}return[e.MIME_UNKNOWN]}e.guessMimeTypes=E;function u(c,r,t){let i=null,o=null,a=null;for(let s=t.length-1;s>=0;s--){const g=t[s];if(r===g.filenameLowercase){i=g;break}if(g.filepattern&&(!o||g.filepattern.length>o.filepattern.length)){const C=g.filepatternOnPath?c:r;P.match(g.filepatternLowercase,C)&&(o=g)}g.extension&&(!a||g.extension.length>a.extension.length)&&r.endsWith(g.extensionLowercase)&&(a=g)}return i?i.mime:o?o.mime:a?a.mime:null}function v(c){if(d.startsWithUTF8BOM(c)&&(c=c.substr(1)),c.length>0)for(let r=L.length-1;r>=0;r--){const t=L[r];if(!!t.firstline){const i=c.match(t.firstline);if(i&&i.length>0)return t.mime}}return null}function _(c){return c?typeof c=="string"?c===e.MIME_BINARY||c===e.MIME_TEXT||c===e.MIME_UNKNOWN:c.length===1&&_(c[0]):!0}e.isUnspecific=_;const w={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function m(c){const r=S.extname(c);return w[r.toLowerCase()]}e.getMediaMime=m;function l(c){for(const r in w)if(w[r]===c)return r}e.getExtensionForMimeType=l}),define(fe[54],he([0,1,3]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function d(D){return D.toJSON()}class P{constructor(b){this._uriTransformer=b}transformIncoming(b){const I=this._uriTransformer.transformIncoming(b);return I===b?b:d(S.URI.from(I))}transformOutgoing(b){const I=this._uriTransformer.transformOutgoing(b);return I===b?b:d(S.URI.from(I))}transformOutgoingURI(b){const I=this._uriTransformer.transformOutgoing(b);return I===b?b:S.URI.from(I)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=P,e.DefaultURITransformer=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function y(D,b,I){if(!D||I>200)return null;if(typeof D=="object"){if(D instanceof S.URI)return b.transformOutgoing(D);for(let E in D)if(Object.hasOwnProperty.call(D,E)){const u=y(D[E],b,I+1);u!==null&&(D[E]=u)}}return null}function k(D,b){const I=y(D,b,0);return I===null?D:I}e.transformOutgoingURIs=k;function L(D,b,I,E){if(!D||E>200)return null;if(typeof D=="object"){if(D.$mid===1)return I?S.URI.revive(b.transformIncoming(D)):b.transformIncoming(D);for(let u in D)if(Object.hasOwnProperty.call(D,u)){const v=L(D[u],b,I,E+1);v!==null&&(D[u]=v)}}return null}function h(D,b){const I=L(D,b,!1,0);return I===null?D:I}e.transformIncomingURIs=h;function n(D,b){const I=L(D,b,!0,0);return I===null?D:I}e.transformAndReviveIncomingURIs=n}),define(fe[23],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function d(h){return S.test(h)}e.isUUID=d;const P=new Uint8Array(16),y=[];for(let h=0;h<256;h++)y.push(h.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(h){for(let n=0;n<h.length;n++)h[n]=Math.floor(Math.random()*256);return h};function L(){k(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let h=0,n="";return n+=y[P[h++]],n+=y[P[h++]],n+=y[P[h++]],n+=y[P[h++]],n+="-",n+=y[P[h++]],n+=y[P[h++]],n+="-",n+=y[P[h++]],n+=y[P[h++]],n+="-",n+=y[P[h++]],n+=y[P[h++]],n+="-",n+=y[P[h++]],n+=y[P[h++]],n+=y[P[h++]],n+=y[P[h++]],n+=y[P[h++]],n+=y[P[h++]],n}e.generateUuid=L}),define(fe[74],he([0,1,233]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class d{constructor(y="utf8"){this.stringDecoder=new S.StringDecoder(y),this.remaining=null}write(y){const k=[],L=this.remaining?this.remaining+this.stringDecoder.write(y):this.stringDecoder.write(y);if(L.length<1)return k;let h=0,n,D=h;for(;D<L.length;)if(n=L.charCodeAt(D),n===13||n===10){if(k.push(L.substring(h,D)),D++,D<L.length){const b=n;n=L.charCodeAt(D),(b===13&&n===10||b===10&&n===13)&&D++}h=D}else D++;return this.remaining=h<L.length?L.substr(h):null,k}end(){return this.remaining}}e.LineDecoder=d}),function(){"use strict";function Q(e,S,d,P){function y(u){return new Promise(v=>d.exists(u,v))}function k(u){return new Promise((v,_)=>{const w=new Date;d.utimes(u,w,w,m=>m?_(m):v())})}function L(u){return new Promise((v,_)=>d.mkdir(u,{recursive:!0},w=>w&&w.code!=="EEXIST"?_(w):v(u)))}function h(u){return new Promise((v,_)=>d.rmdir(u,{recursive:!0},w=>w&&w.code!=="ENOENT"?_(w):v()))}function n(u){return new Promise((v,_)=>d.readFile(u,"utf8",(w,m)=>w?_(w):v(m)))}function D(u,v){return new Promise((_,w)=>d.writeFile(u,v,"utf8",m=>m?w(m):_()))}function b(u){const v=S.join(u,"languagepacks.json");try{return e(v)}catch(_){}}function I(u,v){try{for(;v;){if(u[v])return v;{const _=v.lastIndexOf("-");if(_>0)v=v.substring(0,_);else return}}}catch(_){console.error("Resolving language pack configuration failed.",_)}}function E(u,v,_,w){if(w==="pseudo")return Promise.resolve({locale:w,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:w,availableLanguages:{}});if(w&&(w==="en"||w==="en-us"))return Promise.resolve({locale:w,availableLanguages:{}});const m=w;P.mark("code/willGenerateNls");const l=function(c){return P.mark("code/didGenerateNls"),Promise.resolve({locale:c,availableLanguages:{}})};try{if(!u)return l(m);const c=b(v);if(!c||(w=I(c,w),!w))return l(m);const r=c[w];let t;return!r||typeof r.hash!="string"||!r.translations||typeof(t=r.translations.vscode)!="string"?l(m):y(t).then(i=>{if(!i)return l(m);const o=r.hash+"."+w,a=S.join(v,"clp",o),s=S.join(a,u),g=S.join(a,"tcf.json"),C=S.join(a,"corrupted.info"),R={locale:m,availableLanguages:{"*":w},_languagePackId:o,_translationsConfigFile:g,_cacheRoot:a,_resolvedLanguagePackCoreLocation:s,_corruptedFile:C};return y(C).then(p=>{let f;return p?f=h(a):f=Promise.resolve(void 0),f.then(()=>y(s).then(T=>T?(k(s).catch(()=>{}),P.mark("code/didGenerateNls"),R):L(s).then(()=>Promise.all([n(_),n(t)])).then(O=>{const H=JSON.parse(O[0]),$=JSON.parse(O[1]).contents,x=Object.keys(H.bundles),J=[];for(const Ee of x){const ve=H.bundles[Ee],q=Object.create(null);for(const j of ve){const F=H.keys[j],A=H.messages[j],M=$[j];let U;if(M){U=[];for(let W=0;W<F.length;W++){const ne=F[W],ae=typeof ne=="string"?ne:ne.key;let ce=M[ae];ce===void 0&&(ce=A[W]),U.push(ce)}}else U=A;q[j]=U}J.push(D(S.join(s,Ee.replace(/\//g,"!")+".nls.json"),JSON.stringify(q)))}return J.push(D(g,JSON.stringify(r.translations))),Promise.all(J)}).then(()=>(P.mark("code/didGenerateNls"),R)).catch(O=>(console.error("Generating translation files failed.",O),l(w)))))})})}catch(c){return console.error("Generating translation files failed.",c),l(w)}}return{getNLSConfiguration:E}}if(typeof define=="function")define(fe[118],he([0,119,15,46]),function(e,S,d,P){return Q(e.__$__nodeRequire,S,d,P)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("fs"),d=require("../common/performance");module.exports=Q(require,e,S,d)}else throw new Error("Unknown context")}(),define(fe[120],he([0,1,22]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const d=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(L){const h=L.replace(/\-/g,":").toLowerCase();return!d.has(h)}function y(){return new Promise(async(L,h)=>{const n=setTimeout(()=>h("Unable to retrieve mac address (timeout after 10s)"),1e4);try{L(await k())}catch(D){h(D)}finally{clearTimeout(n)}})}e.getMac=y;function k(){return new Promise((L,h)=>{try{const n=S.networkInterfaces();for(const[,D]of Object.entries(n))for(const b of D)if(P(b.mac))return L(b.mac);h("Unable to retrieve mac address (unexpected format)")}catch(n){h(n)}})}}),define(fe[75],he([0,1,12,23,22,25,120]),function(Q,e,S,d,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(D){return this._virtualMachineOUIs||(this._virtualMachineOUIs=y.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(D)}value(){if(this._value===void 0){let D=0,b=0;const I=P.networkInterfaces();for(let E in I)if(Object.prototype.hasOwnProperty.call(I,E))for(const{mac:u,internal:v}of I[E])v||(b+=1,this._isVirtualMachineMacAdress(u.toUpperCase())&&(D+=1));this._value=b>0?D/b:0}return this._value}};let L;async function h(){return L||(L=(async()=>await n()||d.generateUuid())()),L}e.getMachineId=h;async function n(){try{const D=await new Promise((I,E)=>{Q(["crypto"],I,E)}),b=await k.getMac();return D.createHash("sha256").update(b,"utf8").digest("hex")}catch(D){S.onUnexpectedError(D);return}}}),define(fe[20],he([0,1,15,22,2,13,5,6,28,23,73]),function(Q,e,S,d,P,y,k,L,h,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=e.MAX_HEAP_SIZE=e.MAX_FILE_SIZE=void 0;const b=300*1024*1024,I=16*1024*1024*1024,E=700*1024*1024,u=700*2*1024*1024;e.MAX_FILE_SIZE=process.arch==="ia32"?b:I,e.MAX_HEAP_SIZE=process.arch==="ia32"?E:u;var v;(function(A){A[A.UNLINK=0]="UNLINK",A[A.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function _(A,M=v.UNLINK){if(h.isRootOrDriveLetter(A))throw new Error("rimraf - will refuse to recursively delete root");return M===v.UNLINK?m(A):w(A)}e.rimraf=_;async function w(A){try{const M=P.join(d.tmpdir(),n.generateUuid());try{await S.promises.rename(A,M)}catch(U){return m(A)}m(M).catch(U=>{})}catch(M){if(M.code!=="ENOENT")throw M}}async function m(A){return S.promises.rmdir(A,{recursive:!0,maxRetries:3})}function l(A){if(h.isRootOrDriveLetter(A))throw new Error("rimraf - will refuse to recursively delete root");S.rmdirSync(A,{recursive:!0})}e.rimrafSync=l;async function c(A,M){return i(await(M?r(A):S.promises.readdir(A)))}e.readdir=c;async function r(A){try{return await S.promises.readdir(A,{withFileTypes:!0})}catch(W){console.warn("[node.js fs] readdir with filetypes failed with error: ",W)}const M=[],U=await c(A);for(const W of U){let ne=!1,ae=!1,ce=!1;try{const de=await S.promises.lstat(P.join(A,W));ne=de.isFile(),ae=de.isDirectory(),ce=de.isSymbolicLink()}catch(de){console.warn("[node.js fs] unexpected error from lstat after readdir: ",de)}M.push({name:W,isFile:()=>ne,isDirectory:()=>ae,isSymbolicLink:()=>ce})}return M}function t(A){return i(S.readdirSync(A))}e.readdirSync=t;function i(A){return A.map(M=>typeof M=="string"?k.isMacintosh?D.normalizeNFC(M):M:(M.name=k.isMacintosh?D.normalizeNFC(M.name):M.name,M))}async function o(A){const M=await c(A),U=[];for(const W of M)await s.existsDirectory(P.join(A,W))&&U.push(W);return U}e.readDirsInDir=o;function a(A,M=1e3){return new Promise(U=>{let W=!1;const ne=setInterval(()=>{W||(W=!0,S.access(A,ae=>{W=!1,ae&&(clearInterval(ne),U(void 0))}))},M)})}e.whenDeleted=a;var s;(function(A){async function M(ne){let ae;try{if(ae=await S.promises.lstat(ne),!ae.isSymbolicLink())return{stat:ae}}catch(ce){}try{return{stat:await S.promises.stat(ne),symbolicLink:(ae==null?void 0:ae.isSymbolicLink())?{dangling:!1}:void 0}}catch(ce){if(ce.code==="ENOENT"&&ae)return{stat:ae,symbolicLink:{dangling:!0}};if(k.isWindows&&ce.code==="EACCES")try{return{stat:await S.promises.stat(await S.promises.readlink(ne)),symbolicLink:{dangling:!1}}}catch(de){if(de.code==="ENOENT"&&ae)return{stat:ae,symbolicLink:{dangling:!0}};throw de}throw ce}}A.stat=M;async function U(ne){try{const{stat:ae,symbolicLink:ce}=await A.stat(ne);return ae.isFile()&&(ce==null?void 0:ce.dangling)!==!0}catch(ae){}return!1}A.existsFile=U;async function W(ne){try{const{stat:ae,symbolicLink:ce}=await A.stat(ne);return ae.isDirectory()&&(ce==null?void 0:ce.dangling)!==!0}catch(ae){}return!1}A.existsDirectory=W})(s=e.SymlinkSupport||(e.SymlinkSupport={}));function g(A,M,U){const W=R(A);return p(W).queue(()=>{const ne=H(U);return new Promise((ae,ce)=>T(A,M,ne,de=>de?ce(de):ae()))})}e.writeFile=g;const C=new Map;function R(A){let M=A;return(k.isWindows||k.isMacintosh)&&(M=M.toLowerCase()),M}function p(A){const M=C.get(A);if(M)return M;const U=new y.Queue;return C.set(A,U),L.Event.once(U.onFinished)(()=>{C.delete(A),U.dispose()}),U}let f=!0;function T(A,M,U,W){if(!f)return S.writeFile(A,M,{mode:U.mode,flag:U.flag},W);S.open(A,U.flag,U.mode,(ne,ae)=>{if(ne)return W(ne);S.writeFile(ae,M,ce=>{if(ce)return S.close(ae,()=>W(ce));S.fdatasync(ae,de=>(de&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",de),f=!1),S.close(ae,Pe=>W(Pe))))})})}function O(A,M,U){const W=H(U);if(!f)return S.writeFileSync(A,M,{mode:W.mode,flag:W.flag});const ne=S.openSync(A,W.flag,W.mode);try{S.writeFileSync(ne,M);try{S.fdatasyncSync(ne)}catch(ae){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",ae),f=!1}}finally{S.closeSync(ne)}}e.writeFileSync=O;function H(A){return A?{mode:typeof A.mode=="number"?A.mode:438,flag:typeof A.flag=="string"?A.flag:"w"}:{mode:438,flag:"w"}}async function $(A,M){if(A!==M){async function U(W){try{const ne=await S.promises.lstat(W);if(ne.isDirectory()||ne.isSymbolicLink())return;const ae=await S.promises.open(W,"a");try{await ae.utimes(ne.atime,new Date)}finally{await ae.close()}}catch(ne){}}try{await S.promises.rename(A,M),await U(M)}catch(W){if(A.toLowerCase()!==M.toLowerCase()&&W.code==="EXDEV"||A.endsWith("."))await x(A,M,{preserveSymlinks:!1}),await _(A,v.MOVE),await U(M);else throw W}}}e.move=$;async function x(A,M,U){return Ee(A,M,{root:{source:A,target:M},options:U,handledSourcePaths:new Set})}e.copy=x;const J=511;async function Ee(A,M,U){if(!U.handledSourcePaths.has(A)){U.handledSourcePaths.add(A);const{stat:W,symbolicLink:ne}=await s.stat(A);if(ne){if(ne.dangling)return;if(U.options.preserveSymlinks)try{return await j(A,M,U)}catch(ae){console.warn("[node.js fs] copy of symlink failed: ",ae)}}return W.isDirectory()?ve(A,M,W.mode&J,U):q(A,M,W.mode&J)}}async function ve(A,M,U,W){await S.promises.mkdir(M,{recursive:!0,mode:U});const ne=await c(A);for(const ae of ne)await Ee(P.join(A,ae),P.join(M,ae),W)}async function q(A,M,U){await S.promises.copyFile(A,M),await S.promises.chmod(M,U)}async function j(A,M,U){let W=await S.promises.readlink(A);h.isEqualOrParent(W,U.root.source,!k.isLinux)&&(W=P.join(U.root.target,W.substr(U.root.source.length+1))),await S.promises.symlink(W,M)}async function F(A){try{return await S.promises.access(A),!0}catch(M){return!1}}e.exists=F}),define(fe[121],he([0,1,15,14,2,20]),function(Q,e,S,d,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function k(D){const b=P.dirname(D);if(D===b)return D;const I=(P.basename(D)||D).toLowerCase();try{const u=y.readdirSync(b).filter(v=>v.toLowerCase()===I);if(u.length===1){const v=k(b);if(v)return P.join(v,u[0])}else if(u.length>1){const v=u.indexOf(I);if(v>=0){const _=k(b);if(_)return P.join(_,u[v])}}}catch(E){}return null}e.realcaseSync=k;async function L(D){try{return await S.promises.realpath(D)}catch(b){const I=n(D);return await S.promises.access(I,S.constants.R_OK),I}}e.realpath=L;function h(D){try{return S.realpathSync(D)}catch(b){const I=n(D);return S.accessSync(I,S.constants.R_OK),I}}e.realpathSync=h;function n(D){return d.rtrim(P.normalize(D),P.sep)}}),define(fe[122],he([0,1,76]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=e.randomPort=void 0;function d(){const h=1025;return h+Math.floor((65535-h)*Math.random())}e.randomPort=d;function P(h,n,D){let b=!1;return new Promise(I=>{const E=setTimeout(()=>{if(!b)return b=!0,I(0)},D);y(h,n,u=>{if(!b)return b=!0,clearTimeout(E),I(u)})})}e.findFreePort=P;function y(h,n,D){if(n===0)return D(0);const b=new S.Socket;b.once("connect",()=>(L(b),y(h+1,n-1,D))),b.once("data",()=>{}),b.once("error",I=>(L(b),I.code!=="ECONNREFUSED"?y(h+1,n-1,D):D(h))),b.connect(h,"127.0.0.1")}function k(h,n,D){let b=!1,I,E=1;const u=S.createServer({pauseOnConnect:!0});function v(_,w){b||(b=!0,u.removeAllListeners(),u.close(),I&&clearTimeout(I),w(_))}return new Promise(_=>{I=setTimeout(()=>{v(0,_)},D),u.on("listening",()=>{v(h,_)}),u.on("error",w=>{w&&(w.code==="EADDRINUSE"||w.code==="EACCES")&&E<n?(h++,E++,u.listen(h,"127.0.0.1")):v(0,_)}),u.on("close",()=>{v(0,_)}),u.listen(h,"127.0.0.1")})}e.findFreePortFaster=k;function L(h){try{h.removeAllListeners("connect"),h.removeAllListeners("error"),h.end(),h.destroy(),h.unref()}catch(n){console.error(n)}}});var st=this&&this.__await||function(Q){return this instanceof st?(this.v=Q,this):new st(Q)},$t=this&&this.__asyncGenerator||function(Q,e,S){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var d=S.apply(Q,e||[]),P,y=[];return P={},k("next"),k("throw"),k("return"),P[Symbol.asyncIterator]=function(){return this},P;function k(I){d[I]&&(P[I]=function(E){return new Promise(function(u,v){y.push([I,E,u,v])>1||L(I,E)})})}function L(I,E){try{h(d[I](E))}catch(u){b(y[0][3],u)}}function h(I){I.value instanceof st?Promise.resolve(I.value.v).then(n,D):b(y[0][2],I)}function n(I){L("next",I)}function D(I){L("throw",I)}function b(I,E){I(E),y.shift(),y.length&&L(y[0][0],y[0][1])}},Ht=this&&this.__asyncValues||function(Q){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=Q[Symbol.asyncIterator],S;return e?e.call(Q):(Q=typeof __values=="function"?__values(Q):Q[Symbol.iterator](),S={},d("next"),d("throw"),d("return"),S[Symbol.asyncIterator]=function(){return this},S);function d(y){S[y]=Q[y]&&function(k){return new Promise(function(L,h){k=Q[y](k),P(L,h,k.done,k.value)})}}function P(y,k,L,h){Promise.resolve(h).then(function(n){y({value:n,done:L})},k)}};define(fe[123],he([0,1,20,22,2,36]),function(Q,e,S,d,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,L=/^Microsoft.PowerShell_.*/,h=/^Microsoft.PowerShellPreview_.*/;var n;(function(r){r[r.x64=0]="x64",r[r.x86=1]="x86",r[r.ARM=2]="ARM"})(n||(n={}));let D;switch(process.arch){case"ia32":case"x32":D=1;break;case"arm":case"arm64":D=2;break;default:D=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class I{constructor(t,i,o){this.exePath=t,this.displayName=i,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await S.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function E({useAlternateBitness:r=!1}={}){return r?D===0?y.env["ProgramFiles(x86)"]||null:b===0&&y.env.ProgramW6432||null:y.env.ProgramFiles||null}async function u({useAlternateBitness:r=!1,findPreview:t=!1}={}){const i=E({useAlternateBitness:r});if(!i)return null;const o=P.join(i,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(o))return null;let a=-1,s=null;for(const R of await S.readdir(o)){let p=-1;if(t){const T=R.indexOf("-");if(T<0)continue;const O=R.substring(0,T);if(!k.test(O)||R.substring(T+1)!=="preview")continue;p=parseInt(O,10)}else{if(!k.test(R))continue;p=parseInt(R,10)}if(!(p<=a)){const f=P.join(o,R,"pwsh.exe");!await S.SymlinkSupport.existsFile(f)||(s=f,a=p)}}if(!s)return null;const g=i.includes("x86")?" (x86)":"",C=t?" Preview":"";return new I(s,`PowerShell${C}${g}`,!0)}async function v({findPreview:r}={}){if(!y.env.LOCALAPPDATA)return null;const t=P.join(y.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(t))return null;const{pwshMsixDirRegex:i,pwshMsixName:o}=r?{pwshMsixDirRegex:h,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};try{for(const a of await S.readdir(t))if(i.test(a)){const s=P.join(t,a,"pwsh.exe");return new I(s,o)}}catch(a){console.warn(`Unable to read MSIX directory (${t}) because of the following error: ${a}`)}return null}function _(){const r=P.join(d.homedir(),".dotnet","tools","pwsh.exe");return new I(r,".NET Core PowerShell Global Tool")}function w(){const r=P.join(y.env.windir,D===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(r,"Windows PowerShell",!0)}function m(){return $t(this,arguments,function*(){let t=yield st(u());t&&(yield yield st(t)),t=yield st(u({useAlternateBitness:!0})),t&&(yield yield st(t)),t=yield st(v()),t&&(yield yield st(t)),t=_(),t&&(yield yield st(t)),t=yield st(u({findPreview:!0})),t&&(yield yield st(t)),t=yield st(v({findPreview:!0})),t&&(yield yield st(t)),t=yield st(u({useAlternateBitness:!0,findPreview:!0})),t&&(yield yield st(t)),t=w(),t&&(yield yield st(t))})}function l(){return $t(this,arguments,function*(){var t,i;try{for(var o=Ht(m()),a;a=yield st(o.next()),!a.done;){const s=a.value;(yield st(s.exists()))&&(yield yield st(s))}}catch(s){t={error:s}}finally{try{a&&!a.done&&(i=o.return)&&(yield st(i.call(o)))}finally{if(t)throw t.error}}})}e.enumeratePowerShellInstallations=l;async function c(){var r,t;try{for(var i=Ht(l()),o;o=await i.next(),!o.done;)return o.value}catch(a){r={error:a}}finally{try{o&&!o.done&&(t=i.return)&&await t.call(i)}finally{if(r)throw r.error}}return null}e.getFirstAvailablePowerShellInstallation=c}),define(fe[77],he([0,1,32,8]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function P(k){return new Promise((L,h)=>{let n;const D=new Map;function b(u,v,_,w,m){const l=D.get(v);if(u===k||l){const c={name:I(_),cmd:_,pid:u,ppid:v,load:w,mem:m};D.set(u,c),u===k&&(n=c),l&&(l.children||(l.children=[]),l.children.push(c),l.children.length>1&&(l.children=l.children.sort((r,t)=>r.pid-t.pid)))}}function I(u){const v=/--disable-blink-features=Auxclick/,_=/\\watcher\\win32\\CodeHelper\.exe/,w=/--crashes-directory/,m=/\\pipe\\winpty-control/,l=/conhost\.exe/,c=/--type=([a-zA-Z-]+)/;if(_.exec(u))return"watcherService ";if(w.exec(u))return"electron-crash-reporter";if(m.exec(u))return"winpty-process";if(l.exec(u))return"console-window-host (Windows internal process)";let r=c.exec(u);if(r&&r.length===2)return r[1]==="renderer"?v.exec(u)?"shared-process":"window":r[1];const t=/[a-zA-Z-]+\.js/g;let i="";do r=t.exec(u),r&&(i+=r+" ");while(r);return i&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron_node ${i}`:u}if(process.platform==="win32"){const u=v=>v.indexOf("\\\\?\\")===0||v.indexOf("\\??\\")===0?v.substr(4):v.indexOf('"\\\\?\\')===0||v.indexOf('"\\??\\')===0?'"'+v.substr(5):v;new Promise((v,_)=>{Q(["windows-process-tree"],v,_)}).then(v=>{v.getProcessList(k,_=>{v.getProcessCpuUsage(_,w=>{const m=new Map;w.forEach(l=>{const c=u(l.commandLine||"");m.set(l.pid,{name:I(c),cmd:c,pid:l.pid,ppid:l.ppid,load:l.cpu||0,mem:l.memory||0})}),n=m.get(k),n?(m.forEach(l=>{const c=m.get(l.ppid);c&&(c.children||(c.children=[]),c.children.push(l))}),m.forEach(l=>{l.children&&(l.children=l.children.sort((c,r)=>c.pid-r.pid))}),L(n)):h(new Error(`Root process ${k} not found`))})},v.ProcessDataFlag.CommandLine|v.ProcessDataFlag.Memory)})}else{function E(){let u=[n];const v=[];for(;u.length;){const w=u.shift();w&&(v.push(w.pid),w.children&&(u=u.concat(w.children)))}let _=JSON.stringify(d.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Q).fsPath);_+=" "+v.join(" "),S.exec(_,{},(w,m,l)=>{if(w||l)h(w||new Error(l.toString()));else{const c=m.toString().split(`
`);for(let r=0;r<v.length;r++){const t=D.get(v[r]);t.load=parseFloat(c[r])}if(!n){h(new Error(`Root process ${k} not found`));return}L(n)}})}S.exec("which ps",{},(u,v,_)=>{if(u||_)if(process.platform!=="linux")h(u||new Error(_.toString()));else{const w=JSON.stringify(d.FileAccess.asFileUri("vs/base/node/ps.sh",Q).fsPath);S.exec(w,{},(m,l,c)=>{m||c?h(m||new Error(c.toString())):(y(l,b),E())})}else{const w=v.toString().trim(),m="-ax -o pid=,ppid=,pcpu=,pmem=,command=";S.exec(`${w} ${m}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,c,r)=>{l||r&&!r.includes("screen size is bogus")?h(l||new Error(r.toString())):(y(c,b),process.platform==="linux"?E():n?L(n):h(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=P;function y(k,L){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,n=k.toString().split(`
`);for(const D of n){const b=h.exec(D.trim());b&&b.length===6&&L(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),function(){"use strict";function Q(e,S,d){function P(){let y=process.env.VSCODE_APPDATA;if(!y)switch(process.platform){case"win32":if(y=process.env.APPDATA,!y){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");y=e.join(k,"AppData","Roaming")}break;case"darwin":y=e.join(S.homedir(),"Library","Application Support");break;case"linux":y=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(y,d)}return{getDefaultUserDataPath:P}}if(typeof define=="function")define(fe[124],he([0,119,22,8,21]),function(e,S,d,P,y){const k=y.dirname(P.FileAccess.asFileUri("",e)),L=e.__$__nodeRequire(y.joinPath(k,"package.json").fsPath);return Q(S,d,L.name)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../package.json"),S=require("path"),d=require("os");module.exports=Q(S,d,e.name)}else throw new Error("Unknown context")}(),define(fe[125],he([0,1,2,15,5,73,4,20]),function(Q,e,S,d,P,y,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function h(b,I,E){return D({path:b,isDirectory:!1},I,E)}e.watchFile=h;function n(b,I,E){return D({path:b,isDirectory:!0},I,E)}e.watchFolder=n,e.CHANGE_BUFFER_DELAY=100;function D(b,I,E){const u=S.basename(b.path),v=new Map;let _=!1,w=[k.toDisposable(()=>{v.forEach(m=>k.dispose(m)),v.clear()})];try{const m=d.watch(b.path);w.push(k.toDisposable(()=>{m.removeAllListeners(),m.close()}));const l=new Set;b.isDirectory&&L.readdir(b.path).then(c=>c.forEach(r=>l.add(r))),m.on("error",(c,r)=>{_||E(`Failed to watch ${b.path} for changes using fs.watch() (${c}, ${r})`)}),m.on("change",(c,r)=>{if(!_){let t="";if(r&&(t=r.toString(),P.isMacintosh&&(t=y.normalizeNFC(t))),!(!t||c!=="change"&&c!=="rename")){const i=b.isDirectory?S.join(b.path,t):b.path;if(b.isDirectory)if(c==="rename"){const o=v.get(i);o&&k.dispose(o);const a=setTimeout(async()=>{v.delete(i);const s=await L.exists(i);if(!_){let g;s?l.has(t)?g="changed":(g="added",l.add(t)):(l.delete(t),g="deleted"),I(g,i)}},e.CHANGE_BUFFER_DELAY);v.set(i,k.toDisposable(()=>clearTimeout(a)))}else{let o;l.has(t)?o="changed":(o="added",l.add(t)),I(o,i)}else if(c==="rename"||t!==u){const o=setTimeout(async()=>{const a=await L.exists(i);_||(a?(I("changed",i),w=[D(b,I,E)]):I("deleted",i))},e.CHANGE_BUFFER_DELAY);k.dispose(w),w=[k.toDisposable(()=>clearTimeout(o))]}else I("changed",i)}}})}catch(m){L.exists(b.path).then(l=>{l&&!_&&E(`Failed to watch ${b.path} for changes using fs.watch() (${m.toString()})`)})}return k.toDisposable(()=>{_=!0,w=k.dispose(w)})}}),define(fe[37],he([0,1,6,4,13,27,12,18,16,11,45,14]),function(Q,e,S,d,P,y,k,L,h,n,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var I;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(I=e.RequestType||(e.RequestType={}));function E(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(u=e.ResponseType||(e.ResponseType={}));function v(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var _;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(_||(_={}));class w{constructor(F){this.buffer=F,this.pos=0}read(F){const A=this.buffer.slice(this.pos,this.pos+F);return this.pos+=A.byteLength,A}}class m{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var l;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object"})(l||(l={}));function c(j){const F=L.VSBuffer.alloc(4);return F.writeUInt32BE(j,0),F}function r(j){return j.read(4).readUInt32BE(0)}function t(j){const F=L.VSBuffer.alloc(1);return F.writeUInt8(j,0),F}const i={Undefined:t(l.Undefined),String:t(l.String),Buffer:t(l.Buffer),VSBuffer:t(l.VSBuffer),Array:t(l.Array),Object:t(l.Object)},o=typeof Buffer!="undefined";function a(j,F){if(typeof F=="undefined")j.write(i.Undefined);else if(typeof F=="string"){const A=L.VSBuffer.fromString(F);j.write(i.String),j.write(c(A.byteLength)),j.write(A)}else if(o&&Buffer.isBuffer(F)){const A=L.VSBuffer.wrap(F);j.write(i.Buffer),j.write(c(A.byteLength)),j.write(A)}else if(F instanceof L.VSBuffer)j.write(i.VSBuffer),j.write(c(F.byteLength)),j.write(F);else if(Array.isArray(F)){j.write(i.Array),j.write(c(F.length));for(const A of F)a(j,A)}else{const A=L.VSBuffer.fromString(JSON.stringify(F));j.write(i.Object),j.write(c(A.byteLength)),j.write(A)}}function s(j){switch(j.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return j.read(r(j)).toString();case l.Buffer:return j.read(r(j)).buffer;case l.VSBuffer:return j.read(r(j));case l.Array:{const A=r(j),M=[];for(let U=0;U<A;U++)M.push(s(j));return M}case l.Object:return JSON.parse(j.read(r(j)).toString())}}class g{constructor(F,A,M=null,U=1e3){this.protocol=F,this.ctx=A,this.logger=M,this.timeoutDelay=U,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel(F,A){this.channels.set(F,A),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const A=this.send([F.type]);this.logger&&this.logger.logOutgoing(A,0,1,v(F.type));return}case 201:case 202:case 204:case 203:{const A=this.send([F.type,F.id],F.data);this.logger&&this.logger.logOutgoing(A,F.id,1,v(F.type),F.data);return}}}send(F,A=void 0){const M=new m;return a(M,F),a(M,A),this.sendBuffer(M.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(A){return 0}}onRawMessage(F){const A=new w(F),M=s(A),U=s(A),W=M[0];switch(W){case 100:return this.logger&&this.logger.logIncoming(F.byteLength,M[1],1,`${E(W)}: ${M[2]}.${M[3]}`,U),this.onPromise({type:W,id:M[1],channelName:M[2],name:M[3],arg:U});case 102:return this.logger&&this.logger.logIncoming(F.byteLength,M[1],1,`${E(W)}: ${M[2]}.${M[3]}`,U),this.onEventListen({type:W,id:M[1],channelName:M[2],name:M[3],arg:U});case 101:return this.logger&&this.logger.logIncoming(F.byteLength,M[1],1,`${E(W)}`),this.disposeActiveRequest({type:W,id:M[1]});case 103:return this.logger&&this.logger.logIncoming(F.byteLength,M[1],1,`${E(W)}`),this.disposeActiveRequest({type:W,id:M[1]})}}onPromise(F){const A=this.channels.get(F.channelName);if(!A){this.collectPendingRequest(F);return}const M=new y.CancellationTokenSource;let U;try{U=A.call(this.ctx,F.name,F.arg,M.token)}catch(ae){U=Promise.reject(ae)}const W=F.id;U.then(ae=>{this.sendResponse({id:W,data:ae,type:201}),this.activeRequests.delete(F.id)},ae=>{ae instanceof Error?this.sendResponse({id:W,data:{message:ae.message,name:ae.name,stack:ae.stack?ae.stack.split?ae.stack.split(`
`):ae.stack:void 0},type:202}):this.sendResponse({id:W,data:ae,type:203}),this.activeRequests.delete(F.id)});const ne=d.toDisposable(()=>M.cancel());this.activeRequests.set(F.id,ne)}onEventListen(F){const A=this.channels.get(F.channelName);if(!A){this.collectPendingRequest(F);return}const M=F.id,W=A.listen(this.ctx,F.name,F.arg)(ne=>this.sendResponse({id:M,data:ne,type:204}));this.activeRequests.set(F.id,W)}disposeActiveRequest(F){const A=this.activeRequests.get(F.id);A&&(A.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let A=this.pendingRequests.get(F.channelName);A||(A=[],this.pendingRequests.set(F.channelName,A));const M=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);A.push({request:F,timeoutTimer:M})}flushPendingRequests(F){const A=this.pendingRequests.get(F);if(A){for(const M of A)switch(clearTimeout(M.timeoutTimer),M.request.type){case 100:this.onPromise(M.request);break;case 102:this.onEventListen(M.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}e.ChannelServer=g;var C;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(C=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(F,A=null){this.protocol=F,this.isDisposed=!1,this.state=_.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(M=>this.onBuffer(M)),this.logger=A}getChannel(F){const A=this;return{call(M,U,W){return A.isDisposed?Promise.reject(k.canceled()):A.requestPromise(F,M,U,W)},listen(M,U){return A.isDisposed?Promise.reject(k.canceled()):A.requestEvent(F,M,U)}}}requestPromise(F,A,M,U=y.CancellationToken.None){const W=this.lastRequestId++,ae={id:W,type:100,channelName:F,name:A,arg:M};if(U.isCancellationRequested)return Promise.reject(k.canceled());let ce;return new Promise((Pe,Te)=>{if(U.isCancellationRequested)return Te(k.canceled());const Me=()=>{const et=Je=>{switch(Je.type){case 201:this.handlers.delete(W),Pe(Je.data);break;case 202:this.handlers.delete(W);const we=new Error(Je.data.message);we.stack=Je.data.stack,we.name=Je.data.name,Te(we);break;case 203:this.handlers.delete(W),Te(Je.data);break}};this.handlers.set(W,et),this.sendRequest(ae)};let je=null;this.state===_.Idle?Me():(je=P.createCancelablePromise(et=>this.whenInitialized()),je.then(()=>{je=null,Me()}));const $e=()=>{je?(je.cancel(),je=null):this.sendRequest({id:W,type:101}),Te(k.canceled())},Ye=U.onCancellationRequested($e);ce=d.combinedDisposable(d.toDisposable($e),Ye),this.activeRequests.add(ce)}).finally(()=>{this.activeRequests.delete(ce)})}requestEvent(F,A,M){const U=this.lastRequestId++,ne={id:U,type:102,channelName:F,name:A,arg:M};let ae=null;const ce=new S.Emitter({onFirstListenerAdd:()=>{ae=P.createCancelablePromise(Pe=>this.whenInitialized()),ae.then(()=>{ae=null,this.activeRequests.add(ce),this.sendRequest(ne)})},onLastListenerRemove:()=>{ae?(ae.cancel(),ae=null):(this.activeRequests.delete(ce),this.sendRequest({id:U,type:103}))}}),de=Pe=>ce.fire(Pe.data);return this.handlers.set(U,de),ce.event}sendRequest(F){switch(F.type){case 100:case 102:{const A=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger&&this.logger.logOutgoing(A,F.id,0,`${E(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const A=this.send([F.type,F.id]);this.logger&&this.logger.logOutgoing(A,F.id,0,E(F.type));return}}}send(F,A=void 0){const M=new m;return a(M,F),a(M,A),this.sendBuffer(M.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(A){return 0}}onBuffer(F){const A=new w(F),M=s(A),U=s(A),W=M[0];switch(W){case 200:return this.logger&&this.logger.logIncoming(F.byteLength,0,0,v(W)),this.onResponse({type:M[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(F.byteLength,M[1],0,v(W),U),this.onResponse({type:M[0],id:M[1],data:U})}}onResponse(F){if(F.type===200){this.state=_.Idle,this._onDidInitialize.fire();return}const A=this.handlers.get(F.id);A&&A(F)}whenInitialized(){return this.state===_.Idle?Promise.resolve():S.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}e.ChannelClient=R;class p{constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:A,onDidClientDisconnect:M})=>{S.Event.once(A.onMessage)(W=>{const ne=new w(W),ae=s(ne),ce=new g(A,ae),de=new R(A);this.channels.forEach((Te,Me)=>ce.registerChannel(Me,Te));const Pe={channelServer:ce,channelClient:de,ctx:ae};this._connections.add(Pe),this._onDidAddConnection.fire(Pe),M(()=>{ce.dispose(),de.dispose(),this._connections.delete(Pe),this._onDidRemoveConnection.fire(Pe)})})})}get connections(){const F=[];return this._connections.forEach(A=>F.push(A)),F}getChannel(F,A){const M=this;return{call(U,W,ne){let ae;if(n.isFunction(A)){let de=h.getRandomElement(M.connections.filter(A));ae=de?Promise.resolve(de):S.Event.toPromise(S.Event.filter(M.onDidAddConnection,A))}else ae=A.routeCall(M,U,W);const ce=ae.then(de=>de.channelClient.getChannel(F));return T(ce).call(U,W,ne)},listen(U,W){if(n.isFunction(A))return M.getMulticastEvent(F,A,U,W);const ne=A.routeEvent(M,U,W).then(ae=>ae.channelClient.getChannel(F));return T(ne).listen(U,W)}}}getMulticastEvent(F,A,M,U){const W=this;let ne=new d.DisposableStore;const ae=new S.Emitter({onFirstListenerAdd:()=>{ne=new d.DisposableStore;const ce=new S.EventMultiplexer,de=new Map,Pe=Me=>{const $e=Me.channelClient.getChannel(F).listen(M,U),Ye=ce.add($e);de.set(Me,Ye)},Te=Me=>{const je=de.get(Me);!je||(je.dispose(),de.delete(Me))};W.connections.filter(A).forEach(Pe),S.Event.filter(W.onDidAddConnection,A)(Pe,void 0,ne),W.onDidRemoveConnection(Te,void 0,ne),ce.event(ae.fire,ae,ne),ne.add(ce)},onLastListenerRemove:()=>{ne.dispose()}});return ae.event}registerChannel(F,A){this.channels.set(F,A),this._connections.forEach(M=>{M.channelServer.registerChannel(F,A)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=p;class f{constructor(F,A,M=null){const U=new m;a(U,A),F.send(U.buffer),this.channelClient=new R(F,M),this.channelServer=new g(F,A,M)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,A){this.channelServer.registerChannel(F,A)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=f;function T(j){return{call(F,A,M){return j.then(U=>U.call(F,A,M))},listen(F,A){const M=new S.Relay;return j.then(U=>M.input=U.listen(F,A)),M.event}}}e.getDelayedChannel=T;function O(j){let F=!1;return{call(A,M,U){return F?j.call(A,M,U):P.timeout(0).then(()=>F=!0).then(()=>j.call(A,M,U))},listen(A,M){if(F)return j.listen(A,M);const U=new S.Relay;return P.timeout(0).then(()=>F=!0).then(()=>U.input=j.listen(A,M)),U.event}}}e.getNextTickChannel=O;class H{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const A of F.connections)if(await Promise.resolve(this.fn(A.ctx)))return Promise.resolve(A);return await S.Event.toPromise(F.onDidAddConnection),await this.route(F)}}e.StaticRouter=H;var $;(function(j){function F(U,W){const ne=U,ae=W&&W.disableMarshalling,ce=new Map;for(const de in ne)M(de)&&ce.set(de,S.Event.buffer(ne[de],!0));return new class{listen(de,Pe){const Te=ce.get(Pe);if(Te)return Te;throw new Error(`Event not found: ${Pe}`)}call(de,Pe,Te){const Me=ne[Pe];if(typeof Me=="function"){if(!ae&&Array.isArray(Te))for(let je=0;je<Te.length;je++)Te[je]=D.revive(Te[je]);return Me.apply(ne,Te)}throw new Error(`Method not found: ${Pe}`)}}}j.fromService=F;function A(U,W){const ne=W&&W.disableMarshalling;return new Proxy({},{get(ae,ce){var de;if(typeof ce=="string")return((de=W==null?void 0:W.properties)===null||de===void 0?void 0:de.has(ce))?W.properties.get(ce):M(ce)?U.listen(ce):async function(...Pe){let Te;W&&!n.isUndefinedOrNull(W.context)?Te=[W.context,...Pe]:Te=Pe;const Me=await U.call(ce,Te);return ne?Me:D.revive(Me)};throw new Error(`Property not found: ${String(ce)}`)}})}j.toService=A;function M(U){return U[0]==="o"&&U[1]==="n"&&b.isUpperAsciiLetter(U.charCodeAt(2))}})($=e.ProxyChannel||(e.ProxyChannel={}));const x=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function J(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){let F=j.toString();if(F!=="[object Object]")return F}return j}function Ee(j){return Array.isArray(j)?j.map(J):J(j)}function ve(j,F,A,M,U,W,ne){ne=Ee(ne);const ae=x[U],ce=ae[M%ae.length];let de=[`%c[${j}]%c[${String(F).padStart(7," ")}]%c[len: ${String(A).padStart(5," ")}]%c${String(M).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${ce}`];/\($/.test(W)?(de=de.concat(ne),de.push(")")):de.push(ne),console.log.apply(console,de)}e.logWithColors=ve;class q{constructor(F,A){this._outgoingPrefix=F,this._incomingPrefix=A,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,A,M,U,W){this._totalOutgoing+=F,ve(this._outgoingPrefix,this._totalOutgoing,F,A,M,U,W)}logIncoming(F,A,M,U,W){this._totalIncoming+=F,ve(this._incomingPrefix,this._totalIncoming,F,A,M,U,W)}}e.IPCLogger=q}),define(fe[78],he([0,1,6,37,4,18,5,36]),function(Q,e,S,d,P,y,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let h=null;function n(){return h||(h=y.VSBuffer.alloc(0)),h}class D{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,a){if(o===0)return n();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const R=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=o),R}if(this._chunks[0].byteLength>o){const R=this._chunks[0].slice(0,o);return a&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),R}let s=y.VSBuffer.alloc(o),g=0,C=0;for(;o>0;){const R=this._chunks[C];if(R.byteLength>o){const p=R.slice(0,o);s.set(p,g),g+=o,a&&(this._chunks[C]=R.slice(o),this._totalLength-=o),o-=o}else s.set(R,g),g+=R.byteLength,a?(this._chunks.shift(),this._totalLength-=R.byteLength):C++,o-=R.byteLength}return s}}e.ChunkStream=D;var b;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.KeepAlive=4]="KeepAlive",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest"})(b||(b={}));var I;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",i[i.KeepAliveTime=5e3]="KeepAliveTime",i[i.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(I=e.ProtocolConstants||(e.ProtocolConstants={}));class E{constructor(o,a,s,g){this.type=o,this.id=a,this.ack=s,this.data=g,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends P.Disposable{constructor(o){super();this._onMessage=this._register(new S.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new D,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const s=this._state.messageType,g=this._state.id,C=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new E(s,g,C,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class v{constructor(o){this._isDisposed=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(o){if(!this._isDisposed){o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=y.VSBuffer.alloc(13);a.writeUInt8(o.type,0),a.writeUInt32BE(o.id,1),a.writeUInt32BE(o.ack,5),a.writeUInt32BE(o.data.byteLength,9),this._writeSoon(a,o.data)}}_bufferAdd(o,a){const s=this._totalLength===0;return this._data.push(o,a),this._totalLength+=o.byteLength+a.byteLength,s}_bufferTake(){const o=y.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,a){this._bufferAdd(o,a)&&k.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class _ extends P.Disposable{constructor(o){super();this._onMessage=new S.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new S.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new v(this._socket)),this._socketReader=this._register(new u(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new E(1,0,0,o))}}e.Protocol=_;class w extends d.IPCClient{constructor(o,a,s=null){super(o,a,s);this.protocol=o}static fromSocket(o,a){return new w(new _(o),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=w;class m{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new S.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,L.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=m;class l{constructor(o){this.data=o,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],a=0,s=this._first;for(;s;)o[a++]=s.data,s=s.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const a=new l(o);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class r{constructor(){this.lastRuns=[];const o=Date.now();for(let a=0;a<r._HISTORY_LENGTH;a++)this.lastRuns[a]=o-1e3*a;setInterval(()=>{for(let a=r._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}load(){const o=Date.now(),a=(1+r._HISTORY_LENGTH)*1e3;let s=0;for(let g=0;g<r._HISTORY_LENGTH;g++)o-this.lastRuns[g]<=a&&s++;return 1-s/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class t{constructor(o,a=null){this._loadEstimator=r.getInstance(),this._onControlMessage=new m,this.onControlMessage=this._onControlMessage.event,this._onMessage=new m,this.onMessage=this._onMessage.event,this._onDidDispose=new m,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new m,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new m,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=o,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new u(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(s=>this._receiveMessage(s))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=P.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new E(5,0,0,n());this._socketWriter.write(o),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const o=Date.now()-this._socketWriter.lastWriteTime;if(o>=5e3){const a=new E(4,0,0,n());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-o+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const o=Date.now()-this._socketReader.lastReadTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-o,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,a){this._isReconnecting=!0,this._socketDisposables=P.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=o,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new u(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(s=>this._receiveMessage(s))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const o=this._outgoingUnackMsg.toArray();for(let a=0,s=o.length;a<s;a++)this._socketWriter.write(o[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(o.type===1){if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new E(6,0,0,n())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data)}else if(o.type===2)this._onControlMessage.fire(o.data);else if(o.type===5)this._onDidDispose.fire();else if(o.type===6){const a=this._outgoingUnackMsg.toArray();for(let s=0,g=a.length;s<g;s++)this._socketWriter.write(a[s]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const s=new E(1,a,this._incomingAckId,o);this._outgoingUnackMsg.push(s),this._isReconnecting||(this._socketWriter.write(s),this._recvAckCheck())}sendControl(o){const a=new E(2,0,0,o);this._socketWriter.write(a)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const o=this._outgoingUnackMsg.peek(),a=Date.now()-o.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const o=new E(3,0,this._incomingAckId,n());this._socketWriter.write(o)}}}e.PersistentProtocol=t}),define(fe[126],he([0,1,4,6,13,11]),function(Q,e,S,d,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var k;(function(D){D[D.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));var L;(function(D){D[D.None=0]="None",D[D.Initialized=1]="Initialized",D[D.Closed=2]="Closed"})(L||(L={}));class h extends S.Disposable{constructor(b,I=Object.create(null)){super();this.database=b,this.options=I,this._onDidChangeStorage=this._register(new d.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=L.None,this.cache=new Map,this.flushDelayer=new P.ThrottledDelayer(h.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(b=>this.onDidChangeItemsExternal(b)))}onDidChangeItemsExternal(b){var I,E;(I=b.changed)===null||I===void 0||I.forEach((u,v)=>this.accept(v,u)),(E=b.deleted)===null||E===void 0||E.forEach(u=>this.accept(u,void 0))}accept(b,I){if(this.state!==L.Closed){let E=!1;y.isUndefinedOrNull(I)?E=this.cache.delete(b):this.cache.get(b)!==I&&(this.cache.set(b,I),E=!0),E&&this._onDidChangeStorage.fire(b)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===L.None&&(this.state=L.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(b,I){const E=this.cache.get(b);return y.isUndefinedOrNull(E)?I:E}getBoolean(b,I){const E=this.get(b);return y.isUndefinedOrNull(E)?I:E==="true"}getNumber(b,I){const E=this.get(b);return y.isUndefinedOrNull(E)?I:parseInt(E,10)}async set(b,I){if(this.state!==L.Closed){if(y.isUndefinedOrNull(I))return this.delete(b);const E=String(I);if(this.cache.get(b)!==E)return this.cache.set(b,E),this.pendingInserts.set(b,E),this.pendingDeletes.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(b){if(this.state!==L.Closed&&!!this.cache.delete(b))return this.pendingDeletes.has(b)||this.pendingDeletes.add(b),this.pendingInserts.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=L.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(b){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const b={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(b).finally(()=>{var I;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(I=this.whenFlushedCallbacks.pop())===null||I===void 0||I()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(b=>this.whenFlushedCallbacks.push(b))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=h,h.DEFAULT_FLUSH_DELAY=100;class n{constructor(){this.onDidChangeItemsExternal=d.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(b){b.insert&&b.insert.forEach((I,E)=>this.items.set(E,I)),b.delete&&b.delete.forEach(I=>this.items.delete(I))}async close(){}}e.InMemoryStorageDatabase=n}),define(fe[79],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class S{constructor(P,y){this.lineNumber=P,this.column=y}with(P=this.lineNumber,y=this.column){return P===this.lineNumber&&y===this.column?this:new S(P,y)}delta(P=0,y=0){return this.with(this.lineNumber+P,this.column+y)}equals(P){return S.equals(this,P)}static equals(P,y){return!P&&!y?!0:!!P&&!!y&&P.lineNumber===y.lineNumber&&P.column===y.column}isBefore(P){return S.isBefore(this,P)}static isBefore(P,y){return P.lineNumber<y.lineNumber?!0:y.lineNumber<P.lineNumber?!1:P.column<y.column}isBeforeOrEqual(P){return S.isBeforeOrEqual(this,P)}static isBeforeOrEqual(P,y){return P.lineNumber<y.lineNumber?!0:y.lineNumber<P.lineNumber?!1:P.column<=y.column}static compare(P,y){let k=P.lineNumber|0,L=y.lineNumber|0;if(k===L){let h=P.column|0,n=y.column|0;return h-n}return k-L}clone(){return new S(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(P){return new S(P.lineNumber,P.column)}static isIPosition(P){return P&&typeof P.lineNumber=="number"&&typeof P.column=="number"}}e.Position=S}),define(fe[55],he([0,1,79]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class d{constructor(y,k,L,h){y>L||y===L&&k>h?(this.startLineNumber=L,this.startColumn=h,this.endLineNumber=y,this.endColumn=k):(this.startLineNumber=y,this.startColumn=k,this.endLineNumber=L,this.endColumn=h)}isEmpty(){return d.isEmpty(this)}static isEmpty(y){return y.startLineNumber===y.endLineNumber&&y.startColumn===y.endColumn}containsPosition(y){return d.containsPosition(this,y)}static containsPosition(y,k){return!(k.lineNumber<y.startLineNumber||k.lineNumber>y.endLineNumber||k.lineNumber===y.startLineNumber&&k.column<y.startColumn||k.lineNumber===y.endLineNumber&&k.column>y.endColumn)}containsRange(y){return d.containsRange(this,y)}static containsRange(y,k){return!(k.startLineNumber<y.startLineNumber||k.endLineNumber<y.startLineNumber||k.startLineNumber>y.endLineNumber||k.endLineNumber>y.endLineNumber||k.startLineNumber===y.startLineNumber&&k.startColumn<y.startColumn||k.endLineNumber===y.endLineNumber&&k.endColumn>y.endColumn)}strictContainsRange(y){return d.strictContainsRange(this,y)}static strictContainsRange(y,k){return!(k.startLineNumber<y.startLineNumber||k.endLineNumber<y.startLineNumber||k.startLineNumber>y.endLineNumber||k.endLineNumber>y.endLineNumber||k.startLineNumber===y.startLineNumber&&k.startColumn<=y.startColumn||k.endLineNumber===y.endLineNumber&&k.endColumn>=y.endColumn)}plusRange(y){return d.plusRange(this,y)}static plusRange(y,k){let L,h,n,D;return k.startLineNumber<y.startLineNumber?(L=k.startLineNumber,h=k.startColumn):k.startLineNumber===y.startLineNumber?(L=k.startLineNumber,h=Math.min(k.startColumn,y.startColumn)):(L=y.startLineNumber,h=y.startColumn),k.endLineNumber>y.endLineNumber?(n=k.endLineNumber,D=k.endColumn):k.endLineNumber===y.endLineNumber?(n=k.endLineNumber,D=Math.max(k.endColumn,y.endColumn)):(n=y.endLineNumber,D=y.endColumn),new d(L,h,n,D)}intersectRanges(y){return d.intersectRanges(this,y)}static intersectRanges(y,k){let L=y.startLineNumber,h=y.startColumn,n=y.endLineNumber,D=y.endColumn,b=k.startLineNumber,I=k.startColumn,E=k.endLineNumber,u=k.endColumn;return L<b?(L=b,h=I):L===b&&(h=Math.max(h,I)),n>E?(n=E,D=u):n===E&&(D=Math.min(D,u)),L>n||L===n&&h>D?null:new d(L,h,n,D)}equalsRange(y){return d.equalsRange(this,y)}static equalsRange(y,k){return!!y&&!!k&&y.startLineNumber===k.startLineNumber&&y.startColumn===k.startColumn&&y.endLineNumber===k.endLineNumber&&y.endColumn===k.endColumn}getEndPosition(){return d.getEndPosition(this)}static getEndPosition(y){return new S.Position(y.endLineNumber,y.endColumn)}getStartPosition(){return d.getStartPosition(this)}static getStartPosition(y){return new S.Position(y.startLineNumber,y.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(y,k){return new d(this.startLineNumber,this.startColumn,y,k)}setStartPosition(y,k){return new d(y,k,this.endLineNumber,this.endColumn)}collapseToStart(){return d.collapseToStart(this)}static collapseToStart(y){return new d(y.startLineNumber,y.startColumn,y.startLineNumber,y.startColumn)}static fromPositions(y,k=y){return new d(y.lineNumber,y.column,k.lineNumber,k.column)}static lift(y){return y?new d(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn):null}static isIRange(y){return y&&typeof y.startLineNumber=="number"&&typeof y.startColumn=="number"&&typeof y.endLineNumber=="number"&&typeof y.endColumn=="number"}static areIntersectingOrTouching(y,k){return!(y.endLineNumber<k.startLineNumber||y.endLineNumber===k.startLineNumber&&y.endColumn<k.startColumn||k.endLineNumber<y.startLineNumber||k.endLineNumber===y.startLineNumber&&k.endColumn<y.startColumn)}static areIntersecting(y,k){return!(y.endLineNumber<k.startLineNumber||y.endLineNumber===k.startLineNumber&&y.endColumn<=k.startColumn||k.endLineNumber<y.startLineNumber||k.endLineNumber===y.startLineNumber&&k.endColumn<=y.startColumn)}static compareRangesUsingStarts(y,k){if(y&&k){const n=y.startLineNumber|0,D=k.startLineNumber|0;if(n===D){const b=y.startColumn|0,I=k.startColumn|0;if(b===I){const E=y.endLineNumber|0,u=k.endLineNumber|0;if(E===u){const v=y.endColumn|0,_=k.endColumn|0;return v-_}return E-u}return b-I}return n-D}return(y?1:0)-(k?1:0)}static compareRangesUsingEnds(y,k){return y.endLineNumber===k.endLineNumber?y.endColumn===k.endColumn?y.startLineNumber===k.startLineNumber?y.startColumn-k.startColumn:y.startLineNumber-k.startLineNumber:y.endColumn-k.endColumn:y.endLineNumber-k.endLineNumber}static spansMultipleLines(y){return y.endLineNumber>y.startLineNumber}}e.Range=d}),define(fe[127],he([0,1,44,2]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function P(y,k,L,h){if(Array.isArray(y)){let n=0;for(const D of y){const b=P(D,k,L,h);if(b===10)return b;b>n&&(n=b)}return n}else{if(typeof y=="string")return h?y==="*"?5:y===L?10:0:0;if(y){const{language:n,pattern:D,scheme:b,hasAccessToAllModels:I}=y;if(!h&&!I)return 0;let E=0;if(b)if(b===k.scheme)E=10;else if(b==="*")E=5;else return 0;if(n)if(n===L)E=10;else if(n==="*")E=Math.max(E,5);else return 0;if(D){let u;if(typeof D=="string"?u=D:u=Object.assign(Object.assign({},D),{base:d.normalize(D.base)}),u===k.fsPath||S.match(u,k.fsPath))E=10;else return 0}return E}else return 0}}e.score=P}),define(fe[128],he([0,1,6,4]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class P{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new S.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,L){return this._map.set(k,L),this.fire([k]),d.toDisposable(()=>{this._map.get(k)===L&&(this._map.delete(k),this.fire([k]))})}registerPromise(k,L){let h=null,n=!1;return this._promises.set(k,L.then(D=>{this._promises.delete(k),!(n||!D)&&(h=this.register(k,D))})),d.toDisposable(()=>{n=!0,h&&h.dispose()})}getPromise(k){const L=this.get(k);if(L)return Promise.resolve(L);const h=this._promises.get(k);return h?h.then(n=>this.get(k)):null}get(k){return this._map.get(k)||null}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=P}),define(fe[129],he([9,10]),function(Q,e){return Q.create("vs/base/common/actions",e)}),define(fe[130],he([0,1,129,4,6]),function(Q,e,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class y extends d.Disposable{constructor(I,E="",u="",v=!0,_){super();this._onDidChange=this._register(new P.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._checked=!1,this._id=I,this._label=E,this._cssClass=u,this._enabled=v,this._actionCallback=_}get id(){return this._id}get label(){return this._label}set label(I){this._setLabel(I)}_setLabel(I){this._label!==I&&(this._label=I,this._onDidChange.fire({label:I}))}get tooltip(){return this._tooltip||""}set tooltip(I){this._setTooltip(I)}_setTooltip(I){this._tooltip!==I&&(this._tooltip=I,this._onDidChange.fire({tooltip:I}))}get class(){return this._cssClass}set class(I){this._setClass(I)}_setClass(I){this._cssClass!==I&&(this._cssClass=I,this._onDidChange.fire({class:I}))}get enabled(){return this._enabled}set enabled(I){this._setEnabled(I)}_setEnabled(I){this._enabled!==I&&(this._enabled=I,this._onDidChange.fire({enabled:I}))}get checked(){return this._checked}set checked(I){this._setChecked(I)}_setChecked(I){this._checked!==I&&(this._checked=I,this._onDidChange.fire({checked:I}))}run(I,E){return this._actionCallback?this._actionCallback(I):Promise.resolve(!0)}}e.Action=y;class k extends d.Disposable{constructor(){super(...arguments);this._onBeforeRun=this._register(new P.Emitter),this.onBeforeRun=this._onBeforeRun.event,this._onDidRun=this._register(new P.Emitter),this.onDidRun=this._onDidRun.event}async run(I,E){if(!I.enabled)return Promise.resolve(null);this._onBeforeRun.fire({action:I});try{const u=await this.runAction(I,E);this._onDidRun.fire({action:I,result:u})}catch(u){this._onDidRun.fire({action:I,error:u})}}runAction(I,E){const u=E?I.run(E):I.run();return Promise.resolve(u)}}e.ActionRunner=k;class L extends y{constructor(I){super(L.ID,I,I?"separator text":"separator");this.checked=!1,this.enabled=!1}}e.Separator=L,L.ID="vs.actions.separator";class h{constructor(I,E,u,v){this.tooltip="",this.enabled=!0,this.checked=!1,this.id=I,this.label=E,this.class=v,this._actions=u}dispose(){}get actions(){return this._actions}async run(){}}e.SubmenuAction=h;class n extends y{constructor(){super(n.ID,S.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=n,n.ID="vs.actions.empty";function D(b){var I,E;return{id:b.id,label:b.label,class:void 0,enabled:(I=b.enabled)!==null&&I!==void 0?I:!0,checked:(E=b.checked)!==null&&E!==void 0?E:!1,run:async()=>b.run(),tooltip:b.label,dispose:()=>{}}}e.toAction=D}),define(fe[131],he([9,10]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(fe[132],he([0,1,131]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const d=60,P=d*60,y=P*24,k=y*7,L=y*30,h=y*365;function n(b,I){typeof b!="number"&&(b=b.getTime());const E=Math.round((new Date().getTime()-b)/1e3);if(E<-30)return S.localize(0,null,n(new Date().getTime()+E*1e3,!1));if(E<30)return S.localize(1,null);let u;return E<d?(u=E,I?u===1?S.localize(2,null,u):S.localize(3,null,u):u===1?S.localize(4,null,u):S.localize(5,null,u)):E<P?(u=Math.floor(E/d),I?u===1?S.localize(6,null,u):S.localize(7,null,u):u===1?S.localize(8,null,u):S.localize(9,null,u)):E<y?(u=Math.floor(E/P),I?u===1?S.localize(10,null,u):S.localize(11,null,u):u===1?S.localize(12,null,u):S.localize(13,null,u)):E<k?(u=Math.floor(E/y),I?u===1?S.localize(14,null,u):S.localize(15,null,u):u===1?S.localize(16,null,u):S.localize(17,null,u)):E<L?(u=Math.floor(E/k),I?u===1?S.localize(18,null,u):S.localize(19,null,u):u===1?S.localize(20,null,u):S.localize(21,null,u)):E<h?(u=Math.floor(E/L),I?u===1?S.localize(22,null,u):S.localize(23,null,u):u===1?S.localize(24,null,u):S.localize(25,null,u)):(u=Math.floor(E/h),I?u===1?S.localize(26,null,u):S.localize(27,null,u):u===1?S.localize(28,null,u):S.localize(29,null,u))}e.fromNow=n;function D(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=D}),define(fe[133],he([9,10]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(fe[40],he([0,1,133,11,16]),function(Q,e,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function y(n,D){return D&&(n.stack||n.stacktrace)?S.localize(0,null,L(n),k(n.stack)||k(n.stacktrace)):L(n)}function k(n){return Array.isArray(n)?n.join(`
`):n}function L(n){return typeof n.code=="string"&&typeof n.errno=="number"&&typeof n.syscall=="string"?S.localize(1,null,n.message):n.message||S.localize(2,null)}function h(n=null,D=!1){if(!n)return S.localize(3,null);if(Array.isArray(n)){const b=P.coalesce(n),I=h(b[0],D);return b.length>1?S.localize(4,null,I,b.length):I}if(d.isString(n))return n;if(n.detail){const b=n.detail;if(b.error)return y(b.error,D);if(b.exception)return y(b.exception,D)}return n.stack?y(n,D):n.message?n.message:S.localize(5,null)}e.toErrorMessage=h}),define(fe[134],he([9,10]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(fe[135],he([0,1,134]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function d(P){switch(P){case 1:return S.localize(0,null);case 2:return S.localize(1,null);case 3:return S.localize(2,null);case 4:return S.localize(3,null);case 5:return S.localize(4,null);case 6:return S.localize(5,null);case 7:return S.localize(6,null);case 8:return S.localize(7,null);case 9:return S.localize(8,null);default:return""}}e.getParseErrorMessage=d}),define(fe[136],he([9,10]),function(Q,e){return Q.create("vs/base/node/processes",e)}),define(fe[80],he([0,1,2,15,20,32,136,11,19,28,5,74,8]),function(Q,e,S,d,P,y,k,L,h,n,D,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function E(c){switch(c){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(c,r){if(D.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};r&&(t.cwd=r);const i=y.execFile("taskkill",["/T","/F","/PID",c.pid.toString()],t);return new Promise(o=>{i.once("error",a=>{o({success:!1,error:a})}),i.once("exit",(a,s)=>{o(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?E(t.status):1})}else if(D.isLinux||D.isMacintosh)try{const t=I.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Q).fsPath;return new Promise(i=>{y.execFile(t,[c.pid.toString()],{encoding:"utf8",shell:!0},(o,a,s)=>{i(o?{success:!1,error:o}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else c.kill("SIGKILL");return Promise.resolve({success:!0})}function v(c=process.env){return c.comspec||"cmd.exe"}e.getWindowsShell=v;class _{constructor(r,t,i,o){if(t!==void 0&&i!==void 0&&o!==void 0)this.cmd=r,this.args=t,this.shell=i,this.options=o;else{const a=r;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(process.env).forEach(s=>{a[s]=process.env[s]}),Object.keys(this.options.env).forEach(s=>{a[s]=this.options.env[s]}),this.options.env=a}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const t=r.lastIndexOf(S.sep);return t!==-1&&(r=r.substring(t+1)),_.WellKnowCommands[r]?r:"other"}start(r){return D.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(process.cwd()))?Promise.reject(new Error(k.localize(0,null))):this.useExec().then(t=>{let i,o;const a=new Promise((s,g)=>{i=s,o=g});if(t){let s=this.cmd;this.args&&(s=s+" "+this.args.join(" ")),this.childProcess=y.exec(s,this.options,(g,C,R)=>{this.childProcess=null;const p=g;p&&p.killed?o({killed:this.terminateRequested,stdout:C.toString(),stderr:R.toString()}):this.handleExec(i,r,g,C,R)})}else{let s=null;const g=C=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(C,i,r,o);const R={terminated:this.terminateRequested};L.isNumber(C)&&(R.cmdCode=C),i(R)};if(this.shell&&D.isWindows){const C=h.deepClone(this.options);C.windowsVerbatimArguments=!0,C.detached=!1;let R=!1,p=!1;const f=[];let T=this.ensureQuotes(this.cmd);f.push(T.value),R=T.quoted,this.args&&this.args.forEach(H=>{T=this.ensureQuotes(H),f.push(T.value),p=p&&T.quoted});const O=["/s","/c"];R?p?O.push('"'+f.join(" ")+'"'):f.length>1?O.push('"'+f[0]+'" '+f.slice(1).join(" ")):O.push('"'+f[0]+'"'):O.push(f.join(" ")),s=y.spawn(v(),O,C)}else this.cmd&&(s=y.spawn(this.cmd,this.args,this.options));s&&(this.childProcess=s,this.childProcessPromise=Promise.resolve(s),this.pidResolve&&(this.pidResolve(L.isNumber(s.pid)?s.pid:-1),this.pidResolve=void 0),s.on("error",C=>{this.childProcess=null,o({terminated:this.terminateRequested,error:C})}),s.pid&&(this.childProcess.on("close",g),this.handleSpawn(s,i,r,o,!0)))}return a})}handleClose(r,t,i,o){}ensureQuotes(r){return _.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,u(r,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!D.isWindows)return r(!1);const t=y.spawn(v(),["/s","/c"]);t.on("error",i=>r(!0)),t.on("exit",i=>r(!1))})}}e.AbstractProcess=_,_.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},_.regexp=/^[^"].* .*[^"]/;class w extends _{constructor(r,t,i,o){super(r,t,i,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,t,i,o,a){[o,a].forEach((s,g)=>{const C=new b.LineDecoder;C.write(s).forEach(f=>{t({line:f,source:g===0?0:1})});const p=C.end();p&&t({line:p,source:g===0?0:1})}),r({terminated:this.terminateRequested,error:i})}handleSpawn(r,t,i,o,a){const s=new b.LineDecoder,g=new b.LineDecoder;r.stdout.on("data",C=>{s.write(C).forEach(p=>i({line:p,source:0}))}),r.stderr.on("data",C=>{g.write(C).forEach(p=>i({line:p,source:1}))}),this.stdoutLineDecoder=s,this.stderrLineDecoder=g}handleClose(r,t,i,o){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&i({line:a,source:0});const s=this.stderrLineDecoder?this.stderrLineDecoder.end():null;s&&i({line:s,source:1})}}e.LineProcess=w;function m(c){let r=[],t=!1;const i=function(o){if(t){r.push(o);return}(!c.send(o,s=>{if(s&&console.error(s),t=!1,r.length>0){const g=r.slice(0);r=[],g.forEach(C=>i(C))}})||D.isWindows)&&(t=!0)};return{send:i}}e.createQueuedSender=m;var l;(function(c){async function r(t,i,o){if(S.isAbsolute(t))return t;if(i===void 0&&(i=process.cwd()),S.dirname(t)!=="."||(o===void 0&&L.isString(process.env.PATH)&&(o=process.env.PATH.split(S.delimiter)),o===void 0||o.length===0))return S.join(i,t);async function s(g){return await P.exists(g)?!(await d.promises.stat(g)).isDirectory():!1}for(let g of o){let C;if(S.isAbsolute(g)?C=S.join(g,t):C=S.join(i,g,t),await s(C))return C;let R=C+".com";if(await s(R)||(R=C+".exe",await s(R)))return R}return S.join(i,t)}c.findExecutable=r})(l=e.win32||(e.win32={}))}),define(fe[81],he([0,1,22,5,123,80]),function(Q,e,S,d,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(E,u=process.env){return E===3?d.isWindows?b():y.getWindowsShell(u):n(E,u)}e.getSystemShell=k;function L(E,u=process.env){return E===3?d.isWindows?I(u):y.getWindowsShell(u):n(E,u)}e.getSystemShellSync=L;let h=null;function n(E,u){if(d.isLinux&&E===1||d.isMacintosh&&E===2)return"/bin/bash";if(!h){let v;if(d.isWindows)v="/bin/bash";else{if(v=u.SHELL,!v)try{v=S.userInfo().shell}catch(_){}v||(v="sh"),v==="/bin/false"&&(v="/bin/bash")}h=v}return h}let D=null;async function b(){return D||(D=(await P.getFirstAvailablePowerShellInstallation()).exePath),D}function I(E){if(D)return D;const u=d.isWindows&&parseFloat(S.release())>=10,v=E.hasOwnProperty("PROCESSOR_ARCHITEW6432"),_=`${E.windir}\\${v?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?_:y.getWindowsShell(E)}}),define(fe[82],he([0,1,32,4,13,19,6,80,37,114,27,12,18,5]),function(Q,e,S,d,P,y,k,L,h,n,D,b,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class u extends h.ChannelServer{constructor(w){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch(l){}},onMessage:k.Event.fromNodeEventEmitter(process,"message",m=>I.VSBuffer.wrap(Buffer.from(m,"base64")))},w);process.once("disconnect",()=>this.dispose())}}e.Server=u;class v{constructor(w,m){this.modulePath=w,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new k.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const l=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new P.Delayer(l),this.child=null,this._client=null}getChannel(w){const m=this;return{call(l,c,r){return m.requestPromise(w,l,c,r)},listen(l,c){return m.requestEvent(w,l,c)}}}requestPromise(w,m,l,c=D.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const r=this.getCachedChannel(w),t=P.createCancelablePromise(a=>r.call(m,l,a)),i=c.onCancellationRequested(()=>t.cancel()),o=d.toDisposable(()=>t.cancel());return this.activeRequests.add(o),t.finally(()=>{i.dispose(),this.activeRequests.delete(o),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(w,m,l){if(!this.disposeDelayer)return k.Event.None;this.disposeDelayer.cancel();let c;const r=new k.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(w).listen(m,l)(r.fire,r),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return r.event}get client(){if(!this._client){const w=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env=Object.assign(Object.assign({},y.deepClone(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(m.env=Object.assign(Object.assign({},m.env),this.options.env)),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),E.isMacintosh&&m.env&&delete m.env.DYLD_LIBRARY_PATH,this.child=S.fork(this.modulePath,w,m);const l=new k.Emitter;k.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if(n.isRemoteConsoleLog(s)){n.log(s,`IPC Library: ${this.options.serverName}`);return}l.fire(I.VSBuffer.wrap(Buffer.from(s,"base64")))});const r=this.options.useQueue?L.createQueuedSender(this.child):this.child,t=s=>this.child&&this.child.connected&&r.send(s.buffer.toString("base64")),i=l.event,o={send:t,onMessage:i};this._client=new h.ChannelClient(o);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,g)=>{process.removeListener("exit",a),this.activeRequests.forEach(C=>d.dispose(C)),this.activeRequests.clear(),s!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+g),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:g})})}return this._client}getCachedChannel(w){let m=this.channels.get(w);return m||(m=this.client.getChannel(w),this.channels.set(w,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=v}),define(fe[137],he([9,10]),function(Q,e){return Q.create("vs/base/node/zip",e)}),define(fe[138],he([9,10]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(fe[139],he([9,10]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(fe[140],he([9,10]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(fe[141],he([9,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(fe[142],he([9,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagementCLIService",e)}),define(fe[143],he([9,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(fe[144],he([9,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(fe[145],he([9,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(fe[146],he([9,10]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(fe[147],he([9,10]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(fe[148],he([9,10]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(fe[149],he([9,10]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(fe[150],he([9,10]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(fe[151],he([9,10]),function(Q,e){return Q.create("vs/platform/markers/common/markers",e)}),define(fe[152],he([9,10]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(fe[153],he([9,10]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(fe[154],he([9,10]),function(Q,e){return Q.create("vs/platform/terminal/node/terminalProcess",e)}),define(fe[155],he([9,10]),function(Q,e){return Q.create("vs/platform/workspaces/common/workspaces",e)}),define(fe[156],he([9,10]),function(Q,e){return Q.create("vs/server/remoteAgentEnvironmentImpl",e)}),define(fe[157],he([9,10]),function(Q,e){return Q.create("vs/server/serverEnvironmentService",e)}),define(fe[158],he([9,10]),function(Q,e){return Q.create("vs/workbench/common/editor",e)}),define(fe[159],he([9,10]),function(Q,e){return Q.create("vs/workbench/contrib/terminal/common/terminal",e)}),define(fe[160],he([9,10]),function(Q,e){return Q.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(fe[161],he([9,10]),function(Q,e){return Q.create("vs/workbench/services/extensions/node/extensionPoints",e)}),define(fe[162],he([0,1,6,4]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class P{constructor(){this._onCloseEmitter=new S.Emitter,this._onReloadEmitter=new S.Emitter,this._onTerminateEmitter=new S.Emitter,this._onAttachEmitter=new S.Emitter}call(L,h,n){switch(h){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:n[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:n[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:n[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:n[0],port:n[1],subId:n[2]}))}throw new Error("Method not implemented.")}listen(L,h,n){switch(h){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=P,P.ChannelName="extensionhostdebugservice";class y extends d.Disposable{constructor(L){super();this.channel=L}reload(L){this.channel.call("reload",[L])}get onReload(){return this.channel.listen("reload")}close(L){this.channel.call("close",[L])}get onClose(){return this.channel.listen("close")}attachSession(L,h,n){this.channel.call("attach",[L,h,n])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(L,h){this.channel.call("terminate",[L,h])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(L,h,n){return this.channel.call("openExtensionDevelopmentHostWindow",[L,h,n])}}e.ExtensionHostDebugChannelClient=y}),define(fe[163],he([0,1,3]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class d{constructor(k){this.service=k}listen(k,L,h){throw new Error("Invalid listen")}call(k,L,h){switch(L){case"download":return this.service.download(S.URI.revive(h[0]),S.URI.revive(h[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=d;class P{constructor(k,L){this.channel=k,this.getUriTransformer=L}async download(k,L){const h=this.getUriTransformer();h&&(k=h.transformOutgoingURI(k),L=h.transformOutgoingURI(L)),await this.channel.call("download",[k,L])}}e.DownloadServiceChannelClient=P}),define(fe[164],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var S;(function(k){k[k.ACTIVATE=0]="ACTIVATE",k[k.RESTORE=1]="RESTORE",k[k.PRESERVE=2]="PRESERVE"})(S=e.EditorActivation||(e.EditorActivation={}));var d;(function(k){k[k.PICK=1]="PICK",k[k.DISABLED=2]="DISABLED"})(d=e.EditorOverride||(e.EditorOverride={}));var P;(function(k){k[k.API=0]="API",k[k.USER=1]="USER"})(P=e.EditorOpenContext||(e.EditorOpenContext={}));var y;(function(k){k[k.Center=0]="Center",k[k.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",k[k.NearTop=2]="NearTop",k[k.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(y=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(fe[56],he([0,1,234,139,5]),function(Q,e,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const y={o:d.localize(0,null),e:d.localize(1,null),t:d.localize(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:d.localize(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:d.localize(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:d.localize(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:d.localize(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:d.localize(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:d.localize(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:d.localize(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:d.localize(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:d.localize(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:d.localize(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:d.localize(13,null)},"show-versions":{type:"boolean",cat:"e",description:d.localize(14,null)},category:{type:"string",cat:"e",description:d.localize(15,null)},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:d.localize(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:d.localize(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:d.localize(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:d.localize(19,null)},verbose:{type:"boolean",cat:"t",description:d.localize(20,null)},log:{type:"string",cat:"t",args:"level",description:d.localize(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:d.localize(22,null)},"prof-startup":{type:"boolean",cat:"t",description:d.localize(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:d.localize(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:d.localize(25,null)},sync:{type:"string",cat:"t",description:d.localize(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:d.localize(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:d.localize(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:d.localize(29,null)},"max-memory":{type:"string",cat:"t",description:d.localize(30,null)},telemetry:{type:"boolean",cat:"t",description:d.localize(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{}};function L(u,v,_=k){const w={},m=[],l=[];for(let i in v){const o=v[i];o.alias&&(w[i]=o.alias),o.type==="string"||o.type==="string[]"?(m.push(i),o.deprecates&&m.push(o.deprecates)):o.type==="boolean"&&(l.push(i),o.deprecates&&l.push(o.deprecates))}const c=S(u,{string:m,boolean:l,alias:w}),r={},t=c;r._=c._.map(i=>String(i)).filter(i=>i.length>0),delete t._;for(let i in v){const o=v[i];o.alias&&delete t[o.alias];let a=t[i];o.deprecates&&t.hasOwnProperty(o.deprecates)&&(a||(a=t[o.deprecates]),delete t[o.deprecates]),typeof a!="undefined"&&(o.type==="string[]"?a&&!Array.isArray(a)&&(a=[a]):o.type==="string"&&Array.isArray(a)&&(a=a.pop(),_.onMultipleValues(i,a)),r[i]=a),delete t[i]}for(let i in t)_.onUnknownOption(i);return r}e.parseArgs=L;function h(u,v){let _="";return v.args&&(Array.isArray(v.args)?_=` <${v.args.join("> <")}>`:_=` <${v.args}>`),v.alias?`-${v.alias} --${u}${_}`:`--${u}${_}`}function n(u,v){let _=0,w=[];for(const r in u){const t=u[r],i=h(r,t);_=Math.max(_,i.length),w.push([i,t.description])}let m=_+2+1;if(v-m<25)return w.reduce((r,t)=>r.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let l=v-m-1,c=[];for(const r of w){let t=r[0],i=b(r[1],l),o=D(m-t.length-2);c.push("  "+t+o+i[0]);for(let a=1;a<i.length;a++)c.push(D(m)+i[a])}return c}e.formatOptions=n;function D(u){return" ".repeat(u)}function b(u,v){let _=[];for(;u.length;){let w=u.length<v?u.length:u.lastIndexOf(" ",v),m=u.slice(0,w).trim();u=u.slice(w),_.push(m)}return _}function I(u,v,_,w,m=!0){const l=process.stdout.isTTY&&process.stdout.columns||80;let c=[`${u} ${_}`];c.push(""),c.push(`${d.localize(32,null)}: ${v} [${d.localize(33,null)}][${d.localize(34,null)}...]`),c.push(""),m&&(P.isWindows?c.push(d.localize(35,null,v)):c.push(d.localize(36,null,v)),c.push(""));const r={};for(const t in w){const i=w[t];if(i.description&&i.cat){let o=r[i.cat];o||(r[i.cat]=o={}),o[t]=i}}for(let t in r){const i=t;let o=r[i];o&&(c.push(y[i]),c.push(...n(o,l)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=I;function E(u,v){return`${u||d.localize(37,null)}
${v||d.localize(38,null)}
${process.arch}`}e.buildVersionMessage=E}),define(fe[165],he([0,1,6,3,54,19,4]),function(Q,e,S,d,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function L(u,v){return d.URI.revive(v?v.transformIncoming(u):u)}function h(u,v){return v?v.transformOutgoingURI(u):u}function n(u,v){v=v||P.DefaultURITransformer;const _=u.manifest,w=P.transformAndReviveIncomingURIs(Object.assign(Object.assign({},u),{manifest:void 0}),v);return Object.assign(Object.assign({},w),{manifest:_})}function D(u,v){return v?y.cloneAndChange(u,_=>_ instanceof d.URI?v.transformOutgoingURI(_):void 0):u}class b{constructor(v,_){this.service=v,this.getUriTransformer=_,this.onInstallExtension=S.Event.buffer(v.onInstallExtension,!0),this.onDidInstallExtension=S.Event.buffer(v.onDidInstallExtension,!0),this.onUninstallExtension=S.Event.buffer(v.onUninstallExtension,!0),this.onDidUninstallExtension=S.Event.buffer(v.onDidUninstallExtension,!0)}listen(v,_){const w=this.getUriTransformer(v);switch(_){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return S.Event.map(this.onDidInstallExtension,m=>Object.assign(Object.assign({},m),{local:m.local?D(m.local,w):m.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(v,_,w){const m=this.getUriTransformer(v);switch(_){case"zip":return this.service.zip(n(w[0],m)).then(l=>h(l,m));case"unzip":return this.service.unzip(L(w[0],m));case"install":return this.service.install(L(w[0],m));case"getManifest":return this.service.getManifest(L(w[0],m));case"canInstall":return this.service.canInstall(w[0]);case"installFromGallery":return this.service.installFromGallery(w[0],w[1]);case"uninstall":return this.service.uninstall(n(w[0],m),w[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(n(w[0],m));case"getInstalled":return this.service.getInstalled(w[0]).then(l=>l.map(c=>D(c,m)));case"updateMetadata":return this.service.updateMetadata(n(w[0],m),w[1]).then(l=>D(l,m));case"updateExtensionScope":return this.service.updateExtensionScope(n(w[0],m),w[1]).then(l=>D(l,m));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=b;class I extends k.Disposable{constructor(v){super();this.channel=v,this._onInstallExtension=this._register(new S.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new S.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new S.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new S.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(_=>this._onInstallExtension.fire(_))),this._register(this.channel.listen("onDidInstallExtension")(_=>this._onDidInstallExtension.fire(Object.assign(Object.assign({},_),{local:_.local?n(_.local,null):_.local})))),this._register(this.channel.listen("onUninstallExtension")(_=>this._onUninstallExtension.fire(_))),this._register(this.channel.listen("onDidUninstallExtension")(_=>this._onDidUninstallExtension.fire(_)))}zip(v){return Promise.resolve(this.channel.call("zip",[v]).then(_=>d.URI.revive(_)))}unzip(v){return Promise.resolve(this.channel.call("unzip",[v]))}install(v){return Promise.resolve(this.channel.call("install",[v])).then(_=>n(_,null))}getManifest(v){return Promise.resolve(this.channel.call("getManifest",[v]))}async canInstall(v){return!0}installFromGallery(v,_){return Promise.resolve(this.channel.call("installFromGallery",[v,_])).then(w=>n(w,null))}uninstall(v,_){return Promise.resolve(this.channel.call("uninstall",[v,_]))}reinstallFromGallery(v){return Promise.resolve(this.channel.call("reinstallFromGallery",[v]))}getInstalled(v=null){return Promise.resolve(this.channel.call("getInstalled",[v])).then(_=>_.map(w=>n(w,null)))}updateMetadata(v,_){return Promise.resolve(this.channel.call("updateMetadata",[v,_])).then(w=>n(w,null))}updateExtensionScope(v,_){return Promise.resolve(this.channel.call("updateExtensionScope",[v,_])).then(w=>n(w,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=I;class E{constructor(v){this.service=v}listen(v,_){throw new Error("Invalid listen")}call(v,_,w){switch(_){case"getConfigBasedTips":return this.service.getConfigBasedTips(d.URI.revive(w[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=E}),define(fe[166],he([0,1,19]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const d=/^%([\w\d.-]+)%$/i;function P(y,k){const L=h=>{if(typeof h=="string"){const n=d.exec(h);if(!!n)return k[n[1]]||h}};return S.cloneAndChange(y,L)}e.localizeManifest=P}),define(fe[57],he([0,1,146]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const d=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function P(b){return b=b.trim(),b==="*"||d.test(b)}e.isValidVersionStr=P;function y(b){if(!P(b))return null;if(b=b.trim(),b==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let I=b.match(d);return I?{hasCaret:I[1]==="^",hasGreaterEquals:I[1]===">=",majorBase:I[2]==="x"?0:parseInt(I[2],10),majorMustEqual:I[2]!=="x",minorBase:I[4]==="x"?0:parseInt(I[4],10),minorMustEqual:I[4]!=="x",patchBase:I[6]==="x"?0:parseInt(I[6],10),patchMustEqual:I[6]!=="x",preRelease:I[8]||null}:null}e.parseVersion=y;function k(b){if(!b)return null;let I=b.majorBase,E=b.majorMustEqual,u=b.minorBase,v=b.minorMustEqual,_=b.patchBase,w=b.patchMustEqual;return b.hasCaret&&(I===0||(v=!1),w=!1),{majorBase:I,majorMustEqual:E,minorBase:u,minorMustEqual:v,patchBase:_,patchMustEqual:w,isMinimum:b.hasGreaterEquals}}e.normalizeVersion=k;function L(b,I){let E;typeof b=="string"?E=k(y(b)):E=b;let u;if(typeof I=="string"?u=k(y(I)):u=I,!E||!u)return!1;let v=E.majorBase,_=E.minorBase,w=E.patchBase,m=u.majorBase,l=u.minorBase,c=u.patchBase,r=u.majorMustEqual,t=u.minorMustEqual,i=u.patchMustEqual;return u.isMinimum?v>m?!0:v<m?!1:_>l?!0:_<l?!1:w>=c:(v===1&&m===0&&(!r||!t||!i)&&(m=1,l=0,c=0,r=!0,t=!1,i=!1),v<m?!1:v>m?!r:_<l?!1:_>l?!t:w<c?!1:w>c?!i:!0)}e.isValidVersion=L;function h(b,I,E){return I.isBuiltin||typeof I.main=="undefined"?!0:D(b,I.engines.vscode,E)}e.isValidExtensionVersion=h;function n(b,I){return b==="*"||D(I,b)}e.isEngineValid=n;function D(b,I,E=[]){let u=k(y(I));if(!u)return E.push(S.localize(0,null,I)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return E.push(S.localize(1,null,I)),!1}else if(!u.majorMustEqual)return E.push(S.localize(2,null,I)),!1;return L(b,u)?!0:(E.push(S.localize(3,null,b,I)),!1)}e.isVersionValid=D}),define(fe[167],he([0,1,37,82,4,8]),function(Q,e,S,d,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends P.Disposable{constructor(h,n,D,b){super();this.folders=h,this.onDidFilesChange=n,this.onLogMessage=D,this.verboseLogging=b,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const h=this._register(new d.Client(y.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(h.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService(S.getNextTickChannel(h.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(n=>!this.isDisposed&&this.onDidFilesChange(n))),this._register(this.service.onDidLogMessage(n=>this.onLogMessage(n))),this.setFolders(this.folders)}setVerboseLogging(h){this.verboseLogging=h,!this.isDisposed&&this.service&&this.service.setVerboseLogging(h)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${h}`})}setFolders(h){this.folders=h,this.service&&this.service.setRoots(h)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(fe[168],he([0,1,37,82,4,8]),function(Q,e,S,d,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends P.Disposable{constructor(h,n,D,b,I={}){super();this.folders=h,this.onDidFilesChange=n,this.onLogMessage=D,this.verboseLogging=b,this.watcherOptions=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const h=this._register(new d.Client(y.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(h.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService(S.getNextTickChannel(h.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(n=>!this.isDisposed&&this.onDidFilesChange(n))),this._register(this.service.onDidLogMessage(n=>this.onLogMessage(n))),this.service.setRoots(this.folders)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${h}`})}setVerboseLogging(h){this.verboseLogging=h,this.service&&this.service.setVerboseLogging(h)}setFolders(h){this.folders=h,this.service&&this.service.setRoots(h)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(fe[169],he([0,1,32,74,44,8]),function(Q,e,S,d,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class k{constructor(h,n,D,b,I){this.watchedFolder=h,this.eventCallback=D,this.logCallback=b,this.verboseLogging=I,this.restartCounter=0,Array.isArray(n)?this.ignored=n.map(E=>P.parse(E)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${h}`),this.startWatcher()}startWatcher(){const h=[this.watchedFolder];this.verboseLogging&&h.push("-verbose"),this.handle=S.spawn(y.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",Q).fsPath,h);const n=new d.LineDecoder;this.handle.stdout.on("data",D=>{const b=[];n.write(D).forEach(I=>{const E=I.split("|");if(E.length===2){const u=Number(E[0]),v=E[1];if(u>=0&&u<3){if(this.ignored&&this.ignored.some(_=>_(v))){this.verboseLogging&&this.log(v);return}b.push({type:k.changeTypeMap[u],path:v})}else this.log(E[1])}}),b.length>0&&this.eventCallback(b)}),this.handle.on("error",D=>this.onError(D)),this.handle.stderr.on("data",D=>this.onError(D)),this.handle.on("exit",(D,b)=>this.onExit(D,b))}onError(h){this.error("process error: "+h.toString())}onExit(h,n){this.handle&&(this.error(`terminated unexpectedly (code: ${h}, signal: ${n})`),this.restartCounter<=k.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(h){this.logCallback({type:"error",message:`[File Watcher (C#)] ${h}`})}log(h){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${h}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=k,k.MAX_RESTARTS=5,k.changeTypeMap=[0,1,2]}),define(fe[170],he([0,1,169,2,14]),function(Q,e,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class y{constructor(L,h,n,D){this.onDidFilesChange=h,this.onLogMessage=n,this.verboseLogging=D,this.service=void 0,this.folder=L[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(d.posix.sep)&&(this.folder.path=P.rtrim(this.folder.path,d.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new S.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,L=>this.onFileEvents(L),L=>this.onLogMessage(L),this.verboseLogging)}setVerboseLogging(L){this.verboseLogging=L,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(L){this.isDisposed||L.length>0&&this.onDidFilesChange(L)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=y}),define(fe[58],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class S{constructor(y,k=[],L=!1){this.ctor=y,this.staticArguments=k,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=S;const d=(P,...y)=>new S(P,y);e.createSyncDescriptor=d}),define(fe[171],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(y){this.incoming=new Map,this.outgoing=new Map,this.data=y}}e.Node=S;class d{constructor(y){this._hashFn=y,this._nodes=new Map}roots(){const y=[];for(let k of this._nodes.values())k.outgoing.size===0&&y.push(k);return y}insertEdge(y,k){const L=this.lookupOrInsertNode(y),h=this.lookupOrInsertNode(k);L.outgoing.set(this._hashFn(k),h),h.incoming.set(this._hashFn(y),L)}removeNode(y){const k=this._hashFn(y);this._nodes.delete(k);for(let L of this._nodes.values())L.outgoing.delete(k),L.incoming.delete(k)}lookupOrInsertNode(y){const k=this._hashFn(y);let L=this._nodes.get(k);return L||(L=new S(y),this._nodes.set(k,L)),L}lookup(y){return this._nodes.get(this._hashFn(y))}isEmpty(){return this._nodes.size===0}toString(){let y=[];for(let[k,L]of this._nodes)y.push(`${k}, (incoming)[${[...L.incoming.keys()].join(", ")}], (outgoing)[${[...L.outgoing.keys()].join(",")}]`);return y.join(`
`)}}e.Graph=d}),define(fe[7],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.createDecorator=e.IInstantiationService=e._util=void 0;var S;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function L(h){return h[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=L})(S=e._util||(e._util={})),e.IInstantiationService=P("instantiationService");function d(k,L,h,n){L[S.DI_TARGET]===L?L[S.DI_DEPENDENCIES].push({id:k,index:h,optional:n}):(L[S.DI_DEPENDENCIES]=[{id:k,index:h,optional:n}],L[S.DI_TARGET]=L)}function P(k){if(S.serviceIds.has(k))return S.serviceIds.get(k);const L=function(h,n,D){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");d(L,h,D,!1)};return L.toString=()=>k,S.serviceIds.set(k,L),L}e.createDecorator=P;function y(k){return function(L,h,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");d(k,L,n,!0)}}e.optional=y}),define(fe[172],he([0,1,7]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=S.createDecorator("modelService");function d(P){return!P.isTooLargeForSyncing()&&!P.isForSimpleWidget}e.shouldSynchronizeModel=d}),define(fe[173],he([0,1,6,112,4,25,109,127,172]),function(Q,e,S,d,P,y,k,L,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function n(I){return typeof I=="string"?!1:Array.isArray(I)?I.every(n):!!I.exclusive}class D{constructor(){this._clock=0,this._entries=[],this._onDidChange=new S.Emitter}get onDidChange(){return this._onDidChange.event}register(E,u){let v={selector:E,provider:u,_score:-1,_time:this._clock++};return this._entries.push(v),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),P.toDisposable(()=>{if(v){let _=this._entries.indexOf(v);_>=0&&(this._entries.splice(_,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),v=void 0)}})}has(E){return this.all(E).length>0}all(E){if(!E)return[];this._updateScores(E);const u=[];for(let v of this._entries)v._score>0&&u.push(v.provider);return u}ordered(E){const u=[];return this._orderedForEach(E,v=>u.push(v.provider)),u}orderedGroups(E){const u=[];let v,_;return this._orderedForEach(E,w=>{v&&_===w._score?v.push(w.provider):(_=w._score,v=[w.provider],u.push(v))}),u}_orderedForEach(E,u){if(!!E){this._updateScores(E);for(const v of this._entries)v._score>0&&u(v)}}_updateScores(E){let u={uri:E.uri.toString(),language:E.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===u.language&&this._lastCandidate.uri===u.uri)){this._lastCandidate=u;for(let v of this._entries)if(v._score=L.score(v.selector,E.uri,E.getLanguageIdentifier().language,h.shouldSynchronizeModel(E)),n(v.selector)&&v._score>0){for(let _ of this._entries)_._score=0;v._score=1e3;break}this._entries.sort(D._compareByScoreAndTime)}}static _compareByScoreAndTime(E,u){return E._score<u._score?1:E._score>u._score?-1:E._time<u._time?1:E._time>u._time?-1:0}}e.LanguageFeatureRegistry=D;class b{constructor(E,u,v=Number.MAX_SAFE_INTEGER){this._registry=E,this.min=u,this.max=v,this._cache=new y.LRUCache(50,.7)}_key(E){return E.id+d.hash(this._registry.all(E))}_clamp(E){return E===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(E*1.3)))}get(E){const u=this._key(E),v=this._cache.get(u);return this._clamp(v==null?void 0:v.value)}update(E,u){const v=this._key(E);let _=this._cache.get(v);return _||(_=new k.MovingAverage,this._cache.set(v,_)),_.update(u),this.get(E)}}e.LanguageFeatureRequestDelays=b}),define(fe[174],he([0,1,3,55,173,128,70]),function(Q,e,S,d,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var L;(function(p){p[p.Null=0]="Null",p[p.PlainText=1]="PlainText"})(L=e.LanguageId||(e.LanguageId={}));class h{constructor(f,T){this.language=f,this.id=T}}e.LanguageIdentifier=h;var n;(function(p){p[p.NotSet=-1]="NotSet",p[p.None=0]="None",p[p.Italic=1]="Italic",p[p.Bold=2]="Bold",p[p.Underline=4]="Underline"})(n=e.FontStyle||(e.FontStyle={}));var D;(function(p){p[p.None=0]="None",p[p.DefaultForeground=1]="DefaultForeground",p[p.DefaultBackground=2]="DefaultBackground"})(D=e.ColorId||(e.ColorId={}));var b;(function(p){p[p.Other=0]="Other",p[p.Comment=1]="Comment",p[p.String=2]="String",p[p.RegEx=4]="RegEx"})(b=e.StandardTokenType||(e.StandardTokenType={}));var I;(function(p){p[p.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",p[p.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",p[p.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",p[p.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",p[p.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",p[p.ITALIC_MASK=2048]="ITALIC_MASK",p[p.BOLD_MASK=4096]="BOLD_MASK",p[p.UNDERLINE_MASK=8192]="UNDERLINE_MASK",p[p.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",p[p.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",p[p.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",p[p.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",p[p.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",p[p.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",p[p.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",p[p.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",p[p.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",p[p.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(I=e.MetadataConsts||(e.MetadataConsts={}));class E{static getLanguageId(f){return(f&255)>>>0}static getTokenType(f){return(f&1792)>>>8}static getFontStyle(f){return(f&14336)>>>11}static getForeground(f){return(f&8372224)>>>14}static getBackground(f){return(f&4286578688)>>>23}static getClassNameFromMetadata(f){let T=this.getForeground(f),O="mtk"+T,H=this.getFontStyle(f);return H&1&&(O+=" mtki"),H&2&&(O+=" mtkb"),H&4&&(O+=" mtku"),O}static getInlineStyleFromMetadata(f,T){const O=this.getForeground(f),H=this.getFontStyle(f);let $=`color: ${T[O]};`;return H&1&&($+="font-style: italic;"),H&2&&($+="font-weight: bold;"),H&4&&($+="text-decoration: underline;"),$}}e.TokenMetadata=E;var u;(function(p){p[p.Method=0]="Method",p[p.Function=1]="Function",p[p.Constructor=2]="Constructor",p[p.Field=3]="Field",p[p.Variable=4]="Variable",p[p.Class=5]="Class",p[p.Struct=6]="Struct",p[p.Interface=7]="Interface",p[p.Module=8]="Module",p[p.Property=9]="Property",p[p.Event=10]="Event",p[p.Operator=11]="Operator",p[p.Unit=12]="Unit",p[p.Value=13]="Value",p[p.Constant=14]="Constant",p[p.Enum=15]="Enum",p[p.EnumMember=16]="EnumMember",p[p.Keyword=17]="Keyword",p[p.Text=18]="Text",p[p.Color=19]="Color",p[p.File=20]="File",p[p.Reference=21]="Reference",p[p.Customcolor=22]="Customcolor",p[p.Folder=23]="Folder",p[p.TypeParameter=24]="TypeParameter",p[p.User=25]="User",p[p.Issue=26]="Issue",p[p.Snippet=27]="Snippet"})(u=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let p=Object.create(null);return p[0]="symbol-method",p[1]="symbol-function",p[2]="symbol-constructor",p[3]="symbol-field",p[4]="symbol-variable",p[5]="symbol-class",p[6]="symbol-struct",p[7]="symbol-interface",p[8]="symbol-module",p[9]="symbol-property",p[10]="symbol-event",p[11]="symbol-operator",p[12]="symbol-unit",p[13]="symbol-value",p[14]="symbol-constant",p[15]="symbol-enum",p[16]="symbol-enum-member",p[17]="symbol-keyword",p[27]="symbol-snippet",p[18]="symbol-text",p[19]="symbol-color",p[20]="symbol-file",p[21]="symbol-reference",p[22]="symbol-customcolor",p[23]="symbol-folder",p[24]="symbol-type-parameter",p[25]="account",p[26]="issues",function(f){const T=p[f];let O=T&&k.iconRegistry.get(T);return O||(console.info("No codicon found for CompletionItemKind "+f),O=k.Codicon.symbolProperty),O.classNames}}(),e.completionKindFromString=function(){let p=Object.create(null);return p.method=0,p.function=1,p.constructor=2,p.field=3,p.variable=4,p.class=5,p.struct=6,p.interface=7,p.module=8,p.property=9,p.event=10,p.operator=11,p.unit=12,p.value=13,p.constant=14,p.enum=15,p["enum-member"]=16,p.enumMember=16,p.keyword=17,p.snippet=27,p.text=18,p.color=19,p.file=20,p.reference=21,p.customcolor=22,p.folder=23,p["type-parameter"]=24,p.typeParameter=24,p.account=25,p.issue=26,function(f,T){let O=p[f];return typeof O=="undefined"&&!T&&(O=9),O}}();var v;(function(p){p[p.Deprecated=1]="Deprecated"})(v=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(p){p[p.KeepWhitespace=1]="KeepWhitespace",p[p.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(p){p[p.Invoke=0]="Invoke",p[p.TriggerCharacter=1]="TriggerCharacter",p[p.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var m;(function(p){p[p.Auto=1]="Auto",p[p.Manual=2]="Manual"})(m=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var l;(function(p){p[p.Invoke=1]="Invoke",p[p.TriggerCharacter=2]="TriggerCharacter",p[p.ContentChange=3]="ContentChange"})(l=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var c;(function(p){p[p.Text=0]="Text",p[p.Read=1]="Read",p[p.Write=2]="Write"})(c=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function r(p){return p&&S.URI.isUri(p.uri)&&d.Range.isIRange(p.range)&&(d.Range.isIRange(p.originSelectionRange)||d.Range.isIRange(p.targetSelectionRange))}e.isLocationLink=r;var t;(function(p){p[p.File=0]="File",p[p.Module=1]="Module",p[p.Namespace=2]="Namespace",p[p.Package=3]="Package",p[p.Class=4]="Class",p[p.Method=5]="Method",p[p.Property=6]="Property",p[p.Field=7]="Field",p[p.Constructor=8]="Constructor",p[p.Enum=9]="Enum",p[p.Interface=10]="Interface",p[p.Function=11]="Function",p[p.Variable=12]="Variable",p[p.Constant=13]="Constant",p[p.String=14]="String",p[p.Number=15]="Number",p[p.Boolean=16]="Boolean",p[p.Array=17]="Array",p[p.Object=18]="Object",p[p.Key=19]="Key",p[p.Null=20]="Null",p[p.EnumMember=21]="EnumMember",p[p.Struct=22]="Struct",p[p.Event=23]="Event",p[p.Operator=24]="Operator",p[p.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var i;(function(p){p[p.Deprecated=1]="Deprecated"})(i=e.SymbolTag||(e.SymbolTag={}));var o;(function(p){const f=new Map;f.set("file",0),f.set("module",1),f.set("namespace",2),f.set("package",3),f.set("class",4),f.set("method",5),f.set("property",6),f.set("field",7),f.set("constructor",8),f.set("enum",9),f.set("interface",10),f.set("function",11),f.set("variable",12),f.set("constant",13),f.set("string",14),f.set("number",15),f.set("boolean",16),f.set("array",17),f.set("object",18),f.set("key",19),f.set("null",20),f.set("enum-member",21),f.set("struct",22),f.set("event",23),f.set("operator",24),f.set("type-parameter",25);const T=new Map;T.set(0,"file"),T.set(1,"module"),T.set(2,"namespace"),T.set(3,"package"),T.set(4,"class"),T.set(5,"method"),T.set(6,"property"),T.set(7,"field"),T.set(8,"constructor"),T.set(9,"enum"),T.set(10,"interface"),T.set(11,"function"),T.set(12,"variable"),T.set(13,"constant"),T.set(14,"string"),T.set(15,"number"),T.set(16,"boolean"),T.set(17,"array"),T.set(18,"object"),T.set(19,"key"),T.set(20,"null"),T.set(21,"enum-member"),T.set(22,"struct"),T.set(23,"event"),T.set(24,"operator"),T.set(25,"type-parameter");function O(x){return f.get(x)}p.fromString=O;function H(x){return T.get(x)}p.toString=H;function $(x,J){const Ee=T.get(x);let ve=Ee&&k.iconRegistry.get("symbol-"+Ee);return ve||(console.info("No codicon found for SymbolKind "+x),ve=k.Codicon.symbolProperty),`${J?"inline":"block"} ${ve.classNames}`}p.toCssClassName=$})(o=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(f){this.value=f}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var s;(function(p){p[p.Collapsed=0]="Collapsed",p[p.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var g;(function(p){p[p.Editing=0]="Editing",p[p.Preview=1]="Preview"})(g=e.CommentMode||(e.CommentMode={}));var C;(function(p){p[p.Other=0]="Other",p[p.Type=1]="Type",p[p.Parameter=2]="Parameter"})(C=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new P.LanguageFeatureRegistry,e.RenameProviderRegistry=new P.LanguageFeatureRegistry,e.CompletionProviderRegistry=new P.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new P.LanguageFeatureRegistry,e.HoverProviderRegistry=new P.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new P.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new P.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new P.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new P.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new P.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new P.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new P.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new P.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new P.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new P.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new P.LanguageFeatureRegistry,e.LinkProviderRegistry=new P.LanguageFeatureRegistry,e.ColorProviderRegistry=new P.LanguageFeatureRegistry,e.SelectionRangeRegistry=new P.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new P.LanguageFeatureRegistry,e.TokenizationRegistry=new y.TokenizationRegistryImpl;var R;(function(p){p[p.None=0]="None",p[p.Option=1]="Option",p[p.Default=2]="Default",p[p.Preferred=3]="Preferred"})(R=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(fe[47],he([0,1,14,7,5]),function(Q,e,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let y=P.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",P.isMacintosh),k.set("isLinux",P.isLinux),k.set("isWindows",P.isWindows),k.set("isWeb",P.isWeb),k.set("isMacNative",P.isMacintosh&&!P.isWeb),k.set("isEdge",y.indexOf("Edg/")>=0),k.set("isFirefox",y.indexOf("Firefox")>=0),k.set("isChrome",y.indexOf("Chrome")>=0),k.set("isSafari",y.indexOf("Safari")>=0),k.set("isIPad",y.indexOf("iPad")>=0);const L=Object.prototype.hasOwnProperty;var h;(function(p){p[p.False=0]="False",p[p.True=1]="True",p[p.Defined=2]="Defined",p[p.Not=3]="Not",p[p.Equals=4]="Equals",p[p.NotEquals=5]="NotEquals",p[p.And=6]="And",p[p.Regex=7]="Regex",p[p.NotRegex=8]="NotRegex",p[p.Or=9]="Or",p[p.In=10]="In",p[p.NotIn=11]="NotIn",p[p.Greater=12]="Greater",p[p.GreaterEquals=13]="GreaterEquals",p[p.Smaller=14]="Smaller",p[p.SmallerEquals=15]="SmallerEquals"})(h=e.ContextKeyExprType||(e.ContextKeyExprType={}));class n{static false(){return b.INSTANCE}static true(){return I.INSTANCE}static has(f){return E.create(f)}static equals(f,T){return u.create(f,T)}static notEquals(f,T){return w.create(f,T)}static regex(f,T){return i.create(f,T)}static in(f,T){return v.create(f,T)}static not(f){return m.create(f)}static and(...f){return a.create(f)}static or(...f){return s.create(f)}static greater(f,T){return l.create(f,T)}static less(f,T){return r.create(f,T)}static deserialize(f,T=!1){if(!!f)return this._deserializeOrExpression(f,T)}static _deserializeOrExpression(f,T){let O=f.split("||");return s.create(O.map(H=>this._deserializeAndExpression(H,T)))}static _deserializeAndExpression(f,T){let O=f.split("&&");return a.create(O.map(H=>this._deserializeOne(H,T)))}static _deserializeOne(f,T){if(f=f.trim(),f.indexOf("!=")>=0){let O=f.split("!=");return w.create(O[0].trim(),this._deserializeValue(O[1],T))}if(f.indexOf("==")>=0){let O=f.split("==");return u.create(O[0].trim(),this._deserializeValue(O[1],T))}if(f.indexOf("=~")>=0){let O=f.split("=~");return i.create(O[0].trim(),this._deserializeRegexValue(O[1],T))}if(f.indexOf(" in ")>=0){let O=f.split(" in ");return v.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(f)){const O=f.split(">=");return c.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(f)){const O=f.split(">");return l.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(f)){const O=f.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(f)){const O=f.split("<");return r.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(f)?m.create(f.substr(1).trim()):E.create(f)}static _deserializeValue(f,T){if(f=f.trim(),f==="true")return!0;if(f==="false")return!1;let O=/^'([^']*)'$/.exec(f);return O?O[1].trim():f}static _deserializeRegexValue(f,T){if(S.isFalsyOrWhitespace(f)){if(T)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=f.indexOf("/"),H=f.lastIndexOf("/");if(O===H||O<0){if(T)throw new Error(`bad regexp-value '${f}', missing /-enclosure`);return console.warn(`bad regexp-value '${f}', missing /-enclosure`),null}let $=f.slice(O+1,H),x=f[H+1]==="i"?"i":"";try{return new RegExp($,x)}catch(J){if(T)throw new Error(`bad regexp-value '${f}', parse error: ${J}`);return console.warn(`bad regexp-value '${f}', parse error: ${J}`),null}}}e.ContextKeyExpr=n;function D(p,f){return p.cmp(f)}class b{constructor(){this.type=0}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}evaluate(f){return!1}serialize(){return"false"}keys(){return[]}map(f){return this}negate(){return I.INSTANCE}}e.ContextKeyFalseExpr=b,b.INSTANCE=new b;class I{constructor(){this.type=1}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}evaluate(f){return!0}serialize(){return"true"}keys(){return[]}map(f){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=I,I.INSTANCE=new I;class E{constructor(f){this.key=f,this.type=2}static create(f){const T=k.get(f);return typeof T=="boolean"?T?I.INSTANCE:b.INSTANCE:new E(f)}cmp(f){return f.type!==this.type?this.type-f.type:C(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}evaluate(f){return!!f.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(f){return f.mapDefined(this.key)}negate(){return m.create(this.key)}}e.ContextKeyDefinedExpr=E;class u{constructor(f,T){this.key=f,this.value=T,this.type=4}static create(f,T){if(typeof T=="boolean")return T?E.create(f):m.create(f);const O=k.get(f);return typeof O=="boolean"?T===(O?"true":"false")?I.INSTANCE:b.INSTANCE:new u(f,T)}cmp(f){return f.type!==this.type?this.type-f.type:R(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return f.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(f){return f.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=u;class v{constructor(f,T){this.key=f,this.valueKey=T,this.type=10}static create(f,T){return new v(f,T)}cmp(f){return f.type!==this.type?this.type-f.type:R(this.key,this.valueKey,f.key,f.valueKey)}equals(f){return f.type===this.type?this.key===f.key&&this.valueKey===f.valueKey:!1}evaluate(f){const T=f.getValue(this.valueKey),O=f.getValue(this.key);return Array.isArray(T)?T.indexOf(O)>=0:typeof O=="string"&&typeof T=="object"&&T!==null?L.call(T,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(f){return f.mapIn(this.key,this.valueKey)}negate(){return _.create(this)}}e.ContextKeyInExpr=v;class _{constructor(f){this._actual=f,this.type=11}static create(f){return new _(f)}cmp(f){return f.type!==this.type?this.type-f.type:this._actual.cmp(f._actual)}equals(f){return f.type===this.type?this._actual.equals(f._actual):!1}evaluate(f){return!this._actual.evaluate(f)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(f){return new _(this._actual.map(f))}negate(){return this._actual}}e.ContextKeyNotInExpr=_;class w{constructor(f,T){this.key=f,this.value=T,this.type=5}static create(f,T){if(typeof T=="boolean")return T?m.create(f):E.create(f);const O=k.get(f);return typeof O=="boolean"?T===(O?"true":"false")?b.INSTANCE:I.INSTANCE:new w(f,T)}cmp(f){return f.type!==this.type?this.type-f.type:R(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return f.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(f){return f.mapNotEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class m{constructor(f){this.key=f,this.type=3}static create(f){const T=k.get(f);return typeof T=="boolean"?T?b.INSTANCE:I.INSTANCE:new m(f)}cmp(f){return f.type!==this.type?this.type-f.type:C(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}evaluate(f){return!f.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(f){return f.mapNot(this.key)}negate(){return E.create(this.key)}}e.ContextKeyNotExpr=m;class l{constructor(f,T){this.key=f,this.value=T,this.type=12}static create(f,T){return new l(f,T)}cmp(f){return f.type!==this.type?this.type-f.type:R(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(f){return f.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=l;class c{constructor(f,T){this.key=f,this.value=T,this.type=13}static create(f,T){return new c(f,T)}cmp(f){return f.type!==this.type?this.type-f.type:R(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(f){return f.mapGreaterEquals(this.key,this.value)}negate(){return r.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=c;class r{constructor(f,T){this.key=f,this.value=T,this.type=14}static create(f,T){return new r(f,T)}cmp(f){return f.type!==this.type?this.type-f.type:R(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(f){return f.mapSmaller(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerExpr=r;class t{constructor(f,T){this.key=f,this.value=T,this.type=15}static create(f,T){return new t(f,T)}cmp(f){return f.type!==this.type?this.type-f.type:R(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(f){return f.mapSmallerEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(f,T){this.key=f,this.regexp=T,this.type=7}static create(f,T){return new i(f,T)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.key<f.key)return-1;if(this.key>f.key)return 1;const T=this.regexp?this.regexp.source:"",O=f.regexp?f.regexp.source:"";return T<O?-1:T>O?1:0}equals(f){if(f.type===this.type){const T=this.regexp?this.regexp.source:"",O=f.regexp?f.regexp.source:"";return this.key===f.key&&T===O}return!1}evaluate(f){let T=f.getValue(this.key);return this.regexp?this.regexp.test(T):!1}serialize(){const f=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${f}`}keys(){return[this.key]}map(f){return f.mapRegex(this.key,this.regexp)}negate(){return o.create(this)}}e.ContextKeyRegexExpr=i;class o{constructor(f){this._actual=f,this.type=8}static create(f){return new o(f)}cmp(f){return f.type!==this.type?this.type-f.type:this._actual.cmp(f._actual)}equals(f){return f.type===this.type?this._actual.equals(f._actual):!1}evaluate(f){return!this._actual.evaluate(f)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(f){return new o(this._actual.map(f))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;class a{constructor(f){this.expr=f,this.type=6}static create(f){return a._normalizeArr(f)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let T=0,O=this.expr.length;T<O;T++){const H=D(this.expr[T],f.expr[T]);if(H!==0)return H}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].equals(f.expr[T]))return!1;return!0}return!1}evaluate(f){for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].evaluate(f))return!1;return!0}static _normalizeArr(f){const T=[];let O=!1;for(const H of f)if(!!H){if(H.type===1){O=!0;continue}if(H.type===0)return b.INSTANCE;if(H.type===6){T.push(...H.expr);continue}T.push(H)}if(T.length===0&&O)return I.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];for(T.sort(D);T.length>1;){const H=T[T.length-1];if(H.type!==9)break;T.pop();const $=T.pop(),x=s.create(H.expr.map(J=>a.create([J,$])));x&&(T.push(x),T.sort(D))}return T.length===1?T[0]:new a(T)}}serialize(){return this.expr.map(f=>f.serialize()).join(" && ")}keys(){const f=[];for(let T of this.expr)f.push(...T.keys());return f}map(f){return new a(this.expr.map(T=>T.map(f)))}negate(){let f=[];for(let T of this.expr)f.push(T.negate());return s.create(f)}}e.ContextKeyAndExpr=a;class s{constructor(f){this.expr=f,this.type=9}static create(f){const T=s._normalizeArr(f);if(T.length!==0)return T.length===1?T[0]:new s(T)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let T=0,O=this.expr.length;T<O;T++){const H=D(this.expr[T],f.expr[T]);if(H!==0)return H}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].equals(f.expr[T]))return!1;return!0}return!1}evaluate(f){for(let T=0,O=this.expr.length;T<O;T++)if(this.expr[T].evaluate(f))return!0;return!1}static _normalizeArr(f){let T=[],O=!1;if(f){for(let H=0,$=f.length;H<$;H++){const x=f[H];if(!!x){if(x.type===0){O=!0;continue}if(x.type===1)return[I.INSTANCE];if(x.type===9){T=T.concat(x.expr);continue}T.push(x)}}if(T.length===0&&O)return[b.INSTANCE];T.sort(D)}return T}serialize(){return this.expr.map(f=>f.serialize()).join(" || ")}keys(){const f=[];for(let T of this.expr)f.push(...T.keys());return f}map(f){return new s(this.expr.map(T=>T.map(f)))}negate(){let f=[];for(let O of this.expr)f.push(O.negate());const T=O=>O.type===9?O.expr:[O];for(;f.length>1;){const O=f.shift(),H=f.shift(),$=[];for(const x of T(O))for(const J of T(H))$.push(n.and(x,J));f.unshift(n.or(...$))}return f[0]}}e.ContextKeyOrExpr=s;class g extends E{constructor(f,T,O){super(f);this.key=f,this._defaultValue=T,typeof O=="object"?g._info.push(Object.assign(Object.assign({},O),{key:f})):O!==!0&&g._info.push({key:f,description:O,type:T!=null?typeof T:void 0})}static all(){return g._info.values()}bindTo(f){return f.createKey(this.key,this._defaultValue)}getValue(f){return f.getContextKeyValue(this.key)}toNegated(){return n.not(this.key)}isEqualTo(f){return n.equals(this.key,f)}notEqualsTo(f){return n.notEquals(this.key,f)}}e.RawContextKey=g,g._info=[],e.IContextKeyService=d.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function C(p,f){return p<f?-1:p>f?1:0}function R(p,f,T,O){return p<T?-1:p>T?1:f<O?-1:f>O?1:0}}),define(fe[175],he([0,1,7]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=S.createDecorator(e.ID);function d(P){return!!P.hostName&&!!P.errorMessage}e.isRemoteDiagnosticError=d}),define(fe[83],he([0,1,7]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=S.createDecorator("downloadService")}),define(fe[29],he([0,1,7]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=S.createDecorator("environmentService"),e.INativeEnvironmentService=S.createDecorator("nativeEnvironmentService")}),define(fe[30],he([0,1,141,7,8]),function(Q,e,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function y(b){return b&&typeof b=="object"&&typeof b.id=="string"&&(!b.uuid||typeof b.uuid=="string")}e.isIExtensionIdentifier=y;var k;(function(b){b[b.NoneOrRelevance=0]="NoneOrRelevance",b[b.LastUpdatedDate=1]="LastUpdatedDate",b[b.Title=2]="Title",b[b.PublisherName=3]="PublisherName",b[b.InstallCount=4]="InstallCount",b[b.PublishedDate=5]="PublishedDate",b[b.AverageRating=6]="AverageRating",b[b.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var L;(function(b){b[b.Default=0]="Default",b[b.Ascending=1]="Ascending",b[b.Descending=2]="Descending"})(L=e.SortOrder||(e.SortOrder={}));var h;(function(b){b.Uninstall="uninstall"})(h=e.StatisticType||(e.StatisticType={}));var n;(function(b){b[b.None=0]="None",b[b.Install=1]="Install",b[b.Update=2]="Update"})(n=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=d.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class D extends Error{constructor(I,E){super(I);this.code=E}}e.ExtensionManagementError=D,e.IExtensionManagementService=d.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=d.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=d.createDecorator("IExtensionTipsService"),e.DefaultIconPath=P.FileAccess.asBrowserUri("./media/defaultIcon.png",Q).toString(!0),e.ExtensionsLabel=S.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=S.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=d.createDecorator("IExtensionManagementCLIService")}),define(fe[41],he([0,1,14,7]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function P(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=P,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var y;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(y=e.ExtensionType||(e.ExtensionType={}));class k{constructor(D){this.value=D,this._lower=D.toLowerCase()}static equals(D,b){if(typeof D=="undefined"||D===null)return typeof b=="undefined"||b===null;if(typeof b=="undefined"||b===null)return!1;if(typeof D=="string"||typeof b=="string"){let I=typeof D=="string"?D:D.value,E=typeof b=="string"?b:b.value;return S.equalsIgnoreCase(I,E)}return D._lower===b._lower}static toKey(D){return typeof D=="string"?D.toLowerCase():D._lower}}e.ExtensionIdentifier=k;function L(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=L;function h(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=h,e.IBuiltinExtensionsScannerService=d.createDecorator("IBuiltinExtensionsScannerService")}),define(fe[33],he([0,1,14,41]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function P(E,u){return E.uuid&&u.uuid?E.uuid===u.uuid:E.id===u.id?!0:S.compareIgnoreCase(E.id,u.id)===0}e.areSameExtensions=P;class y{constructor(u,v){this.version=v,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof y?P(this,u)&&this.version===u.version:!1}}e.ExtensionIdentifierWithVersion=y;function k(E,u){return`${E}.${u}`}e.getExtensionId=k;function L(E){return E.toLocaleLowerCase()}e.adoptToGalleryExtensionId=L;function h(E,u){return L(k(E,u))}e.getGalleryExtensionId=h;function n(E,u){const v=[],_=w=>{for(const m of v)if(m.some(l=>P(u(l),u(w))))return m;return null};for(const w of E){const m=_(w);m?m.push(w):v.push([w])}return v}e.groupByExtension=n;function D(E){return{id:E.identifier.id,name:E.manifest.name,galleryId:null,publisherId:E.publisherId,publisherName:E.manifest.publisher,publisherDisplayName:E.publisherDisplayName,dependencies:E.manifest.extensionDependencies&&E.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=D;function b(E){return Object.assign({id:E.identifier.id,name:E.name,galleryId:E.identifier.uuid,publisherId:E.publisherId,publisherName:E.publisher,publisherDisplayName:E.publisherDisplayName,dependencies:!!(E.properties.dependencies&&E.properties.dependencies.length>0)},E.telemetryData)}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new d.ExtensionIdentifier("pprice.better-merge");function I(E){const u=new Set;for(const v of E)v.malicious&&u.add(v.id.id);return u}e.getMaliciousExtensionsSet=I}),define(fe[176],he([0,1,4,2,41,20]),function(Q,e,S,d,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends S.Disposable{constructor(h,n){super();this.environmentService=h,this.extensionsManifestCache=d.join(this.environmentService.userDataPath,P.MANIFEST_CACHE_FOLDER,P.USER_MANIFEST_CACHE_FILE),this._register(n.onDidInstallExtension(D=>this.onDidInstallExtension(D))),this._register(n.onDidUninstallExtension(D=>this.onDidUnInstallExtension(D)))}onDidInstallExtension(h){h.error||this.invalidate()}onDidUnInstallExtension(h){h.error||this.invalidate()}invalidate(){y.rimraf(this.extensionsManifestCache,y.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(fe[24],he([0,1,148,2,3,7,14,11,25]),function(Q,e,S,d,P,y,k,L,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.IFileService=void 0,e.IFileService=y.createDecorator("fileService");var n;(function(O){O[O.Unknown=0]="Unknown",O[O.File=1]="File",O[O.Directory=2]="Directory",O[O.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var D;(function(O){O[O.FileReadWrite=2]="FileReadWrite",O[O.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",O[O.FileReadStream=16]="FileReadStream",O[O.FileFolderCopy=8]="FileFolderCopy",O[O.PathCaseSensitive=1024]="PathCaseSensitive",O[O.Readonly=2048]="Readonly",O[O.Trash=4096]="Trash"})(D=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(O){return!!(O.capabilities&2)}e.hasReadWriteCapability=b;function I(O){return!!(O.capabilities&8)}e.hasFileFolderCopyCapability=I;function E(O){return!!(O.capabilities&4)}e.hasOpenReadWriteCloseCapability=E;function u(O){return!!(O.capabilities&16)}e.hasFileReadStreamCapability=u;var v;(function(O){O.FileExists="EntryExists",O.FileNotFound="EntryNotFound",O.FileNotADirectory="EntryNotADirectory",O.FileIsADirectory="EntryIsADirectory",O.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",O.FileTooLarge="EntryTooLarge",O.NoPermissions="NoPermissions",O.Unavailable="Unavailable",O.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class _ extends Error{constructor(H,$){super(H);this.code=$}}e.FileSystemProviderError=_;function w(O,H){const $=new _(O.toString(),H);return l($,H),$}e.createFileSystemProviderError=w;function m(O){return O||w(S.localize(0,null),v.Unknown)}e.ensureFileSystemProviderError=m;function l(O,H){return O.name=H?`${H} (FileSystemError)`:"FileSystemError",O}e.markAsFileSystemProviderError=l;function c(O){if(!O)return v.Unknown;if(O instanceof _)return O.code;const H=/^(.+) \(FileSystemError\)$/.exec(O.name);if(!H)return v.Unknown;switch(H[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=c;function r(O){if(O instanceof g)return O.fileOperationResult;switch(c(O)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var t;(function(O){O[O.CREATE=0]="CREATE",O[O.DELETE=1]="DELETE",O[O.MOVE=2]="MOVE",O[O.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class i{constructor(H,$,x){this.resource=H,this.operation=$,this.target=x}isOperation(H){return this.operation===H}}e.FileOperationEvent=i;var o;(function(O){O[O.UPDATED=0]="UPDATED",O[O.ADDED=1]="ADDED",O[O.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class a{constructor(H,$){this.ignorePathCasing=$,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=H;for(const x of H)switch(x.type){case 1:this.added||(this.added=h.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(x.resource,x);break;case 0:this.updated||(this.updated=h.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(x.resource,x);break;case 2:this.deleted||(this.deleted=h.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(x.resource,x);break}}contains(H,...$){return this.doContains(H,{includeChildren:!1},...$)}affects(H,...$){return this.doContains(H,{includeChildren:!0},...$)}doContains(H,$,...x){var J,Ee,ve,q,j,F;if(!H)return!1;const A=x.length>0;return!!((!A||x.includes(1))&&(((J=this.added)===null||J===void 0?void 0:J.get(H))||$.includeChildren&&((Ee=this.added)===null||Ee===void 0?void 0:Ee.findSuperstr(H)))||(!A||x.includes(0))&&(((ve=this.updated)===null||ve===void 0?void 0:ve.get(H))||$.includeChildren&&((q=this.updated)===null||q===void 0?void 0:q.findSuperstr(H)))||(!A||x.includes(2))&&(((j=this.deleted)===null||j===void 0?void 0:j.findSubstr(H))||$.includeChildren&&((F=this.deleted)===null||F===void 0?void 0:F.findSuperstr(H))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(H){const $=[],x=H===1?this.added:H===0?this.updated:this.deleted;if(x)for(const[,J]of x)$.push(J);return $}filter(H){return new a(this.changes.filter($=>H($)),this.ignorePathCasing)}}e.FileChangesEvent=a;function s(O,H,$){return!O||!H||O===H||H.length>O.length?!1:(H.charAt(H.length-1)!==d.sep&&(H+=d.sep),$?k.startsWithIgnoreCase(O,H):O.indexOf(H)===0)}e.isParent=s;class g extends Error{constructor(H,$,x){super(H);this.fileOperationResult=$,this.options=x}static isFileOperationError(H){return H instanceof Error&&!L.isUndefinedOrNull(H.fileOperationResult)}}e.FileOperationError=g;var C;(function(O){O[O.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",O[O.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",O[O.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",O[O.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",O[O.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",O[O.FILE_READ_ONLY=5]="FILE_READ_ONLY",O[O.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",O[O.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",O[O.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",O[O.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",O[O.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",O[O.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(C=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var R;(function(O){O[O.FILE=0]="FILE",O[O.FOLDER=1]="FOLDER",O[O.ROOT_FOLDER=2]="ROOT_FOLDER"})(R=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function p(O){if(!(typeof O.size!="number"||typeof O.mtime!="number"))return O.mtime.toString(29)+O.size.toString(31)}e.etag=p;async function f(O,H){if(!H.canHandleResource(P.URI.from({scheme:O.scheme})))return new Promise($=>{const x=H.onDidChangeFileSystemProviderRegistrations(J=>{J.scheme===O.scheme&&J.added&&(x.dispose(),$())})})}e.whenProviderRegistered=f,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class T{static formatSize(H){return L.isNumber(H)||(H=0),H<T.KB?S.localize(1,null,H.toFixed(0)):H<T.MB?S.localize(2,null,(H/T.KB).toFixed(2)):H<T.GB?S.localize(3,null,(H/T.MB).toFixed(2)):H<T.TB?S.localize(4,null,(H/T.GB).toFixed(2)):S.localize(5,null,(H/T.TB).toFixed(2))}}e.ByteSize=T,T.KB=1024,T.MB=T.KB*T.KB,T.GB=T.MB*T.KB,T.TB=T.GB*T.KB}),define(fe[177],he([0,1,235,140,24,56]),function(Q,e,S,d,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function k(I,E){const u={onUnknownOption:_=>{console.warn(d.localize(0,null,_))},onMultipleValues:(_,w)=>{console.warn(d.localize(1,null,_,w))}},v=y.parseArgs(I,y.OPTIONS,E?u:void 0);return v.goto&&v._.forEach(_=>S(/^(\w:)?[^:]+(:\d*){0,2}$/.test(_),d.localize(2,null))),v["max-memory"]&&S(parseInt(v["max-memory"])>=P.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${P.MIN_MAX_MEMORY_SIZE_MB} MB.`),v}function L(I){const E=I.findIndex(u=>!/^-/.test(u));if(E>-1)return[...I.slice(0,E),...I.slice(E+1)]}function h(I){let[,...E]=I;process.env.VSCODE_DEV&&(E=L(E)||[]);const u=!b(process.env);return k(E,u)}e.parseMainProcessArgv=h;function n(I){const[,,...E]=I;return k(E,!0)}e.parseCLIProcessArgv=n;function D(I,...E){const u=I.indexOf("--");return u===-1?I.push(...E):I.splice(u,0,...E),I}e.addArg=D;function b(I){return I.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),define(fe[178],he([0,1,32,23,5,177,40,81]),function(Q,e,S,d,P,y,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function h(b,I,E){return I["force-disable-user-env"]?(b.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(b.trace("resolveShellEnv(): skipped (Windows)"),{}):y.isLaunchedFromCli(E)&&!I["force-user-env"]?(b.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):(y.isLaunchedFromCli(E)?b.trace("resolveShellEnv(): running (--force-user-env)"):b.trace("resolveShellEnv(): running (macOS/Linux)"),n||(n=D(b)),n)}e.resolveShellEnv=h;let n;async function D(b){const I=new Promise(async(E,u)=>{const v=process.env.ELECTRON_RUN_AS_NODE;b.trace("getUnixShellEnvironment#runAsNode",v);const _=process.env.ELECTRON_NO_ATTACH_CONSOLE;b.trace("getUnixShellEnvironment#noAttach",_);const w=d.generateUuid().replace(/-/g,"").substr(0,12),m=new RegExp(w+"(.*)"+w),l=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"}),c=`'${process.execPath}' -p '"${w}" + JSON.stringify(process.env) + "${w}"'`;b.trace("getUnixShellEnvironment#env",l),b.trace("getUnixShellEnvironment#spawn",c);const r=await L.getSystemShell(P.platform),t=S.spawn(r,["-ilc",c],{detached:!0,stdio:["ignore","pipe",process.stderr],env:l}),i=[];t.on("error",()=>E({})),t.stdout.on("data",o=>i.push(o)),t.on("close",o=>{if(o!==0)return u(new Error("Failed to get environment"));const a=Buffer.concat(i).toString("utf8");b.trace("getUnixShellEnvironment#raw",a);const s=m.exec(a),g=s?s[1]:"{}";try{const C=JSON.parse(g);v?C.ELECTRON_RUN_AS_NODE=v:delete C.ELECTRON_RUN_AS_NODE,_?C.ELECTRON_NO_ATTACH_CONSOLE=_:delete C.ELECTRON_NO_ATTACH_CONSOLE,delete C.XDG_RUNTIME_DIR,b.trace("getUnixShellEnvironment#result",C),E(C)}catch(C){b.error("getUnixShellEnvironment#error",C),u(C)}})});try{return await I}catch(E){return b.error("getUnixShellEnvironment#error",k.toErrorMessage(E)),{}}}}),define(fe[84],he([0,1,149,18,24,12]),function(Q,e,S,d,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(D,b,I,E,u,v){let _;try{await L(D,b,I,E,u,v)}catch(w){_=w}finally{_&&u.errorTransformer&&(_=u.errorTransformer(_)),I.end(_)}}e.readFileIntoStream=k;async function L(D,b,I,E,u,v){h(v);const _=await D.open(b,{create:!1});try{h(v);let w=0,m=0,l=u&&typeof u.length=="number"?u.length:void 0,c=d.VSBuffer.alloc(Math.min(u.bufferSize,typeof l=="number"?l:u.bufferSize)),r=u&&typeof u.position=="number"?u.position:0,t=0;do m=await D.read(_,r,c.buffer,t,c.byteLength-t),r+=m,t+=m,w+=m,typeof l=="number"&&(l-=m),t===c.byteLength&&(await I.write(E(c)),c=d.VSBuffer.alloc(Math.min(u.bufferSize,typeof l=="number"?l:u.bufferSize)),t=0);while(m>0&&(typeof l!="number"||l>0)&&h(v)&&n(w,u));if(t>0){let i=t;typeof l=="number"&&(i=Math.min(t,l)),I.write(E(c.slice(0,i)))}}catch(w){throw P.ensureFileSystemProviderError(w)}finally{await D.close(_)}}function h(D){if(D.isCancellationRequested)throw y.canceled();return!0}function n(D,b){if(b==null?void 0:b.limits){if(typeof b.limits.memory=="number"&&D>b.limits.memory)throw P.createFileSystemProviderError(S.localize(0,null),P.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&D>b.limits.size)throw P.createFileSystemProviderError(S.localize(1,null),P.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(fe[85],he([0,1,3,24,5]),function(Q,e,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function y(h){return h.map(n=>({type:n.type,resource:S.URI.file(n.path)}))}e.toFileChanges=y;function k(h){const n=new L;for(const D of h)n.processEvent(D);return n.normalize()}e.normalizeFileChanges=k;class L{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(n){const D=this.mapPathToChange.get(n.path);if(D){const b=D.type,I=n.type;b===1&&I===2?(this.mapPathToChange.delete(n.path),this.normalized.splice(this.normalized.indexOf(D),1)):b===2&&I===1?D.type=0:b===1&&I===0||(D.type=I)}else this.normalized.push(n),this.mapPathToChange.set(n.path,n)}normalize(){const n=[],D=[];return this.normalized.filter(b=>b.type!==2?(n.push(b),!1):!0).sort((b,I)=>b.path.length-I.path.length).filter(b=>D.some(I=>d.isParent(b.path,I,!P.isLinux))?!1:(D.push(b.path),!0)).concat(n)}}}),define(fe[179],he([0,1,85,4,20,121,125,13,2]),function(Q,e,S,d,P,y,k,L,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class n extends d.Disposable{constructor(b,I,E,u){super();this.path=b,this.onDidFilesChange=I,this.onLogMessage=E,this.verboseLogging=u,this.fileChangesDelayer=this._register(new L.ThrottledDelayer(k.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(b){this.verboseLogging=b}async startWatching(){try{const{stat:b,symbolicLink:I}=await P.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let E=this.path;if(I)try{E=await y.realpath(E)}catch(u){if(this.onError(u),I.dangling)return}b.isDirectory()?this._register(k.watchFolder(E,(u,v)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:h.join(this.path,h.basename(v))})},u=>this.onError(u))):this._register(k.watchFile(E,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(b){b.code!=="ENOENT"&&this.onError(b)}}onFileChange(b){this.fileChangesBuffer.push(b),this.verboseLogging&&this.onVerbose(`${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`),this.fileChangesDelayer.trigger(async()=>{const I=this.fileChangesBuffer;this.fileChangesBuffer=[];const E=S.normalizeFileChanges(I);this.verboseLogging&&E.forEach(u=>{this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`)}),E.length>0&&this.onDidFilesChange(E)})}onError(b){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${b}`})}onVerbose(b){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${b}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=n}),define(fe[59],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...P){this._entries=new Map;for(let[y,k]of P)this.set(y,k)}set(P,y){const k=this._entries.get(P);return this._entries.set(P,y),k}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}e.ServiceCollection=S}),define(fe[86],he([0,1,12,171,58,7,59,13]),function(Q,e,S,d,P,y,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const h=!1;class n extends Error{constructor(u){super("cyclic dependency between services");this.message=u.toString()}}class D{constructor(u=new k.ServiceCollection,v=!1,_){this._activeInstantiations=new Set,this._services=u,this._strict=v,this._parent=_,this._services.set(y.IInstantiationService,this)}createChild(u){return new D(u,this._strict,this)}invokeFunction(u,...v){let _=I.traceInvocation(u),w=!1;try{return u({get:(l,c)=>{if(w)throw S.illegalState("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(l,_);if(!r&&c!==y.optional)throw new Error(`[invokeFunction] unknown service '${l}'`);return r}},...v)}finally{w=!0,_.stop()}}createInstance(u,...v){let _,w;return u instanceof P.SyncDescriptor?(_=I.traceCreation(u.ctor),w=this._createInstance(u.ctor,u.staticArguments.concat(v),_)):(_=I.traceCreation(u),w=this._createInstance(u,v,_)),_.stop(),w}_createInstance(u,v=[],_){let w=y._util.getServiceDependencies(u).sort((c,r)=>c.index-r.index),m=[];for(const c of w){let r=this._getOrCreateServiceInstance(c.id,_);if(!r&&this._strict&&!c.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${c.id}.`);m.push(r)}let l=w.length>0?w[0].index:v.length;if(v.length!==l){console.warn(`[createInstance] First service dependency of ${u.name} at position ${l+1} conflicts with ${v.length} static arguments`);let c=l-v.length;c>0?v=v.concat(new Array(c)):v=v.slice(0,l)}return new u(...[...v,...m])}_setServiceInstance(u,v){if(this._services.get(u)instanceof P.SyncDescriptor)this._services.set(u,v);else if(this._parent)this._parent._setServiceInstance(u,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let v=this._services.get(u);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):v}_getOrCreateServiceInstance(u,v){let _=this._getServiceInstanceOrDescriptor(u);return _ instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,_,v.branch(u,!0)):(v.branch(u,!1),_)}_safeCreateAndCacheServiceInstance(u,v,_){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,v,_)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,v,_){const w=new d.Graph(c=>c.id.toString());let m=0;const l=[{id:u,desc:v,_trace:_}];for(;l.length;){const c=l.pop();if(w.lookupOrInsertNode(c),m++>1e3)throw new n(w);for(let r of y._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(r.id);if(!t&&!r.optional&&console.warn(`[createInstance] ${u} depends on ${r.id} which is NOT registered.`),t instanceof P.SyncDescriptor){const i={id:r.id,desc:t,_trace:c._trace.branch(r.id,!0)};w.insertEdge(c,i),l.push(i)}}}for(;;){const c=w.roots();if(c.length===0){if(!w.isEmpty())throw new n(w);break}for(const{data:r}of c){if(this._getServiceInstanceOrDescriptor(r.id)instanceof P.SyncDescriptor){const i=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,i)}w.removeNode(r)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,v,_=[],w,m){if(this._services.get(u)instanceof P.SyncDescriptor)return this._createServiceInstance(v,_,w,m);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,v,_,w,m);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(u,v=[],_,w){if(_){const m=new L.IdleValue(()=>this._createInstance(u,v,w));return new Proxy(Object.create(null),{get(l,c){if(c in l)return l[c];let r=m.value,t=r[c];return typeof t!="function"||(t=t.bind(r),l[c]=t),t},set(l,c,r){return m.value[c]=r,!0}})}else return this._createInstance(u,v,w)}}e.InstantiationService=D;var b;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(b||(b={}));class I{constructor(u,v){this.type=u,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return h?new I(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):I._None}static traceCreation(u){return h?new I(0,u.name):I._None}branch(u,v){let _=new I(2,u.toString());return this._dep.push([u,v,_]),_}stop(){let u=Date.now()-this._start;I._totals+=u;let v=!1;function _(m,l){let c=[],r=new Array(m+1).join("	");for(const[t,i,o]of l._dep)if(i&&o){v=!0,c.push(`${r}CREATES -> ${t}`);let a=_(m+1,o);a&&c.push(a)}else c.push(`${r}uses -> ${t}`);return c.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${_(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${I._totals.toFixed(2)}ms)`];(u>2||v)&&console.log(w.join(`
`))}}I._None=new class extends I{constructor(){super(-1,null)}stop(){}branch(){return this}},I._totals=0}),define(fe[180],he([0,1,7]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=S.createDecorator("labelService")}),define(fe[48],he([0,1,7]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=S.createDecorator("localizationsService");function d(P){if(typeof P.languageId!="string"||!Array.isArray(P.translations)||P.translations.length===0)return!1;for(const y of P.translations)if(typeof y.id!="string"||typeof y.path!="string")return!1;return!(P.languageName&&typeof P.languageName!="string"||P.localizedLanguageName&&typeof P.localizedLanguageName!="string")}e.isValidLocalization=d});var Oe=this&&this.__decorate||function(Q,e,S,d){var P=arguments.length,y=P<3?e:d===null?d=Object.getOwnPropertyDescriptor(e,S):d,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate(Q,e,S,d);else for(var L=Q.length-1;L>=0;L--)(k=Q[L])&&(y=(P<3?k(y):P>3?k(e,S,y):k(e,S))||y);return P>3&&y&&Object.defineProperty(e,S,y),y},Ge=this&&this.__param||function(Q,e){return function(S,d){e(S,d,Q)}};define(fe[87],he([0,1,142,12,3,49,30,33,41,53,27,8,48]),function(Q,e,S,d,P,y,k,L,h,n,D,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLIService=e.getIdAndVersion=void 0;const E=l=>S.localize(0,null,l),u=S.localize(1,null,"ms-dotnettools.csharp");function v(l,c){return c?`${l.publisher}.${l.name}@${l.version}`:`${l.publisher}.${l.name}`}const _=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function w(l){const c=_.exec(l);return c&&c[1]?[L.adoptToGalleryExtensionId(c[1]),c[2]]:[L.adoptToGalleryExtensionId(l),void 0]}e.getIdAndVersion=w;let m=class{constructor(c,r,t){this.extensionManagementService=c,this.extensionGalleryService=r,this.localizationsService=t}get location(){}async listExtensions(c,r,t=console){let i=await this.extensionManagementService.getInstalled(1);const o=h.EXTENSION_CATEGORIES.map(s=>s.toLowerCase());if(r&&r!==""){if(o.indexOf(r.toLowerCase())<0){t.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}i=i.filter(s=>s.manifest.categories?s.manifest.categories.map(C=>C.toLowerCase()).indexOf(r.toLowerCase())>-1:!1)}else if(r===""){t.log("Possible Categories: "),o.forEach(s=>{t.log(s)});return}this.location&&t.log(S.localize(2,null,this.location)),i=i.sort((s,g)=>s.identifier.id.localeCompare(g.identifier.id));let a;for(let s of i)a!==s.identifier.id&&(a=s.identifier.id,t.log(v(s.manifest,c)))}async installExtensions(c,r,t,i,o=console){const a=[],s=[];c.length&&o.log(this.location?S.localize(3,null,this.location):S.localize(4,null));const g=await this.extensionManagementService.getInstalled(1),C=(f,T)=>{const O=g.find(H=>L.areSameExtensions(H.identifier,{id:f}));if(O){if(!T&&!i)return o.log(S.localize(5,null,f,O.manifest.version,f)),!1;if(T&&O.manifest.version===T)return o.log(S.localize(6,null,`${f}@${T}`)),!1}return!0},R=[],p=[];for(const f of c)if(f instanceof P.URI)R.push(f);else{const[T,O]=w(f);C(T,O)&&p.push({id:T,version:O,installOptions:{isBuiltin:!1,isMachineScoped:t}})}for(const f of r){const[T,O]=w(f);C(T,O)&&p.push({id:T,version:O,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(R.length&&await Promise.all(R.map(async f=>{try{const T=await this.installVSIX(f,i,o);T&&s.push(T)}catch(T){o.error(T.message||T.stack||T),a.push(f.toString())}})),p.length){const f=await this.getGalleryExtensions(p);await Promise.all(p.map(async T=>{const O=f.get(T.id.toLowerCase());if(O)try{const H=await this.installFromGallery(T,O,g,i,o);H&&s.push(H)}catch(H){o.error(H.message||H.stack||H),a.push(T.id)}else o.error(`${E(T.version?`${T.id}@${T.version}`:T.id)}
${u}`),a.push(T.id)}))}if(s.some(f=>h.isLanguagePackExtension(f))&&await this.updateLocalizationsCache(),a.length)throw new Error(S.localize(7,null,a.join(", ")))}async installVSIX(c,r,t){const i=await this.extensionManagementService.getManifest(c);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,r,t))try{return await this.extensionManagementService.install(c),t.log(S.localize(8,null,n.getBaseLabel(c))),i}catch(a){if(d.isPromiseCanceledError(a))return t.log(S.localize(9,null,n.getBaseLabel(c))),null;throw a}return null}async getGalleryExtensions(c){const r=c.filter(({version:o})=>o===void 0).map(({id:o})=>o),t=c.filter(({version:o})=>o!==void 0),i=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(r,D.CancellationToken.None)).forEach(a=>i.set(a.identifier.id.toLowerCase(),a))})(),Promise.all(t.map(async({id:o,version:a})=>{const s=await this.extensionGalleryService.getCompatibleExtension({id:o},a);s&&i.set(s.identifier.id.toLowerCase(),s)}))]),i}async installFromGallery({id:c,version:r,installOptions:t},i,o,a,s){const g=await this.extensionGalleryService.getManifest(i,D.CancellationToken.None);if(g&&!this.validateExtensionKind(g,s))return null;const C=o.find(R=>L.areSameExtensions(R.identifier,i.identifier));if(C){if(i.version===C.manifest.version)return s.log(S.localize(10,null,r?`${c}@${r}`:c)),null;s.log(S.localize(11,null,c,i.version))}try{return t.isBuiltin?s.log(S.localize(12,null,c,i.version)):s.log(S.localize(13,null,c,i.version)),await this.extensionManagementService.installFromGallery(i,t),s.log(S.localize(14,null,c,i.version)),g}catch(R){if(d.isPromiseCanceledError(R))return s.log(S.localize(15,null,c)),null;throw R}}validateExtensionKind(c,r){return!0}async validateVSIX(c,r,t){const i={id:L.getGalleryExtensionId(c.publisher,c.name)},a=(await this.extensionManagementService.getInstalled(1)).find(s=>L.areSameExtensions(i,s.identifier)&&y.gt(s.manifest.version,c.version));return a&&!r?(t.log(S.localize(16,null,a.identifier.id,a.manifest.version,c.version)),!1):this.validateExtensionKind(c,t)}async uninstallExtensions(c,r,t=console){const i=async a=>{if(a instanceof P.URI){const s=await this.extensionManagementService.getManifest(a);return v(s)}return a},o=[];for(const a of c){const s=await i(a),C=(await this.extensionManagementService.getInstalled()).filter(R=>L.areSameExtensions(R.identifier,{id:s}));if(!C.length)throw new Error(`${this.notInstalled(s)}
${u}`);if(C.some(R=>R.type===0)){t.log(S.localize(17,null,s));return}if(!r&&C.some(R=>R.isBuiltin)){t.log(S.localize(18,null,s));return}t.log(S.localize(19,null,s));for(const R of C)await this.extensionManagementService.uninstall(R),o.push(R);this.location?t.log(S.localize(20,null,s,this.location)):t.log(S.localize(21,null,s))}o.some(a=>h.isLanguagePackExtension(a.manifest))&&await this.updateLocalizationsCache()}async locateExtension(c,r=console){const t=await this.extensionManagementService.getInstalled();c.forEach(i=>{t.forEach(o=>{if(o.identifier.id===i&&o.location.scheme===b.Schemas.file){r.log(o.location.fsPath);return}})})}updateLocalizationsCache(){return this.localizationsService.update()}notInstalled(c){return this.location?S.localize(22,null,c,this.location):S.localize(23,null,c)}};m=Oe([Ge(0,k.IExtensionManagementService),Ge(1,k.IExtensionGalleryService),Ge(2,I.ILocalizationsService)],m),e.ExtensionManagementCLIService=m}),define(fe[17],he([0,1,7,4,5,6,40]),function(Q,e,S,d,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=S.createDecorator("logService"),e.ILoggerService=S.createDecorator("loggerService");function L(){return new Date().toISOString()}var h;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(h=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=h.Info;class n extends d.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=n;class D extends n{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...t){this.checkLogLevel(h.Trace)&&this.log(h.Trace,this.format([r,...t]))}debug(r,...t){this.checkLogLevel(h.Debug)&&this.log(h.Debug,this.format([r,...t]))}info(r,...t){this.checkLogLevel(h.Info)&&this.log(h.Info,this.format([r,...t]))}warn(r,...t){this.checkLogLevel(h.Warning)&&this.log(h.Warning,this.format([r,...t]))}error(r,...t){if(this.checkLogLevel(h.Error))if(r instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=r.stack,this.log(h.Error,this.format(i))}else this.log(h.Error,this.format([r,...t]))}critical(r,...t){this.checkLogLevel(h.Critical)&&this.log(h.Critical,this.format([r,...t]))}flush(){}format(r){let t="";for(let i=0;i<r.length;i++){let o=r[i];if(typeof o=="object")try{o=JSON.stringify(o)}catch(a){}t+=(i>0?" ":"")+o}return t}}e.AbstractMessageLogger=D;class b extends n{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!P.isWindows}trace(r,...t){this.getLevel()<=h.Trace&&(this.useColors?console.log(`[90m[main ${L()}][0m`,r,...t):console.log(`[main ${L()}]`,r,...t))}debug(r,...t){this.getLevel()<=h.Debug&&(this.useColors?console.log(`[90m[main ${L()}][0m`,r,...t):console.log(`[main ${L()}]`,r,...t))}info(r,...t){this.getLevel()<=h.Info&&(this.useColors?console.log(`[90m[main ${L()}][0m`,r,...t):console.log(`[main ${L()}]`,r,...t))}warn(r,...t){this.getLevel()<=h.Warning&&(this.useColors?console.warn(`[93m[main ${L()}][0m`,r,...t):console.warn(`[main ${L()}]`,r,...t))}error(r,...t){this.getLevel()<=h.Error&&(this.useColors?console.error(`[91m[main ${L()}][0m`,r,...t):console.error(`[main ${L()}]`,r,...t))}critical(r,...t){this.getLevel()<=h.Critical&&(this.useColors?console.error(`[90m[main ${L()}][0m`,r,...t):console.error(`[main ${L()}]`,r,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class I extends n{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...t){this.getLevel()<=h.Trace&&console.log("%cTRACE","color: #888",r,...t)}debug(r,...t){this.getLevel()<=h.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...t)}info(r,...t){this.getLevel()<=h.Info&&console.log("%c INFO","color: #33f",r,...t)}warn(r,...t){this.getLevel()<=h.Warning&&console.log("%c WARN","color: #993",r,...t)}error(r,...t){this.getLevel()<=h.Error&&console.log("%c  ERR","color: #f33",r,...t)}critical(r,...t){this.getLevel()<=h.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...t)}dispose(){}flush(){}}e.ConsoleLogger=I;class E extends n{constructor(r,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(t)}trace(r,...t){this.getLevel()<=h.Trace&&this.adapter.log(h.Trace,[this.extractMessage(r),...t])}debug(r,...t){this.getLevel()<=h.Debug&&this.adapter.log(h.Debug,[this.extractMessage(r),...t])}info(r,...t){this.getLevel()<=h.Info&&this.adapter.log(h.Info,[this.extractMessage(r),...t])}warn(r,...t){this.getLevel()<=h.Warning&&this.adapter.log(h.Warning,[this.extractMessage(r),...t])}error(r,...t){this.getLevel()<=h.Error&&this.adapter.log(h.Error,[this.extractMessage(r),...t])}critical(r,...t){this.getLevel()<=h.Critical&&this.adapter.log(h.Critical,[this.extractMessage(r),...t])}extractMessage(r){return typeof r=="string"?r:k.toErrorMessage(r,this.getLevel()<=h.Trace)}dispose(){}flush(){}}e.AdapterLogger=E;class u extends n{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const t of this.logServices)t.setLevel(r);super.setLevel(r)}trace(r,...t){for(const i of this.logServices)i.trace(r,...t)}debug(r,...t){for(const i of this.logServices)i.debug(r,...t)}info(r,...t){for(const i of this.logServices)i.info(r,...t)}warn(r,...t){for(const i of this.logServices)i.warn(r,...t)}error(r,...t){for(const i of this.logServices)i.error(r,...t)}critical(r,...t){for(const i of this.logServices)i.critical(r,...t)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=u;class v extends d.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...t){this.logger.trace(r,...t)}debug(r,...t){this.logger.debug(r,...t)}info(r,...t){this.logger.info(r,...t)}warn(r,...t){this.logger.warn(r,...t)}error(r,...t){this.logger.error(r,...t)}critical(r,...t){this.logger.critical(r,...t)}flush(){this.logger.flush()}}e.LogService=v;class _{constructor(){this.onDidChangeLogLevel=new y.Emitter().event}setLevel(r){}getLevel(){return h.Info}trace(r,...t){}debug(r,...t){}info(r,...t){}warn(r,...t){}error(r,...t){}critical(r,...t){}dispose(){}flush(){}}e.NullLogService=_;function w(c){if(c.verbose)return h.Trace;if(typeof c.logLevel=="string"){const r=m(c.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=w;function m(c){switch(c){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Critical;case"off":return h.Off}}e.parseLogLevel=m;function l(c){switch(c){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Critical:return"critical";case h.Off:return"off"}}e.LogLevelToString=l}),define(fe[181],he([0,1,15,4,24,30,29,3,21,33,17,23,49,5,13]),function(Q,e,S,d,P,y,k,L,h,n,D,b,I,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let _=class extends d.Disposable{constructor(m,l,c,r){super();this.fileService=l,this.extensionGalleryService=c,this.logService=r,this.extensionsDownloadDir=L.URI.file(m.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(m,l){await this.cleanUpPromise;const c=this.getName(m),r=h.joinPath(this.extensionsDownloadDir,c);if(!await this.fileService.exists(r)){const t=h.joinPath(this.extensionsDownloadDir,`.${c}`);await this.fileService.exists(t)||await this.extensionGalleryService.download(m,t,l),await this.rename(t,r,Date.now()+2*60*1e3)}return r}async delete(m){}async rename(m,l,c){try{await S.promises.rename(m.fsPath,l.fsPath)}catch(r){if(E.isWindows&&r&&r.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${m} to ${l} with 'EPERM' error. Trying again...`),this.rename(m,l,c);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const m=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(m.children){const l=[],c=[];for(const i of m.children){const o=this.parse(i.name);o&&c.push([o,i])}const r=n.groupByExtension(c,([i])=>i),t=[];for(const i of r)i.sort((o,a)=>I.rcompare(o[0].version,a[0].version)),l.push(...i.slice(1).map(o=>o[1].resource)),t.push(i[0][1]);t.sort((i,o)=>i.mtime-o.mtime),l.push(...t.slice(0,Math.max(0,t.length-this.cache)).map(i=>i.resource)),await u.Promises.settled(l.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(m){this.logService.error(m)}}getName(m){return this.cache?new n.ExtensionIdentifierWithVersion(m.identifier,m.version).key().toLowerCase():b.generateUuid()}parse(m){const l=v.exec(m);return l&&l[1]&&l[2]?new n.ExtensionIdentifierWithVersion({id:l[1]},l[2]):null}};_=Oe([Ge(0,k.INativeEnvironmentService),Ge(1,P.IFileService),Ge(2,y.IExtensionGalleryService),Ge(3,D.ILogService)],_),e.ExtensionsDownloader=_}),define(fe[182],he([0,1,4,17,32,40,2,13,6,8,20,29]),function(Q,e,S,d,P,y,k,L,h,n,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let I=class extends S.Disposable{constructor(u,v){super();this.environmentService=u,this.logService=v,this.processesLimiter=new L.Limiter(5)}async postUninstall(u){const v=this.parseScript(u,"uninstall");return v&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(v.script,"uninstall",v.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),_=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${_}`)))),D.rimraf(this.getExtensionStoragePath(u)).then(void 0,_=>this.logService.error("Error while removing extension storage path",_))}parseScript(u,v){const _=`vscode:${v}`;if(u.location.scheme===n.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[_]=="string"){const w=u.manifest.scripts[_].split(" ");return w.length<2||w[0]!=="node"||!w[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${_} should be a node script`),null):{script:k.join(u.location.fsPath,w[1]),args:w.slice(2)||[]}}return null}runLifecycleHook(u,v,_,w,m){return new Promise((l,c)=>{const r=this.start(u,v,_,m);let t;const i=o=>{t&&(clearTimeout(t),t=null),o?c(o):l(void 0)};r.on("error",o=>{i(y.toErrorMessage(o)||"Unknown")}),r.on("exit",(o,a)=>{i(o?`post-${v} process exited with code ${o}`:void 0)}),w&&(t=setTimeout(()=>{t=null,r.kill(),c("timed out")},5e3))})}start(u,v,_,w){const m={silent:!0,execArgv:void 0},l=P.fork(u,[`--type=extension-post-${v}`,..._],m);l.stdout.setEncoding("utf8"),l.stderr.setEncoding("utf8");const c=h.Event.fromNodeEventEmitter(l.stdout,"data"),r=h.Event.fromNodeEventEmitter(l.stderr,"data");c(o=>this.logService.info(w.identifier.id,w.manifest.version,`post-${v}`,o)),r(o=>this.logService.error(w.identifier.id,w.manifest.version,`post-${v}`,o));const t=h.Event.any(h.Event.map(c,o=>({data:`%c${o}`,format:[""]})),h.Event.map(r,o=>({data:`%c${o}`,format:["color: red"]})));return h.Event.debounce(t,(o,a)=>o?{data:o.data+a.data,format:[...o.format,...a.format]}:{data:a.data,format:a.format},100)(o=>{console.group(w.identifier.id),console.log(o.data,...o.format),console.groupEnd()}),l}getExtensionStoragePath(u){return k.join(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};I=Oe([Ge(0,b.IEnvironmentService),Ge(1,d.ILogService)],I),e.ExtensionsLifecycle=I}),define(fe[88],he([0,1,147,46,4,24,6,21,25,16,17,18,39,13,27,8,84,52]),function(Q,e,S,d,P,y,k,L,h,n,D,b,I,E,u,v,_,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let m=class extends P.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueues=new Map}registerProvider(c,r){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);d.mark(`code/registerFilesystem/${c}`),this.provider.set(c,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:r});const t=new P.DisposableStore;return t.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new y.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),t.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:c}))),typeof r.onDidErrorOccur=="function"&&t.add(r.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),P.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:r}),this.provider.delete(c),P.dispose(t)})}async activateProvider(c){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(t){t&&r.push(t)}}),!this.provider.has(c)&&await E.Promises.settled(r)}canHandleResource(c){return this.provider.has(c.scheme)}hasCapability(c,r){const t=this.provider.get(c.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return w.Iterable.map(this.provider,([c,r])=>({scheme:c,capabilities:r.capabilities}))}async withProvider(c){if(!L.isAbsolutePath(c))throw new y.FileOperationError(S.localize(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const r=this.provider.get(c.scheme);if(!r){const t=new Error;throw t.name="ENOPRO",t.message=S.localize(1,null,c.toString()),t}return r}async withReadProvider(c){const r=await this.withProvider(c);if(y.hasOpenReadWriteCloseCapability(r)||y.hasReadWriteCapability(r)||y.hasFileReadStreamCapability(r))return r;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const r=await this.withProvider(c);if(y.hasOpenReadWriteCloseCapability(r)||y.hasReadWriteCapability(r))return r;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,r){try{return await this.doResolveFile(c,r)}catch(t){throw y.toFileSystemProviderErrorCode(t)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError(S.localize(2,null,this.resourceForError(c)),1):y.ensureFileSystemProviderError(t)}}async doResolveFile(c,r){const t=await this.withProvider(c),i=this.isPathCaseSensitive(t),o=r==null?void 0:r.resolveTo,a=r==null?void 0:r.resolveSingleChildDescendants,s=r==null?void 0:r.resolveMetadata,g=await t.stat(c);let C;return this.toFileStat(t,c,g,void 0,!!s,(R,p)=>(C||(C=h.TernarySearchTree.forUris(()=>!i),C.set(c,!0),n.isNonEmptyArray(o)&&o.forEach(f=>C.set(f,!0))),Boolean(C.findSuperstr(R.resource)||C.get(R.resource))?!0:R.isDirectory&&a?p===1:!1))}async toFileStat(c,r,t,i,o,a){const{providerExtUri:s}=this.getExtUri(c),g={resource:r,name:s.basename(r),isFile:(t.type&y.FileType.File)!=0,isDirectory:(t.type&y.FileType.Directory)!=0,isSymbolicLink:(t.type&y.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:y.etag({mtime:t.mtime,size:t.size})};if(g.isDirectory&&a(g,i)){try{const C=await c.readdir(r),R=await E.Promises.settled(C.map(async([p,f])=>{try{const T=s.joinPath(r,p),O=o?await c.stat(T):{type:f};return await this.toFileStat(c,T,O,C.length,o,a)}catch(T){return this.logService.trace(T),null}}));g.children=n.coalesce(R)}catch(C){this.logService.trace(C),g.children=[]}return g}return g}async resolveAll(c){return E.Promises.settled(c.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(c){const r=await this.withProvider(c);try{return!!await r.stat(c)}catch(t){return!1}}async canCreateFile(c,r){try{await this.doValidateCreateFile(c,r)}catch(t){return t}return!0}async doValidateCreateFile(c,r){if(!(r==null?void 0:r.overwrite)&&await this.exists(c))throw new y.FileOperationError(S.localize(3,null,this.resourceForError(c)),3,r)}async createFile(c,r=b.VSBuffer.fromString(""),t){await this.doValidateCreateFile(c,t);const i=await this.writeFile(c,r);return this._onDidRunOperation.fire(new y.FileOperationEvent(c,0,i)),i}async writeFile(c,r,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:o}=this.getExtUri(i);try{await this.validateWriteFile(i,c,t)||await this.mkdirp(i,o.dirname(c));let s;if(y.hasReadWriteCapability(i)&&!(r instanceof b.VSBuffer))if(I.isReadableStream(r)){const g=await I.peekStream(r,3);g.ended?s=b.VSBuffer.concat(g.buffer):s=g}else s=I.peekReadable(r,g=>b.VSBuffer.concat(g),3);else s=r;!y.hasOpenReadWriteCloseCapability(i)||y.hasReadWriteCapability(i)&&s instanceof b.VSBuffer?await this.doWriteUnbuffered(i,c,s):await this.doWriteBuffered(i,c,s instanceof b.VSBuffer?b.bufferToReadable(s):s)}catch(a){throw new y.FileOperationError(S.localize(4,null,this.resourceForError(c),y.ensureFileSystemProviderError(a).toString()),y.toFileOperationResult(a),t)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,r,t){let i;try{i=await c.stat(r)}catch(o){return}if((i.type&y.FileType.Directory)!=0)throw new y.FileOperationError(S.localize(5,null,this.resourceForError(r)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==y.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&t.mtime<i.mtime&&t.etag!==y.etag({mtime:t.mtime,size:i.size}))throw new y.FileOperationError(S.localize(6,null),3,t);return i}async readFile(c,r){const t=await this.withReadProvider(c),i=await this.doReadAsFileStream(t,c,Object.assign(Object.assign({},r),{preferUnbuffered:!0}));return Object.assign(Object.assign({},i),{value:await b.streamToBuffer(i.value)})}async readFileStream(c,r){const t=await this.withReadProvider(c);return this.doReadAsFileStream(t,c,r)}async doReadAsFileStream(c,r,t){const i=new u.CancellationTokenSource,o=this.validateReadFile(r,t).then(s=>s,s=>{throw i.cancel(),s});let a;try{t&&typeof t.etag=="string"&&t.etag!==y.ETAG_DISABLED&&await o,!(y.hasOpenReadWriteCloseCapability(c)||y.hasFileReadStreamCapability(c))||y.hasReadWriteCapability(c)&&(t==null?void 0:t.preferUnbuffered)?a=this.readFileUnbuffered(c,r,t):y.hasFileReadStreamCapability(c)?a=this.readFileStreamed(c,r,i.token,t):a=this.readFileBuffered(c,r,i.token,t);const s=await o;return Object.assign(Object.assign({},s),{value:a})}catch(s){throw a&&await I.consumeStream(a),new y.FileOperationError(S.localize(7,null,this.resourceForError(r),y.ensureFileSystemProviderError(s).toString()),y.toFileOperationResult(s),t)}}readFileStreamed(c,r,t,i=Object.create(null)){const o=c.readFileStream(r,i,t);return I.transform(o,{data:a=>a instanceof b.VSBuffer?a:b.VSBuffer.wrap(a),error:a=>new y.FileOperationError(S.localize(8,null,this.resourceForError(r),y.ensureFileSystemProviderError(a).toString()),y.toFileOperationResult(a),i)},a=>b.VSBuffer.concat(a))}readFileBuffered(c,r,t,i=Object.create(null)){const o=b.newWriteableBufferStream();return _.readFileIntoStream(c,r,o,a=>a,Object.assign(Object.assign({},i),{bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new y.FileOperationError(S.localize(9,null,this.resourceForError(r),y.ensureFileSystemProviderError(a).toString()),y.toFileOperationResult(a),i)}),t),o}readFileUnbuffered(c,r,t){const i=I.newWriteableStream(o=>b.VSBuffer.concat(o));return(async()=>{try{let o=await c.readFile(r);t&&typeof t.position=="number"&&(o=o.slice(t.position)),t&&typeof t.length=="number"&&(o=o.slice(0,t.length)),this.validateReadFileLimits(r,o.byteLength,t),i.end(b.VSBuffer.wrap(o))}catch(o){i.error(o)}})(),i}async validateReadFile(c,r){const t=await this.resolve(c,{resolveMetadata:!0});if(t.isDirectory)throw new y.FileOperationError(S.localize(10,null,this.resourceForError(c)),0,r);if(r&&typeof r.etag=="string"&&r.etag!==y.ETAG_DISABLED&&r.etag===t.etag)throw new y.FileOperationError(S.localize(11,null),2,r);return this.validateReadFileLimits(c,t.size,r),t}validateReadFileLimits(c,r,t){if(t==null?void 0:t.limits){let i;if(typeof t.limits.memory=="number"&&r>t.limits.memory&&(i=9),typeof t.limits.size=="number"&&r>t.limits.size&&(i=7),typeof i=="number")throw new y.FileOperationError(S.localize(12,null,this.resourceForError(c)),i)}}async canMove(c,r,t){return this.doCanMoveCopy(c,r,"move",t)}async canCopy(c,r,t){return this.doCanMoveCopy(c,r,"copy",t)}async doCanMoveCopy(c,r,t,i){if(c.toString()!==r.toString())try{const o=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(o,c,a,r,t,i)}catch(o){return o}return!0}async move(c,r,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),a=await this.doMoveCopy(i,c,o,r,"move",!!t),s=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(c,a==="move"?2:3,s)),s}async copy(c,r,t){const i=await this.withReadProvider(c),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),a=await this.doMoveCopy(i,c,o,r,"copy",!!t),s=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(c,a==="copy"?3:2,s)),s}async doMoveCopy(c,r,t,i,o,a){if(r.toString()===i.toString())return o;const{exists:s,isSameResourceWithDifferentPathCase:g}=await this.doValidateMoveCopy(c,r,t,i,o,a);if(s&&!g&&a&&await this.del(i,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(i)),o==="copy"){if(c===t&&y.hasFileFolderCopyCapability(c))await c.copy(r,i,{overwrite:a});else{const C=await this.resolve(r);C.isDirectory?await this.doCopyFolder(c,C,t,i):await this.doCopyFile(c,r,t,i)}return o}else return c===t?(await c.rename(r,i,{overwrite:a}),o):(await this.doMoveCopy(c,r,t,i,"copy",a),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(c,r,t,i){if(y.hasOpenReadWriteCloseCapability(c)&&y.hasOpenReadWriteCloseCapability(t))return this.doPipeBuffered(c,r,t,i);if(y.hasOpenReadWriteCloseCapability(c)&&y.hasReadWriteCapability(t))return this.doPipeBufferedToUnbuffered(c,r,t,i);if(y.hasReadWriteCapability(c)&&y.hasOpenReadWriteCloseCapability(t))return this.doPipeUnbufferedToBuffered(c,r,t,i);if(y.hasReadWriteCapability(c)&&y.hasReadWriteCapability(t))return this.doPipeUnbuffered(c,r,t,i)}async doCopyFolder(c,r,t,i){await t.mkdir(i),Array.isArray(r.children)&&await E.Promises.settled(r.children.map(async o=>{const a=this.getExtUri(t).providerExtUri.joinPath(i,o.name);return o.isDirectory?this.doCopyFolder(c,await this.resolve(o.resource),t,a):this.doCopyFile(c,o.resource,t,a)}))}async doValidateMoveCopy(c,r,t,i,o,a){let s=!1;if(c===t){const{providerExtUri:C,isPathCaseSensitive:R}=this.getExtUri(c);if(R||(s=C.isEqual(r,i)),s&&o==="copy")throw new Error(S.localize(13,null,this.resourceForError(r),this.resourceForError(i)));if(!s&&C.isEqualOrParent(i,r))throw new Error(S.localize(14,null,this.resourceForError(r),this.resourceForError(i)))}const g=await this.exists(i);if(g&&!s){if(!a)throw new y.FileOperationError(S.localize(15,null,this.resourceForError(r),this.resourceForError(i)),4);if(c===t){const{providerExtUri:C}=this.getExtUri(c);if(C.isEqualOrParent(r,i))throw new Error(S.localize(16,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:g,isSameResourceWithDifferentPathCase:s}}getExtUri(c){const r=this.isPathCaseSensitive(c);return{providerExtUri:r?L.extUri:L.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(r,c);const t=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(c,0,t)),t}async mkdirp(c,r){const t=[],{providerExtUri:i}=this.getExtUri(c);for(;!i.isEqual(r,i.dirname(r));)try{if(((await c.stat(r)).type&y.FileType.Directory)==0)throw new Error(S.localize(17,null,this.resourceForError(r)));break}catch(o){if(y.toFileSystemProviderErrorCode(o)!==y.FileSystemProviderErrorCode.FileNotFound)throw o;t.push(i.basename(r)),r=i.dirname(r)}for(let o=t.length-1;o>=0;o--){r=i.joinPath(r,t[o]);try{await c.mkdir(r)}catch(a){if(y.toFileSystemProviderErrorCode(a)!==y.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(c,r){try{await this.doValidateDelete(c,r)}catch(t){return t}return!0}async doValidateDelete(c,r){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!(r==null?void 0:r.useTrash)&&!(t.capabilities&4096))throw new Error(S.localize(18,null,this.resourceForError(c)));const o=await this.exists(c);if(!o)throw new y.FileOperationError(S.localize(19,null,this.resourceForError(c)),1);if(!!!(r==null?void 0:r.recursive)&&o){const s=await this.resolve(c);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error(S.localize(20,null,this.resourceForError(c)))}return t}async del(c,r){const t=await this.doValidateDelete(c,r),i=!!(r==null?void 0:r.useTrash),o=!!(r==null?void 0:r.recursive);await t.delete(c,{recursive:o,useTrash:i}),this._onDidRunOperation.fire(new y.FileOperationEvent(c,1))}watch(c,r={recursive:!1,excludes:[]}){let t=!1,i=()=>{t=!0};return this.doWatch(c,r).then(o=>{t?P.dispose(o):i=()=>P.dispose(o)},o=>this.logService.error(o)),P.toDisposable(()=>i())}async doWatch(c,r){const t=await this.withProvider(c),i=this.toWatchKey(t,c,r),o=this.activeWatchers.get(i)||{count:0,disposable:t.watch(c,r)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,o),o.count+=1,P.toDisposable(()=>{o.count--,o.count===0&&(P.dispose(o.disposable),this.activeWatchers.delete(i))})}toWatchKey(c,r,t){const{providerExtUri:i}=this.getExtUri(c);return[i.getComparisonKey(r),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(c=>P.dispose(c.disposable)),this.activeWatchers.clear()}ensureWriteQueue(c,r){const{providerExtUri:t}=this.getExtUri(c),i=t.getComparisonKey(r);let o=this.writeQueues.get(i);return o||(o=new E.Queue,this.writeQueues.set(i,o),k.Event.once(o.onFinished)(()=>{this.writeQueues.delete(i),P.dispose(o)})),o}async doWriteBuffered(c,r,t){return this.ensureWriteQueue(c,r).queue(async()=>{const i=await c.open(r,{create:!0});try{I.isReadableStream(t)||I.isReadableBufferedStream(t)?await this.doWriteStreamBufferedQueued(c,i,t):await this.doWriteReadableBufferedQueued(c,i,t)}catch(o){throw y.ensureFileSystemProviderError(o)}finally{await c.close(i)}})}async doWriteStreamBufferedQueued(c,r,t){let i=0,o;if(I.isReadableBufferedStream(t)){if(t.buffer.length>0){const a=b.VSBuffer.concat(t.buffer);await this.doWriteBuffer(c,r,a,a.byteLength,i,0),i+=a.byteLength}if(t.ended)return;o=t.stream}else o=t;return new Promise(async(a,s)=>{I.listenStream(o,{onData:async g=>{o.pause();try{await this.doWriteBuffer(c,r,g,g.byteLength,i,0)}catch(C){return s(C)}i+=g.byteLength,setTimeout(()=>o.resume())},onError:g=>s(g),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(c,r,t){let i=0,o;for(;(o=t.read())!==null;)await this.doWriteBuffer(c,r,o,o.byteLength,i,0),i+=o.byteLength}async doWriteBuffer(c,r,t,i,o,a){let s=0;for(;s<i;)s+=await c.write(r,o+s,t.buffer,a+s,i-s)}async doWriteUnbuffered(c,r,t){return this.ensureWriteQueue(c,r).queue(()=>this.doWriteUnbufferedQueued(c,r,t))}async doWriteUnbufferedQueued(c,r,t){let i;t instanceof b.VSBuffer?i=t:I.isReadableStream(t)?i=await b.streamToBuffer(t):I.isReadableBufferedStream(t)?i=await b.bufferedStreamToBuffer(t):i=b.readableToBuffer(t),await c.writeFile(r,i.buffer,{create:!0,overwrite:!0})}async doPipeBuffered(c,r,t,i){return this.ensureWriteQueue(t,i).queue(()=>this.doPipeBufferedQueued(c,r,t,i))}async doPipeBufferedQueued(c,r,t,i){let o,a;try{o=await c.open(r,{create:!1}),a=await t.open(i,{create:!0});const s=b.VSBuffer.alloc(this.BUFFER_SIZE);let g=0,C=0,R=0;do R=await c.read(o,g,s.buffer,C,s.byteLength-C),await this.doWriteBuffer(t,a,s,R,g,C),g+=R,C+=R,C===s.byteLength&&(C=0);while(R>0)}catch(s){throw y.ensureFileSystemProviderError(s)}finally{await E.Promises.settled([typeof o=="number"?c.close(o):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async doPipeUnbuffered(c,r,t,i){return this.ensureWriteQueue(t,i).queue(()=>this.doPipeUnbufferedQueued(c,r,t,i))}async doPipeUnbufferedQueued(c,r,t,i){return t.writeFile(i,await c.readFile(r),{create:!0,overwrite:!0})}async doPipeUnbufferedToBuffered(c,r,t,i){return this.ensureWriteQueue(t,i).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,r,t,i))}async doPipeUnbufferedToBufferedQueued(c,r,t,i){const o=await t.open(i,{create:!0});try{const a=await c.readFile(r);await this.doWriteBuffer(t,o,b.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw y.ensureFileSystemProviderError(a)}finally{await t.close(o)}}async doPipeBufferedToUnbuffered(c,r,t,i){const o=await b.streamToBuffer(this.readFileBuffered(c,r,u.CancellationToken.None));await this.doWriteUnbuffered(t,i,o)}throwIfFileSystemIsReadonly(c,r){if(c.capabilities&2048)throw new y.FileOperationError(S.localize(21,null,this.resourceForError(r)),6);return c}resourceForError(c){return c.scheme===v.Schemas.file?c.fsPath:c.toString(!0)}};m=Oe([Ge(0,D.ILogService)],m),e.FileService=m}),define(fe[60],he([0,1,15,183,4,24,6,5,20,2,21,28,13,17,150,85,168,170,167,179,39,84,16,18]),function(Q,e,S,d,P,y,k,L,h,n,D,b,I,E,u,v,_,w,m,l,c,r,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class o extends P.Disposable{constructor(s,g){var C;super();this.logService=s,this.options=g,this.BUFFER_SIZE=((C=this.options)===null||C===void 0?void 0:C.bufferSize)||64*1024,this.onDidChangeCapabilities=k.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Set,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new k.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new I.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8,L.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:g,symbolicLink:C}=await h.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(g,C),ctime:g.birthtime.getTime(),mtime:g.mtime.getTime(),size:g.size}}catch(g){throw this.toFileSystemProviderError(g)}}async readdir(s){try{const g=await h.readdir(this.toFilePath(s),{withFileTypes:!0}),C=[];return await Promise.all(g.map(async R=>{try{let p;R.isSymbolicLink()?p=(await this.stat(D.joinPath(s,R.name))).type:p=this.toType(R),C.push([R.name,p])}catch(p){this.logService.trace(p)}})),C}catch(g){throw this.toFileSystemProviderError(g)}}toType(s,g){let C;return(g==null?void 0:g.dangling)?C=y.FileType.Unknown:s.isFile()?C=y.FileType.File:s.isDirectory()?C=y.FileType.Directory:C=y.FileType.Unknown,g&&(C|=y.FileType.SymbolicLink),C}async readFile(s){try{const g=this.toFilePath(s);return await S.promises.readFile(g)}catch(g){throw this.toFileSystemProviderError(g)}}readFileStream(s,g,C){const R=c.newWriteableStream(p=>i.VSBuffer.concat(p.map(f=>i.VSBuffer.wrap(f))).buffer);return r.readFileIntoStream(this,s,R,p=>p.buffer,Object.assign(Object.assign({},g),{bufferSize:this.BUFFER_SIZE}),C),R}async writeFile(s,g,C){let R;try{const p=this.toFilePath(s);if(!C.create||!C.overwrite){if(await h.exists(p)){if(!C.overwrite)throw y.createFileSystemProviderError(u.localize(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!C.create)throw y.createFileSystemProviderError(u.localize(1,null),y.FileSystemProviderErrorCode.FileNotFound)}R=await this.open(s,{create:!0}),await this.write(R,0,g,0,g.byteLength)}catch(p){throw this.toFileSystemProviderError(p)}finally{typeof R=="number"&&await this.close(R)}}async open(s,g){try{const C=this.toFilePath(s);let R;if(g.create){if(L.isWindows)try{await S.promises.truncate(C,0),R="r+"}catch(f){f.code!=="ENOENT"&&this.logService.trace(f)}R||(R="w")}else R="r";const p=await d.promisify(S.open)(C,R);return this.mapHandleToPos.set(p,0),g.create&&this.writeHandles.add(p),p}catch(C){throw this.toFileSystemProviderError(C)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await d.promisify(S.fdatasync)(s)}catch(g){this.canFlush=!1,this.logService.error(g)}return await d.promisify(S.close)(s)}catch(g){throw this.toFileSystemProviderError(g)}}async read(s,g,C,R,p){const f=this.normalizePos(s,g);let T=null;try{const O=await d.promisify(S.read)(s,C,R,p,f);return typeof O=="number"?T=O:T=O.bytesRead,T}catch(O){throw this.toFileSystemProviderError(O)}finally{this.updatePos(s,f,T)}}normalizePos(s,g){return g===this.mapHandleToPos.get(s)?null:g}updatePos(s,g,C){const R=this.mapHandleToPos.get(s);typeof R=="number"&&(typeof g=="number"||(typeof C=="number"?this.mapHandleToPos.set(s,R+C):this.mapHandleToPos.delete(s)))}async write(s,g,C,R,p){return I.retry(()=>this.doWrite(s,g,C,R,p),100,3)}async doWrite(s,g,C,R,p){const f=this.normalizePos(s,g);let T=null;try{const O=await d.promisify(S.write)(s,C,R,p,f);return typeof O=="number"?T=O:T=O.bytesWritten,T}catch(O){throw this.toFileSystemProviderError(O)}finally{this.updatePos(s,f,T)}}async mkdir(s){try{await S.promises.mkdir(this.toFilePath(s))}catch(g){throw this.toFileSystemProviderError(g)}}async delete(s,g){try{const C=this.toFilePath(s);await this.doDelete(C,g)}catch(C){throw this.toFileSystemProviderError(C)}}async doDelete(s,g){g.recursive?await h.rimraf(s,h.RimRafMode.MOVE):await S.promises.unlink(s)}async rename(s,g,C){const R=this.toFilePath(s),p=this.toFilePath(g);if(R!==p)try{await this.validateTargetDeleted(s,g,"move",C.overwrite),await h.move(R,p)}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error(u.localize(2,null,n.basename(R),n.basename(n.dirname(p)),f.toString()))),this.toFileSystemProviderError(f)}}async copy(s,g,C){const R=this.toFilePath(s),p=this.toFilePath(g);if(R!==p)try{await this.validateTargetDeleted(s,g,"copy",C.overwrite),await h.copy(R,p,{preserveSymlinks:!0})}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error(u.localize(3,null,n.basename(R),n.basename(n.dirname(p)),f.toString()))),this.toFileSystemProviderError(f)}}async validateTargetDeleted(s,g,C,R){const p=this.toFilePath(s),f=this.toFilePath(g);let T=!1;if(!!(this.capabilities&1024)||(T=b.isEqual(p,f,!0)),T&&C==="copy")throw y.createFileSystemProviderError(u.localize(4,null),y.FileSystemProviderErrorCode.FileExists);if(!T&&await h.exists(f)){if(!R)throw y.createFileSystemProviderError(u.localize(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(g,{recursive:!0,useTrash:!1})}}watch(s,g){return g.recursive?this.watchRecursive(s,g.excludes):this.watchNonRecursive(s)}watchRecursive(s,g){const C={path:this.toFilePath(s),excludes:g},R=t.insert(this.recursiveFoldersToWatch,C);return this.refreshRecursiveWatchers(),P.toDisposable(()=>{R(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var s,g,C;if(this.recursiveWatcher instanceof m.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(P.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let R,p;((g=(s=this.options)===null||s===void 0?void 0:s.watcher)===null||g===void 0?void 0:g.usePolling)?(R=_.FileWatcher,p=(C=this.options)===null||C===void 0?void 0:C.watcher):this.recursiveFoldersToWatch.length===1?L.isWindows?R=w.FileWatcher:R=_.FileWatcher:R=m.FileWatcher,this.recursiveWatcher=new R(this.recursiveFoldersToWatch,f=>this._onDidChangeFile.fire(v.toFileChanges(f)),f=>{f.type==="error"&&this._onDidWatchErrorOccur.fire(f.message),this.logService[f.type](f.message)},this.logService.getLevel()===E.LogLevel.Trace,p),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)}))}}watchNonRecursive(s){const g=new l.FileWatcher(this.toFilePath(s),R=>this._onDidChangeFile.fire(v.toFileChanges(R)),R=>{R.type==="error"&&this._onDidWatchErrorOccur.fire(R.message),this.logService[R.type](R.message)},this.logService.getLevel()===E.LogLevel.Trace),C=this.logService.onDidChangeLogLevel(()=>{g.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)});return P.combinedDisposable(g,C)}toFilePath(s){return n.normalize(s.fsPath)}toFileSystemProviderError(s){if(s instanceof y.FileSystemProviderError)return s;let g;switch(s.code){case"ENOENT":g=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":g=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":g=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":g=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":g=y.FileSystemProviderErrorCode.NoPermissions;break;default:g=y.FileSystemProviderErrorCode.Unknown}return y.createFileSystemProviderError(s,g)}dispose(){super.dispose(),P.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,P.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=o}),define(fe[89],he([0,1,20,15,61,30,4,29,13,33,17,48,16,6,8,2]),function(Q,e,S,d,P,y,k,L,h,n,D,b,I,E,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let _=class extends k.Disposable{constructor(l,c,r){super();this.extensionManagementService=l,this.logService=r,this._onDidLanguagesChange=this._register(new E.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new w(c,r)),this._register(l.onDidInstallExtension(({local:t})=>this.onDidInstallExtension(t))),this._register(l.onDidUninstallExtension(({identifier:t})=>this.onDidUninstallExtension(t)))}getLanguageIds(){return this.cache.getLanguagePacks().then(l=>{const c=["en",...Object.keys(l)];return I.distinct(c)})}onDidInstallExtension(l){l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",l.identifier.id),this.update().then(c=>{c&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(l){this.cache.getLanguagePacks().then(c=>{Object.keys(c).some(r=>c[r]&&c[r].extensions.some(t=>n.areSameExtensions(t.extensionIdentifier,l)))&&(this.logService.debug("Removing language packs from the extension",l.id),this.update().then(r=>{r&&this._onDidLanguagesChange.fire()}))})}async update(){const[l,c]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),r=await this.cache.update(c);return!I.equals(Object.keys(l),Object.keys(r))}};_=Oe([Ge(0,y.IExtensionManagementService),Ge(1,L.INativeEnvironmentService),Ge(2,D.ILogService)],_),e.LocalizationsService=_;let w=class extends k.Disposable{constructor(l,c){super();this.logService=c,this.languagePacks={},this.languagePacksFilePath=v.join(l.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new h.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(l){return this.withLanguagePacks(c=>{Object.keys(c).forEach(r=>delete c[r]),this.createLanguagePacksFromExtensions(c,...l)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(l,...c){for(const r of c)r&&r.manifest&&r.manifest.contributes&&r.manifest.contributes.localizations&&r.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(l,r);Object.keys(l).forEach(r=>this.updateHash(l[r]))}createLanguagePacksFromExtension(l,c){const r=c.identifier,t=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const i of t)if(c.location.scheme===u.Schemas.file&&b.isValidLocalization(i)){let o=l[i.languageId];o||(o={hash:"",extensions:[],translations:{}},l[i.languageId]=o);let a=o.extensions.filter(s=>n.areSameExtensions(s.extensionIdentifier,r))[0];a?a.version=c.manifest.version:o.extensions.push({extensionIdentifier:r,version:c.manifest.version});for(const s of i.translations)o.translations[s.id]=v.join(c.location.fsPath,s.path)}}updateHash(l){if(l){const c=P.createHash("md5");for(const r of l.extensions)c.update(r.extensionIdentifier.uuid||r.extensionIdentifier.id).update(r.version);l.hash=c.digest("hex")}}withLanguagePacks(l=()=>null){return this.languagePacksFileLimiter.queue(()=>{let c=null;return d.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,r=>r.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(r)).then(r=>{try{return JSON.parse(r)}catch(t){return{}}}).then(r=>(c=l(r),r)).then(r=>{for(const i of Object.keys(r))r[i]||delete r[i];this.languagePacks=r,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),S.writeFile(this.languagePacksFilePath,t)}).then(()=>c,r=>this.logService.error(r))})}};w=Oe([Ge(0,L.INativeEnvironmentService),Ge(1,D.ILogService)],w)}),define(fe[184],he([0,1,17,6,3]),function(Q,e,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class y{constructor(I){this.service=I,this.onDidChangeLogLevel=d.Event.buffer(I.onDidChangeLogLevel,!0)}listen(I,E){switch(E){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${E}`)}async call(I,E,u){switch(E){case"setLevel":return this.service.setLevel(u)}throw new Error(`Call not found: ${E}`)}}e.LogLevelChannel=y;class k{constructor(I){this.channel=I}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(I){k.setLevel(this.channel,I)}static setLevel(I,E){return I.call("setLevel",E)}}e.LogLevelChannelClient=k;class L{constructor(I){this.loggerService=I,this.loggers=new Map}listen(I,E){throw new Error(`Event not found: ${E}`)}async call(I,E,u){switch(E){case"createLogger":this.createLogger(P.URI.revive(u[0]),u[1]);return;case"log":return this.log(P.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1])}throw new Error(`Call not found: ${E}`)}createLogger(I,E){this.loggers.set(I.toString(),this.loggerService.createLogger(I,E))}consoleLog(I,E){let u=console.log;switch(I){case S.LogLevel.Error:u=console.error;break;case S.LogLevel.Warning:u=console.warn;break;case S.LogLevel.Info:u=console.info;break}u.call(console,...E)}log(I,E){const u=this.loggers.get(I.toString());if(!u)throw new Error("Create the logger before logging");for(const[v,_]of E)switch(v){case S.LogLevel.Trace:u.trace(_);break;case S.LogLevel.Debug:u.debug(_);break;case S.LogLevel.Info:u.info(_);break;case S.LogLevel.Warning:u.warn(_);break;case S.LogLevel.Error:u.error(_);break;case S.LogLevel.Critical:u.critical(_);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=L;class h{constructor(I){this.channel=I}createConsoleMainLogger(){return new S.AdapterLogger({log:(I,E)=>{this.channel.call("consoleLog",[I,E])}})}createLogger(I,E){return new n(this.channel,I,E)}}e.LoggerChannelClient=h;class n extends S.AbstractMessageLogger{constructor(I,E,u){super(u==null?void 0:u.always);this.channel=I,this.file=E,this.isLoggerCreated=!1,this.buffer=[],this.channel.call("createLogger",[E,u]).then(()=>{this._log(this.buffer),this.isLoggerCreated=!0})}log(I,E){this._log([[I,E]])}_log(I){this.isLoggerCreated?this.channel.call("log",[this.file,I]):this.buffer.push(...I)}}class D extends S.LogService{constructor(I,E){super(E);this.parent=I,this._register(I.onDidChangeLogLevel(u=>E.setLevel(u)))}setLevel(I){super.setLevel(I),this.parent.setLevel(I)}}e.FollowerLogService=D}),define(fe[90],he([0,1,17,24]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function P(h,n,D,b){try{const I=await new Promise((E,u)=>{Q(["spdlog"],E,u)});return I.setAsyncMode(8192,500),I.createRotatingLoggerAsync(h,n,D,b)}catch(I){console.error(I)}return null}function y(h,n,D,b){return Q.__$__nodeRequire("spdlog").createRotatingLogger(h,n,D,b)}e.createRotatingLogger=y;function k(h,n,D){switch(n){case S.LogLevel.Trace:h.trace(D);break;case S.LogLevel.Debug:h.debug(D);break;case S.LogLevel.Info:h.info(D);break;case S.LogLevel.Warning:h.warn(D);break;case S.LogLevel.Error:h.error(D);break;case S.LogLevel.Critical:h.critical(D);break;default:throw new Error("Invalid log level")}}class L extends S.AbstractMessageLogger{constructor(n,D,b,I){super();this.name=n,this.filepath=D,this.rotating=b,this.buffer=[],this.setLevel(I),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}_createSpdLogLogger(){const n=this.rotating?6:1,D=30/n*d.ByteSize.MB;return P(this.name,this.filepath,D,n).then(b=>{if(b){this._logger=b,this._logger.setLevel(this.getLevel());for(const{level:I,message:E}of this.buffer)k(this._logger,I,E);this.buffer=[]}})}log(n,D){this._logger?k(this._logger,n,D):this.getLevel()<=n&&this.buffer.push({level:n,message:D})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=L}),define(fe[185],he([0,1,7,151,71]),function(Q,e,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var y;(function(h){h[h.Unnecessary=1]="Unnecessary",h[h.Deprecated=2]="Deprecated"})(y=e.MarkerTag||(e.MarkerTag={}));var k;(function(h){h[h.Hint=1]="Hint",h[h.Info=2]="Info",h[h.Warning=4]="Warning",h[h.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(h){function n(u,v){return v-u}h.compare=n;const D=Object.create(null);D[h.Error]=d.localize(0,null),D[h.Warning]=d.localize(1,null),D[h.Info]=d.localize(2,null);function b(u){return D[u]||""}h.toString=b;function I(u){switch(u){case P.default.Error:return h.Error;case P.default.Warning:return h.Warning;case P.default.Info:return h.Info;case P.default.Ignore:return h.Hint}}h.fromSeverity=I;function E(u){switch(u){case h.Error:return P.default.Error;case h.Warning:return P.default.Warning;case h.Info:return P.default.Info;case h.Hint:return P.default.Ignore}}h.toSeverity=E}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var L;(function(h){const n="";function D(I){return b(I,!0)}h.makeKey=D;function b(I,E){let u=[n];return I.source?u.push(I.source.replace("\xA6","\\\xA6")):u.push(n),I.code?typeof I.code=="string"?u.push(I.code.replace("\xA6","\\\xA6")):u.push(I.code.value.replace("\xA6","\\\xA6")):u.push(n),I.severity!==void 0&&I.severity!==null?u.push(k.toString(I.severity)):u.push(n),I.message&&E?u.push(I.message.replace("\xA6","\\\xA6")):u.push(n),I.startLineNumber!==void 0&&I.startLineNumber!==null?u.push(I.startLineNumber.toString()):u.push(n),I.startColumn!==void 0&&I.startColumn!==null?u.push(I.startColumn.toString()):u.push(n),I.endLineNumber!==void 0&&I.endLineNumber!==null?u.push(I.endLineNumber.toString()):u.push(n),I.endColumn!==void 0&&I.endColumn!==null?u.push(I.endColumn.toString()):u.push(n),u.push(n),u.join("\xA6")}h.makeKeyOptionalMessage=b})(L=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=S.createDecorator("markerService")}),define(fe[186],he([0,1,71,7,6]),function(Q,e,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=S.default,e.INotificationService=d.createDecorator("notificationService");var y;(function(n){n[n.WORKSPACE=0]="WORKSPACE",n[n.GLOBAL=1]="GLOBAL"})(y=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var k;(function(n){n[n.OFF=0]="OFF",n[n.SILENT=1]="SILENT",n[n.ERROR=2]="ERROR"})(k=e.NotificationsFilter||(e.NotificationsFilter={}));class L{constructor(){this.progress=new h,this.onDidClose=P.Event.None,this.onDidChangeVisibility=P.Event.None}updateSeverity(D){}updateMessage(D){}updateActions(D){}close(){}}e.NoOpNotification=L;class h{infinite(){}done(){}total(D){}worked(D){}}e.NoOpProgress=h}),define(fe[26],he([0,1,5,36,8,21]),function(Q,e,S,d,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(S.isWeb||typeof Q=="undefined"||typeof Q.__$__nodeRequire!="function")k={webBuiltInExtensions:[{name:"ms-vscode.github-browser",version:"0.0.15",repo:"https://github.com/microsoft/vscode-github-browser",metadata:{id:"c1bcff4b-4ecb-466e-b8f6-b02788b5fb5a",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"com.visualstudio.code",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webEndpointUrl:"https://vscodeweb.azureedge.net",quality:"stable",extensionsGallery:{serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json",recommendationsUrl:"https://az764295.vo.msecnd.net/extensions/workspaceRecommendations.json.gz"},extensionTips:{"ms-dotnettools.csharp":"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json}","msjsdiag.debugger-for-chrome":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","firefox-devtools.vscode-firefox-debug":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","golang.Go":"**/*.go","ms-vscode.PowerShell":"{**/*.ps1,**/*.psd1,**/*.psm1,**/*.ps.config,**/*.ps1.config}","austin.code-gnu-global":"{**/*.c,**/*.cpp,**/*.h}","Ionide.Ionide-fsharp":"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}","dbaeumer.vscode-eslint":"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}","dbaeumer.jshint":"{**/*.js,**/*.jsx,**/*.es6,**/.babelrc,**/jsconfig.json,**/.jshintrc,**/.jshintignore}","ms-vscode.vscode-typescript-tslint-plugin":"{**/tslint.json}","bmewburn.vscode-intelephense-client":"{**/*.php,**/php.ini}","felixfbecker.php-intellisense":"{**/*.php,**/php.ini}","felixfbecker.php-debug":"{**/*.php,**/php.ini}","ikappas.phpcs":"{**/*.php,**/php.ini}","rust-lang.rust":"{**/*.rs,**/*.rslib}","ms-vscode.cpptools-extension-pack":"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}","DavidAnson.vscode-markdownlint":"{**/*.md}","ms-azuretools.vscode-docker":"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml,**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}","EditorConfig.EditorConfig":"{**/.editorconfig}","HookyQR.beautify":"{**/.jsbeautifyrc,**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.babelrc,**/jsconfig.json}","donjayamanne.githistory":"{**/.gitignore,**/.git}","felipecaputo.git-project-manager":"{**/.gitignore,**/.git}","eamodio.gitlens":"{**/.gitignore,**/.git}","rebornix.Ruby":"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}","DotJoshJohnson.xml":"{**/*.xml}","shinnn.stylelint":"{**/.stylelintrc,**/stylelint.config.js}","eg2.vscode-npm-script":"{**/package.json}","ms-mssql.mssql":"{**/*.sql}","bajdzis.vscode-database":"{**/*.sql}","mtxr.sqltools":"{**/*.sql}","usqlextpublisher.usql-vscode-ext":"{**/*.usql}","ms-vscode.sublime-keybindings":"{**/.sublime-project,**/.sublime-workspace}","k--kato.intellij-idea-keybindings":"{**/.idea}","christian-kohler.npm-intellisense":"{**/package.json}","octref.vetur":"{**/*.vue}","ms-python.python":"{**/*.py,**/*.ipynb}","cake-build.cake-vscode":"{**/build.cake}","Angular.ng-template":"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}","vscjava.vscode-maven":"**/pom.xml","ms-azuretools.vscode-azureterraform":"**/*.tf","HashiCorp.terraform":"**/*.tf","vsciot-vscode.vscode-arduino":"**/*.ino","ms-kubernetes-tools.vscode-kubernetes-tools":"{**/Chart.yaml}","GoogleCloudTools.cloudcode":"{**/skaffold.yaml}","Oracle.oracledevtools":"{**/*.sql}"},extensionImportantTips:{"ms-dotnettools.csharp":{name:"C#",languages:["csharp"],pattern:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}"},"ms-python.python":{name:"Python",languages:["python"],pattern:"{**/*.py,**/*.ipynb}"},"golang.Go":{name:"Go",languages:["go"],pattern:"**/*.go"},"vscjava.vscode-java-pack":{name:"Java",languages:["java"],pattern:"{**/*.java}",isExtensionPack:!0},"ms-vscode.PowerShell":{name:"PowerShell",languages:["powershell"],pattern:"{**/*.ps1,**/*.psd1,**/*.psm1}"},"ms-vscode.cpptools":{name:"C/C++",languages:["c","cpp"],pattern:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}"},"ms-azuretools.vscode-docker":{name:"Docker",languages:["dockerfile"],pattern:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}"},"octref.vetur":{name:"Vetur",languages:["vue"],pattern:"{**/*.vue}"},"ms-vscode.cmake-tools":{name:"CMake Tools",pattern:"{**/CMakeLists.txt}"},"msazurermtools.azurerm-vscode-tools":{name:"Azure Resource Manager",pattern:"{**/azuredeploy.json}"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",pattern:"{**/devcontainer.json}"},"ms-azuretools.vscode-bicep":{name:"Bicep",pattern:"{**/*.bicep}"},"svelte.svelte-vscode":{name:"Svelte",pattern:"{**/*.svelte}"}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","hiro-sun.vscode-emacs","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",remotes:["github.com"]},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"bajdzis.vscode-database":{name:"vscode-database"},"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"bajdzis.vscode-database":{name:"vscode-database"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-maven":{name:"Maven for Java"}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"Remote - WSL",important:!0}}}},remoteExtensionTips:{wsl:{friendlyName:"Remote - WSL",extensionId:"ms-vscode-remote.remote-wsl"},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh"},"dev-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},"attached-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},vsonline:{friendlyName:"Visual Studio Online",extensionId:"ms-vsonline.vsonline"}},extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{asimovKey:"AIF-444c3af9-8e69-4462-ab49-4191e6ad1916"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],sendASmile:{reportIssueUrl:"https://go.microsoft.com/fwlink/?LinkId=534872",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482"},documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",twitterUrl:"https://go.microsoft.com/fwlink/?LinkID=533687",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=786907",telemetryOptOutUrl:"https://go.microsoft.com/fwlink/?linkid=870136",npsSurveyUrl:"https://www.research.net/r/Z2RMYRJ",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05}],extensionAllowedProposedApi:["GitHub.codespaces","GitHub.vscode-pull-request-github-insiders","GitHub.vscode-pull-request-github","Microsoft.vscode-nmake-tools","ms-ai-tools.notebook-renderers","ms-dotnettools.dotnet-interactive-vscode","ms-python.gather","ms-python.python","ms-toolsai.jupyter","ms-toolsai.vscode-ai","ms-toolsai.vscode-ai-remote","ms-vscode-remote.remote-containers-nightly","ms-vscode-remote.remote-containers","ms-vscode-remote.remote-ssh-edit-nightly","ms-vscode-remote.remote-ssh-edit","ms-vscode-remote.remote-ssh-nightly","ms-vscode-remote.remote-ssh","ms-vscode-remote.remote-wsl-nightly","ms-vscode-remote.remote-wsl","ms-vscode-remote.remote-wsl-recommender","ms-vscode-remote.vscode-remote-extensionpack-nightly","ms-vscode-remote.vscode-remote-extensionpack","ms-vscode.azure-account","ms-vscode.azure-sphere-tools-ui","ms-vscode.azure-sphere-tools","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.js-debug-nightly","ms-vscode.js-debug","ms-vscode.lsif-browser","ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.vscode-selfhost-test-provider","ms-vsliveshare.cloudenv-explorer","ms-vsliveshare.cloudenv","ms-vsliveshare.vsliveshare","ms-vsonline.vsonline","dbaeumer.vscode-eslint","sandy081.999-test-github-issue-notebooks"],tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},experimentsUrl:"https://vscodeexperiments.azureedge.net/experiments/vscode-experiments.json",extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"manasxx.background-cover":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://vscode-auth.github.com","https://*.gallerycdn.vsassets.io","https://github.com/microsoft/","https://github.com/MicrosoftDocs/","https://login.microsoftonline.com"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{microsoft:{scopes:["https://management.core.windows.net/.default","offline_access"]},github:{scopes:["user:email"]}}},builtInExtensions:[{name:"ms-vscode.node-debug",version:"1.44.17",repo:"https://github.com/microsoft/vscode-node-debug",metadata:{id:"b6ded8fb-a0a0-4c1c-acbd-ab2a3bc995a6",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.node-debug2",version:"1.42.5",repo:"https://github.com/microsoft/vscode-node-debug2",metadata:{id:"36d19e17-7569-4841-a001-947eb18602b2",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.references-view",version:"0.0.77",repo:"https://github.com/microsoft/vscode-reference-view",metadata:{id:"dc489f46-520d-4556-ae85-1f9eab3c412d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug-companion",version:"1.0.8",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.54.3",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"0.0.11",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode-remote.remote-wsl-recommender",version:"0.0.5",repo:"https://github.com/microsoft/vscode-remote-wsl-recommender",metadata:{id:"cb296d3c-017a-4dee-83af-ebb5a5a16e9a",publisherId:{publisherId:"ac9410a2-0d75-40ec-90de-b59bb705801d",publisherName:"ms-vscode-remote",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"},platforms:["win32"],clientOnly:!0}],version:"1.54.1",commit:"f30a9b73e8ffc278e71575118b6bf568f04587c8",date:"2021-03-04T22:26:48.416Z"},Object.keys(k).length===0&&Object.assign(k,{version:"1.54.0-dev",nameShort:S.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:S.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser"]});else{const L=y.dirname(P.FileAccess.asFileUri("",Q));k=Q.__$__nodeRequire(y.joinPath(L,"product.json").fsPath);const h=Q.__$__nodeRequire(y.joinPath(L,"package.json").fsPath);d.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`}),Object.assign(k,{version:h.version})}e.default=k}),define(fe[187],he([0,1,22,26,124,2,21,106,132,8,3]),function(Q,e,S,d,P,y,k,L,h,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataDir=e.parsePathArg=e.parseSearchPort=e.parseExtensionHostPort=e.NativeEnvironmentService=void 0;class b{constructor(m){if(this._args=m,!m.logsPath){const l=h.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");m.logsPath=y.join(this.userDataPath,"logs",l)}this.logsPath=m.logsPath}get args(){return this._args}get appRoot(){return y.dirname(n.FileAccess.asFileUri("",Q).fsPath)}get userHome(){return D.URI.file(S.homedir())}get userDataPath(){const m=process.env.VSCODE_PORTABLE;return m?y.join(m,"user-data"):_(this._args,process)}get appSettingsHome(){return D.URI.file(y.join(this.userDataPath,"User"))}get tmpDir(){return D.URI.file(S.tmpdir())}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return k.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return k.joinPath(this.userRoamingDataHome,"sync")}get userDataSyncLogResource(){return D.URI.file(y.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return k.joinPath(D.URI.file(y.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return D.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return D.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return k.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return k.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=process.env.VSCODE_PORTABLE;return m?D.URI.file(y.join(m,"argv.json")):k.joinPath(this.userHome,d.default.dataFolderName,"argv.json")}get snippetsHome(){return k.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this._args.extensionDevelopmentPath}get untitledWorkspacesHome(){return D.URI.file(y.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return y.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const m=v(this._args["builtin-extensions-dir"],process);return m||y.normalize(y.join(n.FileAccess.asFileUri("",Q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const m=v(this._args["extensions-download-dir"],process);return m||y.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const m=v(this._args["extensions-dir"],process);if(m)return m;const l=process.env.VSCODE_EXTENSIONS;if(l)return l;const c=process.env.VSCODE_PORTABLE;return c?y.join(c,"extensions"):k.joinPath(this.userHome,d.default.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this._args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(l=>/^[^:/?#]+?:\/\//.test(l)?D.URI.parse(l):D.URI.file(y.normalize(l)))}get extensionTestsLocationURI(){const m=this._args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?D.URI.parse(m):D.URI.file(y.normalize(m))}get disableExtensions(){if(this._args["disable-extensions"])return!0;const m=this._args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return I(this._args,this.isBuilt)}get debugRenderer(){return!!this._args.debugRenderer}get isBuilt(){return!process.env.VSCODE_DEV}get verbose(){return!!this._args.verbose}get logLevel(){return this._args.log}get serviceMachineIdResource(){return k.joinPath(D.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this._args["crash-reporter-id"]}get crashReporterDirectory(){return this._args["crash-reporter-directory"]}get driverHandle(){return this._args.driver}get telemetryLogResource(){return D.URI.file(y.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this._args["disable-telemetry"]}}Oe([L.memoize],b.prototype,"appRoot",null),Oe([L.memoize],b.prototype,"userHome",null),Oe([L.memoize],b.prototype,"userDataPath",null),Oe([L.memoize],b.prototype,"appSettingsHome",null),Oe([L.memoize],b.prototype,"tmpDir",null),Oe([L.memoize],b.prototype,"userRoamingDataHome",null),Oe([L.memoize],b.prototype,"settingsResource",null),Oe([L.memoize],b.prototype,"userDataSyncHome",null),Oe([L.memoize],b.prototype,"userDataSyncLogResource",null),Oe([L.memoize],b.prototype,"sync",null),Oe([L.memoize],b.prototype,"machineSettingsResource",null),Oe([L.memoize],b.prototype,"globalStorageHome",null),Oe([L.memoize],b.prototype,"workspaceStorageHome",null),Oe([L.memoize],b.prototype,"keybindingsResource",null),Oe([L.memoize],b.prototype,"keyboardLayoutResource",null),Oe([L.memoize],b.prototype,"argvResource",null),Oe([L.memoize],b.prototype,"snippetsHome",null),Oe([L.memoize],b.prototype,"isExtensionDevelopment",null),Oe([L.memoize],b.prototype,"untitledWorkspacesHome",null),Oe([L.memoize],b.prototype,"installSourcePath",null),Oe([L.memoize],b.prototype,"builtinExtensionsPath",null),Oe([L.memoize],b.prototype,"extensionsPath",null),Oe([L.memoize],b.prototype,"extensionDevelopmentLocationURI",null),Oe([L.memoize],b.prototype,"extensionTestsLocationURI",null),Oe([L.memoize],b.prototype,"debugExtensionHost",null),Oe([L.memoize],b.prototype,"serviceMachineIdResource",null),Oe([L.memoize],b.prototype,"telemetryLogResource",null),e.NativeEnvironmentService=b;function I(w,m){return u(w["inspect-extensions"],w["inspect-brk-extensions"],5870,m,w.debugId)}e.parseExtensionHostPort=I;function E(w,m){return u(w["inspect-search"],w["inspect-brk-search"],5876,m)}e.parseSearchPort=E;function u(w,m,l,c,r){const i=Number(m||w)||(c?null:l),o=i?Boolean(!!m):!1;return{port:i,break:o,debugId:r}}function v(w,m){if(!!w){const l=y.resolve(w);return y.normalize(w)===l?l:y.resolve(m.env.VSCODE_CWD||m.cwd(),w)}}e.parsePathArg=v;function _(w,m){return v(w["user-data-dir"],m)||y.resolve(P.getDefaultUserDataPath())}e.parseUserDataDir=_}),define(fe[50],he([0,1,7]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=S.createDecorator("productService")}),define(fe[31],he([0,1,11,105]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.data=new Map}add(k,L){d.ok(S.isString(k)),d.ok(S.isObject(L)),d.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,L)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new P}),define(fe[188],he([0,1,31,6]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(L){return L.length>0&&L.charAt(L.length-1)==="#"?L.substring(0,L.length-1):L}class y{constructor(){this._onDidChangeSchema=new d.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,n){this.schemasById[P(h)]=n,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new y;S.Registry.add(e.Extensions.JSONContribution,k)}),define(fe[42],he([0,1,138,6,31,11,188]),function(Q,e,S,d,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(_){_[_.APPLICATION=1]="APPLICATION",_[_.MACHINE=2]="MACHINE",_[_.WINDOW=3]="WINDOW",_[_.RESOURCE=4]="RESOURCE",_[_.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",_[_.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const h=P.Registry.as(k.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new d.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new d.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},h.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,m=!0){this.registerConfigurations([w],m)}registerConfigurations(w,m=!0){const l=[];w.forEach(c=>{l.push(...this.validateAndRegisterProperties(c,m)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),h.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterConfigurations(w){const m=[],l=c=>{if(c.properties)for(const r in c.properties)m.push(r),delete this.configurationProperties[r],this.removeFromSchema(r,c.properties[r]);c.allOf&&c.allOf.forEach(r=>l(r))};for(const c of w){l(c);const r=this.configurationContributors.indexOf(c);r!==-1&&this.configurationContributors.splice(r,1)}h.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(m)}registerDefaultConfigurations(w){const m=[],l=[];for(const c of w)for(const r in c)if(m.push(r),e.OVERRIDE_PROPERTY_PATTERN.test(r)){this.defaultValues[r]=Object.assign(Object.assign({},this.defaultValues[r]||{}),c[r]);const t={type:"object",default:this.defaultValues[r],description:S.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId};l.push(b(r)),this.configurationProperties[r]=t,this.defaultLanguageConfigurationOverridesNode.properties[r]=t}else{this.defaultValues[r]=c[r];const t=this.configurationProperties[r];t&&(this.updatePropertyDefaultValue(r,t),this.updateSchema(r,t))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(m)}deregisterDefaultConfigurations(w){const m=[];for(const l of w)for(const c in l)if(m.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const r=this.configurationProperties[c];r&&(this.updatePropertyDefaultValue(c,r),this.updateSchema(c,r))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(m)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const m of w)this.overrideIdentifiers.add(m);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,m=!0,l=3){l=y.isUndefinedOrNull(w.scope)?l:w.scope;let c=[],r=w.properties;if(r)for(let i in r){if(m&&u(i)){delete r[i];continue}const o=r[i];if(this.updatePropertyDefaultValue(i,o),e.OVERRIDE_PROPERTY_PATTERN.test(i)?o.scope=void 0:o.scope=y.isUndefinedOrNull(o.scope)?l:o.scope,r[i].hasOwnProperty("included")&&!r[i].included){this.excludedConfigurationProperties[i]=r[i],delete r[i];continue}else this.configurationProperties[i]=r[i];!r[i].deprecationMessage&&r[i].markdownDeprecationMessage&&(r[i].deprecationMessage=r[i].markdownDeprecationMessage),c.push(i)}let t=w.allOf;if(t)for(let i of t)c.push(...this.validateAndRegisterProperties(i,m,l));return c}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const m=l=>{let c=l.properties;if(c)for(const t in c)this.updateSchema(t,c[t]);let r=l.allOf;r&&r.forEach(m)};m(w)}updateSchema(w,m){switch(e.allSettings.properties[w]=m,m.scope){case 1:e.applicationSettings.properties[w]=m;break;case 2:e.machineSettings.properties[w]=m;break;case 6:e.machineOverridableSettings.properties[w]=m;break;case 3:e.windowSettings.properties[w]=m;break;case 4:e.resourceSettings.properties[w]=m;break;case 5:e.resourceSettings.properties[w]=m,this.resourceLanguageSettingsSchema.properties[w]=m;break}}removeFromSchema(w,m){switch(delete e.allSettings.properties[w],m.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const m=`[${w}]`,l={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(m,l),e.allSettings.properties[m]=l,e.applicationSettings.properties[m]=l,e.machineSettings.properties[m]=l,e.machineOverridableSettings.properties[m]=l,e.windowSettings.properties[m]=l,e.resourceSettings.properties[m]=l}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,m){let l=this.defaultValues[w];y.isUndefined(l)&&(l=m.default),y.isUndefined(l)&&(l=I(m.type)),m.default=l}}const D="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(D);function b(_){return _.substring(1,_.length-1)}e.overrideIdentifierFromKey=b;function I(_){switch(Array.isArray(_)?_[0]:_){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=I;const E=new n;P.Registry.add(e.Extensions.Configuration,E);function u(_){return _.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(_)?S.localize(5,null,_):E.getConfigurationProperties()[_]!==void 0?S.localize(6,null,_):null:S.localize(4,null)}e.validateProperty=u;function v(){const _=[],w=E.getConfigurationProperties();for(const m of Object.keys(w))_.push([m,w[m].scope]);return _.push(["launch",4]),_.push(["task",4]),_}e.getScopes=v}),define(fe[34],he([0,1,19,11,3,31,7,42]),function(Q,e,S,d,P,y,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=k.createDecorator("configurationService");function h(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof P.URI)}e.isConfigurationOverrides=h;var n;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(n=e.ConfigurationTarget||(e.ConfigurationTarget={}));function D(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=D;function b(i,o){const a=o?i?o.keys.filter(T=>i.keys.indexOf(T)===-1):[...o.keys]:[],s=i?o?i.keys.filter(T=>o.keys.indexOf(T)===-1):[...i.keys]:[],g=[];if(o&&i){for(const T of i.keys)if(o.keys.indexOf(T)!==-1){const O=w(i.contents,T),H=w(o.contents,T);S.equals(O,H)||g.push(T)}}const C=[],R=T=>{const O={};for(const H of T)for(const $ of H.identifiers)O[r($)]=H;return O},p=o?R(o.overrides):{},f=i?R(i.overrides):{};if(Object.keys(p).length)for(const T of a){const O=p[T];O&&C.push([L.overrideIdentifierFromKey(T),O.keys])}if(Object.keys(f).length)for(const T of s){const O=f[T];O&&C.push([L.overrideIdentifierFromKey(T),O.keys])}if(Object.keys(p).length&&Object.keys(f).length)for(const T of g){const O=f[T],H=p[T];if(O&&H){const $=b({contents:O.contents,keys:O.keys,overrides:[]},{contents:H.contents,keys:H.keys,overrides:[]});C.push([L.overrideIdentifierFromKey(T),[...$.added,...$.removed,...$.updated]])}}return{added:a,removed:s,updated:g,overrides:C}}e.compare=b;function I(i,o){const a=[];for(const s of Object.keys(i))if(L.OVERRIDE_PROPERTY_PATTERN.test(s)){const g={};for(const C in i[s])g[C]=i[s][C];a.push({identifiers:[L.overrideIdentifierFromKey(s).trim()],keys:Object.keys(g),contents:E(g,o)})}return a}e.toOverrides=I;function E(i,o){const a=Object.create(null);for(let s in i)u(a,s,i[s],o);return a}e.toValuesTree=E;function u(i,o,a,s){const g=o.split("."),C=g.pop();let R=i;for(let p=0;p<g.length;p++){let f=g[p],T=R[f];switch(typeof T){case"undefined":T=R[f]=Object.create(null);break;case"object":break;default:s(`Ignoring ${o} as ${g.slice(0,p+1).join(".")} is ${JSON.stringify(T)}`);return}R=T}if(typeof R=="object"&&R!==null)try{R[C]=a}catch(p){s(`Ignoring ${o} as ${g.join(".")} is ${JSON.stringify(R)}`)}else s(`Ignoring ${o} as ${g.join(".")} is ${JSON.stringify(R)}`)}e.addToValueTree=u;function v(i,o){const a=o.split(".");_(i,a)}e.removeFromValueTree=v;function _(i,o){const a=o.shift();if(o.length===0){delete i[a];return}if(Object.keys(i).indexOf(a)!==-1){const s=i[a];typeof s=="object"&&!Array.isArray(s)&&(_(s,o),Object.keys(s).length===0&&delete i[a])}}function w(i,o,a){function s(R,p){let f=R;for(const T of p){if(typeof f!="object"||f===null)return;f=f[T]}return f}const g=o.split("."),C=s(i,g);return typeof C=="undefined"?a:C}e.getConfigurationValue=w;function m(i,o,a){Object.keys(o).forEach(s=>{s!=="__proto__"&&(s in i?d.isObject(i[s])&&d.isObject(o[s])?m(i[s],o[s],a):a&&(i[s]=o[s]):i[s]=o[s])})}e.merge=m;function l(){const i=y.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=l;function c(){const i=Object.create(null),o=y.Registry.as(L.Extensions.Configuration).getConfigurationProperties();for(let a in o){let s=o[a].default;u(i,a,s,g=>console.error(`Conflict in default settings: ${g}`))}return i}e.getDefaultValues=c;function r(i){return`[${i}]`}e.keyFromOverrideIdentifier=r;function t(i,o,a){const s=i.inspect(o),g=i.inspect(a);return typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:s.defaultValue}e.getMigratedSettingValue=t}),define(fe[189],he([0,1,35,25,16,11,19,3,42,34,31,4,6]),function(Q,e,S,d,P,y,k,L,h,n,D,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class E{constructor(t={},i=[],o=[]){this._contents=t,this._keys=i,this._overrides=o,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?n.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,i){const o=this.getContentsForOverrideIdentifer(i);return o?t?n.getConfigurationValue(o,t):o:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let o={};for(const a of P.distinct([...Object.keys(this.contents),...Object.keys(i)])){let s=this.contents[a],g=i[a];g&&(typeof s=="object"&&typeof g=="object"?(s=k.deepClone(s),this.mergeContents(s,g)):s=g),o[a]=s}return new E(o,this.keys,this.overrides)}merge(...t){const i=k.deepClone(this.contents),o=k.deepClone(this.overrides),a=[...this.keys];for(const s of t){this.mergeContents(i,s.contents);for(const g of s.overrides){const[C]=o.filter(R=>P.equals(R.identifiers,g.identifiers));C?this.mergeContents(C.contents,g.contents):o.push(k.deepClone(g))}for(const g of s.keys)a.indexOf(g)===-1&&a.push(g)}return new E(i,a,o)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const o of Object.keys(i)){if(o in t&&y.isObject(t[o])&&y.isObject(i[o])){this.mergeContents(t[o],i[o]);continue}t[o]=k.deepClone(i[o])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?k.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),n.addToValueTree(this.contents,t,i,o=>{throw new Error(o)})}removeValue(t){this.removeKey(t)&&n.removeFromValueTree(this.contents,t)}addKey(t){let i=this.keys.length;for(let o=0;o<i;o++)t.indexOf(this.keys[o])===0&&(i=o);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=E;class u extends E{constructor(){const t=n.getDefaultValues(),i=n.getConfigurationKeys(),o=[];for(const a of Object.keys(t))h.OVERRIDE_PROPERTY_PATTERN.test(a)&&o.push({identifiers:[h.overrideIdentifierFromKey(a).trim()],keys:Object.keys(t[a]),contents:n.toValuesTree(t[a],s=>console.error(`Conflict in default settings file: ${s}`))});super(t,i,o)}}e.DefaultConfigurationModel=u;class v{constructor(t,i){this._name=t,this._scopes=i,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get errors(){return this._parseErrors}parseContent(t){if(!y.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i)}}parseRaw(t){this._raw=t;const i=this.doParseRaw(t);this._configurationModel=new E(i.contents,i.keys,i.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let i={},o=null,a=[],s=[],g=[];function C(p){Array.isArray(a)?a.push(p):o&&(a[o]=p)}let R={onObjectBegin:()=>{let p={};C(p),s.push(a),a=p,o=null},onObjectProperty:p=>{o=p},onObjectEnd:()=>{a=s.pop()},onArrayBegin:()=>{let p=[];C(p),s.push(a),a=p,o=null},onArrayEnd:()=>{a=s.pop()},onLiteralValue:C,onError:(p,f,T)=>{g.push({error:p,offset:f,length:T})}};if(t)try{S.visit(t,R),i=a[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return i}doParseRaw(t){if(this._scopes){const s=D.Registry.as(h.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,s,!0,this._scopes)}const i=n.toValuesTree(t,s=>console.error(`Conflict in settings file ${this._name}: ${s}`)),o=Object.keys(t),a=n.toOverrides(t,s=>console.error(`Conflict in settings file ${this._name}: ${s}`));return{contents:i,keys:o,overrides:a}}filterByScope(t,i,o,a){const s={};for(let g in t)if(h.OVERRIDE_PROPERTY_PATTERN.test(g)&&o)s[g]=this.filterByScope(t[g],i,!1,a);else{const C=this.getScope(g,i);(C===void 0||a.indexOf(C)!==-1)&&(s[g]=t[g])}return s}getScope(t,i){const o=i[t];return o?typeof o.scope!="undefined"?o.scope:3:void 0}}e.ConfigurationModelParser=v;class _ extends b.Disposable{constructor(t,i,o,a){super();this.userSettingsResource=t,this.scopes=i,this.fileService=a,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(I.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new E}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=_;class w{constructor(t,i,o=new E,a=new E,s=new d.ResourceMap,g=new E,C=new d.ResourceMap,R=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=o,this._workspaceConfiguration=a,this._folderConfigurations=s,this._memoryConfiguration=g,this._memoryConfigurationByResource=C,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new d.ResourceMap,this._userConfiguration=null}getValue(t,i,o){return this.getConsolidateConfigurationModel(i,o).getValue(t)}updateValue(t,i,o={}){let a;o.resource?(a=this._memoryConfigurationByResource.get(o.resource),a||(a=new E,this._memoryConfigurationByResource.set(o.resource,a))):a=this._memoryConfiguration,i===void 0?a.removeValue(t):a.setValue(t,i),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,o){const a=this.getConsolidateConfigurationModel(i,o),s=this.getFolderConfigurationModelForResource(i.resource,o),g=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,C=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),R=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),p=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),f=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),T=o?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=s?i.overrideIdentifier?s.freeze().override(i.overrideIdentifier).getValue(t):s.freeze().getValue(t):void 0,H=i.overrideIdentifier?g.override(i.overrideIdentifier).getValue(t):g.getValue(t),$=a.getValue(t),x=P.distinct(P.flatten(a.overrides.map(J=>J.identifiers))).filter(J=>a.getOverrideValue(t,J)!==void 0);return{defaultValue:C,userValue:R,userLocalValue:p,userRemoteValue:f,workspaceValue:T,workspaceFolderValue:O,memoryValue:H,value:$,default:C!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:R!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:p!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:f!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:s==null?void 0:s.freeze().getValue(t),override:i.overrideIdentifier?s==null?void 0:s.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:H!==void 0?{value:g.getValue(t),override:i.overrideIdentifier?g.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:x.length?x:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const o=i.filter(a=>h.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const s=h.overrideIdentifierFromKey(a),g=this._defaultConfiguration.getKeysForOverrideIdentifier(s),C=t.getKeysForOverrideIdentifier(s),R=[...C.filter(p=>g.indexOf(p)===-1),...g.filter(p=>C.indexOf(p)===-1),...g.filter(p=>!k.equals(this._defaultConfiguration.override(s).getValue(p),t.override(s).getValue(p)))];return[s,R]});return this.updateDefaultConfiguration(t),{keys:i,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:o,removed:a,overrides:s}=n.compare(this.localUserConfiguration,t),g=[...i,...o,...a];return g.length&&this.updateLocalUserConfiguration(t),{keys:g,overrides:s}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:o,removed:a,overrides:s}=n.compare(this.remoteUserConfiguration,t);let g=[...i,...o,...a];return g.length&&this.updateRemoteUserConfiguration(t),{keys:g,overrides:s}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:o,removed:a,overrides:s}=n.compare(this.workspaceConfiguration,t);let g=[...i,...o,...a];return g.length&&this.updateWorkspaceConfiguration(t),{keys:g,overrides:s}}compareAndUpdateFolderConfiguration(t,i){const o=this.folderConfigurations.get(t),{added:a,updated:s,removed:g,overrides:C}=n.compare(o,i);let R=[...a,...s,...g];return(R.length||!o)&&this.updateFolderConfiguration(t,i),{keys:R,overrides:C}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:a,removed:s,overrides:g}=n.compare(i,void 0);return{keys:[...o,...a,...s],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let o=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?o.override(t.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:t},i){let o=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const a=i.getFolder(t);a&&(o=this.getFolderConsolidatedConfiguration(a.uri)||o);const s=this._memoryConfigurationByResource.get(t);s&&(o=o.merge(s))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const o=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(i=o.merge(a),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=o}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const o=i.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:o,overrides:a,keys:s}=this._folderConfigurations.get(i);return t.push([i,{contents:o,overrides:a,keys:s}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(a=>i.add(a))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),o=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),s=t.folders.reduce((g,C)=>(g.set(L.URI.revive(C[0]),this.parseConfigurationModel(C[1])),g),new d.ResourceMap);return new w(i,o,new E,a,s,new E,new d.ResourceMap,!1)}static parseConfigurationModel(t){return new E(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function m(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,i=new Map;for(const a of r)a.keys.forEach(s=>t.add(s)),a.overrides.forEach(([s,g])=>{const C=d.getOrSet(i,s,new Set);g.forEach(R=>C.add(R))});const o=[];return i.forEach((a,s)=>o.push([s,[...a.values()]])),{keys:[...t.values()],overrides:o}}e.mergeChanges=m;class l{constructor(t,i,o,a){this.change=t,this.previous=i,this.currentConfiguraiton=o,this.currentWorkspace=a,this._previousConfiguration=void 0;const s=new Set;t.keys.forEach(C=>s.add(C)),t.overrides.forEach(([,C])=>C.forEach(R=>s.add(R))),this.affectedKeys=[...s.values()];const g=new E;this.affectedKeys.forEach(C=>g.setValue(C,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var o;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const a=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(o=this.previous)===null||o===void 0?void 0:o.workspace):void 0,s=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!k.equals(a,s)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let o=n.toValuesTree({[i]:!0},()=>{}),a;for(;typeof o=="object"&&(a=Object.keys(o)[0]);){if(t=t[a],!t)return!1;o=o[a]}return!0}}e.ConfigurationChangeEvent=l;class c extends l{constructor(t,i,o,a){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=o,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=c}),define(fe[91],he([0,1,31,42,4,34,189,6,13,21]),function(Q,e,S,d,P,y,k,L,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class D extends P.Disposable{constructor(I,E){super();this.settingsResource=I,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new k.UserSettings(this.settingsResource,void 0,n.extUriBiasedIgnorePathCase,E)),this.configuration=new k.Configuration(new k.DefaultConfigurationModel,new k.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new h.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(S.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const I=await this.userConfiguration.loadConfiguration();this.configuration=new k.Configuration(new k.DefaultConfigurationModel,I)}getConfigurationData(){return this.configuration.toData()}getValue(I,E){const u=typeof I=="string"?I:void 0,v=y.isConfigurationOverrides(I)?I:y.isConfigurationOverrides(E)?E:{};return this.configuration.getValue(u,v,void 0)}updateValue(I,E,u,v){return Promise.reject(new Error("not supported"))}inspect(I){return this.configuration.inspect(I,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const I=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(I)}onDidChangeUserConfiguration(I){const E=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(I);this.trigger(u,E,1)}onDidDefaultConfigurationChange(I){const E=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new k.DefaultConfigurationModel,I);this.trigger(u,E,6)}trigger(I,E,u){const v=new k.ConfigurationChangeEvent(I,{data:E},this.configuration);v.source=u,v.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(v)}getTargetConfiguration(I){switch(I){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=D}),define(fe[92],he([0,1,7]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=S.createDecorator("remoteAuthorityResolverService");var d;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(d=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends Error{constructor(k,L=d.Unknown,h){super(k);this._message=k,this._code=L,this._detail=h,this.isHandled=L===d.NotAvailable&&h===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}static isTemporarilyNotAvailable(k){return k instanceof P&&k._code===d.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof P&&k._code===d.NoResolverFound}static isHandled(k){return k instanceof P&&k.isHandled}}e.RemoteAuthorityResolverError=P}),define(fe[190],he([0,1,8]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function d(y){return y.scheme===S.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=d;function P(y){if(!!y){const k=y.indexOf("+");return k<0?y:y.substr(0,k)}}e.getRemoteName=P}),define(fe[62],he([0,1,152,7,42,31,18]),function(Q,e,S,d,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=d.createDecorator("requestService");function L(b){return b.res.statusCode&&b.res.statusCode>=200&&b.res.statusCode<300||b.res.statusCode===1223}e.isSuccess=L;function h(b){return b.res.statusCode===204}async function n(b){if(!L(b))throw new Error("Server returned "+b.res.statusCode);return h(b)?null:(await k.streamToBuffer(b.stream)).toString()}e.asText=n;async function D(b){if(!L(b))throw new Error("Server returned "+b.res.statusCode);if(h(b))return null;const E=(await k.streamToBuffer(b.stream)).toString();try{return JSON.parse(E)}catch(u){throw u.message+=`:
`+E,u}}e.asJson=D,y.Registry.as(P.Extensions.Configuration).registerConfiguration({id:"http",order:15,title:S.localize(0,null),type:"object",properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:S.localize(1,null)},"http.proxyStrictSSL":{type:"boolean",default:!0,description:S.localize(2,null)},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:S.localize(3,null)},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[S.localize(4,null),S.localize(5,null),S.localize(6,null)],default:"override",description:S.localize(7,null)},"http.systemCertificates":{type:"boolean",default:!0,description:S.localize(8,null)}}})}),define(fe[191],he([0,1,27,18]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class P{constructor(L){this.service=L}listen(L,h){throw new Error("Invalid listen")}call(L,h,n){switch(h){case"request":return this.service.request(n[0],S.CancellationToken.None).then(async({res:D,stream:b})=>{const I=await d.streamToBuffer(b);return[{statusCode:D.statusCode,headers:D.headers},I]})}throw new Error("Invalid call")}}e.RequestChannel=P;class y{constructor(L){this.channel=L}async request(L,h){return y.request(this.channel,L,h)}static async request(L,h,n){const[D,b]=await L.call("request",[h]);return{res:D,stream:d.bufferToStream(b)}}}e.RequestChannelClient=y}),define(fe[192],he([0,1,63,11]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function P(k){return k.protocol==="http:"?process.env.HTTP_PROXY||process.env.http_proxy||null:k.protocol==="https:"&&(process.env.HTTPS_PROXY||process.env.https_proxy||process.env.HTTP_PROXY||process.env.http_proxy)||null}async function y(k,L={}){const h=S.parse(k),n=L.proxyUrl||P(h);if(!n)return null;const D=S.parse(n);if(!/^https?:$/.test(D.protocol||""))return null;const b={host:D.hostname||"",port:D.port||(D.protocol==="https"?"443":"80"),auth:D.auth,rejectUnauthorized:d.isBoolean(L.strictSSL)?L.strictSSL:!0};return h.protocol==="http:"?new(await new Promise((I,E)=>{Q(["http-proxy-agent"],I,E)}))(b):new(await new Promise((I,E)=>{Q(["https-proxy-agent"],I,E)}))(b)}e.getProxyAgent=y}),define(fe[193],he([0,1,23,18]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function P(y,k,L){let h=L&&L.get("storage.serviceMachineId",0)||null;if(h)return h;try{const D=(await k.readFile(y.serviceMachineIdResource)).value.toString();h=S.isUUID(D)?D:null}catch(n){h=null}if(!h){h=S.generateUuid();try{await k.writeFile(y.serviceMachineIdResource,d.VSBuffer.fromString(h))}catch(n){}}return L&&L.store("storage.serviceMachineId",h,0,1),h}e.getServiceMachineId=P}),define(fe[194],he([0,1,7,6,4,11,126,13]),function(Q,e,S,d,P,y,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const h="__$__targetStorageMarker";e.IStorageService=S.createDecorator("storageService");var n;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(n=e.WillSaveStateReason||(e.WillSaveStateReason={}));var D;(function(v){v[v.GLOBAL=0]="GLOBAL",v[v.WORKSPACE=1]="WORKSPACE"})(D=e.StorageScope||(e.StorageScope={}));var b;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(b=e.StorageTarget||(e.StorageTarget={}));class I extends P.Disposable{constructor(_={flushInterval:I.DEFAULT_FLUSH_INTERVAL}){super();this.options=_,this._onDidChangeValue=this._register(new d.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new d.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new d.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new P.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=L.runWhenIdle(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){P.dispose([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(_,w){w===h?(_===0?this._globalKeyTargets=void 0:_===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:_})):this._onDidChangeValue.fire({scope:_,key:w,target:this.getKeyTargets(_)[w]})}emitWillSaveState(_){this._onWillSaveState.fire({reason:_})}get(_,w,m){var l;return(l=this.getStorage(w))===null||l===void 0?void 0:l.get(_,m)}getBoolean(_,w,m){var l;return(l=this.getStorage(w))===null||l===void 0?void 0:l.getBoolean(_,m)}getNumber(_,w,m){var l;return(l=this.getStorage(w))===null||l===void 0?void 0:l.getNumber(_,m)}store(_,w,m,l){if(y.isUndefinedOrNull(w)){this.remove(_,m);return}this.withPausedEmitters(()=>{var c;this.updateKeyTarget(_,m,l),(c=this.getStorage(m))===null||c===void 0||c.set(_,w)})}remove(_,w){this.withPausedEmitters(()=>{var m;this.updateKeyTarget(_,w,void 0),(m=this.getStorage(w))===null||m===void 0||m.delete(_)})}withPausedEmitters(_){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{_()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(_,w){const m=[],l=this.getKeyTargets(_);for(const c of Object.keys(l))l[c]===w&&m.push(c);return m}updateKeyTarget(_,w,m){var l,c;const r=this.getKeyTargets(w);typeof m=="number"?r[_]!==m&&(r[_]=m,(l=this.getStorage(w))===null||l===void 0||l.set(h,JSON.stringify(r))):typeof r[_]=="number"&&(delete r[_],(c=this.getStorage(w))===null||c===void 0||c.set(h,JSON.stringify(r)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(_){return _===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(_){const w=this.get(h,_);if(w)try{return JSON.parse(w)}catch(m){}return Object.create(null)}isNew(_){return this.getBoolean(e.IS_NEW_KEY,_)===!0}async flush(){var _,w,m,l;this._onWillSaveState.fire({reason:n.NONE}),await L.Promises.settled([(w=(_=this.getStorage(0))===null||_===void 0?void 0:_.whenFlushed())!==null&&w!==void 0?w:Promise.resolve(),(l=(m=this.getStorage(1))===null||m===void 0?void 0:m.whenFlushed())!==null&&l!==void 0?l:Promise.resolve()])}async logStorage(){var _,w,m,l,c,r;const t=(w=(_=this.getStorage(0))===null||_===void 0?void 0:_.items)!==null&&w!==void 0?w:new Map,i=(l=(m=this.getStorage(1))===null||m===void 0?void 0:m.items)!==null&&l!==void 0?l:new Map;return u(t,i,(c=this.getLogDetails(0))!==null&&c!==void 0?c:"",(r=this.getLogDetails(1))!==null&&r!==void 0?r:"")}}e.AbstractStorageService=I,I.DEFAULT_FLUSH_INTERVAL=60*1e3;class E extends I{constructor(){super();this.globalStorage=new k.Storage(new k.InMemoryStorageDatabase),this.workspaceStorage=new k.Storage(new k.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(_=>this.emitDidChangeValue(1,_))),this._register(this.globalStorage.onDidChangeStorage(_=>this.emitDidChangeValue(0,_)))}getStorage(_){return _===0?this.globalStorage:this.workspaceStorage}getLogDetails(_){return _===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(_){}}e.InMemoryStorageService=E;async function u(v,_,w,m){const l=s=>{try{return JSON.parse(s)}catch(g){return s}},c=new Map,r=new Map;v.forEach((s,g)=>{c.set(g,s),r.set(g,l(s))});const t=new Map,i=new Map;_.forEach((s,g)=>{t.set(g,s),i.set(g,l(s))}),console.group(`Storage: Global (path: ${w})`);let o=[];c.forEach((s,g)=>{o.push({key:g,value:s})}),console.table(o),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${m})`);let a=[];t.forEach((s,g)=>{a.push({key:g,value:s})}),console.table(a),console.groupEnd(),console.log(i)}e.logStorage=u}),define(fe[195],he([0,1,5,36,23,3]),function(Q,e,S,d,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;async function k(h,n,D,b,I,E,u,v,_){const w=Object.create(null);w["common.machineId"]=E,w.sessionID=P.generateUuid()+Date.now(),w.commitHash=b,w.version=I,w["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=S.PlatformToString(S.platform),w["common.nodePlatform"]=d.platform,w["common.nodeArch"]=D,w["common.product"]=_||"desktop";const m=L(u||[]);m&&(w["common.msftInternal"]=m);let l=0;const c=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),S.isLinuxSnap&&(w["common.snap"]="true");try{const r=await h.readFile(y.URI.file(v));w["common.source"]=r.value.toString().slice(0,30)}catch(r){}return w}e.resolveCommonProperties=k;function L(h){const n=d.env.USERDNSDOMAIN;if(!n)return!1;const D=n.toLowerCase();return h.some(b=>D===b)}}),define(fe[196],he([0,1,16,12,4,19]),function(Q,e,S,d,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var k;(function(h){function n(D,b){return D.callstack<b.callstack?-1:D.callstack>b.callstack?1:0}h.compare=n})(k=e.ErrorEvent||(e.ErrorEvent={}));class L{constructor(n,D=L.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new P.DisposableStore,this._telemetryService=n,this._flushDelay=D;const b=d.errorHandler.addListener(I=>this._onErrorEvent(I));this._disposables.add(P.toDisposable(b)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(n){if(!!n){n.detail&&n.detail.stack&&(n=n.detail);let D=Array.isArray(n.stack)?n.stack.join(`
`):n.stack,b=n.message?n.message:y.safeStringify(n);!D||this._enqueue({msg:b,callstack:D})}}_enqueue(n){const D=S.binarySearch(this._buffer,n,k.compare);D<0?(n.count=1,this._buffer.splice(~D,0,n)):(this._buffer[D].count||(this._buffer[D].count=0),this._buffer[D].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(let n of this._buffer)this._telemetryService.publicLogError2("UnhandledError",n);this._buffer.length=0}}e.default=L,L.ERROR_FLUSH_TIMEOUT=5*1e3}),define(fe[43],he([0,1,7]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ITelemetryService=void 0,e.ITelemetryService=S.createDecorator("telemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(fe[197],he([0,1,22,75,175,15,2,35,77,26,5,3,43,52,8,24,20]),function(Q,e,S,d,P,y,k,L,h,n,D,b,I,E,u,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function w(t,i){const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],a=new Map,s=new Map,g=2e4;function C(f,T,O,H){const $=T.substring(f.length+1);return new Promise(async x=>{var J,Ee,ve;let q;try{q=await _.readdir(T,{withFileTypes:!0})}catch(A){x();return}if(H.count>=g){H.count+=q.length,H.maxReached=!0,x();return}let j=q.length;if(j===0){x();return}let F=q;H.count+q.length>g&&(H.maxReached=!0,j=g-H.count,F=q.slice(0,j)),H.count+=q.length;for(const A of F)if(A.isDirectory()){if(O.includes(A.name)||await C(f,k.join(T,A.name),O,H),--j==0){x();return}}else{const M=A.name.lastIndexOf(".");if(M>=0){const U=A.name.substring(M+1);U&&a.set(U,((J=a.get(U))!==null&&J!==void 0?J:0)+1)}for(const U of o)((Ee=U.relativePathPattern)===null||Ee===void 0?void 0:Ee.test($))!==!1&&U.filePattern.test(A.name)&&s.set(U.tag,((ve=s.get(U.tag))!==null&&ve!==void 0?ve:0)+1);if(--j==0){x();return}}})}const R={count:0,maxReached:!1};await C(t,t,i,R);const p=await c(t);return{configFiles:m(s),fileTypes:m(a),fileCount:R.count,maxFilesReached:R.maxReached,launchConfigFiles:p}}e.collectWorkspaceStats=w;function m(t){return[...E.Iterable.map(t.entries(),([i,o])=>({name:i,count:o}))].sort((i,o)=>o.count-i.count)}function l(){const t={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/v.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/v.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(d.virtualMachineHint.value()*100)}%`},i=S.cpus();return i&&i.length>0&&(t.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),t}e.getMachineInfo=l;function c(t){let i=new Map,o=k.join(t,".vscode","launch.json");return new Promise((a,s)=>{y.exists(o,g=>{if(g)y.readFile(o,(C,R)=>{if(C)return a([]);const p=[],f=L.parse(R.toString(),p);if(p.length)return console.log(`Unable to parse ${o}`),a([]);if(L.getNodeType(f)==="object"&&f.configurations)for(const T of f.configurations){const O=T.type;O&&(i.has(O)?i.set(O,i.get(O)+1):i.set(O,1))}return a(m(i))});else return a([])})})}e.collectLaunchConfigs=c;let r=class{constructor(i){this.telemetryService=i}formatMachineInfo(i){const o=[];return o.push(`OS Version:       ${i.os}`),o.push(`CPUs:             ${i.cpus}`),o.push(`Memory (System):  ${i.memory}`),o.push(`VM:               ${i.vmHint}`),o.join(`
`)}formatEnvironment(i){const o=[];o.push(`Version:          ${n.default.nameShort} ${n.default.version} (${n.default.commit||"Commit unknown"}, ${n.default.date||"Date unknown"})`),o.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const a=S.cpus();return a&&a.length>0&&o.push(`CPUs:             ${a[0].model} (${a.length} x ${a[0].speed})`),o.push(`Memory (System):  ${(S.totalmem()/v.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/v.ByteSize.GB).toFixed(2)}GB free)`),D.isWindows||o.push(`Load (avg):       ${S.loadavg().map(s=>Math.round(s)).join(", ")}`),o.push(`VM:               ${Math.round(d.virtualMachineHint.value()*100)}%`),o.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${i.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(i,o){return Promise.all([h.listProcesses(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async a=>{let[s,g]=a,C=this.formatProcessList(i,s);return o.forEach(R=>{if(P.isRemoteDiagnosticError(R))C+=`
${R.errorMessage}`,g+=`
${R.errorMessage}`;else if(C+=`

Remote: ${R.hostName}`,R.processes&&(C+=`
${this.formatProcessList(i,R.processes)}`),R.workspaceMetadata){g+=`
|  Remote: ${R.hostName}`;for(const p of Object.keys(R.workspaceMetadata)){const f=R.workspaceMetadata[p];let T=`${f.fileCount} files`;f.maxFilesReached&&(T=`more than ${T}`),g+=`|    Folder (${p}): ${T}`,g+=this.formatWorkspaceStats(f)}}}),{processInfo:C,workspaceInfo:g}})}async getSystemInfo(i,o){const{memory:a,vmHint:s,os:g,cpus:C}=l(),R={os:g,memory:a,cpus:C,vmHint:s,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:o};return D.isWindows||(R.load=`${S.loadavg().map(p=>Math.round(p)).join(", ")}`),D.isLinux&&(R.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(R)}async getDiagnostics(i,o){const a=[];return h.listProcesses(i.mainPID).then(async s=>(a.push(""),a.push(this.formatEnvironment(i)),a.push(""),a.push(this.formatProcessList(i,s)),i.windows.some(g=>g.folderURIs&&g.folderURIs.length>0&&!g.remoteAuthority)&&(a.push(""),a.push("Workspace Stats: "),a.push(await this.formatWorkspaceMetadata(i))),o.forEach(g=>{if(P.isRemoteDiagnosticError(g))a.push(`
${g.errorMessage}`);else if(a.push(`

`),a.push(`Remote:           ${g.hostName}`),a.push(this.formatMachineInfo(g.machineInfo)),g.processes&&a.push(this.formatProcessList(i,g.processes)),g.workspaceMetadata)for(const C of Object.keys(g.workspaceMetadata)){const R=g.workspaceMetadata[C];let p=`${R.fileCount} files`;R.maxFilesReached&&(p=`more than ${p}`),a.push(`Folder (${C}): ${p}`),a.push(this.formatWorkspaceStats(R))}}),a.push(""),a.push(""),a.join(`
`)))}formatWorkspaceStats(i){const o=[],a=60;let s=0;const g=(f,T)=>{const O=` ${f}(${T})`;s+O.length>a?(o.push(C),C="|                 ",s=C.length):s+=O.length,C+=O};let C="|      File types:";const R=10;let p=i.fileTypes.length>R?R:i.fileTypes.length;for(let f=0;f<p;f++){const T=i.fileTypes[f];g(T.name,T.count)}if(o.push(C),i.configFiles.length>=0&&(C="|      Conf files:",s=0,i.configFiles.forEach(f=>{g(f.name,f.count)}),o.push(C)),i.launchConfigFiles.length>0){let f="|      Launch Configs:";i.launchConfigFiles.forEach(T=>{f+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),o.push(f)}return o.join(`
`)}expandGPUFeatures(i){const o=Math.max(...Object.keys(i).map(a=>a.length));return Object.keys(i).map(a=>`${a}:  ${" ".repeat(o-a.length)}  ${i[a]}`).join(`
                  `)}formatWorkspaceMetadata(i){const o=[],a=[];return i.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(o.push(`|  Window (${s.title})`),s.folderURIs.forEach(g=>{const C=b.URI.revive(g);if(C.scheme===u.Schemas.file){const R=C.fsPath;a.push(w(R,["node_modules",".git"]).then(p=>{let f=`${p.fileCount} files`;p.maxFilesReached&&(f=`more than ${f}`),o.push(`|    Folder (${k.basename(R)}): ${f}`),o.push(this.formatWorkspaceStats(p))}).catch(p=>{o.push(`|      Error: Unable to collect workspace stats for folder ${R} (${p.toString()})`)}))}else o.push(`|    Folder (${C.toString()}): Workspace stats not available.`)}))}),Promise.all(a).then(s=>o.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(i,o){const a=new Map;i.windows.forEach(g=>a.set(g.pid,g.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),o&&this.formatProcessItem(i.mainPID,a,s,o,0),s.join(`
`)}formatProcessItem(i,o,a,s,g){const C=g===0;let R;C?R=s.pid===i?`${n.default.applicationName} main`:"remote agent":(R=`${"  ".repeat(g)} ${s.name}`,s.name==="window"&&(R=`${R} (${o.get(s.pid)})`));const p=process.platform==="win32"?s.mem:S.totalmem()*(s.mem/100);a.push(`${s.load.toFixed(0).padStart(5," ")}	${(p/v.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${R}`),Array.isArray(s.children)&&s.children.forEach(f=>this.formatProcessItem(i,o,a,f,g+1))}async reportWorkspaceStats(i){for(const{uri:o}of i.folders){const a=b.URI.revive(o);if(a.scheme===u.Schemas.file){const s=a.fsPath;try{const g=await w(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),g.fileTypes.forEach(C=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:C.name,count:C.count})}),g.launchConfigFiles.forEach(C=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:C.name,count:C.count})}),g.configFiles.forEach(C=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:C.name,count:C.count})})}catch(g){}}}}};r=Oe([Ge(0,I.ITelemetryService)],r),e.DiagnosticsService=r}),define(fe[93],he([0,1,12,30,33,19,43,62,57,29,27,17,24,3,50,194,193,7,21]),function(Q,e,S,d,P,y,k,L,h,n,D,b,I,E,u,v,_,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var l;(function(F){F[F.None=0]="None",F[F.IncludeVersions=1]="IncludeVersions",F[F.IncludeFiles=2]="IncludeFiles",F[F.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",F[F.IncludeSharedAccounts=8]="IncludeSharedAccounts",F[F.IncludeVersionProperties=16]="IncludeVersionProperties",F[F.ExcludeNonValidated=32]="ExcludeNonValidated",F[F.IncludeInstallationTargets=64]="IncludeInstallationTargets",F[F.IncludeAssetUri=128]="IncludeAssetUri",F[F.IncludeStatistics=256]="IncludeStatistics",F[F.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",F[F.Unpublished=4096]="Unpublished"})(l||(l={}));function c(...F){return String(F.reduce((A,M)=>A|M,0))}var r;(function(F){F[F.Tag=1]="Tag",F[F.ExtensionId=4]="ExtensionId",F[F.Category=5]="Category",F[F.ExtensionName=7]="ExtensionName",F[F.Target=8]="Target",F[F.Featured=9]="Featured",F[F.SearchText=10]="SearchText",F[F.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:l.None,criteria:[],assetTypes:[]};class s{constructor(A=a){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,M=this.state.pageSize){return new s(Object.assign(Object.assign({},this.state),{pageNumber:A,pageSize:M}))}withFilter(A,...M){const U=[...this.state.criteria,...M.length?M.map(W=>({filterType:A,value:W})):[{filterType:A}]];return new s(Object.assign(Object.assign({},this.state),{criteria:U}))}withSortBy(A){return new s(Object.assign(Object.assign({},this.state),{sortBy:A}))}withSortOrder(A){return new s(Object.assign(Object.assign({},this.state),{sortOrder:A}))}withFlags(...A){return new s(Object.assign(Object.assign({},this.state),{flags:A.reduce((M,U)=>M|U,0)}))}withAssetTypes(...A){return new s(Object.assign(Object.assign({},this.state),{assetTypes:A}))}get raw(){const{criteria:A,pageNumber:M,pageSize:U,sortBy:W,sortOrder:ne,flags:ae,assetTypes:ce}=this.state;return{filters:[{criteria:A,pageNumber:M,pageSize:U,sortBy:W,sortOrder:ne}],assetTypes:ce,flags:ae}}get searchText(){const A=this.state.criteria.filter(M=>M.filterType===r.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function g(F,A){const M=(F||[]).filter(U=>U.statisticName===A)[0];return M?M.value:0}function C(F){const A="Microsoft.VisualStudio.Code.Translation.";return F.files.filter(U=>U.assetType.indexOf(A)===0).reduce((U,W)=>{const ne=T(F,W.assetType);return ne&&U.push([W.assetType.substring(A.length),ne]),U},[])}function R(F){if(F.properties){const A=F.properties.filter(W=>W.key===t.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),U=A.filter(W=>M.test(W.value))[0];return U?{uri:U.value,fallbackUri:U.value}:null}return T(F,t.Repository)}function p(F){return{uri:`${F.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${F.fallbackAssetUri}/${t.VSIX}`}}function f(F){const A=T(F,t.Icon);if(A)return A;const M=d.DefaultIconPath;return{uri:M,fallbackUri:M}}function T(F,A){return F.files.filter(U=>U.assetType===A)[0]?{uri:`${F.assetUri}/${A}`,fallbackUri:`${F.fallbackAssetUri}/${A}`}:null}function O(F,A){const M=F.properties?F.properties.filter(W=>W.key===A):[],U=M.length>0&&M[0].value;return U?U.split(",").map(W=>P.adoptToGalleryExtensionId(W)):[]}function H(F){const A=F.properties?F.properties.filter(M=>M.key===i.Engine):[];return A.length>0&&A[0].value||""}function $(F){const A=F.properties?F.properties.filter(U=>U.key===i.LocalizedLanguages):[],M=A.length>0&&A[0].value||"";return M?M.split(","):[]}function x(F){return F.indexOf("preview")!==-1}function J(F){const A=F.properties?F.properties.find(M=>M.key===i.WebExtension):void 0;return!!A&&A.value==="true"}function Ee(F){return F.files.some(A=>A.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?m.joinPath(E.URI.parse(F.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function ve(F,A,M,U,W){const ne={manifest:T(A,t.Manifest),readme:T(A,t.Details),changelog:T(A,t.Changelog),license:T(A,t.License),repository:R(A),download:p(A),icon:f(A),coreTranslations:C(A)};return{identifier:{id:P.getGalleryExtensionId(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},name:F.extensionName,version:A.version,date:A.lastUpdated,displayName:F.displayName,publisherId:F.publisher.publisherId,publisher:F.publisher.publisherName,publisherDisplayName:F.publisher.displayName,description:F.shortDescription||"",installCount:g(F.statistics,"install"),rating:g(F.statistics,"averagerating"),ratingCount:g(F.statistics,"ratingcount"),assetUri:E.URI.parse(A.assetUri),webResource:Ee(A),assetTypes:A.files.map(({assetType:ae})=>ae),assets:ne,properties:{dependencies:O(A,i.Dependency),extensionPack:O(A,i.ExtensionPack),engine:H(A),localizedLanguages:$(A),webExtension:J(A)},telemetryData:{index:(U.pageNumber-1)*U.pageSize+M,searchText:U.searchText,querySource:W},preview:x(F.flags)}}let q=class{constructor(A,M,U,W,ne,ae,ce){this.requestService=A,this.logService=M,this.environmentService=U,this.telemetryService=W,this.fileService=ne,this.productService=ae;const de=ae.extensionsGallery;this.extensionsGalleryUrl=de&&de.serviceUrl,this.extensionsControlUrl=de&&de.controlUrl,this.commonHeadersPromise=j(ae.version,this.environmentService,this.fileService,ce)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,M){const U=[];let{total:W,firstPage:ne,getPage:ae}=await this.query({names:A,pageSize:A.length},M);U.push(...ne);for(let ce=1;U.length<W&&(ne=await ae(ce,M),ne.length);ce++)U.push(...ne);return U}async getCompatibleExtension(A,M){const U=await this.getCompatibleExtensionByEngine(A,M);return(U==null?void 0:U.properties.webExtension)?U.webResource?U:null:U}async getCompatibleExtensionByEngine(A,M){const U=d.isIExtensionIdentifier(A)?null:A;if(U&&U.properties.engine&&h.isEngineValid(U.properties.engine,this.productService.version))return U;const{id:W,uuid:ne}=U?U.identifier:A;let ae=new s().withFlags(l.IncludeAssetUri,l.IncludeStatistics,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");ne?ae=ae.withFilter(r.ExtensionId,ne):ae=ae.withFilter(r.ExtensionName,W);const{galleryExtensions:ce}=await this.queryGallery(ae,D.CancellationToken.None),[de]=ce;if(!de||!de.versions.length)return null;if(M){const Te=de.versions.filter(Me=>Me.version===M)[0];if(Te){const Me=ve(de,Te,0,ae);if(Me.properties.engine&&h.isEngineValid(Me.properties.engine,this.productService.version))return Me}return null}const Pe=await this.getLastValidExtensionVersion(de,de.versions);return Pe?ve(de,Pe,0,ae):null}async query(A,M){const U=D.CancellationToken.isCancellationToken(A)?{}:A,W=D.CancellationToken.isCancellationToken(A)?A:M;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ne=U.text||"";const ae=y.getOrDefault(U,je=>je.pageSize,50);let ce=new s().withFlags(l.IncludeLatestVersionOnly,l.IncludeAssetUri,l.IncludeStatistics,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,ae).withFilter(r.Target,"Microsoft.VisualStudio.Code");ne?(ne=ne.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(je,$e,Ye)=>(ce=ce.withFilter(r.Category,Ye||$e),"")),ne=ne.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(je,$e,Ye)=>(ce=ce.withFilter(r.Tag,Ye||$e),"")),ne=ne.replace(/\bfeatured(\s+|\b|$)/g,()=>(ce=ce.withFilter(r.Featured),"")),ne=ne.trim(),ne&&(ne=ne.length<200?ne:ne.substring(0,200),ce=ce.withFilter(r.SearchText,ne)),ce=ce.withSortBy(0)):U.ids?ce=ce.withFilter(r.ExtensionId,...U.ids):U.names?ce=ce.withFilter(r.ExtensionName,...U.names):ce=ce.withSortBy(4),typeof U.sortBy=="number"&&(ce=ce.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(ce=ce.withSortOrder(U.sortOrder));const{galleryExtensions:de,total:Pe}=await this.queryGallery(ce,W),Te=de.map((je,$e)=>ve(je,je.versions[0],$e,ce,U.source)),Me=async(je,$e)=>{if($e.isCancellationRequested)throw S.canceled();const Ye=ce.withPage(je+1),{galleryExtensions:et}=await this.queryGallery(Ye,$e);return et.map((Je,we)=>ve(Je,Je.versions[0],we,Ye,U.source))};return{firstPage:Te,total:Pe,pageSize:ce.pageSize,getPage:Me}}async queryGallery(A,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,l.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,c(l.Unpublished));const U=await this.commonHeadersPromise,W=JSON.stringify(A.raw),ne=Object.assign(Object.assign({},U),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(W.length)}),ae=new Date().getTime();let ce,de,Pe=0;try{if(ce=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:W,headers:ne},M),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:Pe};const Te=await L.asJson(ce);if(Te){const Me=Te.results[0],je=Me.extensions,$e=Me.resultMetadata&&Me.resultMetadata.filter(Ye=>Ye.metadataType==="ResultCount")[0];return Pe=$e&&$e.metadataItems.filter(Ye=>Ye.name==="TotalCount")[0].count||0,{galleryExtensions:je,total:Pe}}return{galleryExtensions:[],total:Pe}}catch(Te){throw de=Te,Te}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},A.telemetryData),{requestBodySize:String(W.length),duration:new Date().getTime()-ae,success:!!ce&&L.isSuccess(ce),responseBodySize:ce==null?void 0:ce.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:de?S.isPromiseCanceledError(de)?"canceled":S.getErrorMessage(de).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Pe)}))}}async reportStatistic(A,M,U,W){if(!!this.isEnabled()){const ne=await this.commonHeadersPromise,ae=Object.assign(Object.assign({},ne),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${A}/extensions/${M}/${U}/stats?statType=${W}`),headers:ae},D.CancellationToken.None)}catch(ce){}}}async download(A,M,U){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const W=P.getGalleryExtensionTelemetryData(A),ne=new Date().getTime(),ae=Te=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},W),{duration:Te})),ce=U===1?"install":U===2?"update":"",de=ce?{uri:`${A.assets.download.uri}&${ce}=true`,fallbackUri:`${A.assets.download.fallbackUri}?${ce}=true`}:A.assets.download,Pe=await this.getAsset(de);await this.fileService.writeFile(M,Pe.stream),ae(new Date().getTime()-ne)}async getReadme(A,M){if(A.assets.readme){const U=await this.getAsset(A.assets.readme,{},M);return await L.asText(U)||""}return""}async getManifest(A,M){if(A.assets.manifest){const U=await this.getAsset(A.assets.manifest,{},M),W=await L.asText(U);return W?JSON.parse(W):null}return null}async getCoreTranslation(A,M){const U=A.assets.coreTranslations.filter(W=>W[0]===M.toUpperCase())[0];if(U){const W=await this.getAsset(U[1]),ne=await L.asText(W);return ne?JSON.parse(ne):null}return null}async getChangelog(A,M){if(A.assets.changelog){const U=await this.getAsset(A.assets.changelog,{},M);return await L.asText(U)||""}return""}async getAllVersions(A,M){let U=new s().withFlags(l.IncludeVersions,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");A.identifier.uuid?U=U.withFilter(r.ExtensionId,A.identifier.uuid):U=U.withFilter(r.ExtensionName,A.identifier.id);const W=[],{galleryExtensions:ne}=await this.queryGallery(U,D.CancellationToken.None);return ne.length&&(M?await Promise.all(ne[0].versions.map(async ae=>{let ce;try{ce=await this.getEngine(ae)}catch(de){}ce&&h.isEngineValid(ce,this.productService.version)&&W.push({version:ae.version,date:ae.lastUpdated})})):W.push(...ne[0].versions.map(ae=>({version:ae.version,date:ae.lastUpdated})))),W}async getAsset(A,M={},U=D.CancellationToken.None){const W=await this.commonHeadersPromise,ne={type:"GET"},ae=Object.assign(Object.assign({},W),M.headers||{});M=Object.assign(Object.assign(Object.assign({},M),ne),{headers:ae});const ce=A.uri,de=A.fallbackUri,Pe=Object.assign(Object.assign({},M),{url:ce});try{const Te=await this.requestService.request(Pe,U);if(Te.res.statusCode===200)return Te;const Me=await L.asText(Te);throw new Error(`Expected 200, got back ${Te.res.statusCode} instead.

${Me}`)}catch(Te){if(S.isPromiseCanceledError(Te))throw Te;const Me=S.getErrorMessage(Te);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ce,message:Me});const je=Object.assign(Object.assign({},M),{url:de});return this.requestService.request(je,U)}}async getLastValidExtensionVersion(A,M){const U=this.getLastValidExtensionVersionFromProperties(A,M);return U||this.getLastValidExtensionVersionRecursively(A,M)}getLastValidExtensionVersionFromProperties(A,M){for(const U of M){const W=H(U);if(!W)return null;if(h.isEngineValid(W,this.productService.version))return U}return null}async getEngine(A){const M=H(A);if(M)return M;const U=T(A,t.Manifest);if(!U)throw new Error("Manifest was not found");const W={"Accept-Encoding":"gzip"},ne=await this.getAsset(U,{headers:W}),ae=await L.asJson(ne);if(ae)return ae.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(A,M){if(!M.length)return null;const U=M[0],W=await this.getEngine(U);return h.isEngineValid(W,this.productService.version)?(U.properties=U.properties||[],U.properties.push({key:i.Engine,value:W}),U):this.getLastValidExtensionVersionRecursively(A,M.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},D.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await L.asJson(A),U=new Map;if(M)for(const W of M.malicious){const ne=U.get(W)||{id:{id:W},malicious:!0,slow:!1};ne.malicious=!0,U.set(W,ne)}return[...U.values()]}};q=Oe([Ge(0,L.IRequestService),Ge(1,b.ILogService),Ge(2,n.IEnvironmentService),Ge(3,k.ITelemetryService),Ge(4,I.IFileService),Ge(5,u.IProductService),Ge(6,w.optional(v.IStorageService))],q),e.ExtensionGalleryService=q;async function j(F,A,M,U){const W={"X-Market-Client-Id":`VSCode ${F}`,"User-Agent":`VSCode ${F}`},ne=await _.getServiceMachineId(A,M,U);return W["X-Market-User-Id"]=ne,W}e.resolveMarketplaceHeaders=j}),define(fe[198],he([0,1,26,153,14,7,34,42,4,19,31]),function(Q,e,S,d,P,y,k,L,h,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let b=class{constructor(u,v){this._configurationService=v,this._experimentProperties={},this._disposables=new h.DisposableStore,this._cleanupPatterns=[],this._appender=u.appender,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let _ of this._piiPaths)this._cleanupPatterns.push(new RegExp(P.escapeRegExpCharacters(_),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(_=>{const w=/^[a-f0-9]+$/i.test(_["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!w})}))}setExperimentProperty(u,v){this._experimentProperties[u]=v}setEnabled(u){this._enabled=u}_updateUserOptIn(){var u;const v=(u=this._configurationService)===null||u===void 0?void 0:u.getValue(I);this._userOptIn=v?v.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const u=await this._commonProperties;let v=u.sessionID,_=u["common.instanceId"],w=u["common.machineId"],m=u["common.firstSessionDate"],l=u["common.msftInternal"];return{sessionId:v,instanceId:_,machineId:w,firstSessionDate:m,msftInternal:l}}dispose(){this._disposables.dispose()}publicLog(u,v,_){return this.isOptedIn?this._commonProperties.then(w=>{v=n.mixin(v,w),v=n.mixin(v,this._experimentProperties),v=n.cloneAndChange(v,m=>{if(typeof m=="string")return this._cleanupInfo(m,_)}),this._appender.log(u,v)},w=>{console.error(w)}):Promise.resolve(void 0)}publicLog2(u,v,_){return this.publicLog(u,v,_)}publicLogError(u,v){return this.sendErrorTelemetry?this.publicLog(u,v,!0):Promise.resolve(void 0)}publicLogError2(u,v){return this.publicLogError(u,v)}_cleanupInfo(u,v){let _=u;if(v){const w=[];for(let r of this._cleanupPatterns)for(;;){const t=r.exec(u);if(!t)break;w.push([t.index,r.lastIndex])}const m=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(_="";;){const r=l.exec(u);if(!r)break;!m.test(r[0])&&w.every(([t,i])=>r.index<t||r.index>=i)&&(_+=u.substring(c,r.index)+"<REDACTED: user-file-path>",c=l.lastIndex)}c<u.length&&(_+=u.substr(c))}for(let w of this._cleanupPatterns)_=_.replace(w,"");return _}};b.IDLE_START_EVENT_NAME="UserIdleStart",b.IDLE_STOP_EVENT_NAME="UserIdleStop",b=Oe([Ge(1,y.optional(k.IConfigurationService))],b),e.TelemetryService=b;const I="telemetry";D.Registry.as(L.Extensions.Configuration).registerConfiguration({id:I,order:110,type:"object",title:d.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:S.default.privacyStatementUrl?d.localize(2,null,S.default.privacyStatementUrl):d.localize(1,null),default:!0,tags:["usesOnlineServices"]}}})}),define(fe[64],he([0,1,34,19,11,13]),function(Q,e,S,d,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(E,u){return Promise.resolve(void 0)}publicLog2(E,u){return this.publicLog(E,u)}publicLogError(E,u){return Promise.resolve(void 0)}publicLogError2(E,u){return this.publicLogError(E,u)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};function k(...E){return{log:(u,v)=>E.forEach(_=>_.log(u,v)),flush:()=>y.Promises.settled(E.map(u=>u.flush()))}}e.combinedAppender=k,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function L(E,u){return u.onDidChangeConfiguration(v=>{v.source!==6&&E.publicLog2("updateConfiguration",{configurationSource:S.ConfigurationTargetToString(v.source),configurationKeys:b(v.sourceConfig)})})}e.configurationTelemetry=L;function h(E){const u=Object.create(null),v=Object.create(null),_=Object.create(null);D(E,_);for(let w in _){w=w.length>150?w.substr(w.length-149):w;const m=_[w];typeof m=="number"?v[w]=m:typeof m=="boolean"?v[w]=m?1:0:typeof m=="string"?u[w]=m.substring(0,1023):typeof m!="undefined"&&m!==null&&(u[w]=m)}return{properties:u,measurements:v}}e.validateTelemetryData=h;function n(E){if(!E)return"none";let u="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(_=>{E.indexOf(`${_}+`)===0&&(u=_)}),u}e.cleanRemoteAuthority=n;function D(E,u,v=0,_){if(!!E)for(let w of Object.getOwnPropertyNames(E)){const m=E[w],l=_?_+w:w;Array.isArray(m)?u[l]=d.safeStringify(m):m instanceof Date?u[l]=m.toISOString():P.isObject(m)?v<2?D(m,u,v+1,l+"."):u[l]=d.safeStringify(m):u[l]=m}}function b(E){if(!E)return[];const u=[];return I(u,"",E),u}function I(E,u,v){v&&typeof v=="object"&&!Array.isArray(v)?Object.keys(v).forEach(_=>I(E,u?`${u}.${_}`:_,v[_])):E.push(u)}}),define(fe[199],he([0,1,12,19,64]),function(Q,e,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function y(L){const h=await new Promise((D,b)=>{Q(["applicationinsights"],D,b)});let n;return h.defaultClient?(n=new h.TelemetryClient(L),n.channel.setUseDiskRetryCaching(!0)):(h.setup(L).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),n=h.defaultClient),L.indexOf("AIF-")===0&&(n.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),n}class k{constructor(h,n,D){this._eventPrefix=h,this._defaultData=n,this._defaultData||(this._defaultData=Object.create(null)),typeof D=="function"?this._aiClient=D():this._aiClient=D,this._asyncAIClient=null}_withAIClient(h){if(!!this._aiClient){if(typeof this._aiClient!="string"){h(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=y(this._aiClient)),this._asyncAIClient.then(n=>{h(n)},n=>{S.onUnexpectedError(n),console.error(n)})}}log(h,n){!this._aiClient||(n=d.mixin(n,this._defaultData),n=P.validateTelemetryData(n),this._withAIClient(D=>D.trackEvent({name:this._eventPrefix+"/"+h,properties:n.properties,measurements:n.measurements})))}flush(){return this._aiClient?new Promise(h=>{this._withAIClient(n=>{n.flush({callback:()=>{this._aiClient=void 0,h(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=k}),define(fe[200],he([0,1,12,196]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class P extends d.default{installErrorListeners(){S.setUnexpectedErrorHandler(L=>console.error(L));const k=[];process.on("unhandledRejection",(L,h)=>{k.push(h),setTimeout(()=>{const n=k.indexOf(h);n>=0&&h.catch(D=>{k.splice(n,1),console.warn(`rejected promise not handled within 1 second: ${D}`),D.stack&&console.warn(`stack trace: ${D.stack}`),S.onUnexpectedError(L)})},1e3)}),process.on("rejectionHandled",L=>{const h=k.indexOf(L);h>=0&&k.splice(h,1)}),process.on("uncaughtException",L=>{S.onUnexpectedError(L)})}}e.default=P}),define(fe[201],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class S{constructor(P){this._callback=P,this._terminalBufferMap=new Map}dispose(){for(const P of this._terminalBufferMap.values())P.dispose()}startBuffering(P,y,k=5){let L;return L=y(h=>{const n=typeof h=="string"?h:h.data;let D=this._terminalBufferMap.get(P);if(D){D.data.push(n);return}const b=setTimeout(()=>this._flushBuffer(P),k);D={data:[n],timeoutId:b,dispose:()=>{clearTimeout(b),this._flushBuffer(P),L.dispose()}},this._terminalBufferMap.set(P,D)}),L}stopBuffering(P){const y=this._terminalBufferMap.get(P);y&&y.dispose()}_flushBuffer(P){const y=this._terminalBufferMap.get(P);y&&(this._terminalBufferMap.delete(P),this._callback(P,y.data.join("")))}}e.TerminalDataBufferer=S}),define(fe[202],he([0,1,22,2,20,11,19,5]),function(Q,e,S,d,P,y,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function h(){const D=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());let b=0;return D&&D.length===4&&(b=parseInt(D[3])),b}e.getWindowsBuildNumber=h;async function n(D,b,I,E=process.env){if(d.isAbsolute(D))return await P.exists(D)?D:void 0;if(b===void 0&&(b=process.cwd()),d.dirname(D)!=="."){const w=d.join(b,D);return await P.exists(w)?w:void 0}const v=k.getCaseInsensitive(E,"PATH");if(I===void 0&&y.isString(v)&&(I=v.split(d.delimiter)),I===void 0||I.length===0){const w=d.join(b,D);return await P.exists(w)?w:void 0}for(let w of I){let m;if(d.isAbsolute(w)?m=d.join(w,D):m=d.join(b,w,D),await P.exists(m))return m;if(L.isWindows){let l=m+".com";if(await P.exists(l)||(l=m+".exe",await P.exists(l)))return l}}const _=d.join(b,D);return await P.exists(_)?_:void 0}e.findExecutable=n}),define(fe[203],he([0,1,2,5,15,22,6,4,32,17,202,3,154]),function(Q,e,S,d,P,y,k,L,h,n,D,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalProcess=void 0;const E=50,u=5;let v=class extends L.Disposable{constructor(m,l,c,r,t,i,o,a){var s;super();this._shellLaunchConfig=m,this._executableEnv=i,this._logService=a,this.id=0,this.shouldPersist=!1,this._currentTitle="",this._isDisposed=!1,this._titleInterval=null,this._writeQueue=[],this._isPtyPaused=!1,this._unacknowledgedCharCount=0,this._onProcessData=this._register(new k.Emitter),this._onProcessExit=this._register(new k.Emitter),this._onProcessReady=this._register(new k.Emitter),this._onProcessTitleChanged=this._register(new k.Emitter);let g;d.isWindows?g=S.basename(this._shellLaunchConfig.executable||""):g="xterm-256color",this._initialCwd=l;const C=o&&process.platform==="win32"&&D.getWindowsBuildNumber()>=18309;this._ptyOptions={name:g,cwd:l,env:t,cols:c,rows:r,useConpty:C,conptyInheritCursor:C&&!!m.initialText},d.isWindows&&C&&c===0&&r===0&&((s=this._shellLaunchConfig.executable)===null||s===void 0?void 0:s.endsWith("Git\\bin\\bash.exe"))&&(this._delayedResizer=new _,this._register(this._delayedResizer.onTrigger(R=>{var p;(p=this._delayedResizer)===null||p===void 0||p.dispose(),this._delayedResizer=void 0,R.cols&&R.rows&&this.resize(R.cols,R.rows)})))}get exitMessage(){return this._exitMessage}get currentTitle(){return this._currentTitle}get onProcessData(){return this._onProcessData.event}get onProcessExit(){return this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}get onProcessTitleChanged(){return this._onProcessTitleChanged.event}async start(){const l=(await Promise.all([this._validateCwd(),this._validateExecutable()])).find(c=>c!==void 0);if(l)return l;try{await this.setupPtyProcess(this._shellLaunchConfig,this._ptyOptions);return}catch(c){return this._logService.trace("IPty#spawn native exception",c),{message:`A native exception occurred during launch (${c.message})`}}}async _validateCwd(){try{if(!(await P.promises.stat(this._initialCwd)).isDirectory())return{message:I.localize(0,null,this._initialCwd.toString())}}catch(m){if((m==null?void 0:m.code)==="ENOENT")return{message:I.localize(1,null,this._initialCwd.toString())}}}async _validateExecutable(){const m=this._shellLaunchConfig;if(!m.executable)throw new Error("IShellLaunchConfig.executable not set");try{const l=await P.promises.stat(m.executable);if(!l.isFile()&&!l.isSymbolicLink())return{message:I.localize(2,null,m.executable)}}catch(l){if((l==null?void 0:l.code)==="ENOENT"){let c=m.cwd instanceof b.URI?m.cwd.path:m.cwd;const r=m.env&&m.env.PATH?m.env.PATH.split(S.delimiter):void 0;if(!await D.findExecutable(m.executable,c,r,this._executableEnv))return{message:I.localize(3,null,m.executable)}}}}async setupPtyProcess(m,l){const c=m.args||[];this._logService.trace("IPty#spawn",m.executable,c,l);const r=(await new Promise((t,i)=>{Q(["node-pty"],t,i)})).spawn(m.executable,c,l);this._ptyProcess=r,this._processStartupComplete=new Promise(t=>{this.onProcessReady(()=>t())}),r.onData(t=>{this._shellLaunchConfig.flowControl&&(this._unacknowledgedCharCount+=t.length,!this._isPtyPaused&&this._unacknowledgedCharCount>1e5&&(this._logService.trace(`Flow control: Pause (${this._unacknowledgedCharCount} > ${1e5})`),this._isPtyPaused=!0,r.pause())),this._onProcessData.fire(t),this._closeTimeout&&(clearTimeout(this._closeTimeout),this._queueProcessExit())}),r.onExit(t=>{this._exitCode=t.exitCode,this._queueProcessExit()}),this._setupTitlePolling(r),this._sendProcessId(r.pid)}dispose(){this._isDisposed=!0,this._titleInterval&&clearInterval(this._titleInterval),this._titleInterval=null,this._onProcessData.dispose(),this._onProcessExit.dispose(),this._onProcessReady.dispose(),this._onProcessTitleChanged.dispose(),super.dispose()}_setupTitlePolling(m){setTimeout(()=>this._sendProcessTitle(m),0),d.isWindows||(this._titleInterval=setInterval(()=>{this._currentTitle!==m.process&&this._sendProcessTitle(m)},200))}_queueProcessExit(){this._closeTimeout&&clearTimeout(this._closeTimeout),this._closeTimeout=setTimeout(()=>this._kill(),250)}async _kill(){if(await this._processStartupComplete,!this._isDisposed){try{this._ptyProcess&&(this._logService.trace("IPty#kill"),this._ptyProcess.kill())}catch(m){}this._onProcessExit.fire(this._exitCode||0),this.dispose()}}_sendProcessId(m){this._onProcessReady.fire({pid:m,cwd:this._initialCwd})}_sendProcessTitle(m){this._isDisposed||(this._currentTitle=m.process,this._onProcessTitleChanged.fire(this._currentTitle))}shutdown(m){m?this._kill():this._queueProcessExit()}input(m){if(!(this._isDisposed||!this._ptyProcess)){for(let l=0;l<=Math.floor(m.length/E);l++)this._writeQueue.push(m.substr(l*E,E));this._startWrite()}}_startWrite(){if(!(this._writeTimeout!==void 0||this._writeQueue.length===0)){if(this._doWrite(),this._writeQueue.length===0){this._writeTimeout=void 0;return}this._writeTimeout=setTimeout(()=>{this._writeTimeout=void 0,this._startWrite()},u)}}_doWrite(){const m=this._writeQueue.shift();this._logService.trace("IPty#write",`${m.length} characters`),this._ptyProcess.write(m)}resize(m,l){if(!this._isDisposed&&!(typeof m!="number"||typeof l!="number"||isNaN(m)||isNaN(l))&&this._ptyProcess){if(m=Math.max(m,1),l=Math.max(l,1),this._delayedResizer){this._delayedResizer.cols=m,this._delayedResizer.rows=l;return}this._logService.trace("IPty#resize",m,l);try{this._ptyProcess.resize(m,l)}catch(c){if(this._logService.trace("IPty#resize exception "+c.message),this._exitCode!==void 0&&c.message!=="ioctl(2) failed, EBADF")throw c}}}acknowledgeDataEvent(m){var l;!this._shellLaunchConfig.flowControl||(this._unacknowledgedCharCount=Math.max(this._unacknowledgedCharCount-m,0),this._logService.trace(`Flow control: Ack ${m} chars (unacknowledged: ${this._unacknowledgedCharCount})`),this._isPtyPaused&&this._unacknowledgedCharCount<5e3&&(this._logService.trace(`Flow control: Resume (${this._unacknowledgedCharCount} < ${5e3})`),(l=this._ptyProcess)===null||l===void 0||l.resume(),this._isPtyPaused=!1))}clearUnacknowledgedChars(){var m;!this._shellLaunchConfig.flowControl||(this._unacknowledgedCharCount=0,this._logService.trace("Flow control: Cleared all unacknowledged chars, forcing resume"),this._isPtyPaused&&((m=this._ptyProcess)===null||m===void 0||m.resume(),this._isPtyPaused=!1))}getInitialCwd(){return Promise.resolve(this._initialCwd)}getCwd(){if(d.isMacintosh){const m=y.release().split(".");if(m.length>0&&parseInt(m[0])<20)return new Promise(l=>{if(!this._ptyProcess){l(this._initialCwd);return}this._logService.trace("IPty#pid"),h.exec("lsof -OPln -p "+this._ptyProcess.pid+" | grep cwd",(c,r,t)=>{!c&&r!==""?l(r.substring(r.indexOf("/"),r.length-1)):(this._logService.error("lsof did not run successfully, it may not be on the $PATH?",c,r,t),l(this._initialCwd))})})}return d.isLinux?new Promise(m=>{if(!this._ptyProcess){m(this._initialCwd);return}this._logService.trace("IPty#pid"),P.readlink("/proc/"+this._ptyProcess.pid+"/cwd",(l,c)=>{l&&m(this._initialCwd),m(c)})}):new Promise(m=>{m(this._initialCwd)})}getLatency(){return Promise.resolve(0)}};v=Oe([Ge(7,n.ILogService)],v),e.TerminalProcess=v;class _ extends L.Disposable{constructor(){super();this._onTrigger=this._register(new k.Emitter),this._timeout=setTimeout(()=>{this._onTrigger.fire({rows:this.rows,cols:this.cols})},1e3),this._register({dispose:()=>{clearTimeout(this._timeout)}})}get onTrigger(){return this._onTrigger.event}dispose(){super.dispose(),clearTimeout(this._timeout)}}}),define(fe[94],he([0,1,3,21,7,25]),function(Q,e,S,d,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=P.createDecorator("contextService");var k;(function(I){I[I.EMPTY=1]="EMPTY",I[I.FOLDER=2]="FOLDER",I[I.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function L(I){const E=I;return!!(E&&typeof E=="object"&&typeof E.id=="string"&&Array.isArray(E.folders))}e.isWorkspace=L;function h(I){const E=I;return!!(E&&typeof E=="object"&&S.URI.isUri(E.uri)&&typeof E.name=="string"&&typeof E.toResource=="function")}e.isWorkspaceFolder=h;class n{constructor(E,u,v,_){this._id=E,this._configuration=v,this._ignorePathCasing=_,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=u}update(E){this._id=E.id,this._configuration=E.configuration,this._ignorePathCasing=E._ignorePathCasing,this.folders=E.folders}get folders(){return this._folders}set folders(E){this._folders=E,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(E){this._configuration=E}getFolder(E){return E&&this._foldersMap.findSubstr(E.with({scheme:E.scheme,authority:E.authority,path:E.path}))||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing);for(const E of this.folders)this._foldersMap.set(E.uri,E)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=n;class D{constructor(E,u){this.raw=u,this.uri=E.uri,this.index=E.index,this.name=E.name}toResource(E){return d.joinPath(this.uri,E)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=D;function b(I){return new D({uri:I,index:0,name:d.basenameOrAuthority(I)},{uri:I.toString()})}e.toWorkspaceFolder=b}),define(fe[204],he([0,1,7,155,94,3,5,2,21,108,35,8,53,28,190]),function(Q,e,S,d,P,y,k,L,h,n,D,b,I,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const v=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:d.localize(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _($){return(typeof $=="string"?L.extname($):h.extname($))===v}e.hasWorkspaceFileExtension=_,e.IWorkspacesService=S.createDecorator("workspacesService");function w($){return $.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function m($){return $.hasOwnProperty("folderUri")}e.isRecentFolder=m;function l($){return $.hasOwnProperty("fileUri")}e.isRecentFile=l;function c($){const x=$;return typeof(x==null?void 0:x.id)=="string"&&y.URI.isUri(x.uri)}e.isSingleFolderWorkspaceIdentifier=c;function r($){if($.configuration)return{id:$.id,configPath:$.configuration};if($.folders.length===1)return{id:$.id,uri:$.folders[0].uri}}e.toWorkspaceIdentifier=r;function t($){const x=$;return typeof(x==null?void 0:x.id)=="string"&&y.URI.isUri(x.configPath)}e.isWorkspaceIdentifier=t;function i($){const x=$;if(x==null?void 0:x.uri)return{id:x.id,uri:y.URI.revive(x.uri)};const J=$;if(J==null?void 0:J.configPath)return{id:J.id,configPath:y.URI.revive(J.configPath)};if($==null?void 0:$.id)return{id:$.id}}e.reviveIdentifier=i;function o($,x){return h.extUriBiasedIgnorePathCase.isEqualOrParent($,x.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function a($){return s($)||g($)}e.isStoredWorkspaceFolder=a;function s($){const x=$;return typeof(x==null?void 0:x.path)=="string"&&(!x.name||typeof x.name=="string")}e.isRawFileWorkspaceFolder=s;function g($){const x=$;return typeof(x==null?void 0:x.uri)=="string"&&(!x.name||typeof x.name=="string")}e.isRawUriWorkspaceFolder=g;function C($,x,J,Ee,ve=!k.isWindows,q){if($.scheme!==Ee.scheme)return{name:J,uri:$.toString(!0)};let j=x?void 0:q.relativePath(Ee,$);if(j!==void 0)j.length===0?j=".":k.isWindows&&$.scheme===b.Schemas.file&&!ve&&(j=j.replace(/\//g,"\\"));else if($.scheme===b.Schemas.file)j=$.fsPath,k.isWindows&&(j=I.normalizeDriveLetter(j),ve&&(j=E.toSlashes(j)));else{if(!q.isEqualAuthority($.authority,Ee.authority))return{name:J,uri:$.toString(!0)};j=$.path}return{name:J,path:j}}e.getStoredWorkspaceFolder=C;function R($,x,J){let Ee=[],ve=new Set;const q=J.dirname(x);for(let j of $){let F=null;if(s(j))j.path&&(F=J.resolvePath(q,j.path));else if(g(j))try{F=y.URI.parse(j.uri),F.path[0]!=="/"&&(F=F.with({path:"/"+F.path}))}catch(A){console.warn(A)}if(F){let A=J.getComparisonKey(F);if(!ve.has(A)){ve.add(A);const M=j.name||J.basenameOrAuthority(F);Ee.push(new P.WorkspaceFolder({uri:F,name:M,index:Ee.length},j))}}}return Ee}e.toWorkspaceFolders=R;function p($,x,J,Ee,ve){let q=f(x,$);const j=ve.dirname(x),F=ve.dirname(Ee),A=[],M=T(q.folders);for(const ae of q.folders){const ce=s(ae)?ve.resolvePath(j,ae.path):y.URI.parse(ae.uri);let de;J?de=!1:de=!s(ae)||L.isAbsolute(ae.path),A.push(C(ce,de,ae.name,F,M,ve))}const U={insertSpaces:!1,tabSize:4,eol:k.isLinux||k.isMacintosh?`
`:`\r
`},W=n.setProperty($,["folders"],A,U);let ne=n.applyEdits($,W);return q.remoteAuthority===u.getRemoteAuthority(Ee)&&(ne=n.applyEdits(ne,n.removeProperty(ne,["remoteAuthority"],U))),ne}e.rewriteWorkspaceFileForNewLocation=p;function f($,x){let J=D.parse(x);if(J&&Array.isArray(J.folders))J.folders=J.folders.filter(Ee=>a(Ee));else throw new Error(`${$} looks like an invalid workspace file.`);return J}function T($){return k.isWindows?$.some(x=>s(x)&&x.path.indexOf("/")>=0):!0}e.useSlashForPath=T;function O($,x){const J={workspaces:[],files:[]};if($){const Ee=function(q,j){for(let F=0;F<q.length;F++)try{j(q[F],F)}catch(A){x.warn(`Error restoring recent entry ${JSON.stringify(q[F])}: ${A.toString()}. Skip entry.`)}},ve=$;Array.isArray(ve.workspaces3)&&Ee(ve.workspaces3,(q,j)=>{const F=Array.isArray(ve.workspaceLabels)&&ve.workspaceLabels[j]||void 0;typeof q=="object"&&typeof q.id=="string"&&typeof q.configURIPath=="string"?J.workspaces.push({label:F,workspace:{id:q.id,configPath:y.URI.parse(q.configURIPath)}}):typeof q=="string"&&J.workspaces.push({label:F,folderUri:y.URI.parse(q)})}),Array.isArray(ve.files2)&&Ee(ve.files2,(q,j)=>{const F=Array.isArray(ve.fileLabels)&&ve.fileLabels[j]||void 0;typeof q=="string"&&J.files.push({label:F,fileUri:y.URI.parse(q)})})}return J}e.restoreRecentlyOpened=O;function H($){const x={workspaces3:[],files2:[]};let J=!1;const Ee=[];for(const q of $.workspaces)m(q)?x.workspaces3.push(q.folderUri.toString()):x.workspaces3.push({id:q.workspace.id,configURIPath:q.workspace.configPath.toString()}),Ee.push(q.label||null),J=J||!!q.label;J&&(x.workspaceLabels=Ee),J=!1;const ve=[];for(const q of $.files)x.files2.push(q.fileUri.toString()),ve.push(q.label||null),J=J||!!q.label;return J&&(x.fileLabels=ve),x}e.toStoreData=H}),define(fe[95],he([0,1,6,13]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=e.printTime=void 0;function P(k){let L=0,h=0,n=0;k>=1e3&&(n=Math.floor(k/1e3),k-=n*1e3),n>=60&&(h=Math.floor(n/60),n-=h*60),h>=60&&(L=Math.floor(h/60),h-=L*60);const D=L?`${L}h`:"",b=h?`${h}m`:"",I=n?`${n}s`:"",E=k?`${k}ms`:"";return`${D}${b}${I}${E}`}e.printTime=P;class y{constructor(L,h,n,D){this._logService=L,this._reconnectionToken=h,this._onClose=new S.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=108e5,this._reconnectionShortGraceTime=3e5,this._remoteAddress=n,this.protocol=D,this._disposed=!1,this._disconnectRunner1=new d.RunOnceScheduler(()=>{this._log(`The reconnection grace time of ${P(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new d.RunOnceScheduler(()=>{this._log(`The reconnection short grace time of ${P(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onDidDispose(()=>{this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${P(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(L){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${L}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${P(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){if(!this._disposed){this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const L=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),L.end(),this._onClose.fire(void 0)}}acceptReconnection(L,h,n){this._remoteAddress=L,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(h,n),this.protocol.endAcceptReconnection()}}e.ManagementConnection=y}),define(fe[96],he([0,1,15,8,2,118,26]),function(Q,e,S,d,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const L=P.join(d.FileAccess.asFileUri("",Q).fsPath,"nls.metadata.json"),h=new Map;function n(I){return new Promise(E=>S.exists(I,E))}function D(I,E){return n(L).then(u=>{if(!u||!k.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});let v=`${I}||${E}`,_=h.get(v);return _||(_=y.getNLSConfiguration(k.default.commit,E,L,I).then(w=>(b.is(w)&&(w._languagePackSupport=!0),w)),h.set(v,_)),_})}e.getNLSConfiguration=D;var b;(function(I){function E(u){let v=u;return v&&typeof v._languagePackId=="string"}I.is=E})(b=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}))}),define(fe[38],he([0,1,54,8]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createRemoteURITransformer=e.uriTransformerPath=void 0,e.uriTransformerPath=d.FileAccess.asFileUri("vs/server/uriTransformer.js",Q).fsPath;function P(y){const L=Q.__$__nodeRequire(e.uriTransformerPath)(y);return new S.URITransformer(L)}e.createRemoteURITransformer=P}),define(fe[205],he([0,1,6,4,3,38,60,18,2,39,27]),function(Q,e,S,d,P,y,k,L,h,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemChannel=void 0;class b extends d.Disposable{constructor(u,v,_,w){super();this.logService=u,this.environmentService=v,this.uriTransformer=_,this.watcherRequests=new Map,this.fileWatcher=this._register(new k.DiskFileSystemProvider(this.logService,{watcher:this.getWatcherOptions()})),this.registerListeners(w)}registerListeners(u){const v=this._register(new S.Emitter);this._register(v.event(_=>{u.fire(_.map(w=>({resource:this.uriTransformer.transformOutgoingURI(w.resource),type:w.type})))})),this._register(this.fileWatcher.onDidChangeFile(_=>v.fire(_))),this._register(this.fileWatcher.onDidErrorOccur(_=>u.fire(_)))}getWatcherOptions(){const u=this.environmentService.args.fileWatcherPolling;if(u){const v=u.split(h.delimiter),_=Number(v[0]);if(_>0)return{usePolling:v.length>1?v.slice(1):!0,pollingInterval:_}}}watch(u,v,_){const w=P.URI.revive(this.uriTransformer.transformIncoming(v));return this.environmentService.extensionsPath&&(_.excludes=[..._.excludes||[],h.posix.join(this.environmentService.extensionsPath,"**")]),this.watcherRequests.set(u,this.fileWatcher.watch(w,_)),d.toDisposable(()=>{d.dispose(this.watcherRequests.get(u)),this.watcherRequests.delete(u)})}dispose(){super.dispose(),this.watcherRequests.forEach(u=>d.dispose(u)),this.watcherRequests.clear()}}class I extends d.Disposable{constructor(u,v){super();this.logService=u,this.environmentService=v,this.BUFFER_SIZE=256*1024,this.uriTransformerCache=new Map,this.fileWatchers=new Map,this.fsProvider=this._register(new k.DiskFileSystemProvider(this.logService,{bufferSize:this.BUFFER_SIZE})),this.watchRequests=new Map}call(u,v,_){const w=this.getUriTransformer(u.remoteAuthority);switch(v){case"stat":return this.stat(w,_[0]);case"readdir":return this.readdir(w,_[0]);case"open":return this.open(w,_[0],_[1]);case"close":return this.close(_[0]);case"read":return this.read(_[0],_[1],_[2]);case"readFile":return this.readFile(w,_[0]);case"write":return this.write(_[0],_[1],_[2],_[3],_[4]);case"writeFile":return this.writeFile(w,_[0],_[1],_[2]);case"rename":return this.rename(w,_[0],_[1],_[2]);case"copy":return this.copy(w,_[0],_[1],_[2]);case"mkdir":return this.mkdir(w,_[0]);case"delete":return this.delete(w,_[0],_[1]);case"watch":return Promise.resolve(this.watch(_[0],_[1],_[2],_[3]));case"unwatch":return Promise.resolve(this.unwatch(_[0],_[1]))}throw new Error(`IPC Command ${v} not found`)}listen(u,v,_){const w=this.getUriTransformer(u.remoteAuthority);switch(v){case"filechange":return this.onFileChange(w,_[0]);case"readFileStream":return this.onReadFileStream(w,_[0],_[1])}throw new Error(`Unknown event ${v}`)}onFileChange(u,v){const _=new S.Emitter({onFirstListenerAdd:()=>{this.fileWatchers.set(v,new b(this.logService,this.environmentService,u,_))},onLastListenerRemove:()=>{d.dispose(this.fileWatchers.get(v)),this.fileWatchers.delete(v)}});return _.event}onReadFileStream(u,v,_){const w=this.transformIncoming(u,v,!0),m=new D.CancellationTokenSource,l=new S.Emitter({onLastListenerRemove:()=>{m.cancel()}}),c=this.fsProvider.readFileStream(w,_,m.token);return n.listenStream(c,{onData:r=>l.fire(L.VSBuffer.wrap(r)),onError:r=>l.fire(r),onEnd:()=>{l.fire("end"),l.dispose(),m.dispose()}}),l.event}getUriTransformer(u){let v=this.uriTransformerCache.get(u);return v||(v=y.createRemoteURITransformer(u),this.uriTransformerCache.set(u,v)),v}stat(u,v){const _=this.transformIncoming(u,v,!0);return this.fsProvider.stat(_)}readdir(u,v){const _=this.transformIncoming(u,v);return this.fsProvider.readdir(_)}open(u,v,_){const w=this.transformIncoming(u,v,!0);return this.fsProvider.open(w,_)}close(u){return this.fsProvider.close(u)}async read(u,v,_){const w=L.VSBuffer.alloc(_),m=0,l=await this.fsProvider.read(u,v,w.buffer,m,_);return[w,l]}async readFile(u,v){const _=this.transformIncoming(u,v,!0),w=await this.fsProvider.readFile(_);return L.VSBuffer.wrap(w)}write(u,v,_,w,m){return this.fsProvider.write(u,v,_.buffer,w,m)}writeFile(u,v,_,w){const m=this.transformIncoming(u,v);return this.fsProvider.writeFile(m,_.buffer,w)}rename(u,v,_,w){const m=P.URI.revive(u.transformIncoming(v)),l=P.URI.revive(u.transformIncoming(_));return this.fsProvider.rename(m,l,w)}copy(u,v,_,w){const m=this.transformIncoming(u,v),l=this.transformIncoming(u,_);return this.fsProvider.copy(m,l,w)}mkdir(u,v){const _=this.transformIncoming(u,v);return this.fsProvider.mkdir(_)}delete(u,v,_){const w=this.transformIncoming(u,v);return this.fsProvider.delete(w,_)}transformIncoming(u,v,_=!1){if(_&&v.path==="/vscode-resource"&&v.query){const w=JSON.parse(v.query).requestResourcePath;return P.URI.from({scheme:"file",path:w})}return P.URI.revive(u.transformIncoming(v))}watch(u,v,_,w){const m=u+v,l=this.fileWatchers.get(u);if(l){const c=l.watch(v,_,w);this.watchRequests.set(m,c)}}unwatch(u,v){const _=u+v,w=this.watchRequests.get(_);w&&(d.dispose(w),this.watchRequests.delete(_))}dispose(){super.dispose(),this.watchRequests.forEach(u=>d.dispose(u)),this.watchRequests.clear(),this.fileWatchers.forEach(u=>d.dispose(u)),this.fileWatchers.clear()}}e.RemoteAgentFileSystemChannel=I}),define(fe[65],he([0,1,157,187,56]),function(Q,e,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={port:{type:"string"},connectionToken:{type:"string"},"connection-secret":{type:"string",description:S.localize(0,null)},host:{type:"string"},"socket-path":{type:"string"},driver:{type:"string"},"start-server":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},fileWatcherPolling:{type:"string"},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"without-browser-env-var":{type:"boolean"},"disable-telemetry":P.OPTIONS["disable-telemetry"],"extensions-dir":P.OPTIONS["extensions-dir"],"extensions-download-dir":P.OPTIONS["extensions-download-dir"],"install-extension":P.OPTIONS["install-extension"],"install-builtin-extension":P.OPTIONS["install-builtin-extension"],"uninstall-extension":P.OPTIONS["uninstall-extension"],"locate-extension":P.OPTIONS["locate-extension"],"list-extensions":P.OPTIONS["list-extensions"],force:P.OPTIONS.force,"show-versions":P.OPTIONS["show-versions"],category:P.OPTIONS.category,"do-not-sync":P.OPTIONS["do-not-sync"],"force-disable-user-env":P.OPTIONS["force-disable-user-env"],folder:{type:"string"},workspace:{type:"string"},"web-user-data-dir":{type:"string"},"use-host-proxy":{type:"string"},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},_:P.OPTIONS._};class y extends d.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=y}),define(fe[206],he([0,1,15,63,183,236,61,28,117,5,3,38,26,2,8,23]),function(Q,e,S,d,P,y,k,L,h,n,D,b,I,E,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebClientServer=e.serveFile=e.serveError=void 0;const _={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function w(r,t,i,o){t.writeHead(i,{"Content-Type":"text/plain"}),t.end(o)}e.serveError=w;async function m(r,t,i,o,a=Object.create(null)){try{const s=await P.promisify(S.stat)(o),g=`W/"${[s.ino,s.size,s.mtime.getTime()].join("-")}"`;if(t.headers["if-none-match"]===g)return i.writeHead(304),i.end();a["Content-Type"]=_[E.extname(o)]||h.getMediaMime(o)||"text/plain",a.Etag=g,i.writeHead(200,a),S.createReadStream(o).pipe(i)}catch(s){return s.code!=="ENOENT"&&(r.error(s),console.error(s.toString())),i.writeHead(404,{"Content-Type":"text/plain"}),i.end("Not found")}}e.serveFile=m;const l=E.dirname(u.FileAccess.asFileUri("",Q).fsPath);class c{constructor(t,i,o){this._connectionToken=t,this._environmentService=i,this._logService=o,this._webviewEndpoint="https://{{uuid}}.vscode-webview-test.com/{{commit}}",this._mapCallbackUriToRequestId=new Map}async handle(t,i,o){try{const a=o.pathname;return a==="/favicon.ico"||a==="/manifest.json"||a==="/code-192.png"||a==="/code-512.png"?m(this._logService,t,i,E.join(l,"resources","server",a.substr(1))):/^\/static\//.test(a)?this._handleStatic(t,i,o):a==="/"?this._handleRoot(t,i,o):a==="/callback"?this._handleCallback(t,i,o):a==="/fetch-callback"?this._handleFetchCallback(t,i,o):w(t,i,404,"Not found.")}catch(a){return this._logService.error(a),console.error(a.toString()),w(t,i,500,"Internal Server Error.")}}_hasCorrectTokenCookie(t){return y.parse(t.headers.cookie||"")["vscode-tkn"]===this._connectionToken}async _handleStatic(t,i,o){const a=Object.create(null),s=decodeURIComponent(o.pathname),g=E.normalize(s.substr("/static/".length)),C=E.join(l,g);return L.isEqualOrParent(C,l,!n.isLinux)?m(this._logService,t,i,C,a):w(t,i,400,"Bad request.")}async _handleRoot(t,i,o){if(!t.headers.host)return w(t,i,400,"Bad request.");const a=o.query.tkn;if(typeof a=="string"){const x=Object.create(null);x["Set-Cookie"]=y.serialize("vscode-tkn",a,{sameSite:"strict",maxAge:60*60*24*7});const J=Object.create(null);for(let ve in o.query)ve!=="tkn"&&(J[ve]=o.query[ve]);const Ee=d.format({pathname:"/",query:J});return x.Location=Ee,i.writeHead(302,x),i.end()}if(this._environmentService.isBuilt&&!this._hasCorrectTokenCookie(t))return w(t,i,403,"Forbidden.");const s=t.headers.host,g=b.createRemoteURITransformer(s),{workspacePath:C,isFolder:R}=await this._getWorkspaceFromCLI();function p(x){return x.replace(/"/g,"&quot;")}let f;this._environmentService.driverHandle&&(f=!1);const T=u.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html",Q).fsPath,O=!this._environmentService.isBuilt&&this._environmentService.args["github-auth"]?{id:v.generateUuid(),providerId:"github",accessToken:this._environmentService.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,H=(await P.promisify(S.readFile)(T)).toString().replace("{{WORKBENCH_WEB_CONFIGURATION}}",p(JSON.stringify({folderUri:C&&R?g.transformOutgoing(D.URI.file(C)):void 0,workspaceUri:C&&!R?g.transformOutgoing(D.URI.file(C)):void 0,remoteAuthority:s,webviewEndpoint:this._webviewEndpoint,_wrapWebWorkerExtHostInIframe:f,driver:this._environmentService.driverHandle==="web"?!0:void 0,settingsSyncOptions:!this._environmentService.isBuilt&&this._environmentService.args["enable-sync"]?{enabled:!0}:void 0}))).replace("{{WORKBENCH_AUTH_SESSION}}",()=>O?p(JSON.stringify(O)):""),$=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' 'unsafe-eval' https://az416426.vo.msecnd.net ${this._getScriptCspHashes(H).join(" ")} 'sha256-O98pkmgtvUCQGVoddaGy891K52PVRnySDRxRszVLPNQ=' http://${s};`,"child-src 'self';","frame-src 'self' https://*.vscode-webview-test.com https://vscodeweb.azureedge.net data:;","worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ");return i.writeHead(200,{"Content-Type":"text/html","Set-Cookie":y.serialize("vscode-tkn",this._connectionToken,{sameSite:"strict",maxAge:60*60*24*7}),"Content-Security-Policy":$}),i.end(H)}_getScriptCspHashes(t){const i=/<script>([\s\S]+?)<\/script>/img,o=[];let a;for(;a=i.exec(t);){const s=k.createHash("sha256"),g=a[1].replace(/\r\n/g,`
`),C=s.update(Buffer.from(g)).digest().toString("base64");o.push(`'sha256-${C}'`)}return o}async _getWorkspaceFromCLI(){const t=process.env.VSCODE_CWD||process.cwd(),i=this._environmentService.args.workspace;if(i&&i.length>0){const a=L.sanitizeFilePath(i,t);if(await P.promisify(S.exists)(a))return{workspacePath:a}}const o=this._environmentService.args.folder;if(o&&o.length>0){const a=L.sanitizeFilePath(o,t);if(await P.promisify(S.exists)(a))return{workspacePath:a,isFolder:!0}}return{}}_getFirstQueryValue(t,i){const o=t.query[i];return Array.isArray(o)?o[0]:o}_getFirstQueryValues(t,i){const o=new Map;for(const a in t.query)if(!(i&&i.indexOf(a)>=0)){const s=this._getFirstQueryValue(t,a);typeof s=="string"&&o.set(a,s)}return o}async _handleCallback(t,i,o){const a=["vscode-requestId","vscode-scheme","vscode-authority","vscode-path","vscode-query","vscode-fragment"],[s,g,C,R,p,f]=a.map(H=>{const $=this._getFirstQueryValue(o,H);return $&&decodeURIComponent($)});if(!s)return i.writeHead(400,{"Content-Type":"text/plain"}),i.end("Bad request.");let T=p,O=0;return this._getFirstQueryValues(o,a).forEach((H,$)=>{T||(T=""),T+=`${O++==0?"":"&"}${$}=${H}`}),this._mapCallbackUriToRequestId.set(s,D.URI.from({scheme:g||I.default.urlProtocol,authority:C,path:R,query:T,fragment:f}).toJSON()),m(this._logService,t,i,u.FileAccess.asFileUri("vs/code/browser/workbench/callback.html",Q).fsPath,{"Content-Type":"text/html"})}async _handleFetchCallback(t,i,o){const a=this._getFirstQueryValue(o,"vscode-requestId");if(!a)return i.writeHead(400,{"Content-Type":"text/plain"}),i.end("Bad request.");const s=this._mapCallbackUriToRequestId.get(a);return s&&this._mapCallbackUriToRequestId.delete(a),i.writeHead(200,{"Content-Type":"text/json"}),i.end(JSON.stringify(s))}}e.WebClientServer=c}),define(fe[207],he([0,1,7]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=S.createDecorator("IExtHostRpcService");class d{constructor(y){this.getProxy=y.getProxy.bind(y),this.set=y.set.bind(y),this.assertRegistered=y.assertRegistered.bind(y),this.drain=y.drain.bind(y)}}e.ExtHostRpcService=d}),define(fe[97],he([0,1,44,8,2,5,47]),function(Q,e,S,d,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookCellRunState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var L;(function(R){R[R.Markdown=1]="Markdown",R[R.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var h;(function(R){R[R.Running=1]="Running",R[R.Idle=2]="Idle"})(h=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={editable:!0,runnable:!0,cellEditable:!0,cellRunnable:!0,cellHasExecutionOrder:!0,displayOrder:e.NOTEBOOK_DISPLAY_ORDER,custom:{},runState:h.Idle,trusted:!0};var n;(function(R){R[R.Running=1]="Running",R[R.Idle=2]="Idle",R[R.Success=3]="Success",R[R.Error=4]="Error"})(n=e.NotebookCellRunState||(e.NotebookCellRunState={}));var D;(function(R){R[R.ModelChange=1]="ModelChange",R[R.Move=2]="Move",R[R.CellClearOutput=3]="CellClearOutput",R[R.CellsClearOutput=4]="CellsClearOutput",R[R.ChangeLanguage=5]="ChangeLanguage",R[R.Initialize=6]="Initialize",R[R.ChangeCellMetadata=7]="ChangeCellMetadata",R[R.Output=8]="Output",R[R.OutputItem=9]="OutputItem",R[R.ChangeCellContent=10]="ChangeCellContent",R[R.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",R[R.Unknown=12]="Unknown"})(D=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var b;(function(R){R[R.Handle=0]="Handle",R[R.Index=1]="Index"})(b=e.SelectionStateType||(e.SelectionStateType={}));var I;(function(R){R[R.Replace=1]="Replace",R[R.Output=2]="Output",R[R.Metadata=3]="Metadata",R[R.CellLanguage=4]="CellLanguage",R[R.DocumentMetadata=5]="DocumentMetadata",R[R.OutputsSplice=6]="OutputsSplice",R[R.Move=7]="Move",R[R.Unknown=8]="Unknown",R[R.CellContent=9]="CellContent",R[R.OutputItems=10]="OutputItems"})(I=e.CellEditType||(e.CellEditType={}));function E(R){const p=u.parse(R);return p?p.notebook.toString():R.toString()}e.getCellUndoRedoComparisonKey=E;var u;(function(R){R.scheme=d.Schemas.vscodeNotebookCell;const p=/^ch(\d{7,})/;function f($,x){return $.with({scheme:R.scheme,fragment:`ch${x.toString().padStart(7,"0")}${$.scheme!==d.Schemas.file?$.scheme:""}`})}R.generate=f;function T($){if($.scheme===R.scheme){const x=p.exec($.fragment);if(!!x)return{handle:Number(x[1]),notebook:$.with({scheme:$.fragment.substr(x[0].length)||d.Schemas.file,fragment:null})}}}R.parse=T;function O($,x){return $.with({scheme:d.Schemas.vscodeNotebookCellMetadata,fragment:`ch${x.toString().padStart(7,"0")}${$.scheme!==d.Schemas.file?$.scheme:""}`})}R.generateCellMetadataUri=O;function H($){if($.scheme===d.Schemas.vscodeNotebookCellMetadata){const x=p.exec($.fragment);if(!!x)return{handle:Number(x[1]),notebook:$.with({scheme:$.fragment.substr(x[0].length)||d.Schemas.file,fragment:null})}}}R.parseCellMetadataUri=H})(u=e.CellUri||(e.CellUri={}));const v=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}]]);function _(R){var p,f;return(f=(p=v.get(R))===null||p===void 0?void 0:p.alwaysSecure)!==null&&f!==void 0?f:!1}e.mimeTypeIsAlwaysSecure=_;function w(R){var p,f;return(f=(p=v.get(R))===null||p===void 0?void 0:p.supportedByCore)!==null&&f!==void 0?f:!1}e.mimeTypeSupportedByCore=w;function m(R,p){return y.isWindows&&(R=R.replace(/\//g,"\\"),p=p.replace(/\//g,"\\")),S.match(R,p)}function l(R,p,f,T){let O=0;for(let H=0;H<p.length;H++){if(m(p[H],R))return O;O++}for(let H=0;H<f.length;H++){if(m(f[H],R))return O;O++}for(let H=0;H<T.length;H++){if(m(T[H],R))return O;O++}return O}function c(R,p,f,T){return R.sort((H,$)=>l(H,p,f,T)-l($,p,f,T))}e.sortMimeTypes=c;function r(R,p,f,T=(O,H)=>O===H){const O=[];function H(J,Ee,ve){if(!(Ee===0&&ve.length===0)){const q=O[O.length-1];q&&q.start+q.deleteCount===J?(q.deleteCount+=Ee,q.toInsert.push(...ve)):O.push({start:J,deleteCount:Ee,toInsert:ve})}}let $=0,x=0;for(;;){if($===R.length){H($,0,p.slice(x));break}if(x===p.length){H($,R.length-$,[]);break}const J=R[$],Ee=p[x];if(T(J,Ee)){$+=1,x+=1;continue}f(Ee)?(H($,1,[]),$+=1):(H($,0,[Ee]),x+=1)}return O}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=new k.RawContextKey("notebookEditorCursorAtEditorBeginEnd",!1);var t;(function(R){R.default="default",R.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function i(R){const p=R;return!!((typeof p.include=="string"||S.isRelativePattern(p.include))&&(typeof p.exclude=="string"||S.isRelativePattern(p.exclude)))}e.isDocumentExcludePattern=i;function o(R,p,f){if(Array.isArray(R.viewType)&&R.viewType.indexOf(p)>=0||R.viewType===p)return!0;if(R.filenamePattern){let T=i(R.filenamePattern)?R.filenamePattern.include:R.filenamePattern,O=i(R.filenamePattern)?R.filenamePattern.exclude:void 0;if(S.match(T,P.basename(f.fsPath).toLowerCase()))return!(O&&S.match(O,P.basename(f.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o;class a{constructor(p){this.textModel=p}getElements(){const p=new Int32Array(this.textModel.cells.length);for(let f=0;f<this.textModel.cells.length;f++)p[f]=this.textModel.cells[f].getHashValue();return p}}e.CellSequence=a,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview";var s;(function(R){R[R.LEFT=0]="LEFT",R[R.RIGHT=1]="RIGHT"})(s=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function g(R){const p=R.shift();return p===void 0?[]:R.reduce(function(f,T){return T<=f[0][1]?f[0][1]=T+1:f.unshift([T,T+1]),f},[[p,p+1]]).reverse().map(f=>({start:f[0],end:f[1]}))}e.cellIndexesToRanges=g;function C(R){return R.reduce((f,T)=>{for(let O=T.start;O<T.end;O++)f.push(O);return f},[])}e.cellRangesToIndexes=C});var Et=this&&this.__classPrivateFieldSet||function(Q,e,S){if(!e.has(Q))throw new TypeError("attempted to set private field on non-instance");return e.set(Q,S),S},ft=this&&this.__classPrivateFieldGet||function(Q,e){if(!e.has(Q))throw new TypeError("attempted to get private field on non-instance");return e.get(Q)};define(fe[98],he([0,1,16,12,72,25,11,3,23,24,92,97]),function(Q,e,S,d,P,y,k,L,h,n,D,b){"use strict";var I,E,u,v,_,w,m,l,c,r,t,i,o,a,s,g;Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessageSeverity=e.TestRunState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookRunState=e.NotebookCellRunState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTrigger=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function C(B){function N(){return Reflect.construct(B,arguments,this.constructor)}return Object.defineProperty(N,"name",Object.getOwnPropertyDescriptor(B,"name")),Object.setPrototypeOf(N,B),Object.setPrototypeOf(N.prototype,B.prototype),N}let R=u=class{constructor(N){I.set(this,void 0),Et(this,I,N)}static from(...N){let Z=N;return new u(function(){if(Z){for(const pe of Z)pe&&typeof pe.dispose=="function"&&pe.dispose();Z=void 0}})}dispose(){typeof ft(this,I)=="function"&&(ft(this,I).call(this),Et(this,I,void 0))}};I=new WeakMap,R=u=Oe([C],R),e.Disposable=R;let p=v=class{constructor(N,Z){if(N<0)throw d.illegalArgument("line must be non-negative");if(Z<0)throw d.illegalArgument("character must be non-negative");this._line=N,this._character=Z}static Min(...N){if(N.length===0)throw new TypeError;let Z=N[0];for(let pe=1;pe<N.length;pe++){const Ne=N[pe];Ne.isBefore(Z)&&(Z=Ne)}return Z}static Max(...N){if(N.length===0)throw new TypeError;let Z=N[0];for(let pe=1;pe<N.length;pe++){const Ne=N[pe];Ne.isAfter(Z)&&(Z=Ne)}return Z}static isPosition(N){if(!N)return!1;if(N instanceof v)return!0;let{line:Z,character:pe}=N;return typeof Z=="number"&&typeof pe=="number"}get line(){return this._line}get character(){return this._character}isBefore(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<N._character}isBeforeOrEqual(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<=N._character}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this._line===N._line&&this._character===N._character}compareTo(N){return this._line<N._line?-1:this._line>N.line?1:this._character<N._character?-1:this._character>N._character?1:0}translate(N,Z=0){if(N===null||Z===null)throw d.illegalArgument();let pe;return typeof N=="undefined"?pe=0:typeof N=="number"?pe=N:(pe=typeof N.lineDelta=="number"?N.lineDelta:0,Z=typeof N.characterDelta=="number"?N.characterDelta:0),pe===0&&Z===0?this:new v(this.line+pe,this.character+Z)}with(N,Z=this.character){if(N===null||Z===null)throw d.illegalArgument();let pe;return typeof N=="undefined"?pe=this.line:typeof N=="number"?pe=N:(pe=typeof N.line=="number"?N.line:this.line,Z=typeof N.character=="number"?N.character:this.character),pe===this.line&&Z===this.character?this:new v(pe,Z)}toJSON(){return{line:this.line,character:this.character}}};p=v=Oe([C],p),e.Position=p;let f=_=class{constructor(N,Z,pe,Ne){let We,xe;if(typeof N=="number"&&typeof Z=="number"&&typeof pe=="number"&&typeof Ne=="number"?(We=new p(N,Z),xe=new p(pe,Ne)):N instanceof p&&Z instanceof p&&(We=N,xe=Z),!We||!xe)throw new Error("Invalid arguments");We.isBefore(xe)?(this._start=We,this._end=xe):(this._start=xe,this._end=We)}static isRange(N){return N instanceof _?!0:N?p.isPosition(N.start)&&p.isPosition(N.end):!1}get start(){return this._start}get end(){return this._end}contains(N){return N instanceof _?this.contains(N._start)&&this.contains(N._end):N instanceof p?!(N.isBefore(this._start)||this._end.isBefore(N)):!1}isEqual(N){return this._start.isEqual(N._start)&&this._end.isEqual(N._end)}intersection(N){const Z=p.Max(N.start,this._start),pe=p.Min(N.end,this._end);if(!Z.isAfter(pe))return new _(Z,pe)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const Z=p.Min(N.start,this._start),pe=p.Max(N.end,this.end);return new _(Z,pe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(N,Z=this.end){if(N===null||Z===null)throw d.illegalArgument();let pe;return N?p.isPosition(N)?pe=N:(pe=N.start||this.start,Z=N.end||this.end):pe=this.start,pe.isEqual(this._start)&&Z.isEqual(this.end)?this:new _(pe,Z)}toJSON(){return[this.start,this.end]}};f=_=Oe([C],f),e.Range=f;let T=w=class extends f{constructor(N,Z,pe,Ne){let We,xe;if(typeof N=="number"&&typeof Z=="number"&&typeof pe=="number"&&typeof Ne=="number"?(We=new p(N,Z),xe=new p(pe,Ne)):N instanceof p&&Z instanceof p&&(We=N,xe=Z),!We||!xe)throw new Error("Invalid arguments");super(We,xe);this._anchor=We,this._active=xe}static isSelection(N){return N instanceof w?!0:N?f.isRange(N)&&p.isPosition(N.anchor)&&p.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};T=w=Oe([C],T),e.Selection=T;class O{constructor(N,Z,pe){if(typeof N!="string"||N.length===0)throw d.illegalArgument("host");if(typeof Z!="number"||Z===0||Math.round(Z)!==Z)throw d.illegalArgument("port");if(typeof pe!="undefined"&&(typeof pe!="string"||pe.length===0||!/^[0-9A-Za-z\-]+$/.test(pe)))throw d.illegalArgument("connectionToken");this.host=N,this.port=Math.round(Z),this.connectionToken=pe}}e.ResolvedAuthority=O;class H extends Error{constructor(N,Z=D.RemoteAuthorityResolverErrorCode.Unknown,pe){super(N);this._message=N,this._code=Z,this._detail=pe,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,H.prototype)}static NotAvailable(N,Z){return new H(N,D.RemoteAuthorityResolverErrorCode.NotAvailable,Z)}static TemporarilyNotAvailable(N){return new H(N,D.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=H;var $;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})($=e.EndOfLine||(e.EndOfLine={}));var x;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let J=m=class{constructor(N,Z){this._range=N,this._newText=Z}static isTextEdit(N){return N instanceof m?!0:N?f.isRange(N)&&typeof N.newText=="string":!1}static replace(N,Z){return new m(N,Z)}static insert(N,Z){return m.replace(new f(N,N),Z)}static delete(N){return m.replace(N,"")}static setEndOfLine(N){const Z=new m(new f(new p(0,0),new p(0,0)),"");return Z.newEol=N,Z}get range(){return this._range}set range(N){if(N&&!f.isRange(N))throw d.illegalArgument("range");this._range=N}get newText(){return this._newText||""}set newText(N){if(N&&typeof N!="string")throw d.illegalArgument("newText");this._newText=N}get newEol(){return this._newEol}set newEol(N){if(N&&typeof N!="number")throw d.illegalArgument("newEol");this._newEol=N}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};J=m=Oe([C],J),e.TextEdit=J;var Ee;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellOutput=4]="CellOutput",B[B.CellReplace=5]="CellReplace",B[B.CellOutputItem=6]="CellOutputItem"})(Ee=e.FileEditType||(e.FileEditType={}));let ve=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(N,Z,pe,Ne){this._edits.push({_type:1,from:N,to:Z,options:pe,metadata:Ne})}createFile(N,Z,pe){this._edits.push({_type:1,from:void 0,to:N,options:Z,metadata:pe})}deleteFile(N,Z,pe){this._edits.push({_type:1,from:N,to:void 0,options:Z,metadata:pe})}replaceNotebookMetadata(N,Z,pe){this._edits.push({_type:3,metadata:pe,uri:N,edit:{editType:5,metadata:Object.assign(Object.assign({},b.notebookDocumentMetadataDefaults),Z)},notebookMetadata:Z})}replaceNotebookCells(N,Z,pe,Ne,We){(Z!==pe||Ne.length>0)&&this._edits.push({_type:5,uri:N,index:Z,count:pe-Z,cells:Ne,metadata:We})}replaceNotebookCellOutput(N,Z,pe,Ne){this._editNotebookCellOutput(N,Z,!1,pe,Ne)}appendNotebookCellOutput(N,Z,pe,Ne){this._editNotebookCellOutput(N,Z,!0,pe,Ne)}replaceNotebookCellOutputItems(N,Z,pe,Ne,We){this._editNotebookCellOutputItems(N,Z,pe,!1,Ne,We)}appendNotebookCellOutputItems(N,Z,pe,Ne,We){this._editNotebookCellOutputItems(N,Z,pe,!0,Ne,We)}_editNotebookCellOutputItems(N,Z,pe,Ne,We,xe){this._edits.push({_type:6,metadata:xe,uri:N,index:Z,outputId:pe,append:Ne,newOutputItems:We})}_editNotebookCellOutput(N,Z,pe,Ne,We){this._edits.push({_type:4,metadata:We,uri:N,index:Z,append:pe,newOutputs:Ne,newMetadata:void 0})}replaceNotebookCellMetadata(N,Z,pe,Ne){this._edits.push({_type:3,metadata:Ne,uri:N,edit:{editType:3,index:Z,metadata:pe}})}replace(N,Z,pe,Ne){this._edits.push({_type:2,uri:N,edit:new J(Z,pe),metadata:Ne})}insert(N,Z,pe,Ne){this.replace(N,new f(Z,Z),pe,Ne)}delete(N,Z,pe){this.replace(N,Z,"",pe)}has(N){return this._edits.some(Z=>Z._type===2&&Z.uri.toString()===N.toString())}set(N,Z){if(Z)for(const pe of Z)pe&&this._edits.push({_type:2,uri:N,edit:pe});else{for(let pe=0;pe<this._edits.length;pe++){const Ne=this._edits[pe];Ne._type===2&&Ne.uri.toString()===N.toString()&&(this._edits[pe]=void 0)}S.coalesceInPlace(this._edits)}}get(N){const Z=[];for(let pe of this._edits)pe._type===2&&pe.uri.toString()===N.toString()&&Z.push(pe.edit);return Z}entries(){const N=new y.ResourceMap;for(let Z of this._edits)if(Z._type===2){let pe=N.get(Z.uri);pe||(pe=[Z.uri,[]],N.set(Z.uri,pe)),pe[1].push(Z.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ve=Oe([C],ve),e.WorkspaceEdit=ve;let q=l=class{constructor(N){this._tabstop=1,this.value=N||""}static isSnippetString(N){return N instanceof l?!0:N?typeof N.value=="string":!1}static _escape(N){return N.replace(/\$|}|\\/g,"\\$&")}appendText(N){return this.value+=l._escape(N),this}appendTabstop(N=this._tabstop++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,Z=this._tabstop++){if(typeof N=="function"){const pe=new l;pe._tabstop=this._tabstop,N(pe),this._tabstop=pe._tabstop,N=pe.value}else N=l._escape(N);return this.value+="${",this.value+=Z,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,Z=this._tabstop++){const pe=N.map(Ne=>Ne.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=Z,this.value+="|",this.value+=pe,this.value+="|}",this}appendVariable(N,Z){if(typeof Z=="function"){const pe=new l;pe._tabstop=this._tabstop,Z(pe),this._tabstop=pe._tabstop,Z=pe.value}else typeof Z=="string"&&(Z=Z.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,Z&&(this.value+=":",this.value+=Z),this.value+="}",this}};q=l=Oe([C],q),e.SnippetString=q;var j;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(j=e.DiagnosticTag||(e.DiagnosticTag={}));var F;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(F=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let A=c=class{constructor(N,Z){if(this.uri=N,Z)if(Z instanceof f)this.range=Z;else if(Z instanceof p)this.range=new f(Z,Z);else throw new Error("Illegal argument")}static isLocation(N){return N instanceof c?!0:N?f.isRange(N.range)&&L.URI.isUri(N.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};A=c=Oe([C],A),e.Location=A;let M=class{constructor(N,Z){this.location=N,this.message=Z}static is(N){return N?typeof N.message=="string"&&N.location&&f.isRange(N.location.range)&&L.URI.isUri(N.location.uri):!1}static isEqual(N,Z){return N===Z?!0:!N||!Z?!1:N.message===Z.message&&N.location.range.isEqual(Z.location.range)&&N.location.uri.toString()===Z.location.uri.toString()}};M=Oe([C],M),e.DiagnosticRelatedInformation=M;let U=class{constructor(N,Z,pe=F.Error){if(!f.isRange(N))throw new TypeError("range must be set");if(!Z)throw new TypeError("message must be set");this.range=N,this.message=Z,this.severity=pe}toJSON(){return{severity:F[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,Z){return N===Z?!0:!N||!Z?!1:N.message===Z.message&&N.severity===Z.severity&&N.code===Z.code&&N.severity===Z.severity&&N.source===Z.source&&N.range.isEqual(Z.range)&&S.equals(N.tags,Z.tags)&&S.equals(N.relatedInformation,Z.relatedInformation,M.isEqual)}};U=Oe([C],U),e.Diagnostic=U;let W=class{constructor(N,Z){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:P.isMarkdownString(N)?this.contents=[N]:this.contents=[N],this.range=Z}};W=Oe([C],W),e.Hover=W;var ne;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(ne=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ae=class{constructor(N,Z=ne.Text){this.range=N,this.kind=Z}toJSON(){return{range:this.range,kind:ne[this.kind]}}};ae=Oe([C],ae),e.DocumentHighlight=ae;var ce;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(ce=e.SymbolKind||(e.SymbolKind={}));var de;(function(B){B[B.Deprecated=1]="Deprecated"})(de=e.SymbolTag||(e.SymbolTag={}));let Pe=r=class{constructor(N,Z,pe,Ne,We){this.name=N,this.kind=Z,this.containerName=We,typeof pe=="string"&&(this.containerName=pe),Ne instanceof A?this.location=Ne:pe instanceof f&&(this.location=new A(Ne,pe)),r.validate(this)}static validate(N){if(!N.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ce[this.kind],location:this.location,containerName:this.containerName}}};Pe=r=Oe([C],Pe),e.SymbolInformation=Pe;let Te=t=class{constructor(N,Z,pe,Ne,We){this.name=N,this.detail=Z,this.kind=pe,this.range=Ne,this.selectionRange=We,this.children=[],t.validate(this)}static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children&&N.children.forEach(t.validate)}};Te=t=Oe([C],Te),e.DocumentSymbol=Te;var Me;(function(B){B[B.Automatic=1]="Automatic",B[B.Manual=2]="Manual"})(Me=e.CodeActionTrigger||(e.CodeActionTrigger={}));let je=class{constructor(N,Z){this.title=N,this.kind=Z}};je=Oe([C],je),e.CodeAction=je;let $e=i=class{constructor(N){this.value=N}append(N){return new i(this.value?this.value+i.sep+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+i.sep)}};$e.sep=".",$e=i=Oe([C],$e),e.CodeActionKind=$e,$e.Empty=new $e(""),$e.QuickFix=$e.Empty.append("quickfix"),$e.Refactor=$e.Empty.append("refactor"),$e.RefactorExtract=$e.Refactor.append("extract"),$e.RefactorInline=$e.Refactor.append("inline"),$e.RefactorRewrite=$e.Refactor.append("rewrite"),$e.Source=$e.Empty.append("source"),$e.SourceOrganizeImports=$e.Source.append("organizeImports"),$e.SourceFixAll=$e.Source.append("fixAll");let Ye=class{constructor(N,Z){if(this.range=N,this.parent=Z,Z&&!Z.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ye=Oe([C],Ye),e.SelectionRange=Ye;class et{constructor(N,Z,pe,Ne,We,xe){this.kind=N,this.name=Z,this.detail=pe,this.uri=Ne,this.range=We,this.selectionRange=xe}}e.CallHierarchyItem=et;class Je{constructor(N,Z){this.fromRanges=Z,this.from=N}}e.CallHierarchyIncomingCall=Je;class we{constructor(N,Z){this.fromRanges=Z,this.to=N}}e.CallHierarchyOutgoingCall=we;let Se=class{constructor(N,Z){this.range=N,this.command=Z}get isResolved(){return!!this.command}};Se=Oe([C],Se),e.CodeLens=Se;let Ce=o=class{constructor(N,Z=!1){E.set(this,void 0),Et(this,E,new P.MarkdownString(N,{supportThemeIcons:Z}))}static isMarkdownString(N){return N instanceof o?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}get value(){return ft(this,E).value}set value(N){ft(this,E).value=N}get isTrusted(){return ft(this,E).isTrusted}set isTrusted(N){ft(this,E).isTrusted=N}get supportThemeIcons(){return ft(this,E).supportThemeIcons}appendText(N){return ft(this,E).appendText(N),this}appendMarkdown(N){return ft(this,E).appendMarkdown(N),this}appendCodeblock(N,Z){return ft(this,E).appendCodeblock(Z!=null?Z:"",N),this}};E=new WeakMap,Ce=o=Oe([C],Ce),e.MarkdownString=Ce;let ke=class{constructor(N,Z){this.label=N,this.documentation=Z}};ke=Oe([C],ke),e.ParameterInformation=ke;let Le=class{constructor(N,Z){this.label=N,this.documentation=Z,this.parameters=[]}};Le=Oe([C],Le),e.SignatureInformation=Le;let ze=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ze=Oe([C],ze),e.SignatureHelp=ze;var He;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(He=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ve;(function(B){B[B.Other=0]="Other",B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(Ve=e.InlineHintKind||(e.InlineHintKind={}));let Qe=class{constructor(N,Z,pe){this.text=N,this.range=Z,this.kind=pe}};Qe=Oe([C],Qe),e.InlineHint=Qe;var re;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(re=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ge;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(ge=e.CompletionItemKind||(e.CompletionItemKind={}));var me;(function(B){B[B.Deprecated=1]="Deprecated"})(me=e.CompletionItemTag||(e.CompletionItemTag={}));let Fe=class{constructor(N,Z){this.label=N,this.kind=Z}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&ge[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Fe=Oe([C],Fe),e.CompletionItem=Fe;let z=class{constructor(N=[],Z=!1){this.items=N,this.isIncomplete=Z}};z=Oe([C],z),e.CompletionList=z;var X;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(X=e.ViewColumn||(e.ViewColumn={}));var ee;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(ee=e.StatusBarAlignment||(e.StatusBarAlignment={}));var V;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(V=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var K;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(K=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var te;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(te=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ie;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(ie=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ue;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(ue=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(B){function N(Z){switch(Z){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=N}(ie=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let De=class{constructor(N,Z){if(Z&&!L.URI.isUri(Z))throw d.illegalArgument("target");if(!f.isRange(N)||N.isEmpty)throw d.illegalArgument("range");this.range=N,this.target=Z}};De=Oe([C],De),e.DocumentLink=De;let le=class{constructor(N,Z,pe,Ne){this.red=N,this.green=Z,this.blue=pe,this.alpha=Ne}};le=Oe([C],le),e.Color=le;let ye=class{constructor(N,Z){if(Z&&!(Z instanceof le))throw d.illegalArgument("color");if(!f.isRange(N)||N.isEmpty)throw d.illegalArgument("range");this.range=N,this.color=Z}};ye=Oe([C],ye),e.ColorInformation=ye;let be=class{constructor(N){if(!N||typeof N!="string")throw d.illegalArgument("label");this.label=N}};be=Oe([C],be),e.ColorPresentation=be;var Ae;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Ae=e.ColorFormat||(e.ColorFormat={}));var se;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(se=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var oe;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(oe=e.TaskRevealKind||(e.TaskRevealKind={}));var Y;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(Y=e.TaskPanelKind||(e.TaskPanelKind={}));let G=a=class{constructor(N,Z){if(typeof N!="string"||typeof Z!="string")throw d.illegalArgument("name");this._id=N}static from(N){switch(N){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}get id(){return this._id}};G.Clean=new a("clean","Clean"),G.Build=new a("build","Build"),G.Rebuild=new a("rebuild","Rebuild"),G.Test=new a("test","Test"),G=a=Oe([C],G),e.TaskGroup=G;function _e(B){let N="";for(let Z=0;Z<B.length;Z++)N+=B[Z].replace(/,/g,",,")+",";return N}let Ie=class{constructor(N,Z,pe){if(typeof N!="string")throw d.illegalArgument("process");this._args=[],this._process=N,Z!==void 0&&(Array.isArray(Z)?(this._args=Z,this._options=pe):this._options=Z)}get process(){return this._process}set process(N){if(typeof N!="string")throw d.illegalArgument("process");this._process=N}get args(){return this._args}set args(N){Array.isArray(N)||(N=[]),this._args=N}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("process"),this._process!==void 0&&N.push(this._process),this._args&&this._args.length>0)for(let Z of this._args)N.push(Z);return _e(N)}};Ie=Oe([C],Ie),e.ProcessExecution=Ie;let Be=class{constructor(N,Z,pe){if(this._args=[],Array.isArray(Z)){if(!N)throw d.illegalArgument("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw d.illegalArgument("command");this._command=N,this._args=Z,this._options=pe}else{if(typeof N!="string")throw d.illegalArgument("commandLine");this._commandLine=N,this._options=Z}}get commandLine(){return this._commandLine}set commandLine(N){if(typeof N!="string")throw d.illegalArgument("commandLine");this._commandLine=N}get command(){return this._command?this._command:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw d.illegalArgument("command");this._command=N}get args(){return this._args}set args(N){this._args=N||[]}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("shell"),this._commandLine!==void 0&&N.push(this._commandLine),this._command!==void 0&&N.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let Z of this._args)N.push(typeof Z=="string"?Z:Z.value);return _e(N)}};Be=Oe([C],Be),e.ShellExecution=Be;var Re;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Re=e.ShellQuoting||(e.ShellQuoting={}));var qe;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(qe=e.TaskScope||(e.TaskScope={}));class Xe{constructor(N){this._callback=N}computeId(){return"customExecution"+h.generateUuid()}set callback(N){this._callback=N}get callback(){return this._callback}}e.CustomExecution=Xe;let Ue=s=class{constructor(N,Z,pe,Ne,We,xe){this.__deprecated=!1,this._definition=this.definition=N;let Ke;typeof Z=="string"?(this._name=this.name=Z,this._source=this.source=pe,this.execution=Ne,Ke=We,this.__deprecated=!0):Z===qe.Global||Z===qe.Workspace?(this.target=Z,this._name=this.name=pe,this._source=this.source=Ne,this.execution=We,Ke=xe):(this.target=Z,this._name=this.name=pe,this._source=this.source=Ne,this.execution=We,Ke=xe),typeof Ke=="string"?(this._problemMatchers=[Ke],this._hasDefinedMatchers=!0):Array.isArray(Ke)?(this._problemMatchers=Ke,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(N){this.__id=N}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ie?this._definition={type:s.ProcessType,id:this._execution.computeId()}:this._execution instanceof Be?this._definition={type:s.ShellType,id:this._execution.computeId()}:this._execution instanceof Xe?this._definition={type:s.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:s.EmptyType,id:h.generateUuid()}}get definition(){return this._definition}set definition(N){if(N==null)throw d.illegalArgument("Kind can't be undefined or null");this.clear(),this._definition=N}get scope(){return this._scope}set target(N){this.clear(),this._scope=N}get name(){return this._name}set name(N){if(typeof N!="string")throw d.illegalArgument("name");this.clear(),this._name=N}get execution(){return this._execution}set execution(N){N===null&&(N=void 0),this.clear(),this._execution=N;const Z=this._definition.type;(s.EmptyType===Z||s.ProcessType===Z||s.ShellType===Z||s.ExtensionCallbackType===Z)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(N){if(Array.isArray(N))this.clear(),this._problemMatchers=N,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.clear(),this._isBackground=N}get source(){return this._source}set source(N){if(typeof N!="string"||N.length===0)throw d.illegalArgument("source must be a string of length > 0");this.clear(),this._source=N}get group(){return this._group}set group(N){N===null&&(N=void 0),this.clear(),this._group=N}get detail(){return this._detail}set detail(N){N===null&&(N=void 0),this._detail=N}get presentationOptions(){return this._presentationOptions}set presentationOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._presentationOptions=N}get runOptions(){return this._runOptions}set runOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._runOptions=N}};Ue.ExtensionCallbackType="customExecution",Ue.ProcessType="process",Ue.ShellType="shell",Ue.EmptyType="$empty",Ue=s=Oe([C],Ue),e.Task=Ue;var tt;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(tt=e.ProgressLocation||(e.ProgressLocation={}));let it=class{constructor(N,Z=ot.None){this.collapsibleState=Z,L.URI.isUri(N)?this.resourceUri=N:this.label=N}};it=Oe([C],it),e.TreeItem=it;var ot;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(ot=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ut=class{constructor(N,Z){this.id=N,this.color=Z}};ut=Oe([C],ut),e.ThemeIcon=ut,ut.File=new ut("file"),ut.Folder=new ut("folder");let mt=class{constructor(N){this.id=N}};mt=Oe([C],mt),e.ThemeColor=mt;var xt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(xt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let yt=class{constructor(N,Z){if(typeof N!="string"&&(!N||!L.URI.isUri(N)&&!L.URI.isUri(N.uri)))throw d.illegalArgument("base");if(typeof Z!="string")throw d.illegalArgument("pattern");typeof N=="string"?(this.baseFolder=L.URI.file(N),this.base=N):L.URI.isUri(N)?(this.baseFolder=N,this.base=N.fsPath):(this.baseFolder=N.uri,this.base=N.uri.fsPath),this.pattern=Z}};yt=Oe([C],yt),e.RelativePattern=yt;let dt=class{constructor(N,Z,pe,Ne){this.enabled=typeof N=="boolean"?N:!0,typeof Z=="string"&&(this.condition=Z),typeof pe=="string"&&(this.hitCondition=pe),typeof Ne=="string"&&(this.logMessage=Ne)}get id(){return this._id||(this._id=h.generateUuid()),this._id}};dt=Oe([C],dt),e.Breakpoint=dt;let bt=class extends dt{constructor(N,Z,pe,Ne,We){super(Z,pe,Ne,We);if(N===null)throw d.illegalArgument("location");this.location=N}};bt=Oe([C],bt),e.SourceBreakpoint=bt;let St=class extends dt{constructor(N,Z,pe,Ne,We){super(Z,pe,Ne,We);this.functionName=N}};St=Oe([C],St),e.FunctionBreakpoint=St;let _t=class extends dt{constructor(N,Z,pe,Ne,We,xe,Ke){super(Ne,We,xe,Ke);if(!Z)throw d.illegalArgument("dataId");this.label=N,this.dataId=Z,this.canPersist=pe}};_t=Oe([C],_t),e.DataBreakpoint=_t;let It=class{constructor(N,Z,pe){this.command=N,this.args=Z||[],this.options=pe}};It=Oe([C],It),e.DebugAdapterExecutable=It;let Ct=class{constructor(N,Z){this.port=N,this.host=Z}};Ct=Oe([C],Ct),e.DebugAdapterServer=Ct;let Dt=class{constructor(N){this.path=N}};Dt=Oe([C],Dt),e.DebugAdapterNamedPipeServer=Dt;let kt=class{constructor(N){this.implementation=N}};kt=Oe([C],kt),e.DebugAdapterInlineImplementation=kt;let Pt=class{constructor(N,Z){this.range=N,this.expression=Z}};Pt=Oe([C],Pt),e.EvaluatableExpression=Pt;let Tt=class{constructor(N,Z){this.range=N,this.text=Z}};Tt=Oe([C],Tt),e.InlineValueText=Tt;let At=class{constructor(N,Z,pe=!0){this.range=N,this.variableName=Z,this.caseSensitiveLookup=pe}};At=Oe([C],At),e.InlineValueVariableLookup=At;let Rt=class{constructor(N,Z){this.range=N,this.expression=Z}};Rt=Oe([C],Rt),e.InlineValueEvaluatableExpression=Rt;let Lt=class{constructor(N){this.stoppedLocation=N}};Lt=Oe([C],Lt),e.InlineValueContext=Lt;var Kt;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Kt=e.FileChangeType||(e.FileChangeType={}));let Ft=g=class extends Error{constructor(N,Z=n.FileSystemProviderErrorCode.Unknown,pe){var Ne;super(L.URI.isUri(N)?N.toString(!0):N);this.code=(Ne=pe==null?void 0:pe.name)!==null&&Ne!==void 0?Ne:"Unknown",n.markAsFileSystemProviderError(this,Z),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,g.prototype),typeof Error.captureStackTrace=="function"&&typeof pe=="function"&&Error.captureStackTrace(this,pe)}static FileExists(N){return new g(N,n.FileSystemProviderErrorCode.FileExists,g.FileExists)}static FileNotFound(N){return new g(N,n.FileSystemProviderErrorCode.FileNotFound,g.FileNotFound)}static FileNotADirectory(N){return new g(N,n.FileSystemProviderErrorCode.FileNotADirectory,g.FileNotADirectory)}static FileIsADirectory(N){return new g(N,n.FileSystemProviderErrorCode.FileIsADirectory,g.FileIsADirectory)}static NoPermissions(N){return new g(N,n.FileSystemProviderErrorCode.NoPermissions,g.NoPermissions)}static Unavailable(N){return new g(N,n.FileSystemProviderErrorCode.Unavailable,g.Unavailable)}};Ft=g=Oe([C],Ft),e.FileSystemError=Ft;let Ot=class{constructor(N,Z,pe){this.start=N,this.end=Z,this.kind=pe}};Ot=Oe([C],Ot),e.FoldingRange=Ot;var Xt;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Xt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Yt;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Yt=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Qt;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Qt=e.CommentMode||(e.CommentMode={}));class Jt{constructor(N,Z=[]){this.tokenTypes=N,this.tokenModifiers=Z}}e.SemanticTokensLegend=Jt;function Zt(B){return typeof B=="undefined"||k.isStringArray(B)}class Nt{constructor(N){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,N){this._hasLegend=!0;for(let Z=0,pe=N.tokenTypes.length;Z<pe;Z++)this._tokenTypeStrToInt.set(N.tokenTypes[Z],Z);for(let Z=0,pe=N.tokenModifiers.length;Z<pe;Z++)this._tokenModifierStrToInt.set(N.tokenModifiers[Z],Z)}}push(N,Z,pe,Ne,We){if(typeof N=="number"&&typeof Z=="number"&&typeof pe=="number"&&typeof Ne=="number"&&(typeof We=="number"||typeof We=="undefined"))return typeof We=="undefined"&&(We=0),this._pushEncoded(N,Z,pe,Ne,We);if(f.isRange(N)&&typeof Z=="string"&&Zt(pe))return this._push(N,Z,pe);throw d.illegalArgument()}_push(N,Z,pe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(Z))throw new Error("`tokenType` is not in the provided legend");const Ne=N.start.line,We=N.start.character,xe=N.end.character-N.start.character,Ke=this._tokenTypeStrToInt.get(Z);let Ze=0;if(pe)for(const nt of pe){if(!this._tokenModifierStrToInt.has(nt))throw new Error("`tokenModifier` is not in the provided legend");const rt=this._tokenModifierStrToInt.get(nt);Ze|=1<<rt>>>0}this._pushEncoded(Ne,We,xe,Ke,Ze)}_pushEncoded(N,Z,pe,Ne,We){if(this._dataIsSortedAndDeltaEncoded&&(N<this._prevLine||N===this._prevLine&&Z<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ze=this._data.length/5|0;let nt=0,rt=0;for(let at=0;at<Ze;at++){let lt=this._data[5*at],ct=this._data[5*at+1];lt===0?(lt=nt,ct+=rt):lt+=nt,this._data[5*at]=lt,this._data[5*at+1]=ct,nt=lt,rt=ct}}let xe=N,Ke=Z;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(xe-=this._prevLine,xe===0&&(Ke-=this._prevChar)),this._data[this._dataLen++]=xe,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=pe,this._data[this._dataLen++]=Ne,this._data[this._dataLen++]=We,this._prevLine=N,this._prevChar=Z}static _sortAndDeltaEncode(N){let Z=[];const pe=N.length/5|0;for(let Ke=0;Ke<pe;Ke++)Z[Ke]=Ke;Z.sort((Ke,Ze)=>{const nt=N[5*Ke],rt=N[5*Ze];if(nt===rt){const at=N[5*Ke+1],lt=N[5*Ze+1];return at-lt}return nt-rt});const Ne=new Uint32Array(N.length);let We=0,xe=0;for(let Ke=0;Ke<pe;Ke++){const Ze=5*Z[Ke],nt=N[Ze+0],rt=N[Ze+1],at=N[Ze+2],lt=N[Ze+3],ct=N[Ze+4],qt=nt-We,Sn=qt===0?rt-xe:rt,gt=5*Ke;Ne[gt+0]=qt,Ne[gt+1]=Sn,Ne[gt+2]=at,Ne[gt+3]=lt,Ne[gt+4]=ct,We=nt,xe=rt}return Ne}build(N){return this._dataIsSortedAndDeltaEncoded?new Mt(new Uint32Array(this._data),N):new Mt(Nt._sortAndDeltaEncode(this._data),N)}}e.SemanticTokensBuilder=Nt;class Mt{constructor(N,Z){this.resultId=Z,this.data=N}}e.SemanticTokens=Mt;class en{constructor(N,Z,pe){this.start=N,this.deleteCount=Z,this.data=pe}}e.SemanticTokensEdit=en;class tn{constructor(N,Z){this.resultId=Z,this.edits=N}}e.SemanticTokensEdits=tn;var nn;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(nn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var rn;(function(B){B[B.Initial=1]="Initial",B[B.Dynamic=2]="Dynamic"})(rn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let vt=class{constructor(){}};vt.Back={iconPath:new ut("arrow-left")},vt=Oe([C],vt),e.QuickInputButtons=vt;var sn;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(sn=e.ExtensionKind||(e.ExtensionKind={}));class on{constructor(N,Z,pe){this.badge=N,this.tooltip=Z,this.color=pe}static validate(N){if(N.badge&&N.badge.length!==1&&N.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=on;let Ut=class{constructor(N){this.kind=N}};Ut=Oe([C],Ut),e.ColorTheme=Ut;var an;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast"})(an=e.ColorThemeKind||(e.ColorThemeKind={}));class ln{constructor(N,Z){this._start=N,this._end=Z}get start(){return this._start}get end(){return this._end}}e.NotebookCellRange=ln;class Bt{constructor(N,Z,pe,Ne,We,xe,Ke,Ze,nt,rt,at,lt){this.editable=N,this.breakpointMargin=Z,this.runnable=pe,this.hasExecutionOrder=Ne,this.executionOrder=We,this.runState=xe,this.runStartTime=Ke,this.statusMessage=Ze,this.lastRunDuration=nt,this.inputCollapsed=rt,this.outputCollapsed=at,this.custom=lt}with(N){let{editable:Z,breakpointMargin:pe,runnable:Ne,hasExecutionOrder:We,executionOrder:xe,runState:Ke,runStartTime:Ze,statusMessage:nt,lastRunDuration:rt,inputCollapsed:at,outputCollapsed:lt,custom:ct}=N;return Z===void 0?Z=this.editable:Z===null&&(Z=void 0),pe===void 0?pe=this.breakpointMargin:pe===null&&(pe=void 0),Ne===void 0?Ne=this.runnable:Ne===null&&(Ne=void 0),We===void 0?We=this.hasExecutionOrder:We===null&&(We=void 0),xe===void 0?xe=this.executionOrder:xe===null&&(xe=void 0),Ke===void 0?Ke=this.runState:Ke===null&&(Ke=void 0),Ze===void 0?Ze=this.runStartTime:Ze===null&&(Ze=void 0),nt===void 0?nt=this.statusMessage:nt===null&&(nt=void 0),rt===void 0?rt=this.lastRunDuration:rt===null&&(rt=void 0),at===void 0?at=this.inputCollapsed:at===null&&(at=void 0),lt===void 0?lt=this.outputCollapsed:lt===null&&(lt=void 0),ct===void 0?ct=this.custom:ct===null&&(ct=void 0),Z===this.editable&&pe===this.breakpointMargin&&Ne===this.runnable&&We===this.hasExecutionOrder&&xe===this.executionOrder&&Ke===this.runState&&Ze===this.runStartTime&&nt===this.statusMessage&&rt===this.lastRunDuration&&at===this.inputCollapsed&&lt===this.outputCollapsed&&ct===this.custom?this:new Bt(Z,pe,Ne,We,xe,Ke,Ze,nt,rt,at,lt,ct)}}e.NotebookCellMetadata=Bt;class zt{constructor(N=!0,Z=!0,pe=!0,Ne=!0,We=!0,xe=b.NOTEBOOK_DISPLAY_ORDER,Ke={},Ze=Vt.Idle,nt=!0){this.editable=N,this.runnable=Z,this.cellEditable=pe,this.cellRunnable=Ne,this.cellHasExecutionOrder=We,this.displayOrder=xe,this.custom=Ke,this.runState=Ze,this.trusted=nt}with(N){let{editable:Z,runnable:pe,cellEditable:Ne,cellRunnable:We,cellHasExecutionOrder:xe,displayOrder:Ke,custom:Ze,runState:nt,trusted:rt}=N;return Z===void 0?Z=this.editable:Z===null&&(Z=void 0),pe===void 0?pe=this.runnable:pe===null&&(pe=void 0),Ne===void 0?Ne=this.cellEditable:Ne===null&&(Ne=void 0),We===void 0?We=this.cellRunnable:We===null&&(We=void 0),xe===void 0?xe=this.cellHasExecutionOrder:xe===null&&(xe=void 0),Ke===void 0?Ke=this.displayOrder:Ke===null&&(Ke=void 0),Ze===void 0?Ze=this.custom:Ze===null&&(Ze=void 0),nt===void 0?nt=this.runState:nt===null&&(nt=void 0),rt===void 0?rt=this.trusted:rt===null&&(rt=void 0),Z===this.editable&&pe===this.runnable&&Ne===this.cellEditable&&We===this.cellRunnable&&xe===this.cellHasExecutionOrder&&Ke===this.displayOrder&&Ze===this.custom&&nt===this.runState&&rt===this.trusted?this:new zt(Z,pe,Ne,We,xe,Ke,Ze,nt,rt)}}e.NotebookDocumentMetadata=zt;class jt{constructor(N,Z,pe){this.mime=N,this.value=Z,this.metadata=pe}static isNotebookCellOutputItem(N){return N instanceof jt}}e.NotebookCellOutputItem=jt;class cn{constructor(N,Z,pe){this.outputs=N,typeof Z=="string"?(this.id=Z,this.metadata=pe):(this.id=h.generateUuid(),this.metadata=Z!=null?Z:pe)}}e.NotebookCellOutput=cn;var un;(function(B){B[B.Markdown=1]="Markdown",B[B.Code=2]="Code"})(un=e.NotebookCellKind||(e.NotebookCellKind={}));var fn;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle",B[B.Success=3]="Success",B[B.Error=4]="Error"})(fn=e.NotebookCellRunState||(e.NotebookCellRunState={}));var Vt;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(Vt=e.NotebookRunState||(e.NotebookRunState={}));var hn;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(hn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var dn;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(dn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));let Wt=class{constructor(N,Z){this.label=N,this.timestamp=Z}};Wt=Oe([C],Wt),e.TimelineItem=Wt;var mn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(mn=e.ExtensionMode||(e.ExtensionMode={}));var gn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(gn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var vn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=4]="RegEx"})(vn=e.StandardTokenType||(e.StandardTokenType={}));class pn{constructor(N,Z){this.ranges=N,this.wordPattern=Z}}e.LinkedEditingRanges=pn;var wn;(function(B){B[B.Unset=0]="Unset",B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(wn=e.TestRunState||(e.TestRunState={}));var En;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information",B[B.Hint=3]="Hint"})(En=e.TestMessageSeverity||(e.TestMessageSeverity={}));var yn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(yn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var bn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unknown=2]="Unknown"})(bn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}))}),define(fe[99],he([0,1,7]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=S.createDecorator("environmentVariableService");var d;(function(P){P[P.Replace=1]="Replace",P[P.Append=2]="Append",P[P.Prepend=3]="Prepend"})(d=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(fe[208],he([0,1,5,99]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class P{constructor(h){this.map=new Map,h.forEach((n,D)=>{const b=n.map.entries();let I=b.next();for(;!I.done;){const E=I.value[0];let u=this.map.get(E);if(u||(u=[],this.map.set(E,u)),u.length>0&&u[0].type===d.EnvironmentVariableMutatorType.Replace){I=b.next();continue}const v=I.value[1];u.unshift({extensionIdentifier:D,value:v.value,type:v.type}),I=b.next()}})}applyToProcessEnvironment(h,n){let D;S.isWindows&&(D={},Object.keys(h).forEach(b=>D[b.toLowerCase()]=b)),this.map.forEach((b,I)=>{const E=S.isWindows&&D[I.toLowerCase()]||I;b.forEach(u=>{const v=n?n(u.value):u.value;switch(u.type){case d.EnvironmentVariableMutatorType.Append:h[E]=(h[E]||"")+v;break;case d.EnvironmentVariableMutatorType.Prepend:h[E]=v+(h[E]||"");break;case d.EnvironmentVariableMutatorType.Replace:h[E]=v;break}})})}diff(h){const n=new Map,D=new Map,b=new Map;if(h.map.forEach((I,E)=>{const u=this.map.get(E),v=y(I,u);v&&n.set(E,v)}),this.map.forEach((I,E)=>{const u=h.map.get(E),v=y(I,u);v&&b.set(E,v)}),this.map.forEach((I,E)=>{const u=h.map.get(E),v=k(I,u);v&&D.set(E,v)}),!(n.size===0&&D.size===0&&b.size===0))return{added:n,changed:D,removed:b}}}e.MergedEnvironmentVariableCollection=P;function y(L,h){if(!h)return L;const n=new Set;h.forEach(b=>n.add(b.extensionIdentifier));const D=[];return L.forEach(b=>{n.has(b.extensionIdentifier)||D.push(b)}),D.length===0?void 0:D}function k(L,h){if(!!h){const n=new Map;h.forEach(b=>n.set(b.extensionIdentifier,b));const D=[];return L.forEach(b=>{const I=n.get(b.extensionIdentifier);I&&(b.type!==I.type||b.value!==I.value)&&D.push(I)}),D.length===0?void 0:D}}}),define(fe[100],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function S(P){return[...P.entries()]}e.serializeEnvironmentVariableCollection=S;function d(P){return new Map(P)}e.deserializeEnvironmentVariableCollection=d}),define(fe[209],he([0,1,159,47]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.terminalContributionsDescriptor=e.DEFAULT_COMMANDS_TO_SKIP_SHELL=e.TERMINAL_COMMAND_ID=e.TitleEventSource=e.LinuxDistro=e.ProcessState=e.DEFAULT_LOCAL_ECHO_EXCLUDE=e.SUGGESTIONS_FONT_WEIGHT=e.DEFAULT_BOLD_FONT_WEIGHT=e.DEFAULT_FONT_WEIGHT=e.MAXIMUM_FONT_WEIGHT=e.MINIMUM_FONT_WEIGHT=e.DEFAULT_LINE_HEIGHT=e.MINIMUM_LETTER_SPACING=e.DEFAULT_LETTER_SPACING=e.TERMINAL_ACTION_CATEGORY=e.TERMINAL_CONFIG_SECTION=e.TerminalCursorStyle=e.TERMINAL_CREATION_COMMANDS=e.NEVER_MEASURE_RENDER_TIME_STORAGE_KEY=e.IS_WORKSPACE_SHELL_ALLOWED_STORAGE_KEY=e.KEYBINDING_CONTEXT_TERMINAL_PROCESS_SUPPORTED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_NOT_VISIBLE=e.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE=e.KEYBINDING_CONTEXT_TERMINAL_TEXT_NOT_SELECTED=e.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED=e.KEYBINDING_CONTEXT_TERMINAL_A11Y_TREE_FOCUS=e.KEYBINDING_CONTEXT_TERMINAL_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_ALT_BUFFER_ACTIVE=e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE=e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY=e.KEYBINDING_CONTEXT_TERMINAL_FOCUS=e.KEYBINDING_CONTEXT_TERMINAL_IS_OPEN=e.TERMINAL_VIEW_ID=void 0,e.TERMINAL_VIEW_ID="terminal",e.KEYBINDING_CONTEXT_TERMINAL_IS_OPEN=new d.RawContextKey("terminalIsOpen",!1,!0),e.KEYBINDING_CONTEXT_TERMINAL_FOCUS=new d.RawContextKey("terminalFocus",!1,S.localize(0,null)),e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY="terminalShellType",e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE=new d.RawContextKey(e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY,void 0,{type:"string",description:S.localize(1,null)}),e.KEYBINDING_CONTEXT_TERMINAL_ALT_BUFFER_ACTIVE=new d.RawContextKey("terminalAltBufferActive",!1,!0),e.KEYBINDING_CONTEXT_TERMINAL_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FOCUS.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_A11Y_TREE_FOCUS=new d.RawContextKey("terminalA11yTreeFocus",!1,!0),e.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED=new d.RawContextKey("terminalTextSelected",!1,S.localize(2,null)),e.KEYBINDING_CONTEXT_TERMINAL_TEXT_NOT_SELECTED=e.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE=new d.RawContextKey("terminalFindVisible",!1,!0),e.KEYBINDING_CONTEXT_TERMINAL_FIND_NOT_VISIBLE=e.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED=new d.RawContextKey("terminalFindInputFocused",!1,!0),e.KEYBINDING_CONTEXT_TERMINAL_FIND_FOCUSED=new d.RawContextKey("terminalFindFocused",!1,!0),e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_PROCESS_SUPPORTED=new d.RawContextKey("terminalProcessSupported",!1,S.localize(3,null)),e.IS_WORKSPACE_SHELL_ALLOWED_STORAGE_KEY="terminal.integrated.isWorkspaceShellAllowed",e.NEVER_MEASURE_RENDER_TIME_STORAGE_KEY="terminal.integrated.neverMeasureRenderTime",e.TERMINAL_CREATION_COMMANDS=["workbench.action.terminal.toggleTerminal","workbench.action.terminal.new","workbench.action.togglePanel","workbench.action.terminal.focus"],e.TerminalCursorStyle={BLOCK:"block",LINE:"line",UNDERLINE:"underline"},e.TERMINAL_CONFIG_SECTION="terminal.integrated",e.TERMINAL_ACTION_CATEGORY=S.localize(4,null),e.DEFAULT_LETTER_SPACING=0,e.MINIMUM_LETTER_SPACING=-5,e.DEFAULT_LINE_HEIGHT=1,e.MINIMUM_FONT_WEIGHT=1,e.MAXIMUM_FONT_WEIGHT=1e3,e.DEFAULT_FONT_WEIGHT="normal",e.DEFAULT_BOLD_FONT_WEIGHT="bold",e.SUGGESTIONS_FONT_WEIGHT=["normal","bold","100","200","300","400","500","600","700","800","900"],e.DEFAULT_LOCAL_ECHO_EXCLUDE=["vim","vi","nano","tmux"];var P;(function(h){h[h.UNINITIALIZED=0]="UNINITIALIZED",h[h.LAUNCHING=1]="LAUNCHING",h[h.RUNNING=2]="RUNNING",h[h.KILLED_DURING_LAUNCH=3]="KILLED_DURING_LAUNCH",h[h.KILLED_BY_USER=4]="KILLED_BY_USER",h[h.KILLED_BY_PROCESS=5]="KILLED_BY_PROCESS"})(P=e.ProcessState||(e.ProcessState={}));var y;(function(h){h[h.Fedora=0]="Fedora",h[h.Ubuntu=1]="Ubuntu",h[h.Unknown=2]="Unknown"})(y=e.LinuxDistro||(e.LinuxDistro={}));var k;(function(h){h[h.Api=0]="Api",h[h.Process=1]="Process",h[h.Sequence=2]="Sequence"})(k=e.TitleEventSource||(e.TitleEventSource={}));var L;(function(h){h.FIND_NEXT="workbench.action.terminal.findNext",h.FIND_PREVIOUS="workbench.action.terminal.findPrevious",h.TOGGLE="workbench.action.terminal.toggleTerminal",h.KILL="workbench.action.terminal.kill",h.QUICK_KILL="workbench.action.terminal.quickKill",h.CONFIGURE_TERMINAL_SETTINGS="workbench.action.terminal.openSettings",h.COPY_SELECTION="workbench.action.terminal.copySelection",h.SELECT_ALL="workbench.action.terminal.selectAll",h.DELETE_WORD_LEFT="workbench.action.terminal.deleteWordLeft",h.DELETE_WORD_RIGHT="workbench.action.terminal.deleteWordRight",h.DELETE_TO_LINE_START="workbench.action.terminal.deleteToLineStart",h.MOVE_TO_LINE_START="workbench.action.terminal.moveToLineStart",h.MOVE_TO_LINE_END="workbench.action.terminal.moveToLineEnd",h.NEW="workbench.action.terminal.new",h.NEW_WITH_CWD="workbench.action.terminal.newWithCwd",h.NEW_LOCAL="workbench.action.terminal.newLocal",h.NEW_IN_ACTIVE_WORKSPACE="workbench.action.terminal.newInActiveWorkspace",h.SPLIT="workbench.action.terminal.split",h.SPLIT_IN_ACTIVE_WORKSPACE="workbench.action.terminal.splitInActiveWorkspace",h.RELAUNCH="workbench.action.terminal.relaunch",h.FOCUS_PREVIOUS_PANE="workbench.action.terminal.focusPreviousPane",h.FOCUS_NEXT_PANE="workbench.action.terminal.focusNextPane",h.RESIZE_PANE_LEFT="workbench.action.terminal.resizePaneLeft",h.RESIZE_PANE_RIGHT="workbench.action.terminal.resizePaneRight",h.RESIZE_PANE_UP="workbench.action.terminal.resizePaneUp",h.RESIZE_PANE_DOWN="workbench.action.terminal.resizePaneDown",h.FOCUS="workbench.action.terminal.focus",h.FOCUS_NEXT="workbench.action.terminal.focusNext",h.FOCUS_PREVIOUS="workbench.action.terminal.focusPrevious",h.PASTE="workbench.action.terminal.paste",h.SELECT_DEFAULT_SHELL="workbench.action.terminal.selectDefaultShell",h.RUN_SELECTED_TEXT="workbench.action.terminal.runSelectedText",h.RUN_ACTIVE_FILE="workbench.action.terminal.runActiveFile",h.SWITCH_TERMINAL="workbench.action.terminal.switchTerminal",h.SCROLL_DOWN_LINE="workbench.action.terminal.scrollDown",h.SCROLL_DOWN_PAGE="workbench.action.terminal.scrollDownPage",h.SCROLL_TO_BOTTOM="workbench.action.terminal.scrollToBottom",h.SCROLL_UP_LINE="workbench.action.terminal.scrollUp",h.SCROLL_UP_PAGE="workbench.action.terminal.scrollUpPage",h.SCROLL_TO_TOP="workbench.action.terminal.scrollToTop",h.CLEAR="workbench.action.terminal.clear",h.CLEAR_SELECTION="workbench.action.terminal.clearSelection",h.MANAGE_WORKSPACE_SHELL_PERMISSIONS="workbench.action.terminal.manageWorkspaceShellPermissions",h.RENAME="workbench.action.terminal.rename",h.RENAME_WITH_ARG="workbench.action.terminal.renameWithArg",h.FIND_FOCUS="workbench.action.terminal.focusFind",h.FIND_HIDE="workbench.action.terminal.hideFind",h.QUICK_OPEN_TERM="workbench.action.quickOpenTerm",h.SCROLL_TO_PREVIOUS_COMMAND="workbench.action.terminal.scrollToPreviousCommand",h.SCROLL_TO_NEXT_COMMAND="workbench.action.terminal.scrollToNextCommand",h.SELECT_TO_PREVIOUS_COMMAND="workbench.action.terminal.selectToPreviousCommand",h.SELECT_TO_NEXT_COMMAND="workbench.action.terminal.selectToNextCommand",h.SELECT_TO_PREVIOUS_LINE="workbench.action.terminal.selectToPreviousLine",h.SELECT_TO_NEXT_LINE="workbench.action.terminal.selectToNextLine",h.TOGGLE_ESCAPE_SEQUENCE_LOGGING="toggleEscapeSequenceLogging",h.SEND_SEQUENCE="workbench.action.terminal.sendSequence",h.TOGGLE_FIND_REGEX="workbench.action.terminal.toggleFindRegex",h.TOGGLE_FIND_WHOLE_WORD="workbench.action.terminal.toggleFindWholeWord",h.TOGGLE_FIND_CASE_SENSITIVE="workbench.action.terminal.toggleFindCaseSensitive",h.NAVIGATION_MODE_EXIT="workbench.action.terminal.navigationModeExit",h.NAVIGATION_MODE_FOCUS_NEXT="workbench.action.terminal.navigationModeFocusNext",h.NAVIGATION_MODE_FOCUS_PREVIOUS="workbench.action.terminal.navigationModeFocusPrevious",h.SHOW_ENVIRONMENT_INFORMATION="workbench.action.terminal.showEnvironmentInformation",h.SEARCH_WORKSPACE="workbench.action.terminal.searchWorkspace",h.ATTACH_TO_REMOTE_TERMINAL="workbench.action.terminal.attachToSession"})(L=e.TERMINAL_COMMAND_ID||(e.TERMINAL_COMMAND_ID={})),e.DEFAULT_COMMANDS_TO_SKIP_SHELL=["workbench.action.terminal.clearSelection","workbench.action.terminal.clear","workbench.action.terminal.copySelection","workbench.action.terminal.deleteToLineStart","workbench.action.terminal.deleteWordLeft","workbench.action.terminal.deleteWordRight","workbench.action.terminal.focusFind","workbench.action.terminal.hideFind","workbench.action.terminal.findNext","workbench.action.terminal.findPrevious","workbench.action.terminal.toggleFindRegex","workbench.action.terminal.toggleFindWholeWord","workbench.action.terminal.toggleFindCaseSensitive","workbench.action.terminal.focusNextPane","workbench.action.terminal.focusNext","workbench.action.terminal.focusPreviousPane","workbench.action.terminal.focusPrevious","workbench.action.terminal.focus","workbench.action.terminal.kill","workbench.action.terminal.moveToLineEnd","workbench.action.terminal.moveToLineStart","workbench.action.terminal.newInActiveWorkspace","workbench.action.terminal.new","workbench.action.terminal.paste","workbench.action.terminal.resizePaneDown","workbench.action.terminal.resizePaneLeft","workbench.action.terminal.resizePaneRight","workbench.action.terminal.resizePaneUp","workbench.action.terminal.runActiveFile","workbench.action.terminal.runSelectedText","workbench.action.terminal.scrollDown","workbench.action.terminal.scrollDownPage","workbench.action.terminal.scrollToBottom","workbench.action.terminal.scrollToNextCommand","workbench.action.terminal.scrollToPreviousCommand","workbench.action.terminal.scrollToTop","workbench.action.terminal.scrollUp","workbench.action.terminal.scrollUpPage","workbench.action.terminal.sendSequence","workbench.action.terminal.selectAll","workbench.action.terminal.selectToNextCommand","workbench.action.terminal.selectToNextLine","workbench.action.terminal.selectToPreviousCommand","workbench.action.terminal.selectToPreviousLine","workbench.action.terminal.splitInActiveWorkspace","workbench.action.terminal.split","workbench.action.terminal.toggleTerminal","workbench.action.terminal.navigationModeExit","workbench.action.terminal.navigationModeFocusNext","workbench.action.terminal.navigationModeFocusPrevious","editor.action.toggleTabFocusMode","workbench.action.quickOpen","workbench.action.quickOpenPreviousEditor","workbench.action.showCommands","workbench.action.tasks.build","workbench.action.tasks.restartTask","workbench.action.tasks.runTask","workbench.action.tasks.reRunTask","workbench.action.tasks.showLog","workbench.action.tasks.showTasks","workbench.action.tasks.terminate","workbench.action.tasks.test","workbench.action.toggleFullScreen","workbench.action.terminal.focusAtIndex1","workbench.action.terminal.focusAtIndex2","workbench.action.terminal.focusAtIndex3","workbench.action.terminal.focusAtIndex4","workbench.action.terminal.focusAtIndex5","workbench.action.terminal.focusAtIndex6","workbench.action.terminal.focusAtIndex7","workbench.action.terminal.focusAtIndex8","workbench.action.terminal.focusAtIndex9","workbench.action.focusSecondEditorGroup","workbench.action.focusThirdEditorGroup","workbench.action.focusFourthEditorGroup","workbench.action.focusFifthEditorGroup","workbench.action.focusSixthEditorGroup","workbench.action.focusSeventhEditorGroup","workbench.action.focusEighthEditorGroup","workbench.action.focusNextPart","workbench.action.focusPreviousPart","workbench.action.nextPanelView","workbench.action.previousPanelView","workbench.action.nextSideBarView","workbench.action.previousSideBarView","workbench.action.debug.start","workbench.action.debug.stop","workbench.action.debug.run","workbench.action.debug.restart","workbench.action.debug.continue","workbench.action.debug.pause","workbench.action.debug.stepInto","workbench.action.debug.stepOut","workbench.action.debug.stepOver","workbench.action.nextEditor","workbench.action.previousEditor","workbench.action.nextEditorInGroup","workbench.action.previousEditorInGroup","workbench.action.openNextRecentlyUsedEditor","workbench.action.openPreviousRecentlyUsedEditor","workbench.action.openNextRecentlyUsedEditorInGroup","workbench.action.openPreviousRecentlyUsedEditorInGroup","workbench.action.quickOpenPreviousRecentlyUsedEditor","workbench.action.quickOpenLeastRecentlyUsedEditor","workbench.action.quickOpenPreviousRecentlyUsedEditorInGroup","workbench.action.quickOpenLeastRecentlyUsedEditorInGroup","workbench.action.focusActiveEditorGroup","workbench.action.focusFirstEditorGroup","workbench.action.focusLastEditorGroup","workbench.action.firstEditorInGroup","workbench.action.lastEditorInGroup","workbench.action.navigateUp","workbench.action.navigateDown","workbench.action.navigateRight","workbench.action.navigateLeft","workbench.action.togglePanel","workbench.action.quickOpenView","workbench.action.toggleMaximizedPanel"],e.terminalContributionsDescriptor={extensionPoint:"terminal",defaultExtensionKind:"workspace",jsonSchema:{description:S.localize(5,null),type:"object",properties:{types:{type:"array",description:S.localize(6,null),items:{type:"object",required:["command","title"],properties:{command:{description:S.localize(7,null),type:"string"},title:{description:S.localize(8,null),type:"string"}}}}}}}}),define(fe[210],he([0,1,2,5,110]),function(Q,e,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.escapeNonWindowsPath=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function y(r,t){if(!!t)if(d.isWindows)for(const i in t){let o=i;for(const s in r)if(i.toLowerCase()===s.toLowerCase()){o=s;break}const a=t[i];k(r,o,a)}else Object.keys(t).forEach(i=>{const o=t[i];k(r,i,o)})}e.mergeEnvironments=y;function k(r,t,i){typeof i=="string"?r[t]=i:delete r[t]}function L(r,t,i,o){r.TERM_PROGRAM="vscode",t&&(r.TERM_PROGRAM_VERSION=t),D(r,o)&&(r.LANG=b(i)),r.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=L;function h(r,t){if(!!t)for(const i of Object.keys(t)){const o=t[i];o&&(r[i]=o)}}function n(r,t){return Object.keys(t).forEach(i=>{const o=t[i];if(typeof o=="string")try{t[i]=r(o)}catch(a){t[i]=o}}),t}function D(r,t){if(t==="on")return!0;if(t==="auto"){const i=r.LANG;return!i||i.search(/\.UTF\-8$/)===-1&&i.search(/\.utf8$/)===-1&&i.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=D;function b(r){const t=r?r.split("-"):[],i=t.length;if(i===0)return"en_US.UTF-8";if(i===1){const o={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in o&&t.push(o[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.getLangEnvVariable=b;function I(r,t,i,o,a,s){if(r.cwd){const C=typeof r.cwd=="object"?r.cwd.fsPath:r.cwd,R=E(C,i);return u(R||C)}let g;return!r.ignoreConfigurationCwd&&a&&(i&&(a=E(a,i,s)),a&&(S.isAbsolute(a)?g=a:o&&(g=S.join(o.fsPath,a)))),g||(g=o?o.fsPath:t||""),u(g)}e.getCwd=I;function E(r,t,i){if(t)try{return t(r)}catch(o){i==null||i.error("Could not resolve terminal cwd",o);return}return r}function u(r){return d.platform===3&&r&&r[1]===":"?r[0].toUpperCase()+r.substr(1):r}function v(r){let t=r;t.indexOf("\\")!==0&&(t=t.replace(/\\/g,"\\\\")),t.indexOf(" ")!==-1&&(t=t.replace(/ /g,"\\ "));const i=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return t=t.replace(i,""),`'${t}'`}e.escapeNonWindowsPath=v;function _(r,t){if(!!t)return i=>t.resolve(r,i)}e.createVariableResolver=_;function w(r,t,i,o,a,s,g,C,R=d.platform){let p=null;C&&(p=l(r,t,"automationShell",R)),p||(p=l(r,t,"shell",R));let f=p||i;if(R===3&&!o&&a){const T=S.join(a,"Sysnative").replace(/\//g,"\\").toLowerCase();f&&f.toLowerCase().indexOf(T)===0&&(f=S.join(a,"System32",f.substr(T.length+1)))}if(f&&R===3&&(f=f.replace(/\//g,"\\")),s)try{f=s(f)}catch(T){g.error("Could not resolve shell",T)}return f}e.getDefaultShell=w;function m(r,t,i,o,a,s=d.platform){if(i&&l(r,t,"automationShell",s))return[];const g=s===3?"windows":s===1?"osx":"linux",C=r(`terminal.integrated.shellArgs.${g}`);let R=(t?C.value:C.userValue)||C.defaultValue;if(!R)return[];if(typeof R=="string"&&s===3)return o?o(R):R;if(o){const p=[];for(const f of R)try{p.push(o(f))}catch(T){a.error(`Could not resolve terminal.integrated.shellArgs.${g}`,T),p.push(f)}R=p}return R}e.getDefaultShellArgs=m;function l(r,t,i,o=d.platform){const s=r(`terminal.integrated.${i}.${o===3?"windows":o===1?"osx":"linux"}`);return(t?s.value:s.userValue)||s.defaultValue}function c(r,t,i,o,a,s,g){let C={};if(r.strictEnv)h(C,r.env);else{h(C,g);const R=Object.assign({},o?t.value:t.userValue);i&&(R&&n(i,R),r.env&&n(i,r.env)),P.sanitizeProcessEnvironment(C,"VSCODE_IPC_HOOK_CLI"),y(C,R),y(C,r.env),L(C,a,d.locale,s)}return C}e.createTerminalEnvironment=c}),define(fe[211],he([0,1,15,2,5]),function(Q,e,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMainProcessParentEnv=void 0;let y;async function k(L=process.env){if(y)return y;if(P.isLinux){const h=process.ppid,n=d.basename(process.argv[0]);let D=0,b=h,I=n;do D=b,(await S.promises.readFile(`/proc/${D}/status`,"utf8")).split(`
`).forEach(w=>{w.indexOf("Name:")===0&&(I=w.replace(/^Name:\s+/,"")),w.indexOf("PPid:")===0&&(b=parseInt(w.replace(/^PPid:\s+/,"")))});while(I===n);const E=await S.promises.readFile(`/proc/${D}/environ`,"utf8"),u={};E.split("\0").forEach(v=>{const _=v.indexOf("=");u[v.substr(0,_)]=v.substr(_+1)}),y=u}return P.isMacintosh&&(y={},["SHELL","SSH_AUTH_SOCK","Apple_PubSub_Socket_Render","XPC_FLAGS","XPC_SERVICE_NAME","HOME","LOGNAME","TMPDIR"].forEach(n=>{L[n]&&(y[n]=L[n])})),P.isWindows&&(y=L),y}e.getMainProcessParentEnv=k}),define(fe[212],he([0,1,7]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.LOCAL_MACHINE_SCOPES=[1,3,4,5],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=S.createDecorator("configurationService"),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(fe[213],he([0,1,7]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=S.createDecorator("configurationResolverService")}),define(fe[214],he([0,1,2,36,11,19,5,53,160]),function(Q,e,S,d,P,y,k,L,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class n{constructor(b,I,E){if(this._contributedVariables=new Map,this._context=b,this._labelService=I,E)if(k.isWindows){const u=Object.create(null);this._envVariables=u,Object.keys(E).forEach(v=>{u[v.toLowerCase()]=E[v]})}else this._envVariables=E}resolve(b,I){return this.recursiveResolve(b?b.uri:void 0,I)}resolveAnyBase(b,I,E,u){const v=y.deepClone(I);return k.isWindows&&v.windows?Object.keys(v.windows).forEach(_=>v[_]=v.windows[_]):k.isMacintosh&&v.osx?Object.keys(v.osx).forEach(_=>v[_]=v.osx[_]):k.isLinux&&v.linux&&Object.keys(v.linux).forEach(_=>v[_]=v.linux[_]),delete v.windows,delete v.osx,delete v.linux,this.recursiveResolve(b?b.uri:void 0,v,E,u)}resolveAny(b,I,E){return this.resolveAnyBase(b,I,E)}resolveAnyMap(b,I,E){const u=new Map;return{newConfig:this.resolveAnyBase(b,I,E,u),resolvedVariables:u}}resolveWithInteractionReplace(b,I,E,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,I,E,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,I){if(this._contributedVariables.has(b))throw new Error("Variable "+b+" is contributed twice.");this._contributedVariables.set(b,I)}recursiveResolve(b,I,E,u){if(P.isString(I))return this.resolveString(b,I,E,u);if(P.isArray(I))return I.map(v=>this.recursiveResolve(b,v,E,u));if(P.isObject(I)){let v=Object.create(null);return Object.keys(I).forEach(_=>{const w=this.resolveString(b,_,E,u);v[w]=this.recursiveResolve(b,I[_],E,u)}),v}return I}resolveString(b,I,E,u){return I.replace(n.VARIABLE_REGEXP,(_,w)=>{if(w.includes(n.VARIABLE_LHS))return _;let m=this.evaluateSingleVariable(_,w,b,E);return u&&u.set(w,m),m})}fsPath(b){return this._labelService?this._labelService.getUriLabel(b,{noPrefix:!0}):b.fsPath}evaluateSingleVariable(b,I,E,u){let v;const _=I.split(":");_.length>1&&(I=_[0],v=_[1]);const w=()=>{const c=this._context.getFilePath();if(c)return c;throw new Error(h.localize(0,null,b))},m=()=>{const c=w();if(this._context.getWorkspaceFolderPathForFile){const r=this._context.getWorkspaceFolderPathForFile();if(r)return r}throw new Error(h.localize(1,null,b,S.basename(c)))},l=()=>{if(v){const c=this._context.getFolderUri(v);if(c)return c;throw new Error(h.localize(2,null,b,v))}if(E)return E;throw this._context.getWorkspaceFolderCount()>1?new Error(h.localize(3,null,b)):new Error(h.localize(4,null,b))};switch(I){case"env":if(v){if(this._envVariables){const c=this._envVariables[k.isWindows?v.toLowerCase():v];if(P.isString(c))return c}return""}throw new Error(h.localize(5,null,b));case"config":if(v){const c=this._context.getConfigurationValue(E,v);if(P.isUndefinedOrNull(c))throw new Error(h.localize(6,null,b,v));if(P.isObject(c))throw new Error(h.localize(7,null,b,v));return c}throw new Error(h.localize(8,null,b));case"command":return this.resolveFromMap(b,v,u,"command");case"input":return this.resolveFromMap(b,v,u,"input");default:switch(I){case"workspaceRoot":case"workspaceFolder":return L.normalizeDriveLetter(this.fsPath(l()));case"cwd":return E||v?L.normalizeDriveLetter(this.fsPath(l())):d.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return S.basename(this.fsPath(l()));case"lineNumber":const c=this._context.getLineNumber();if(c)return c;throw new Error(h.localize(9,null,b));case"selectedText":const r=this._context.getSelectedText();if(r)return r;throw new Error(h.localize(10,null,b));case"file":return w();case"fileWorkspaceFolder":return m();case"relativeFile":return E||v?S.relative(this.fsPath(l()),w()):w();case"relativeFileDirname":const t=S.dirname(w());if(E||v){const s=S.relative(this.fsPath(l()),t);return s.length===0?".":s}return t;case"fileDirname":return S.dirname(w());case"fileExtname":return S.extname(w());case"fileBasename":return S.basename(w());case"fileBasenameNoExtension":const i=S.basename(w());return i.slice(0,i.length-S.extname(i).length);case"fileDirnameBasename":return S.basename(S.dirname(w()));case"execPath":const o=this._context.getExecPath();return o||b;case"execInstallFolder":const a=this._context.getAppRoot();return a||b;case"pathSeparator":return S.sep;default:try{const s=v?`${I}:${v}`:I;return this.resolveFromMap(b,s,u,void 0)}catch(s){return b}}}}resolveFromMap(b,I,E,u){if(I&&E){const v=u===void 0?E[I]:E[u+":"+I];if(typeof v=="string")return v;throw new Error(h.localize(11,null,b))}return b}}e.AbstractVariableResolverService=n,n.VARIABLE_LHS="${",n.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(fe[66],he([0,1,7]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=S.createDecorator("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(fe[215],he([0,1,174,98,164,3,55,72,185,66,11,237,45,19,16,97]),function(Q,e,S,d,P,y,k,L,h,n,D,b,I,E,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestResults=e.TestItem=e.TestState=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var _;(function(se){function oe(G){const{selectionStartLineNumber:_e,selectionStartColumn:Ie,positionLineNumber:Be,positionColumn:Re}=G,qe=new d.Position(_e-1,Ie-1),Xe=new d.Position(Be-1,Re-1);return new d.Selection(qe,Xe)}se.to=oe;function Y(G){const{anchor:_e,active:Ie}=G;return{selectionStartLineNumber:_e.line+1,selectionStartColumn:_e.character+1,positionLineNumber:Ie.line+1,positionColumn:Ie.character+1}}se.from=Y})(_=e.Selection||(e.Selection={}));var w;(function(se){function oe(G){if(!!G){const{start:_e,end:Ie}=G;return{startLineNumber:_e.line+1,startColumn:_e.character+1,endLineNumber:Ie.line+1,endColumn:Ie.character+1}}}se.from=oe;function Y(G){if(!!G){const{startLineNumber:_e,startColumn:Ie,endLineNumber:Be,endColumn:Re}=G;return new d.Range(_e-1,Ie-1,Be-1,Re-1)}}se.to=Y})(w=e.Range||(e.Range={}));var m;(function(se){function oe(Y){switch(Y){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 4:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}se.to=oe})(m=e.TokenType||(e.TokenType={}));var l;(function(se){function oe(G){return new d.Position(G.lineNumber-1,G.column-1)}se.to=oe;function Y(G){return{lineNumber:G.line+1,column:G.character+1}}se.from=Y})(l=e.Position||(e.Position={}));var c;(function(se){function oe(G){switch(G){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}se.from=oe;function Y(G){switch(G){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}se.to=Y})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(se){function oe(G){let _e;return G.code&&(D.isString(G.code)||D.isNumber(G.code)?_e=String(G.code):_e={value:String(G.code.value),target:G.code.target}),Object.assign(Object.assign({},w.from(G.range)),{message:G.message,source:G.source,code:_e,severity:i.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(t.from),tags:Array.isArray(G.tags)?u.coalesce(G.tags.map(c.from)):void 0})}se.from=oe;function Y(G){var _e;const Ie=new d.Diagnostic(w.to(G),G.message,i.to(G.severity));return Ie.source=G.source,Ie.code=D.isString(G.code)?G.code:(_e=G.code)===null||_e===void 0?void 0:_e.value,Ie.relatedInformation=G.relatedInformation&&G.relatedInformation.map(t.to),Ie.tags=G.tags&&u.coalesce(G.tags.map(c.to)),Ie}se.to=Y})(r=e.Diagnostic||(e.Diagnostic={}));var t;(function(se){function oe(G){return Object.assign(Object.assign({},w.from(G.location.range)),{message:G.message,resource:G.location.uri})}se.from=oe;function Y(G){return new d.DiagnosticRelatedInformation(new d.Location(G.resource,w.to(G)),G.message)}se.to=Y})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(se){function oe(G){switch(G){case d.DiagnosticSeverity.Error:return h.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return h.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return h.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return h.MarkerSeverity.Hint}return h.MarkerSeverity.Error}se.from=oe;function Y(G){switch(G){case h.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case h.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case h.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case h.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}se.to=Y})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var o;(function(se){function oe(G){return typeof G=="number"&&G>=d.ViewColumn.One?G-1:G===d.ViewColumn.Beside?n.SIDE_GROUP:n.ACTIVE_GROUP}se.from=oe;function Y(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}se.to=Y})(o=e.ViewColumn||(e.ViewColumn={}));function a(se){return typeof se.range!="undefined"}function s(se){return se.length===0?!0:!!a(se[0])}e.isDecorationOptionsArr=s;var g;(function(se){function oe(Re){return Re.map(se.from)}se.fromMany=oe;function Y(Re){return Re&&typeof Re=="object"&&typeof Re.language=="string"&&typeof Re.value=="string"}function G(Re){let qe;if(Y(Re)){const{language:it,value:ot}=Re;qe={value:"```"+it+`
`+ot+"\n```\n"}}else d.MarkdownString.isMarkdownString(Re)?qe={value:Re.value,isTrusted:Re.isTrusted,supportThemeIcons:Re.supportThemeIcons}:typeof Re=="string"?qe={value:Re}:qe={value:""};const Xe=Object.create(null);qe.uris=Xe;const Ue=it=>{try{let ot=y.URI.parse(it,!0);ot=ot.with({query:_e(ot.query,Xe)}),Xe[it]=ot}catch(ot){}return""},tt=new b.Renderer;return tt.link=Ue,tt.image=it=>Ue(L.parseHrefAndDimensions(it).href),b(qe.value,{renderer:tt}),qe}se.from=G;function _e(Re,qe){if(!Re)return Re;let Xe;try{Xe=I.parse(Re)}catch(tt){}if(!Xe)return Re;let Ue=!1;return Xe=E.cloneAndChange(Xe,tt=>{if(y.URI.isUri(tt)){const it=`__uri_${Math.random().toString(16).slice(2,8)}`;return qe[it]=tt,Ue=!0,it}else return}),Ue?JSON.stringify(Xe):Re}function Ie(Re){const qe=new d.MarkdownString(Re.value,Re.supportThemeIcons);return qe.isTrusted=Re.isTrusted,qe}se.to=Ie;function Be(Re){if(!!Re)return typeof Re=="string"?Re:se.from(Re)}se.fromStrict=Be})(g=e.MarkdownString||(e.MarkdownString={}));function C(se){return s(se)?se.map(oe=>({range:w.from(oe.range),hoverMessage:Array.isArray(oe.hoverMessage)?g.fromMany(oe.hoverMessage):oe.hoverMessage?g.from(oe.hoverMessage):void 0,renderOptions:oe.renderOptions})):se.map(oe=>({range:w.from(oe)}))}e.fromRangeOrRangeWithMessage=C;function R(se){return typeof se=="undefined"?se:typeof se=="string"?y.URI.file(se):se}e.pathOrURIToURI=R;var p;(function(se){function oe(Y){return typeof Y=="undefined"?Y:{contentText:Y.contentText,contentIconPath:Y.contentIconPath?R(Y.contentIconPath):void 0,border:Y.border,borderColor:Y.borderColor,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,color:Y.color,backgroundColor:Y.backgroundColor,margin:Y.margin,width:Y.width,height:Y.height}}se.from=oe})(p=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var f;(function(se){function oe(Y){return typeof Y=="undefined"?Y:{backgroundColor:Y.backgroundColor,outline:Y.outline,outlineColor:Y.outlineColor,outlineStyle:Y.outlineStyle,outlineWidth:Y.outlineWidth,border:Y.border,borderColor:Y.borderColor,borderRadius:Y.borderRadius,borderSpacing:Y.borderSpacing,borderStyle:Y.borderStyle,borderWidth:Y.borderWidth,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,cursor:Y.cursor,color:Y.color,opacity:Y.opacity,letterSpacing:Y.letterSpacing,gutterIconPath:Y.gutterIconPath?R(Y.gutterIconPath):void 0,gutterIconSize:Y.gutterIconSize,overviewRulerColor:Y.overviewRulerColor,before:Y.before?p.from(Y.before):void 0,after:Y.after?p.from(Y.after):void 0}}se.from=oe})(f=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var T;(function(se){function oe(Y){if(typeof Y=="undefined")return Y;switch(Y){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}se.from=oe})(T=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var O;(function(se){function oe(Y){return{isWholeLine:Y.isWholeLine,rangeBehavior:Y.rangeBehavior?T.from(Y.rangeBehavior):void 0,overviewRulerLane:Y.overviewRulerLane,light:Y.light?f.from(Y.light):void 0,dark:Y.dark?f.from(Y.dark):void 0,backgroundColor:Y.backgroundColor,outline:Y.outline,outlineColor:Y.outlineColor,outlineStyle:Y.outlineStyle,outlineWidth:Y.outlineWidth,border:Y.border,borderColor:Y.borderColor,borderRadius:Y.borderRadius,borderSpacing:Y.borderSpacing,borderStyle:Y.borderStyle,borderWidth:Y.borderWidth,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,cursor:Y.cursor,color:Y.color,opacity:Y.opacity,letterSpacing:Y.letterSpacing,gutterIconPath:Y.gutterIconPath?R(Y.gutterIconPath):void 0,gutterIconSize:Y.gutterIconSize,overviewRulerColor:Y.overviewRulerColor,before:Y.before?p.from(Y.before):void 0,after:Y.after?p.from(Y.after):void 0}}se.from=oe})(O=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var H;(function(se){function oe(G){return{text:G.newText,eol:G.newEol&&Ve.from(G.newEol),range:w.from(G.range)}}se.from=oe;function Y(G){const _e=new d.TextEdit(w.to(G.range),G.text);return _e.newEol=typeof G.eol=="undefined"?void 0:Ve.to(G.eol),_e}se.to=Y})(H=e.TextEdit||(e.TextEdit={}));var $;(function(se){function oe(G,_e,Ie){var Be,Re,qe;const Xe={edits:[]};if(G instanceof d.WorkspaceEdit)for(let Ue of G._allEntries())if(Ue._type===1)Xe.edits.push({_type:1,oldUri:Ue.from,newUri:Ue.to,options:Ue.options,metadata:Ue.metadata});else if(Ue._type===2){const tt=_e==null?void 0:_e.getDocument(Ue.uri);Xe.edits.push({_type:2,resource:Ue.uri,edit:H.from(Ue.edit),modelVersionId:tt==null?void 0:tt.version,metadata:Ue.metadata})}else Ue._type===3?Xe.edits.push({_type:3,metadata:Ue.metadata,resource:Ue.uri,edit:Ue.edit,notebookMetadata:Ue.notebookMetadata,notebookVersionId:(Be=Ie==null?void 0:Ie.lookupNotebookDocument(Ue.uri))===null||Be===void 0?void 0:Be.notebookDocument.version}):Ue._type===4?(Ue.newOutputs&&Xe.edits.push({_type:3,metadata:Ue.metadata,resource:Ue.uri,edit:{editType:2,index:Ue.index,append:Ue.append,outputs:Ue.newOutputs.map(ue.from)}}),Ue.newMetadata&&Xe.edits.push({_type:3,metadata:Ue.metadata,resource:Ue.uri,edit:{editType:3,index:Ue.index,metadata:Ue.newMetadata}})):Ue._type===5?Xe.edits.push({_type:3,metadata:Ue.metadata,resource:Ue.uri,notebookVersionId:(Re=Ie==null?void 0:Ie.lookupNotebookDocument(Ue.uri))===null||Re===void 0?void 0:Re.notebookDocument.version,edit:{editType:1,index:Ue.index,count:Ue.count,cells:Ue.cells.map(te.from)}}):Ue._type===6&&Xe.edits.push({_type:3,metadata:Ue.metadata,resource:Ue.uri,edit:{editType:10,index:Ue.index,outputId:Ue.outputId,items:((qe=Ue.newOutputItems)===null||qe===void 0?void 0:qe.map(ie.from))||[],append:Ue.append}});return Xe}se.from=oe;function Y(G){const _e=new d.WorkspaceEdit;for(const Ie of G.edits)Ie.edit?_e.replace(y.URI.revive(Ie.resource),w.to(Ie.edit.range),Ie.edit.text):_e.renameFile(y.URI.revive(Ie.oldUri),y.URI.revive(Ie.newUri),Ie.options);return _e}se.to=Y})($=e.WorkspaceEdit||(e.WorkspaceEdit={}));var x;(function(se){const oe=Object.create(null);oe[d.SymbolKind.File]=0,oe[d.SymbolKind.Module]=1,oe[d.SymbolKind.Namespace]=2,oe[d.SymbolKind.Package]=3,oe[d.SymbolKind.Class]=4,oe[d.SymbolKind.Method]=5,oe[d.SymbolKind.Property]=6,oe[d.SymbolKind.Field]=7,oe[d.SymbolKind.Constructor]=8,oe[d.SymbolKind.Enum]=9,oe[d.SymbolKind.Interface]=10,oe[d.SymbolKind.Function]=11,oe[d.SymbolKind.Variable]=12,oe[d.SymbolKind.Constant]=13,oe[d.SymbolKind.String]=14,oe[d.SymbolKind.Number]=15,oe[d.SymbolKind.Boolean]=16,oe[d.SymbolKind.Array]=17,oe[d.SymbolKind.Object]=18,oe[d.SymbolKind.Key]=19,oe[d.SymbolKind.Null]=20,oe[d.SymbolKind.EnumMember]=21,oe[d.SymbolKind.Struct]=22,oe[d.SymbolKind.Event]=23,oe[d.SymbolKind.Operator]=24,oe[d.SymbolKind.TypeParameter]=25;function Y(_e){return typeof oe[_e]=="number"?oe[_e]:6}se.from=Y;function G(_e){for(const Ie in oe)if(oe[Ie]===_e)return Number(Ie);return d.SymbolKind.Property}se.to=G})(x=e.SymbolKind||(e.SymbolKind={}));var J;(function(se){function oe(G){switch(G){case d.SymbolTag.Deprecated:return 1}}se.from=oe;function Y(G){switch(G){case 1:return d.SymbolTag.Deprecated}}se.to=Y})(J=e.SymbolTag||(e.SymbolTag={}));var Ee;(function(se){function oe(G){return{name:G.name,kind:x.from(G.kind),tags:G.tags&&G.tags.map(J.from),containerName:G.containerName,location:A.from(G.location)}}se.from=oe;function Y(G){const _e=new d.SymbolInformation(G.name,x.to(G.kind),G.containerName,A.to(G.location));return _e.tags=G.tags&&G.tags.map(J.to),_e}se.to=Y})(Ee=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var ve;(function(se){function oe(G){var _e,Ie;const Be={name:G.name||"!!MISSING: name!!",detail:G.detail,range:w.from(G.range),selectionRange:w.from(G.selectionRange),kind:x.from(G.kind),tags:(Ie=(_e=G.tags)===null||_e===void 0?void 0:_e.map(J.from))!==null&&Ie!==void 0?Ie:[]};return G.children&&(Be.children=G.children.map(oe)),Be}se.from=oe;function Y(G){const _e=new d.DocumentSymbol(G.name,G.detail,x.to(G.kind),w.to(G.range),w.to(G.selectionRange));return u.isNonEmptyArray(G.tags)&&(_e.tags=G.tags.map(J.to)),G.children&&(_e.children=G.children.map(Y)),_e}se.to=Y})(ve=e.DocumentSymbol||(e.DocumentSymbol={}));var q;(function(se){function oe(Y){const G=new d.CallHierarchyItem(x.to(Y.kind),Y.name,Y.detail||"",y.URI.revive(Y.uri),w.to(Y.range),w.to(Y.selectionRange));return G._sessionId=Y._sessionId,G._itemId=Y._itemId,G}se.to=oe})(q=e.CallHierarchyItem||(e.CallHierarchyItem={}));var j;(function(se){function oe(Y){return new d.CallHierarchyIncomingCall(q.to(Y.from),Y.fromRanges.map(G=>w.to(G)))}se.to=oe})(j=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var F;(function(se){function oe(Y){return new d.CallHierarchyOutgoingCall(q.to(Y.to),Y.fromRanges.map(G=>w.to(G)))}se.to=oe})(F=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var A;(function(se){function oe(G){return{range:G.range&&w.from(G.range),uri:G.uri}}se.from=oe;function Y(G){return new d.Location(G.uri,w.to(G.range))}se.to=Y})(A=e.location||(e.location={}));var M;(function(se){function oe(G){const _e=G,Ie=G;return{originSelectionRange:_e.originSelectionRange?w.from(_e.originSelectionRange):void 0,uri:_e.targetUri?_e.targetUri:Ie.uri,range:w.from(_e.targetRange?_e.targetRange:Ie.range),targetSelectionRange:_e.targetSelectionRange?w.from(_e.targetSelectionRange):void 0}}se.from=oe;function Y(G){return{targetUri:G.uri,targetRange:w.to(G.range),targetSelectionRange:G.targetSelectionRange?w.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?w.to(G.originSelectionRange):void 0}}se.to=Y})(M=e.DefinitionLink||(e.DefinitionLink={}));var U;(function(se){function oe(G){return{range:w.from(G.range),contents:g.fromMany(G.contents)}}se.from=oe;function Y(G){return new d.Hover(G.contents.map(g.to),w.to(G.range))}se.to=Y})(U=e.Hover||(e.Hover={}));var W;(function(se){function oe(G){return{range:w.from(G.range),expression:G.expression}}se.from=oe;function Y(G){return new d.EvaluatableExpression(w.to(G.range),G.expression)}se.to=Y})(W=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ne;(function(se){function oe(G){if(G instanceof d.InlineValueText)return{type:"text",range:w.from(G.range),text:G.text};if(G instanceof d.InlineValueVariableLookup)return{type:"variable",range:w.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}se.from=oe;function Y(G){switch(G.type){case"text":return{range:w.to(G.range),text:G.text};case"variable":return{range:w.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:w.to(G.range),expression:G.expression}}}se.to=Y})(ne=e.InlineValue||(e.InlineValue={}));var ae;(function(se){function oe(G){return{stoppedLocation:w.from(G.stoppedLocation)}}se.from=oe;function Y(G){return new d.InlineValueContext(w.to(G.stoppedLocation))}se.to=Y})(ae=e.InlineValueContext||(e.InlineValueContext={}));var ce;(function(se){function oe(G){return{range:w.from(G.range),kind:G.kind}}se.from=oe;function Y(G){return new d.DocumentHighlight(w.to(G.range),G.kind)}se.to=Y})(ce=e.DocumentHighlight||(e.DocumentHighlight={}));var de;(function(se){function oe(Y){switch(Y){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}se.to=oe})(de=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Pe;(function(se){function oe(Y){return{triggerKind:de.to(Y.triggerKind),triggerCharacter:Y.triggerCharacter}}se.to=oe})(Pe=e.CompletionContext||(e.CompletionContext={}));var Te;(function(se){function oe(G){switch(G){case d.CompletionItemTag.Deprecated:return 1}}se.from=oe;function Y(G){switch(G){case 1:return d.CompletionItemTag.Deprecated}}se.to=Y})(Te=e.CompletionItemTag||(e.CompletionItemTag={}));var Me;(function(se){const oe=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function Y(Ie){var Be;return(Be=oe.get(Ie))!==null&&Be!==void 0?Be:9}se.from=Y;const G=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function _e(Ie){var Be;return(Be=G.get(Ie))!==null&&Be!==void 0?Be:d.CompletionItemKind.Property}se.to=_e})(Me=e.CompletionItemKind||(e.CompletionItemKind={}));var je;(function(se){function oe(Y,G){var _e;const Ie=new d.CompletionItem(typeof Y.label=="string"?Y.label:Y.label.name);return typeof Y.label!="string"&&(Ie.label2=Y.label),Ie.insertText=Y.insertText,Ie.kind=Me.to(Y.kind),Ie.tags=(_e=Y.tags)===null||_e===void 0?void 0:_e.map(Te.to),Ie.detail=Y.detail,Ie.documentation=L.isMarkdownString(Y.documentation)?g.to(Y.documentation):Y.documentation,Ie.sortText=Y.sortText,Ie.filterText=Y.filterText,Ie.preselect=Y.preselect,Ie.commitCharacters=Y.commitCharacters,k.Range.isIRange(Y.range)?Ie.range=w.to(Y.range):typeof Y.range=="object"&&(Ie.range={inserting:w.to(Y.range.insert),replacing:w.to(Y.range.replace)}),Ie.keepWhitespace=typeof Y.insertTextRules=="undefined"?!1:Boolean(Y.insertTextRules&1),typeof Y.insertTextRules!="undefined"&&Y.insertTextRules&4?Ie.insertText=new d.SnippetString(Y.insertText):(Ie.insertText=Y.insertText,Ie.textEdit=Ie.range instanceof d.Range?new d.TextEdit(Ie.range,Ie.insertText):void 0),Y.additionalTextEdits&&Y.additionalTextEdits.length>0&&(Ie.additionalTextEdits=Y.additionalTextEdits.map(Be=>H.to(Be))),Ie.command=G&&Y.command?G.fromInternal(Y.command):void 0,Ie}se.to=oe})(je=e.CompletionItem||(e.CompletionItem={}));var $e;(function(se){function oe(G){return{label:G.label,documentation:G.documentation?g.fromStrict(G.documentation):void 0}}se.from=oe;function Y(G){return{label:G.label,documentation:L.isMarkdownString(G.documentation)?g.to(G.documentation):G.documentation}}se.to=Y})($e=e.ParameterInformation||(e.ParameterInformation={}));var Ye;(function(se){function oe(G){return{label:G.label,documentation:G.documentation?g.fromStrict(G.documentation):void 0,parameters:Array.isArray(G.parameters)?G.parameters.map($e.from):[],activeParameter:G.activeParameter}}se.from=oe;function Y(G){return{label:G.label,documentation:L.isMarkdownString(G.documentation)?g.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map($e.to):[],activeParameter:G.activeParameter}}se.to=Y})(Ye=e.SignatureInformation||(e.SignatureInformation={}));var et;(function(se){function oe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(Ye.from):[]}}se.from=oe;function Y(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(Ye.to):[]}}se.to=Y})(et=e.SignatureHelp||(e.SignatureHelp={}));var Je;(function(se){function oe(G){var _e;return{text:G.text,range:w.from(G.range),kind:we.from((_e=G.kind)!==null&&_e!==void 0?_e:d.InlineHintKind.Other),description:G.description&&g.fromStrict(G.description),whitespaceBefore:G.whitespaceBefore,whitespaceAfter:G.whitespaceAfter}}se.from=oe;function Y(G){const _e=new d.InlineHint(G.text,w.to(G.range),we.to(G.kind));return _e.whitespaceAfter=G.whitespaceAfter,_e.whitespaceBefore=G.whitespaceBefore,_e.description=L.isMarkdownString(G.description)?g.to(G.description):G.description,_e}se.to=Y})(Je=e.InlineHint||(e.InlineHint={}));var we;(function(se){function oe(G){return G}se.from=oe;function Y(G){return G}se.to=Y})(we=e.InlineHintKind||(e.InlineHintKind={}));var Se;(function(se){function oe(G){return{range:w.from(G.range),url:G.target,tooltip:G.tooltip}}se.from=oe;function Y(G){let _e;if(G.url)try{_e=typeof G.url=="string"?y.URI.parse(G.url,!0):y.URI.revive(G.url)}catch(Ie){}return new d.DocumentLink(w.to(G.range),_e)}se.to=Y})(Se=e.DocumentLink||(e.DocumentLink={}));var Ce;(function(se){function oe(G){const _e=new d.ColorPresentation(G.label);return G.textEdit&&(_e.textEdit=H.to(G.textEdit)),G.additionalTextEdits&&(_e.additionalTextEdits=G.additionalTextEdits.map(Ie=>H.to(Ie))),_e}se.to=oe;function Y(G){return{label:G.label,textEdit:G.textEdit?H.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(_e=>H.from(_e)):void 0}}se.from=Y})(Ce=e.ColorPresentation||(e.ColorPresentation={}));var ke;(function(se){function oe(G){return new d.Color(G[0],G[1],G[2],G[3])}se.to=oe;function Y(G){return[G.red,G.green,G.blue,G.alpha]}se.from=Y})(ke=e.Color||(e.Color={}));var Le;(function(se){function oe(G){return{range:w.from(G.range)}}se.from=oe;function Y(G){return new d.SelectionRange(w.to(G.range))}se.to=Y})(Le=e.SelectionRange||(e.SelectionRange={}));var ze;(function(se){function oe(Y){switch(Y){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}se.to=oe})(ze=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var He;(function(se){function oe(G){switch(G){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}se.from=oe;function Y(G){switch(G){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}se.to=Y})(He=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ve;(function(se){function oe(G){if(G===d.EndOfLine.CRLF)return 1;if(G===d.EndOfLine.LF)return 0}se.from=oe;function Y(G){if(G===1)return d.EndOfLine.CRLF;if(G===0)return d.EndOfLine.LF}se.to=Y})(Ve=e.EndOfLine||(e.EndOfLine={}));var Qe;(function(se){function oe(Y){if(typeof Y=="object")return Y.viewId;switch(Y){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}se.from=oe})(Qe=e.ProgressLocation||(e.ProgressLocation={}));var re;(function(se){function oe(Y){const G={start:Y.start+1,end:Y.end+1};return Y.kind&&(G.kind=ge.from(Y.kind)),G}se.from=oe})(re=e.FoldingRange||(e.FoldingRange={}));var ge;(function(se){function oe(Y){if(Y)switch(Y){case d.FoldingRangeKind.Comment:return S.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return S.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return S.FoldingRangeKind.Region}}se.from=oe})(ge=e.FoldingRangeKind||(e.FoldingRangeKind={}));var me;(function(se){function oe(Y){if(Y)return{pinned:typeof Y.preview=="boolean"?!Y.preview:void 0,inactive:Y.background,preserveFocus:Y.preserveFocus,selection:typeof Y.selection=="object"?w.from(Y.selection):void 0,override:typeof Y.override=="boolean"?P.EditorOverride.DISABLED:void 0}}se.from=oe})(me=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Fe;(function(se){function oe(G){return G instanceof d.RelativePattern||typeof G=="string"?G:Y(G)?new d.RelativePattern(G.base,G.pattern):G}se.from=oe;function Y(G){const _e=G;return _e&&typeof _e.base=="string"&&typeof _e.pattern=="string"}})(Fe=e.GlobPattern||(e.GlobPattern={}));var z;(function(se){function oe(Y){if(Y){if(Array.isArray(Y))return Y.map(oe);if(typeof Y=="string")return Y;{const G=Y;return{language:G.language,scheme:G.scheme,pattern:typeof G.pattern=="undefined"?void 0:Fe.from(G.pattern),exclusive:G.exclusive}}}else return}se.from=oe})(z=e.LanguageSelector||(e.LanguageSelector={}));var X;(function(se){function oe(G){return{start:G.start,end:G.end}}se.from=oe;function Y(G){return new d.NotebookCellRange(G.start,G.end)}se.to=Y})(X=e.NotebookCellRange||(e.NotebookCellRange={}));var ee;(function(se){function oe(Y){return new d.NotebookCellMetadata(Y.editable,Y.breakpointMargin,Y.runnable,Y.hasExecutionOrder,Y.executionOrder,Y.runState,Y.runStartTime,Y.statusMessage,Y.lastRunDuration,Y.inputCollapsed,Y.outputCollapsed,Y.custom)}se.to=oe})(ee=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var V;(function(se){function oe(G){return G}se.from=oe;function Y(G){return new d.NotebookDocumentMetadata(G.editable,G.runnable,G.cellEditable,G.cellRunnable,G.cellHasExecutionOrder,G.displayOrder,G.custom,G.runState,G.trusted)}se.to=Y})(V=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var K;(function(se){function oe(G){switch(G){case d.NotebookCellKind.Markdown:return v.CellKind.Markdown;case d.NotebookCellKind.Code:default:return v.CellKind.Code}}se.from=oe;function Y(G){switch(G){case v.CellKind.Markdown:return d.NotebookCellKind.Markdown;case v.CellKind.Code:default:return d.NotebookCellKind.Code}}se.to=Y})(K=e.NotebookCellKind||(e.NotebookCellKind={}));var te;(function(se){function oe(Y){return{cellKind:K.from(Y.cellKind),language:Y.language,source:Y.source,metadata:Y.metadata,outputs:Y.outputs.map(G=>({outputId:G.id,metadata:G.metadata,outputs:(G.outputs||[]).map(_e=>({mime:_e.mime,value:_e.value,metadata:_e.metadata}))}))}}se.from=oe})(te=e.NotebookCellData||(e.NotebookCellData={}));var ie;(function(se){function oe(G){return{mime:G.mime,value:G.value,metadata:G.metadata}}se.from=oe;function Y(G){return new d.NotebookCellOutputItem(G.mime,G.value,G.metadata)}se.to=Y})(ie=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ue;(function(se){function oe(G){return{outputId:G.id,outputs:G.outputs.map(ie.from),metadata:G.metadata}}se.from=oe;function Y(G){const _e=G.outputs.map(ie.to);return new d.NotebookCellOutput(_e,G.outputId,G.metadata)}se.to=Y})(ue=e.NotebookCellOutput||(e.NotebookCellOutput={}));var De;(function(se){function oe(Ie){if(Ie!=null){if(Ie instanceof d.RelativePattern||typeof Ie=="string")return Ie;if(_e(Ie))return new d.RelativePattern(Ie.base,Ie.pattern);if(G(Ie))return{include:Fe.from(Ie.include)||void 0,exclude:Fe.from(Ie.exclude)||void 0}}}se.from=oe;function Y(Ie){return typeof Ie=="string"?Ie:_e(Ie)?{base:Ie.base,pattern:Ie.pattern}:{include:Ie.include,exclude:Ie.exclude}}se.to=Y;function G(Ie){const Be=Ie,Re=Fe.from(Be.include);if(!(Re&&Re instanceof d.RelativePattern||typeof Re=="string"))return!1;const qe=Fe.from(Be.exclude);return!!(qe&&qe instanceof d.RelativePattern||typeof qe=="string")}function _e(Ie){const Be=Ie;return Be&&typeof Be.base=="string"&&typeof Be.pattern=="string"}})(De=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var le;(function(se){function oe(Y){return{backgroundColor:Y.backgroundColor,borderColor:Y.borderColor,top:Y.top?p.from(Y.top):void 0}}se.from=oe})(le=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ye;(function(se){function oe(G){var _e,Ie;return{state:G.state,duration:G.duration,messages:(Ie=(_e=G.messages)===null||_e===void 0?void 0:_e.map(Be=>({message:g.fromStrict(Be.message)||"",severity:Be.severity,expectedOutput:Be.expectedOutput,actualOutput:Be.actualOutput,location:Be.location?A.from(Be.location):void 0})))!==null&&Ie!==void 0?Ie:[]}}se.from=oe;function Y(G){return{state:G.state,messages:G.messages.map(_e=>({message:typeof _e.message=="string"?_e.message:g.to(_e.message),severity:_e.severity,expectedOutput:_e.expectedOutput,actualOutput:_e.actualOutput,location:_e.location&&A.to({range:_e.location.range,uri:y.URI.revive(_e.location.uri)})})),duration:G.duration}}se.to=Y})(ye=e.TestState||(e.TestState={}));var be;(function(se){function oe(G){var _e,Ie;return{extId:G.id,label:G.label,location:G.location?A.from(G.location):void 0,debuggable:(_e=G.debuggable)!==null&&_e!==void 0?_e:!1,description:G.description,runnable:(Ie=G.runnable)!==null&&Ie!==void 0?Ie:!0}}se.from=oe;function Y(G){return{id:G.extId,label:G.label,location:G.location&&A.to({range:G.location.range,uri:y.URI.revive(G.location.uri)}),debuggable:G.debuggable,description:G.description,runnable:G.runnable}}se.toShallow=Y})(be=e.TestItem||(e.TestItem={}));var Ae;(function(se){function oe(_e,Ie){var Be,Re,qe;const Xe={completedAt:Ie.completedAt,id:_e,items:[]},Ue=[[null,Ie.results]];for(;Ue.length;){const[tt,it]=Ue.pop();for(const ot of it){const ut={children:(Re=(Be=ot.children)===null||Be===void 0?void 0:Be.map(mt=>mt.id))!==null&&Re!==void 0?Re:[],computedState:ot.result.state,item:be.from(ot),state:ye.from(ot.result),retired:void 0,parent:(qe=tt==null?void 0:tt.item.extId)!==null&&qe!==void 0?qe:null,providerId:"",direct:!tt};Xe.items.push(ut),ot.children&&Ue.push([ut,ot.children])}}return Xe}se.from=oe;const Y=(_e,Ie)=>Object.assign(Object.assign({},be.toShallow(_e.item)),{result:ye.to(_e.state),children:_e.children.map(Be=>Ie.get(Be)).filter(D.isDefined).map(Be=>Y(Be,Ie))});function G(_e){const Ie=[],Be=new Map;for(const Re of _e.items)Be.set(Re.item.extId,Re),Re.direct&&Ie.push(Re);return{completedAt:_e.completedAt,results:Ie.map(Re=>Y(Re,Be))}}se.to=G})(Ae=e.TestResults||(e.TestResults={}))}),define(fe[216],he([0,1,158,6,11,3,4,7,47,31,130,16,66]),function(Q,e,S,d,P,y,k,L,h,n,D,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.editorGroupToViewColumn=e.viewColumnToEditorGroup=e.computeEditorAriaLabel=e.EditorsOrder=e.pathsToEditors=e.Extensions=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCommandsContextActionRunner=e.TextEditorOptions=e.EditorOptions=e.isEditorInputWithOptions=e.EditorModel=e.SideBySideEditorInput=e.isEditorInputWithPreferredResource=e.EncodingMode=e.EditorInput=e.SaveReason=e.Verbosity=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=void 0,e.ActiveEditorDirtyContext=new h.RawContextKey("activeEditorIsDirty",!1,S.localize(0,null)),e.ActiveEditorPinnedContext=new h.RawContextKey("activeEditorIsNotPreview",!1,S.localize(1,null)),e.ActiveEditorStickyContext=new h.RawContextKey("activeEditorIsPinned",!1,S.localize(2,null)),e.ActiveEditorReadonlyContext=new h.RawContextKey("activeEditorIsReadonly",!1,S.localize(3,null)),e.ActiveEditorContext=new h.RawContextKey("activeEditor",null,{type:"string",description:S.localize(4,null)}),e.ActiveEditorAvailableEditorIdsContext=new h.RawContextKey("activeEditorAvailableEditorIds","",S.localize(5,null)),e.TextCompareEditorVisibleContext=new h.RawContextKey("textCompareEditorVisible",!1,S.localize(6,null)),e.TextCompareEditorActiveContext=new h.RawContextKey("textCompareEditorActive",!1,S.localize(7,null)),e.EditorGroupEditorsCountContext=new h.RawContextKey("groupEditorsCount",0,S.localize(8,null)),e.ActiveEditorGroupEmptyContext=new h.RawContextKey("activeEditorGroupEmpty",!1,S.localize(9,null)),e.ActiveEditorGroupIndexContext=new h.RawContextKey("activeEditorGroupIndex",0,S.localize(10,null)),e.ActiveEditorGroupLastContext=new h.RawContextKey("activeEditorGroupLast",!1,S.localize(11,null)),e.MultipleEditorGroupsContext=new h.RawContextKey("multipleEditorGroups",!1,S.localize(12,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new h.RawContextKey("editorIsOpen",!1,S.localize(13,null)),e.InEditorZenModeContext=new h.RawContextKey("inZenMode",!1,S.localize(14,null)),e.IsCenteredLayoutContext=new h.RawContextKey("isCenteredLayout",!1,S.localize(15,null)),e.SplitEditorsVertically=new h.RawContextKey("splitEditorsVertically",!1,S.localize(16,null)),e.EditorAreaVisibleContext=new h.RawContextKey("editorAreaVisible",!0,S.localize(17,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function E(H){const $=H;return typeof($==null?void 0:$.getViewState)=="function"}e.isTextEditorPane=E;var u;(function(H){H[H.SHORT=0]="SHORT",H[H.MEDIUM=1]="MEDIUM",H[H.LONG=2]="LONG"})(u=e.Verbosity||(e.Verbosity={}));var v;(function(H){H[H.EXPLICIT=1]="EXPLICIT",H[H.AUTO=2]="AUTO",H[H.FOCUS_CHANGE=3]="FOCUS_CHANGE",H[H.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(v=e.SaveReason||(e.SaveReason={}));class _ extends k.Disposable{constructor(){super(...arguments);this._onDidChangeDirty=this._register(new d.Emitter),this.onDidChangeDirty=this._onDidChangeDirty.event,this._onDidChangeLabel=this._register(new d.Emitter),this.onDidChangeLabel=this._onDidChangeLabel.event,this._onDispose=this._register(new d.Emitter),this.onDispose=this._onDispose.event,this.disposed=!1}getName(){return`Editor ${this.getTypeId()}`}getDescription($){}getTitle($){return this.getName()}getAriaLabel(){return this.getTitle(0)}getPreferredEditorId($){return b.firstOrDefault($)}getTelemetryDescriptor(){return{typeId:this.getTypeId()}}isReadonly(){return!0}isUntitled(){return!1}isDirty(){return!1}isSaving(){return!1}async resolve(){return null}async save($,x){return this}async saveAs($,x){return this}async revert($,x){}rename($,x){}supportsSplitEditor(){return!0}matches($){return this===$}isDisposed(){return this.disposed}dispose(){this.disposed||(this.disposed=!0,this._onDispose.fire()),super.dispose()}}e.EditorInput=_;var w;(function(H){H[H.Encode=0]="Encode",H[H.Decode=1]="Decode"})(w=e.EncodingMode||(e.EncodingMode={}));function m(H){const $=H;return $&&!!$.preferredResource}e.isEditorInputWithPreferredResource=m;class l extends _{constructor($,x,J,Ee){super();this.name=$,this.description=x,this._secondary=J,this._primary=Ee,this.registerListeners()}registerListeners(){const $=d.Event.once(this.secondary.onDispose);this._register($(()=>{this.isDisposed()||this.dispose()}));const x=d.Event.once(this.primary.onDispose);this._register(x(()=>{this.isDisposed()||this.dispose()})),this._register(this.primary.onDidChangeDirty(()=>this._onDidChangeDirty.fire())),this._register(this.primary.onDidChangeLabel(()=>this._onDidChangeLabel.fire()))}get resource(){}get primary(){return this._primary}get secondary(){return this._secondary}getTypeId(){return l.ID}getName(){return this.name?this.name:S.localize(18,null,this._secondary.getName(),this._primary.getName())}getDescription(){return this.description}isReadonly(){return this.primary.isReadonly()}isUntitled(){return this.primary.isUntitled()}isDirty(){return this.primary.isDirty()}isSaving(){return this.primary.isSaving()}save($,x){return this.primary.save($,x)}saveAs($,x){return this.primary.saveAs($,x)}revert($,x){return this.primary.revert($,x)}getTelemetryDescriptor(){const $=this.primary.getTelemetryDescriptor();return Object.assign($,super.getTelemetryDescriptor())}matches($){return $===this?!0:$ instanceof l?this.primary.matches($.primary)&&this.secondary.matches($.secondary):!1}}e.SideBySideEditorInput=l,l.ID="workbench.editorinputs.sidebysideEditorInput";class c extends k.Disposable{constructor(){super(...arguments);this._onDispose=this._register(new d.Emitter),this.onDispose=this._onDispose.event,this.disposed=!1}async load(){return this}isResolved(){return!0}isDisposed(){return this.disposed}dispose(){this.disposed=!0,this._onDispose.fire(),super.dispose()}}e.EditorModel=c;function r(H){const $=H;return!!$&&!!$.editor}e.isEditorInputWithOptions=r;class t{static create($){const x=new t;return x.overwrite($),x}overwrite($){return typeof $.forceReload=="boolean"&&(this.forceReload=$.forceReload),typeof $.revealIfVisible=="boolean"&&(this.revealIfVisible=$.revealIfVisible),typeof $.revealIfOpened=="boolean"&&(this.revealIfOpened=$.revealIfOpened),typeof $.preserveFocus=="boolean"&&(this.preserveFocus=$.preserveFocus),typeof $.activation=="number"&&(this.activation=$.activation),typeof $.pinned=="boolean"&&(this.pinned=$.pinned),typeof $.sticky=="boolean"&&(this.sticky=$.sticky),typeof $.inactive=="boolean"&&(this.inactive=$.inactive),typeof $.ignoreError=="boolean"&&(this.ignoreError=$.ignoreError),typeof $.index=="number"&&(this.index=$.index),$.override!==void 0&&(this.override=$.override),typeof $.context=="number"&&(this.context=$.context),this}}e.EditorOptions=t;class i extends t{static from($){if(!!($==null?void 0:$.options))return i.create($.options)}static create($=Object.create(null)){const x=new i;return x.overwrite($),x}overwrite($){var x,J;return super.overwrite($),$.selection&&(this.selection={startLineNumber:$.selection.startLineNumber,startColumn:$.selection.startColumn,endLineNumber:(x=$.selection.endLineNumber)!==null&&x!==void 0?x:$.selection.startLineNumber,endColumn:(J=$.selection.endColumn)!==null&&J!==void 0?J:$.selection.startColumn}),$.viewState&&(this.editorViewState=$.viewState),typeof $.selectionRevealType!="undefined"&&(this.selectionRevealType=$.selectionRevealType),this}hasOptionsDefined(){return!!this.editorViewState||!!this.selectionRevealType||!!this.selection}static fromEditor($,x){const J=i.create(x);return J.editorViewState=P.withNullAsUndefined($.saveViewState()),J}apply($,x){var J,Ee;let ve=!1;if(this.editorViewState)$.restoreViewState(this.editorViewState),ve=!0;else if(this.selection){const q={startLineNumber:this.selection.startLineNumber,startColumn:this.selection.startColumn,endLineNumber:(J=this.selection.endLineNumber)!==null&&J!==void 0?J:this.selection.startLineNumber,endColumn:(Ee=this.selection.endColumn)!==null&&Ee!==void 0?Ee:this.selection.startColumn};$.setSelection(q),this.selectionRevealType===2?$.revealRangeNearTop(q,x):this.selectionRevealType===3?$.revealRangeNearTopIfOutsideViewport(q,x):this.selectionRevealType===1?$.revealRangeInCenterIfOutsideViewport(q,x):$.revealRangeInCenter(q,x),ve=!0}return ve}}e.TextEditorOptions=i;class o extends D.ActionRunner{constructor($){super();this.context=$}run($){return super.run($,this.context)}}e.EditorCommandsContextActionRunner=o;var a;(function(H){H[H.PRIMARY=1]="PRIMARY",H[H.SECONDARY=2]="SECONDARY",H[H.BOTH=3]="BOTH"})(a=e.SideBySideEditor||(e.SideBySideEditor={}));class s{getOriginalUri($,x){if(!!$){if((x==null?void 0:x.supportSideBySide)&&$ instanceof l){if((x==null?void 0:x.supportSideBySide)===a.BOTH)return{primary:this.getOriginalUri($.primary,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri($.secondary,{filterByScheme:x.filterByScheme})};$=x.supportSideBySide===a.PRIMARY?$.primary:$.secondary}const J=m($)?$.preferredResource:$.resource;return!J||!x||!x.filterByScheme?J:this.filterUri(J,x.filterByScheme)}}getCanonicalUri($,x){if(!!$){if((x==null?void 0:x.supportSideBySide)&&$ instanceof l){if((x==null?void 0:x.supportSideBySide)===a.BOTH)return{primary:this.getCanonicalUri($.primary,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri($.secondary,{filterByScheme:x.filterByScheme})};$=x.supportSideBySide===a.PRIMARY?$.primary:$.secondary}const J=$.resource;return!J||!x||!x.filterByScheme?J:this.filterUri(J,x.filterByScheme)}}filterUri($,x){if(Array.isArray(x)){if(x.some(J=>$.scheme===J))return $}else if(x===$.scheme)return $}}e.EditorResourceAccessor=new s;var g;(function(H){H[H.LEFT=0]="LEFT",H[H.RIGHT=1]="RIGHT"})(g=e.CloseDirection||(e.CloseDirection={}));class C{constructor(){this.editorInputFactoryConstructors=new Map,this.editorInputFactoryInstances=new Map,this.customEditorInputFactoryInstances=new Map}start($){const x=this.instantiationService=$.get(L.IInstantiationService);this.editorInputFactoryConstructors.forEach((J,Ee)=>{this.createEditorInputFactory(Ee,J,x)}),this.editorInputFactoryConstructors.clear()}createEditorInputFactory($,x,J){const Ee=J.createInstance(x);this.editorInputFactoryInstances.set($,Ee)}registerFileEditorInputFactory($){this.fileEditorInputFactory=$}getFileEditorInputFactory(){return P.assertIsDefined(this.fileEditorInputFactory)}registerCustomEditorInputFactory($,x){this.customEditorInputFactoryInstances.set($,x)}getCustomEditorInputFactory($){return this.customEditorInputFactoryInstances.get($)}registerEditorInputFactory($,x){return this.instantiationService?this.createEditorInputFactory($,x,this.instantiationService):this.editorInputFactoryConstructors.set($,x),k.toDisposable(()=>{this.editorInputFactoryConstructors.delete($),this.editorInputFactoryInstances.delete($)})}getEditorInputFactory($){return this.editorInputFactoryInstances.get($)}}e.Extensions={EditorInputFactories:"workbench.contributions.editor.inputFactories"},n.Registry.add(e.Extensions.EditorInputFactories,new C);async function R(H,$){if(!H||!H.length)return[];const x=await Promise.all(H.map(async J=>{const Ee=y.URI.revive(J.fileUri);if(!(!Ee||!$.canHandleResource(Ee))){const ve=typeof J.exists=="boolean"?J.exists:await $.exists(Ee);if(!(!ve&&J.openOnlyIfExists)){const q=ve&&typeof J.lineNumber=="number"?{selection:{startLineNumber:J.lineNumber,startColumn:J.columnNumber||1},pinned:!0,override:J.editorOverrideId}:{pinned:!0,override:J.editorOverrideId};let j;return ve?j={resource:Ee,options:q,forceFile:!0}:j={resource:Ee,options:q,forceUntitled:!0},j}}}));return b.coalesce(x)}e.pathsToEditors=R;var p;(function(H){H[H.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",H[H.SEQUENTIAL=1]="SEQUENTIAL"})(p=e.EditorsOrder||(e.EditorsOrder={}));function f(H,$,x,J){let Ee=H.getAriaLabel();return x&&!x.isPinned(H)&&(Ee=S.localize(19,null,Ee)),(x==null?void 0:x.isSticky($!=null?$:H))&&(Ee=S.localize(20,null,Ee)),x&&J>1&&(Ee=`${Ee}, ${x.ariaLabel}`),Ee}e.computeEditorAriaLabel=f;function T(H,$){if(typeof $!="number"||$===I.ACTIVE_GROUP)return I.ACTIVE_GROUP;const x=H.getGroups(2);let J=x[$];if(J)return J.id;let Ee=x[0];return x.length===1&&Ee.count===0?Ee.id:I.SIDE_GROUP}e.viewColumnToEditorGroup=T;function O(H,$){let x=typeof $=="number"?H.getGroup($):$;return x=x!=null?x:H.activeGroup,H.getGroups(2).indexOf(x)}e.editorGroupToViewColumn=O}),define(fe[217],he([0,1,11,212,17,92,94,100,213,216,66,8,180,99,209]),function(Q,e,S,d,P,y,k,L,h,n,D,b,I,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let v=class{constructor(w,m,l,c,r,t,i,o,a,s){this._remoteAuthority=w,this._channel=m,this._configurationService=l,this._workspaceContextService=c,this._resolverService=r,this._environmentVariableService=t,this._remoteAuthorityResolverService=i,this._logService=o,this._editorService=a,this._labelService=s}_readSingleTerminalConfiguration(w){const m=this._configurationService.inspect(w);return{userValue:m.userValue,value:m.value,defaultValue:m.defaultValue}}async createTerminalProcess(w,m,l,c,r,t){await this._configurationService.whenRemoteConfigurationLoaded();const i=this._configurationService.getValue(u.TERMINAL_CONFIG_SECTION),o={"terminal.integrated.automationShell.windows":this._readSingleTerminalConfiguration("terminal.integrated.automationShell.windows"),"terminal.integrated.automationShell.osx":this._readSingleTerminalConfiguration("terminal.integrated.automationShell.osx"),"terminal.integrated.automationShell.linux":this._readSingleTerminalConfiguration("terminal.integrated.automationShell.linux"),"terminal.integrated.shell.windows":this._readSingleTerminalConfiguration("terminal.integrated.shell.windows"),"terminal.integrated.shell.osx":this._readSingleTerminalConfiguration("terminal.integrated.shell.osx"),"terminal.integrated.shell.linux":this._readSingleTerminalConfiguration("terminal.integrated.shell.linux"),"terminal.integrated.shellArgs.windows":this._readSingleTerminalConfiguration("terminal.integrated.shellArgs.windows"),"terminal.integrated.shellArgs.osx":this._readSingleTerminalConfiguration("terminal.integrated.shellArgs.osx"),"terminal.integrated.shellArgs.linux":this._readSingleTerminalConfiguration("terminal.integrated.shellArgs.linux"),"terminal.integrated.env.windows":this._readSingleTerminalConfiguration("terminal.integrated.env.windows"),"terminal.integrated.env.osx":this._readSingleTerminalConfiguration("terminal.integrated.env.osx"),"terminal.integrated.env.linux":this._readSingleTerminalConfiguration("terminal.integrated.env.linux"),"terminal.integrated.inheritEnv":i.inheritEnv,"terminal.integrated.cwd":i.cwd,"terminal.integrated.detectLocale":i.detectLocale,"terminal.flowControl":i.flowControl},a=Object.create(null),s=m?S.withNullAsUndefined(this._workspaceContextService.getWorkspaceFolder(m)):void 0;let g;try{g=await this._resolverService.resolveWithInteraction(s,{shellLaunchConfig:w,configuration:o})}catch(x){this._logService.error(x)}if(g)for(const[x,J]of g.entries())(/^config:/.test(x)||x==="selectedText"||x==="lineNumber")&&(a[x]=J);const C=[];for(const[x,J]of this._environmentVariableService.collections.entries())C.push([x,L.serializeEnvironmentVariableCollection(J.map)]);const R=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),p=R.options&&R.options.extensionHostEnv,f=this._workspaceContextService.getWorkspace(),T=f.folders,O=m?this._workspaceContextService.getWorkspaceFolder(m):null,H=n.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:n.SideBySideEditor.PRIMARY,filterByScheme:[b.Schemas.file,b.Schemas.userData,b.Schemas.vscodeRemote]}),$={configuration:o,resolvedVariables:a,envVariableCollections:C,shellLaunchConfig:w,workspaceId:f.id,workspaceName:this._labelService.getWorkspaceLabel(f),workspaceFolders:T,activeWorkspaceFolder:O,activeFileResource:H,shouldPersistTerminal:l,cols:c,rows:r,isWorkspaceShellAllowed:t,resolverEnv:p};return await this._channel.call("$createTerminalProcess",$)}async startTerminalProcess(w){const m={id:w};return this._channel.call("$startTerminalProcess",m)}onTerminalProcessEvent(w){const m={id:w};return this._channel.listen("$onTerminalProcessEvent",m)}sendInputToTerminalProcess(w,m){const l={id:w,data:m};return this._channel.call("$sendInputToTerminalProcess",l)}sendCharCountToTerminalProcess(w,m){const l={id:w,charCount:m};return this._channel.call("$sendCharCountToTerminalProcess",l)}shutdownTerminalProcess(w,m){const l={id:w,immediate:m};return this._channel.call("$shutdownTerminalProcess",l)}resizeTerminalProcess(w,m,l){const c={id:w,cols:m,rows:l};return this._channel.call("$resizeTerminalProcess",c)}getTerminalInitialCwd(w){const m={id:w};return this._channel.call("$getTerminalInitialCwd",m)}getTerminalCwd(w){const m={id:w};return this._channel.call("$getTerminalCwd",m)}sendCommandResultToTerminalProcess(w,m,l,c){const r={id:w,reqId:m,isError:l,payload:c};return this._channel.call("$sendCommandResultToTerminalProcess",r)}orphanQuestionReply(w){const m={id:w};return this._channel.call("$orphanQuestionReply",m)}listTerminals(w){const m={isInitialization:w};return this._channel.call("$listTerminals",m)}setTerminalLayoutInfo(w){const l={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:w.tabs};return this._channel.call("$setTerminalLayoutInfo",l)}getTerminalLayoutInfo(){const m={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",m)}};v=Oe([Ge(2,d.IWorkbenchConfigurationService),Ge(3,k.IWorkspaceContextService),Ge(4,h.IConfigurationResolverService),Ge(5,E.IEnvironmentVariableService),Ge(6,y.IRemoteAuthorityResolverService),Ge(7,P.ILogService),Ge(8,D.IEditorService),Ge(9,I.ILabelService)],v),e.RemoteTerminalChannelClient=v}),define(fe[218],he([0,1,186]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Logger=e.Translations=void 0;var d;(function(y){function k(L,h){if(L===h)return!0;let n=Object.keys(L),D=new Set;for(let b of Object.keys(h))D.add(b);if(n.length!==D.size)return!1;for(let b of n){if(L[b]!==h[b])return!1;D.delete(b)}return D.size===0}y.equals=k})(d=e.Translations||(e.Translations={}));class P{constructor(k){this._messageHandler=k}error(k,L){this._messageHandler(S.Severity.Error,k,L)}warn(k,L){this._messageHandler(S.Severity.Warning,k,L)}info(k,L){this._messageHandler(S.Severity.Info,k,L)}}e.Logger=P}),define(fe[219],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class S{constructor(h,n){this.isMain=h,this.sid=n,this.nid=++S.count}}e.ProxyIdentifier=S,S.count=0;const d=[];function P(L){const h=new S(!0,L);return d[h.nid]=h,h}e.createMainContextProxyIdentifier=P;function y(L){const h=new S(!1,L);return d[h.nid]=h,h}e.createExtHostContextProxyIdentifier=y;function k(L){return d[L].sid}e.getStringIdentifierForProxy=k}),define(fe[220],he([0,1,3,219,45]),function(Q,e,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var y;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(y=e.UIKind||(e.UIKind={}));var k;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(k=e.TextEditorRevealType||(e.TextEditorRevealType={}));var L;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(L=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var h;(function(l){l[l.Markdown=1]="Markdown",l[l.Code=2]="Code"})(h=e.CellKind||(e.CellKind={}));var n;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(n=e.CellOutputKind||(e.CellOutputKind={}));var D;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(D=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var b;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(b=e.CandidatePortSource||(e.CandidatePortSource={}));var I;(function(l){l.name="$ident";function c(t,i){return Object.defineProperty(t,l.name,{value:i,enumerable:!0}),t}l.mixin=c;function r(t){return t[l.name]}l.of=r})(I=e.ObjectIdentifier||(e.ObjectIdentifier={}));class E{static mixin(c){return c._id=E._n++,c}}e.IdObject=E,E._n=0;var u;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n",l.label2="o"})(u=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var _;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(_=e.WorkspaceEditType||(e.WorkspaceEditType={}));function w(l){if(l&&l.edits)for(const c of l.edits)typeof c.resource=="object"?c.resource=S.URI.revive(c.resource):(c.newUri=S.URI.revive(c.newUri),c.oldUri=S.URI.revive(c.oldUri)),c.metadata&&c.metadata.iconPath&&(c.metadata=P.revive(c.metadata));return l}e.reviveWorkspaceEditDto=w;var m;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(m=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:d.createMainContextProxyIdentifier("MainThreadAuthentication"),MainThreadBulkEdits:d.createMainContextProxyIdentifier("MainThreadBulkEdits"),MainThreadClipboard:d.createMainContextProxyIdentifier("MainThreadClipboard"),MainThreadCommands:d.createMainContextProxyIdentifier("MainThreadCommands"),MainThreadComments:d.createMainContextProxyIdentifier("MainThreadComments"),MainThreadConfiguration:d.createMainContextProxyIdentifier("MainThreadConfiguration"),MainThreadConsole:d.createMainContextProxyIdentifier("MainThreadConsole"),MainThreadDebugService:d.createMainContextProxyIdentifier("MainThreadDebugService"),MainThreadDecorations:d.createMainContextProxyIdentifier("MainThreadDecorations"),MainThreadDiagnostics:d.createMainContextProxyIdentifier("MainThreadDiagnostics"),MainThreadDialogs:d.createMainContextProxyIdentifier("MainThreadDiaglogs"),MainThreadDocuments:d.createMainContextProxyIdentifier("MainThreadDocuments"),MainThreadDocumentContentProviders:d.createMainContextProxyIdentifier("MainThreadDocumentContentProviders"),MainThreadTextEditors:d.createMainContextProxyIdentifier("MainThreadTextEditors"),MainThreadEditorInsets:d.createMainContextProxyIdentifier("MainThreadEditorInsets"),MainThreadEditorTabs:d.createMainContextProxyIdentifier("MainThreadEditorTabs"),MainThreadErrors:d.createMainContextProxyIdentifier("MainThreadErrors"),MainThreadTreeViews:d.createMainContextProxyIdentifier("MainThreadTreeViews"),MainThreadDownloadService:d.createMainContextProxyIdentifier("MainThreadDownloadService"),MainThreadKeytar:d.createMainContextProxyIdentifier("MainThreadKeytar"),MainThreadLanguageFeatures:d.createMainContextProxyIdentifier("MainThreadLanguageFeatures"),MainThreadLanguages:d.createMainContextProxyIdentifier("MainThreadLanguages"),MainThreadLog:d.createMainContextProxyIdentifier("MainThread"),MainThreadMessageService:d.createMainContextProxyIdentifier("MainThreadMessageService"),MainThreadOutputService:d.createMainContextProxyIdentifier("MainThreadOutputService"),MainThreadProgress:d.createMainContextProxyIdentifier("MainThreadProgress"),MainThreadQuickOpen:d.createMainContextProxyIdentifier("MainThreadQuickOpen"),MainThreadStatusBar:d.createMainContextProxyIdentifier("MainThreadStatusBar"),MainThreadSecretState:d.createMainContextProxyIdentifier("MainThreadSecretState"),MainThreadStorage:d.createMainContextProxyIdentifier("MainThreadStorage"),MainThreadTelemetry:d.createMainContextProxyIdentifier("MainThreadTelemetry"),MainThreadTerminalService:d.createMainContextProxyIdentifier("MainThreadTerminalService"),MainThreadWebviews:d.createMainContextProxyIdentifier("MainThreadWebviews"),MainThreadWebviewPanels:d.createMainContextProxyIdentifier("MainThreadWebviewPanels"),MainThreadWebviewViews:d.createMainContextProxyIdentifier("MainThreadWebviewViews"),MainThreadCustomEditors:d.createMainContextProxyIdentifier("MainThreadCustomEditors"),MainThreadUrls:d.createMainContextProxyIdentifier("MainThreadUrls"),MainThreadUriOpeners:d.createMainContextProxyIdentifier("MainThreadUriOpeners"),MainThreadWorkspace:d.createMainContextProxyIdentifier("MainThreadWorkspace"),MainThreadFileSystem:d.createMainContextProxyIdentifier("MainThreadFileSystem"),MainThreadExtensionService:d.createMainContextProxyIdentifier("MainThreadExtensionService"),MainThreadSCM:d.createMainContextProxyIdentifier("MainThreadSCM"),MainThreadSearch:d.createMainContextProxyIdentifier("MainThreadSearch"),MainThreadTask:d.createMainContextProxyIdentifier("MainThreadTask"),MainThreadWindow:d.createMainContextProxyIdentifier("MainThreadWindow"),MainThreadLabelService:d.createMainContextProxyIdentifier("MainThreadLabelService"),MainThreadNotebook:d.createMainContextProxyIdentifier("MainThreadNotebook"),MainThreadTheming:d.createMainContextProxyIdentifier("MainThreadTheming"),MainThreadTunnelService:d.createMainContextProxyIdentifier("MainThreadTunnelService"),MainThreadTimeline:d.createMainContextProxyIdentifier("MainThreadTimeline"),MainThreadTesting:d.createMainContextProxyIdentifier("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:d.createExtHostContextProxyIdentifier("ExtHostCommands"),ExtHostConfiguration:d.createExtHostContextProxyIdentifier("ExtHostConfiguration"),ExtHostDiagnostics:d.createExtHostContextProxyIdentifier("ExtHostDiagnostics"),ExtHostDebugService:d.createExtHostContextProxyIdentifier("ExtHostDebugService"),ExtHostDecorations:d.createExtHostContextProxyIdentifier("ExtHostDecorations"),ExtHostDocumentsAndEditors:d.createExtHostContextProxyIdentifier("ExtHostDocumentsAndEditors"),ExtHostDocuments:d.createExtHostContextProxyIdentifier("ExtHostDocuments"),ExtHostDocumentContentProviders:d.createExtHostContextProxyIdentifier("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:d.createExtHostContextProxyIdentifier("ExtHostDocumentSaveParticipant"),ExtHostEditors:d.createExtHostContextProxyIdentifier("ExtHostEditors"),ExtHostTreeViews:d.createExtHostContextProxyIdentifier("ExtHostTreeViews"),ExtHostFileSystem:d.createExtHostContextProxyIdentifier("ExtHostFileSystem"),ExtHostFileSystemInfo:d.createExtHostContextProxyIdentifier("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:d.createExtHostContextProxyIdentifier("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:d.createExtHostContextProxyIdentifier("ExtHostLanguageFeatures"),ExtHostQuickOpen:d.createExtHostContextProxyIdentifier("ExtHostQuickOpen"),ExtHostExtensionService:d.createExtHostContextProxyIdentifier("ExtHostExtensionService"),ExtHostLogService:d.createExtHostContextProxyIdentifier("ExtHostLogService"),ExtHostTerminalService:d.createExtHostContextProxyIdentifier("ExtHostTerminalService"),ExtHostSCM:d.createExtHostContextProxyIdentifier("ExtHostSCM"),ExtHostSearch:d.createExtHostContextProxyIdentifier("ExtHostSearch"),ExtHostTask:d.createExtHostContextProxyIdentifier("ExtHostTask"),ExtHostWorkspace:d.createExtHostContextProxyIdentifier("ExtHostWorkspace"),ExtHostWindow:d.createExtHostContextProxyIdentifier("ExtHostWindow"),ExtHostWebviews:d.createExtHostContextProxyIdentifier("ExtHostWebviews"),ExtHostWebviewPanels:d.createExtHostContextProxyIdentifier("ExtHostWebviewPanels"),ExtHostCustomEditors:d.createExtHostContextProxyIdentifier("ExtHostCustomEditors"),ExtHostWebviewViews:d.createExtHostContextProxyIdentifier("ExtHostWebviewViews"),ExtHostEditorInsets:d.createExtHostContextProxyIdentifier("ExtHostEditorInsets"),ExtHostEditorTabs:d.createExtHostContextProxyIdentifier("ExtHostEditorTabs"),ExtHostProgress:d.createMainContextProxyIdentifier("ExtHostProgress"),ExtHostComments:d.createMainContextProxyIdentifier("ExtHostComments"),ExtHostSecretState:d.createMainContextProxyIdentifier("ExtHostSecretState"),ExtHostStorage:d.createMainContextProxyIdentifier("ExtHostStorage"),ExtHostUrls:d.createExtHostContextProxyIdentifier("ExtHostUrls"),ExtHostUriOpeners:d.createExtHostContextProxyIdentifier("ExtHostUriOpeners"),ExtHostOutputService:d.createMainContextProxyIdentifier("ExtHostOutputService"),ExtHosLabelService:d.createMainContextProxyIdentifier("ExtHostLabelService"),ExtHostNotebook:d.createMainContextProxyIdentifier("ExtHostNotebook"),ExtHostTheming:d.createMainContextProxyIdentifier("ExtHostTheming"),ExtHostTunnelService:d.createMainContextProxyIdentifier("ExtHostTunnelService"),ExtHostAuthentication:d.createMainContextProxyIdentifier("ExtHostAuthentication"),ExtHostTimeline:d.createMainContextProxyIdentifier("ExtHostTimeline"),ExtHostTesting:d.createMainContextProxyIdentifier("ExtHostTesting")}}),define(fe[221],he([0,1,11,98,215,19,220,16,17,45,55,79,3,4,7,207]),function(Q,e,S,d,P,y,k,L,h,n,D,b,I,E,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let _=class{constructor(t,i){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(k.MainContext.MainThreadCommands),this._logService=i,this.converter=new w(this,o=>{const a=this._apiCommands.get(o);return(a==null?void 0:a.result)===l.Void?a:void 0},i),this._argumentProcessors=[{processArgument(o){return n.revive(o)}},{processArgument(o){return y.cloneAndChange(o,function(a){if(D.Range.isIRange(a))return P.Range.to(a);if(b.Position.isIPosition(a))return P.Position.to(a);if(D.Range.isIRange(a.range)&&I.URI.isUri(a.uri))return P.location.to(a);if(!Array.isArray(a))return a})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const i=this.registerCommand(!1,t.id,async(...o)=>{const a=t.args.map((g,C)=>{if(!g.validate(o[C]))throw new Error(`Invalid argument '${g.name}' when running '${t.id}', received: ${o[C]}`);return g.convert(o[C])}),s=await this.executeCommand(t.internalId,...a);return t.result.convert(s,o,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new d.Disposable(()=>{i.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,i,o,a,s){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:o,thisArg:a,description:s}),t&&this._proxy.$registerCommand(i),new d.Disposable(()=>{this._commands.delete(i)&&t&&this._proxy.$unregisterCommand(i)})}executeCommand(t,...i){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,i,!0)}async _doExecuteCommand(t,i,o){if(this._commands.has(t))return this._executeContributedCommand(t,i);{const a=y.cloneAndChange(i,function(s){if(s instanceof d.Position)return P.Position.from(s);if(s instanceof d.Range)return P.Range.from(s);if(s instanceof d.Location)return P.location.from(s);if(!Array.isArray(s))return s});try{const s=await this._proxy.$executeCommand(t,a,o);return n.revive(s)}catch(s){if(s instanceof Error&&s.message==="$executeCommand:retry")return this._doExecuteCommand(t,i,!1);throw s}}}async _executeContributedCommand(t,i){const o=this._commands.get(t);if(!o)throw new Error("Unknown command");let{callback:a,thisArg:s,description:g}=o;if(g)for(let C=0;C<g.args.length;C++)try{S.validateConstraint(i[C],g.args[C].constraint)}catch(R){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${g.args[C].name}' - ${g.args[C].description}`)}try{return await a.apply(s,i)}catch(C){if(t===this.converter.delegatingCommandId){const R=this.converter.getActualCommand(...i);R&&(t=R.command)}throw this._logService.error(C,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(i=i.map(o=>this._argumentProcessors.reduce((a,s)=>s.processArgument(a),o)),this._executeContributedCommand(t,i)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(i=>(t&&(i=i.filter(o=>o[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[i,o]of this._commands){let{description:a}=o;a&&(t[i]=a)}return Promise.resolve(t)}};_=Oe([Ge(0,v.IExtHostRpcService),Ge(1,h.ILogService)],_),e.ExtHostCommands=_,e.IExtHostCommands=u.createDecorator("IExtHostCommands");class w{constructor(t,i,o){this._commands=t,this._lookupApiCommand=i,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,i){if(!!t){const o={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return o;const a=this._lookupApiCommand(t.command);if(a)o.id=a.internalId,o.arguments=a.args.map((s,g)=>s.convert(t.arguments&&t.arguments[g]));else if(L.isNonEmptyArray(t.arguments)){const s=++this._cachIdPool;this._cache.set(s,t),i.add(E.toDisposable(()=>{this._cache.delete(s),this._logService.trace("CommandsConverter#DISPOSE",s)})),o.$ident=s,o.id=this.delegatingCommandId,o.arguments=[s],this._logService.trace("CommandsConverter#CREATE",t.command,s)}return o}}fromInternal(t){const i=k.ObjectIdentifier.of(t);return typeof i=="number"?this._cache.get(i):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const i=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class m{constructor(t,i,o,a){this.name=t,this.description=i,this.validate=o,this.convert=a}optional(){return new m(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,i){return new m(t!=null?t:this.name,i!=null?i:this.description,this.validate,this.convert)}}e.ApiCommandArgument=m,m.Uri=new m("uri","Uri of a text document",r=>I.URI.isUri(r),r=>r),m.Position=new m("position","A position in a text document",r=>d.Position.isPosition(r),P.Position.from),m.Range=new m("range","A range in a text document",r=>d.Range.isRange(r),P.Range.from),m.Selection=new m("selection","A selection in a text document",r=>d.Selection.isSelection(r),P.Selection.from),m.Number=new m("number","",r=>typeof r=="number",r=>r),m.String=new m("string","",r=>typeof r=="string",r=>r),m.CallHierarchyItem=new m("item","A call hierarchy item",r=>r instanceof d.CallHierarchyItem,P.CallHierarchyItem.to);class l{constructor(t,i){this.description=t,this.convert=i}}e.ApiCommandResult=l,l.Void=new l("no result",r=>r);class c{constructor(t,i,o,a,s){this.id=t,this.internalId=i,this.description=o,this.args=a,this.result=s}}e.ApiCommand=c}),define(fe[222],he([0,1,15,161,2,49,35,16,135,11,3,20,33,57,41,218]),function(Q,e,S,d,P,y,k,L,h,n,D,b,I,E,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionScanner=e.ExtensionScannerInput=void 0;const _="package.json";class w{constructor(a,s,g,C,R){this._ourVersion=a,this._log=s,this._absoluteFolderPath=g,this._isBuiltin=C,this._isUnderDevelopment=R,this._absoluteManifestPath=P.join(g,_)}}class m extends w{static _fastParseJSON(a,s){try{return JSON.parse(a)}catch(g){return k.parse(a,s)}}parse(){return S.promises.readFile(this._absoluteManifestPath).then(a=>{var s;const g=[],C=m._fastParseJSON(a.toString(),g);if(k.getNodeType(C)!=="object")this._log.error(this._absoluteFolderPath,d.localize(0,null,this._absoluteManifestPath));else{if(g.length===0)return C.__metadata&&(C.uuid=C.__metadata.id),C.isUserBuiltin=!!((s=C.__metadata)===null||s===void 0?void 0:s.isBuiltin),delete C.__metadata,C;g.forEach(R=>{this._log.error(this._absoluteFolderPath,d.localize(1,null,this._absoluteManifestPath,R.offset,R.length,h.getParseErrorMessage(R.error)))})}return null},a=>(a.code==="ENOENT"||this._log.error(this._absoluteFolderPath,d.localize(2,null,this._absoluteManifestPath,a.message)),null))}}class l extends w{constructor(a,s,g,C,R,p){super(a,s,g,C,R);this._nlsConfig=p}replaceNLS(a){const s=(O,H)=>{H.forEach($=>{this._log.error(this._absoluteFolderPath,d.localize(3,null,O,h.getParseErrorMessage($.error)))})},g=O=>{this._log.error(this._absoluteFolderPath,d.localize(4,null,O))};let C=P.extname(this._absoluteManifestPath),R=this._absoluteManifestPath.substr(0,this._absoluteManifestPath.length-C.length);const p=`${a.publisher}.${a.name}`;let f=this._nlsConfig.translations[p],T;return f?T=S.promises.readFile(f,"utf8").then(O=>{let H=[],$=k.parse(O,H);return H.length>0?(s(f,H),{values:void 0,default:`${R}.nls.json`}):k.getNodeType($)!=="object"?(g(f),{values:void 0,default:`${R}.nls.json`}):{values:$.contents?$.contents.package:void 0,default:`${R}.nls.json`}},O=>({values:void 0,default:`${R}.nls.json`})):T=b.SymlinkSupport.existsFile(R+".nls"+C).then(O=>{if(!!O)return l.findMessageBundles(this._nlsConfig,R).then(H=>H.localized?S.promises.readFile(H.localized,"utf8").then($=>{let x=[],J=k.parse($,x);return x.length>0?(s(H.localized,x),{values:void 0,default:H.original}):k.getNodeType(J)!=="object"?(g(H.localized),{values:void 0,default:H.original}):{values:J,default:H.original}},$=>({values:void 0,default:H.original})):{values:void 0,default:H.original},H=>{})}),T.then(O=>{if(O===void 0)return a;let H=[];return l.resolveOriginalMessageBundle(O.default,H).then($=>{if(H.length>0)return s(O.default,H),a;if(k.getNodeType(O)!=="object")return g(O.default),a;const x=O.values||Object.create(null);return l._replaceNLStrings(this._nlsConfig,a,x,$,this._log,this._absoluteFolderPath),a})},O=>a)}static resolveOriginalMessageBundle(a,s){return new Promise((g,C)=>{a?S.promises.readFile(a).then(R=>{g(k.parse(R.toString(),s))},R=>{g(null)}):g(null)})}static findMessageBundles(a,s){return new Promise((g,C)=>{function R(p,f){let T=`${p}.nls.${f}.json`;b.SymlinkSupport.existsFile(T).then(O=>{O&&g({localized:T,original:`${p}.nls.json`});let H=f.lastIndexOf("-");H===-1?g({localized:`${p}.nls.json`,original:null}):(f=f.substring(0,H),R(p,f))})}if(a.devMode||a.pseudo||!a.locale)return g({localized:s+".nls.json",original:null});R(s,a.locale)})}static _replaceNLStrings(a,s,g,C,R,p){function f(T,O,H){let $=T[O];if(n.isString($)){let x=$,J=x.length;if(J>1&&x[0]==="%"&&x[J-1]==="%"){let Ee=x.substr(1,J-2),ve=g[Ee];ve===void 0&&C&&(ve=C[Ee]),ve?(a.pseudo&&(ve="\uFF3B"+ve.replace(/[aouei]/g,"$&$&")+"\uFF3D"),T[O]=H&&(O==="title"||O==="category")&&C?{value:ve,original:C[Ee]}:ve):R.warn(p,d.localize(5,null,Ee))}}else if(n.isObject($))for(let x in $)$.hasOwnProperty(x)&&(x==="commands"?f($,x,!0):f($,x,H));else if(n.isArray($))for(let x=0;x<$.length;x++)f($,x,H)}for(let T in s)s.hasOwnProperty(T)&&f(s,T)}}class c extends w{validate(a){let s=a;s.isBuiltin=this._isBuiltin,s.isUserBuiltin=!this._isBuiltin&&!!s.isUserBuiltin,s.isUnderDevelopment=this._isUnderDevelopment;let g=[];return c.isValidExtensionDescription(this._ourVersion,this._absoluteFolderPath,s,g)?(g.forEach(C=>{this._log.warn(this._absoluteFolderPath,C)}),s.publisher||(s.publisher="undefined_publisher"),s.id=I.getExtensionId(s.publisher,s.name),s.identifier=new u.ExtensionIdentifier(s.id),s.extensionLocation=D.URI.file(this._absoluteFolderPath),s):(g.forEach(C=>{this._log.error(this._absoluteFolderPath,C)}),null)}static isValidExtensionDescription(a,s,g,C){return c.baseIsValidExtensionDescription(s,g,C)?y.valid(g.version)?E.isValidExtensionVersion(a,g,C):(C.push(d.localize(6,null)),!1):!1}static baseIsValidExtensionDescription(a,s,g){if(!s)return g.push(d.localize(7,null)),!1;if(typeof s.publisher!="undefined"&&typeof s.publisher!="string")return g.push(d.localize(8,null)),!1;if(typeof s.name!="string")return g.push(d.localize(9,null,"name")),!1;if(typeof s.version!="string")return g.push(d.localize(10,null,"version")),!1;if(!s.engines)return g.push(d.localize(11,null,"engines")),!1;if(typeof s.engines.vscode!="string")return g.push(d.localize(12,null,"engines.vscode")),!1;if(typeof s.extensionDependencies!="undefined"&&!c._isStringArray(s.extensionDependencies))return g.push(d.localize(13,null,"extensionDependencies")),!1;if(typeof s.activationEvents!="undefined"){if(!c._isStringArray(s.activationEvents))return g.push(d.localize(14,null,"activationEvents")),!1;if(typeof s.main=="undefined"&&typeof s.browser=="undefined")return g.push(d.localize(15,null,"activationEvents","main")),!1}if(typeof s.main!="undefined"){if(typeof s.main!="string")return g.push(d.localize(16,null,"main")),!1;{const C=P.join(a,s.main);C.startsWith(a)||g.push(d.localize(17,null,C,a))}if(typeof s.activationEvents=="undefined")return g.push(d.localize(18,null,"activationEvents","main")),!1}if(typeof s.browser!="undefined"){if(typeof s.browser!="string")return g.push(d.localize(19,null,"browser")),!1;{const C=P.join(a,s.browser);C.startsWith(a)||g.push(d.localize(20,null,C,a))}if(typeof s.activationEvents=="undefined")return g.push(d.localize(21,null,"activationEvents","browser")),!1}return!0}static _isStringArray(a){if(!Array.isArray(a))return!1;for(let s=0,g=a.length;s<g;s++)if(typeof a[s]!="string")return!1;return!0}}class r{constructor(a,s,g,C,R,p,f,T){this.ourVersion=a,this.commit=s,this.locale=g,this.devMode=C,this.absoluteFolderPath=R,this.isBuiltin=p,this.isUnderDevelopment=f,this.translations=T}static createNLSConfig(a){return{devMode:a.devMode,locale:a.locale,pseudo:a.locale==="pseudo",translations:a.translations}}static equals(a,s){return a.ourVersion===s.ourVersion&&a.commit===s.commit&&a.locale===s.locale&&a.devMode===s.devMode&&a.absoluteFolderPath===s.absoluteFolderPath&&a.isBuiltin===s.isBuiltin&&a.isUnderDevelopment===s.isUnderDevelopment&&a.mtime===s.mtime&&v.Translations.equals(a.translations,s.translations)}}e.ExtensionScannerInput=r;class t{constructor(a){this.root=a}resolveExtensions(){return b.readDirsInDir(this.root).then(a=>a.map(s=>({name:s,path:P.join(this.root,s)})))}}class i{static scanExtension(a,s,g,C,R,p){return g=P.normalize(g),new m(a,s,g,C,R).parse().then(T=>T===null?null:new l(a,s,g,C,R,p).replaceNLS(T)).then(T=>T===null?null:new c(a,s,g,C,R).validate(T))}static async scanExtensions(a,s,g=null){const C=a.absoluteFolderPath,R=a.isBuiltin,p=a.isUnderDevelopment;g||(g=new t(C));try{let f={};if(!R)try{const x=await S.promises.readFile(P.join(C,".obsolete"),"utf8");f=JSON.parse(x)}catch(x){}let T=await g.resolveExtensions();T.sort((x,J)=>x.name<J.name?-1:1),R||(T=T.filter(x=>x.name.indexOf(".")!==0));const O=r.createNLSConfig(a);let H=await Promise.all(T.map(x=>this.scanExtension(a.ourVersion,s,x.path,R,p,O))),$=L.coalesce(H);return $=$.filter(x=>x!==null&&!f[new I.ExtensionIdentifierWithVersion({id:I.getGalleryExtensionId(x.publisher,x.name)},x.version).key()]),R||($=I.groupByExtension($,J=>({id:J.identifier.value,uuid:J.uuid})).map(J=>J.sort((Ee,ve)=>y.rcompare(Ee.version,ve.version))[0])),$.sort((x,J)=>x.extensionLocation.fsPath<J.extensionLocation.fsPath?-1:1),$}catch(f){return s.error(C,f),[]}}static scanOneOrMultipleExtensions(a,s){const g=a.absoluteFolderPath,C=a.isBuiltin,R=a.isUnderDevelopment;return b.SymlinkSupport.existsFile(P.join(g,_)).then(p=>{if(p){const f=r.createNLSConfig(a);return this.scanExtension(a.ourVersion,s,g,C,R,f).then(T=>T===null?[]:[T])}return this.scanExtensions(a,s)},p=>(s.error(g,p),[]))}static scanSingleExtension(a,s){const g=a.absoluteFolderPath,C=a.isBuiltin,R=a.isUnderDevelopment,p=r.createNLSConfig(a);return this.scanExtension(a.ourVersion,s,g,C,R,p)}static mergeBuiltinExtensions(a,s){return Promise.all([a,s]).then(([g,C])=>{let R=Object.create(null);for(let f=0,T=g.length;f<T;f++)R[u.ExtensionIdentifier.toKey(g[f].identifier)]=g[f];for(let f=0,T=C.length;f<T;f++)R[u.ExtensionIdentifier.toKey(C[f].identifier)]=C[f];let p=Object.keys(R).map(f=>R[f]);return p.sort((f,T)=>{const O=P.basename(f.extensionLocation.fsPath),H=P.basename(T.extensionLocation.fsPath);return O<H?-1:O>H?1:0}),p})}}e.ExtensionScanner=i}),define(fe[223],he([0,1,5,46,3,38,156,15,8,26,222,41,54,96,47,77,197,2]),function(Q,e,S,d,P,y,k,L,h,n,D,b,I,E,u,v,_,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;let m=null;function l(){return m||(m=w.normalize(w.join(h.FileAccess.asFileUri("",Q).fsPath,"..","extensions"))),m}let c=null;function r(){return c||(c=w.normalize(w.join(h.FileAccess.asFileUri("",Q).fsPath,"..",".build","builtInExtensions"))),c}class t{constructor(o,a,s,g,C,R){this._connectionToken=o,this.environmentService=a,this.logService=g,this.telemetryService=C,this.telemetryAppender=R,this._logger=new class{error(f,T){g.error(f,T)}warn(f,T){g.warn(f,T)}info(f,T){g.info(f,T)}},a.args["install-builtin-extension"]?this.whenExtensionsReady=s.installExtensions([],a.args["install-builtin-extension"],!!a.args["do-not-sync"],!!a.args.force).then(null,f=>{g.error(f)}):this.whenExtensionsReady=Promise.resolve();const p=a.args["install-extension"];if(p){const f=p.map(T=>/\.vsix$/i.test(T)?P.URI.file(w.isAbsolute(T)?T:w.join(process.cwd(),T)):T);this.whenExtensionsReady.then(()=>s.installExtensions(f,[],!!a.args["do-not-sync"],!!a.args.force)).then(null,T=>{g.error(T)})}}async call(o,a,s){switch(a){case"disableTelemetry":{this.telemetryService.setEnabled(!1);return}case"getEnvironmentData":{const g=s,C=y.createRemoteURITransformer(g.remoteAuthority);let R=await this._getEnvironmentData();return R=I.transformOutgoingURIs(R,C),R}case"whenExtensionsReady":{await this.whenExtensionsReady;return}case"scanExtensions":{await this.whenExtensionsReady;const g=s,C=g.language;this.logService.trace(`Scanning extensions using UI language: ${C}`);const R=y.createRemoteURITransformer(g.remoteAuthority),p=g.extensionDevelopmentPath&&g.extensionDevelopmentPath.map(O=>P.URI.revive(R.transformIncoming(O))),f=p?p.filter(O=>O.scheme===h.Schemas.file).map(O=>O.fsPath):void 0;let T=await this._scanExtensions(C,f);return T=I.transformOutgoingURIs(T,R),this.logService.trace("Scanned Extensions",T),t._massageWhenConditions(T),T}case"scanSingleExtension":{await this.whenExtensionsReady;const g=s,C=g.language,R=g.isBuiltin,p=y.createRemoteURITransformer(g.remoteAuthority),f=P.URI.revive(p.transformIncoming(g.extensionLocation)),T=f.scheme===h.Schemas.file?f.fsPath:null;if(!T)return null;const O=await this._getTranslations(C);let H=await this._scanSingleExtension(T,R,C,O);return H?(H=I.transformOutgoingURIs(H,p),t._massageWhenConditions([H]),H):null}case"getDiagnosticInfo":{const g=s,C={machineInfo:_.getMachineInfo()},R=g.includeProcesses?v.listProcesses(process.pid):Promise.resolve();let p=[];const f={};if(g.folders){const T=y.createRemoteURITransformer("");p=g.folders.map(H=>P.URI.revive(T.transformIncoming(H))).filter(H=>H.scheme==="file").map(H=>_.collectWorkspaceStats(H.fsPath,["node_modules",".git"]).then($=>{f[w.basename(H.fsPath)]=$}))}return Promise.all([R,...p]).then(([T,O])=>(C.processes=T||void 0,C.workspaceMetadata=g.folders?f:void 0,C))}case"logTelemetry":{const{eventName:g,data:C}=s;return this.telemetryAppender?this.telemetryAppender.log(g,C):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve()}throw new Error(`IPC Command ${a} not found`)}listen(o,a,s){throw new Error("Not supported")}static _massageWhenConditions(o){const a=(f,T)=>f.replace(/file/g,"vscode-remote"),s=f=>{let T="";return T+=f.global?"g":"",T+=f.ignoreCase?"i":"",T+=f.multiline?"m":"",new RegExp(a(f.source,!0),T)},g=new class{mapDefined(f){return u.ContextKeyDefinedExpr.create(f)}mapNot(f){return u.ContextKeyNotExpr.create(f)}mapEquals(f,T){return f==="resourceScheme"&&typeof T=="string"?u.ContextKeyEqualsExpr.create(f,a(T,!1)):u.ContextKeyEqualsExpr.create(f,T)}mapNotEquals(f,T){return f==="resourceScheme"&&typeof T=="string"?u.ContextKeyNotEqualsExpr.create(f,a(T,!1)):u.ContextKeyNotEqualsExpr.create(f,T)}mapGreater(f,T){return u.ContextKeyGreaterExpr.create(f,T)}mapGreaterEquals(f,T){return u.ContextKeyGreaterEqualsExpr.create(f,T)}mapSmaller(f,T){return u.ContextKeySmallerExpr.create(f,T)}mapSmallerEquals(f,T){return u.ContextKeySmallerEqualsExpr.create(f,T)}mapRegex(f,T){return f==="resourceScheme"&&T?u.ContextKeyRegexExpr.create(f,s(T)):u.ContextKeyRegexExpr.create(f,T)}mapIn(f,T){return u.ContextKeyInExpr.create(f,T)}},C=f=>{if(!(!f||!f.when||!/resourceScheme/.test(f.when))){const T=u.ContextKeyExpr.deserialize(f.when);if(!!T){const O=T.map(g);f.when=O.serialize()}}},R=f=>{if(Array.isArray(f))for(let T of f)C(T);else C(f)},p=f=>{for(let T in f)R(f[T])};o.forEach(f=>{f.contributes&&(f.contributes.menus&&p(f.contributes.menus),f.contributes.keybindings&&R(f.contributes.keybindings),f.contributes.views&&p(f.contributes.views))})}async _getEnvironmentData(){return{pid:process.pid,connectionToken:this._connectionToken,appRoot:P.URI.file(this.environmentService.appRoot),settingsPath:this.environmentService.machineSettingsResource,logsPath:P.URI.file(this.environmentService.logsPath),extensionsPath:P.URI.file(this.environmentService.extensionsPath),extensionHostLogsPath:P.URI.file(w.join(this.environmentService.logsPath,`exthost${t._namePool++}`)),globalStorageHome:this.environmentService.globalStorageHome,workspaceStorageHome:this.environmentService.workspaceStorageHome,userHome:this.environmentService.userHome,os:S.OS,marks:d.getMarks()}}async _getTranslations(o){const a=await E.getNLSConfiguration(o,this.environmentService.userDataPath);if(E.InternalNLSConfiguration.is(a))try{const s=await L.promises.readFile(a._translationsConfigFile,"utf8");return JSON.parse(s)}catch(s){return Object.create(null)}else return Object.create(null)}async _scanExtensions(o,a){const s=await this._getTranslations(o),[g,C,R]=await Promise.all([this._scanBuiltinExtensions(o,s),this._scanInstalledExtensions(o,s),this._scanDevelopedExtensions(o,s,a)]);let p=new Map;g.forEach(T=>{!T||p.set(b.ExtensionIdentifier.toKey(T.identifier),T)}),C.forEach(T=>{!T||(p.has(b.ExtensionIdentifier.toKey(T.identifier))&&console.warn(k.localize(0,null,p.get(b.ExtensionIdentifier.toKey(T.identifier)).extensionLocation.fsPath,T.extensionLocation.fsPath)),p.set(b.ExtensionIdentifier.toKey(T.identifier),T))}),R.forEach(T=>{!T||p.set(b.ExtensionIdentifier.toKey(T.identifier),T)});const f=[];return p.forEach(T=>f.push(T)),f}_scanDevelopedExtensions(o,a,s){if(s){const g=s.map(C=>D.ExtensionScanner.scanOneOrMultipleExtensions(new D.ExtensionScannerInput(n.default.version,n.default.commit,o,!0,C,!1,!0,a),this._logger));return Promise.all(g).then(C=>{let R=[];for(let p of C)R=R.concat(p);return R})}return Promise.resolve([])}_scanBuiltinExtensions(o,a){const s=n.default.version,g=n.default.commit,C=!!process.env.VSCODE_DEV,R=new D.ExtensionScannerInput(s,g,o,C,l(),!0,!1,a),p=D.ExtensionScanner.scanExtensions(R,this._logger);let f=p;if(C){class T{constructor(J){this.builtInExtensions=J}resolveExtensions(){return Promise.resolve(this.builtInExtensions.map(J=>({name:J.name,path:w.join(r(),J.name)})))}}const O=Promise.resolve(n.default.builtInExtensions||[]),H=new D.ExtensionScannerInput(s,g,o,C,r(),!0,!1,{}),$=O.then(x=>new T(x)).then(x=>D.ExtensionScanner.scanExtensions(H,this._logger,x));f=D.ExtensionScanner.mergeBuiltinExtensions(p,$)}return f}_scanInstalledExtensions(o,a){const s=!!process.env.VSCODE_DEV,g=new D.ExtensionScannerInput(n.default.version,n.default.commit,o,s,this.environmentService.extensionsPath,!1,!1,a);return D.ExtensionScanner.scanExtensions(g,this._logger)}_scanSingleExtension(o,a,s,g){const C=!!process.env.VSCODE_DEV,R=new D.ExtensionScannerInput(n.default.version,n.default.commit,s,C,o,a,!1,g);return D.ExtensionScanner.scanSingleExtension(R,this._logger)}}e.RemoteAgentEnvironmentChannel=t,t._namePool=1}),define(fe[224],he([0,1,6,4,3,23,18,39,12,40]),function(Q,e,S,d,P,y,k,L,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProvider=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remotefilesystem";class D extends d.Disposable{constructor(I){super();this.session=y.generateUuid(),this._onDidChange=this._register(new S.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchErrorOccur=this._register(new S.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeCapabilities=this._register(new S.Emitter),this.onDidChangeCapabilities=this._onDidChangeCapabilities.event;const E=I.getConnection();this.channel=E.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),this.setCaseSensitive(!0),(async()=>{const u=await I.getEnvironment();this.setCaseSensitive((u==null?void 0:u.os)===3)})(),this.registerListeners()}get capabilities(){return this._capabilities}registerListeners(){this._register(this.channel.listen("filechange",[this.session])(I=>{if(Array.isArray(I)){const E=I;this._onDidChange.fire(E.map(u=>({resource:P.URI.revive(u.resource),type:u.type})))}else{const E=I;this._onDidWatchErrorOccur.fire(E)}}))}setCaseSensitive(I){let E=2|4|16|8;I&&(E|=1024),this._capabilities=E,this._onDidChangeCapabilities.fire(void 0)}stat(I){return this.channel.call("stat",[I])}open(I,E){return this.channel.call("open",[I,E])}close(I){return this.channel.call("close",[I])}async read(I,E,u,v,_){const[w,m]=await this.channel.call("read",[I,E,_]);return u.set(w.buffer.slice(0,m),v),m}async readFile(I){return(await this.channel.call("readFile",[I])).buffer}readFileStream(I,E,u){const v=L.newWriteableStream(w=>k.VSBuffer.concat(w.map(m=>k.VSBuffer.wrap(m))).buffer),_=this.channel.listen("readFileStream",[I,E])(w=>{if(w instanceof k.VSBuffer)v.write(w.buffer);else{if(w==="end")v.end();else{let m=w;m instanceof Error||(m=new Error(n.toErrorMessage(m))),v.end(m)}_.dispose()}});return u.onCancellationRequested(()=>{v.end(h.canceled()),_.dispose()}),v}write(I,E,u,v,_){return this.channel.call("write",[I,E,k.VSBuffer.wrap(u),v,_])}writeFile(I,E,u){return this.channel.call("writeFile",[I,k.VSBuffer.wrap(E),u])}delete(I,E){return this.channel.call("delete",[I,E])}mkdir(I){return this.channel.call("mkdir",[I])}readdir(I){return this.channel.call("readdir",[I])}rename(I,E,u){return this.channel.call("rename",[I,E,u])}copy(I,E,u){return this.channel.call("copy",[I,E,u])}watch(I,E){const u=Math.random();return this.channel.call("watch",[this.session,u,I,E]),d.toDisposable(()=>this.channel.call("unwatch",[this.session,u]))}}e.RemoteFileSystemProvider=D}),define(fe[101],he([0,1,7]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=S.createDecorator("remoteAgentService")}),define(fe[67],he([0,1,137,2,15,13,20,238,239,11]),function(Q,e,S,d,P,y,k,L,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class D extends Error{constructor(t,i){let o=i.message;switch(t){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o);this.type=t,this.cause=i}}e.ExtractError=D;function b(r){const t=r.externalFileAttributes>>16||33188;return[448,56,7].map(i=>t&i).reduce((i,o)=>i+o,t&61440)}function I(r){if(r instanceof D)return r;let t;return/end of central directory record signature not found/.test(r.message)&&(t="CorruptZip"),new D(t,r)}function E(r,t,i,o,a,s){const g=d.dirname(t),C=d.join(o,g);if(!C.startsWith(o))return Promise.reject(new Error(S.localize(0,null,t)));const R=d.join(o,t);let p;return s.onCancellationRequested(()=>{p&&p.destroy()}),Promise.resolve(P.promises.mkdir(C,{recursive:!0})).then(()=>new Promise((f,T)=>{if(!s.isCancellationRequested)try{p=P.createWriteStream(R,{mode:i}),p.once("close",()=>f()),p.once("error",T),r.once("error",T),r.pipe(p)}catch(O){T(O)}}))}function u(r,t,i,o){let a=y.createCancelablePromise(()=>Promise.resolve()),s=0;return o.onCancellationRequested(()=>{a.cancel(),r.close()}),new Promise((g,C)=>{const R=new y.Sequencer,p=f=>{f.isCancellationRequested||(s++,r.readEntry())};r.once("error",C),r.once("close",()=>a.then(()=>{o.isCancellationRequested||r.entryCount===s?g():C(new D("Incomplete",new Error(S.localize(1,null,s,r.entryCount))))},C)),r.readEntry(),r.on("entry",f=>{if(!o.isCancellationRequested){if(!i.sourcePathRegex.test(f.fileName)){p(o);return}const T=f.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(T)){const $=d.join(t,T);a=y.createCancelablePromise(x=>P.promises.mkdir($,{recursive:!0}).then(()=>p(x)).then(void 0,C));return}const O=_(r,f),H=b(f);a=y.createCancelablePromise($=>R.queue(()=>O.then(x=>E(x,T,H,t,i,$).then(()=>p($)))).then(null,C))}})})}function v(r,t=!1){return new Promise((i,o)=>{L.open(r,t?{lazyEntries:!0}:void 0,(a,s)=>{a?o(I(a)):i(n.assertIsDefined(s))})})}function _(r,t){return new Promise((i,o)=>{r.openReadStream(t,(a,s)=>{a?o(I(a)):i(n.assertIsDefined(s))})})}function w(r,t){return new Promise((i,o)=>{const a=new h.ZipFile;t.forEach(g=>{g.contents?a.addBuffer(typeof g.contents=="string"?Buffer.from(g.contents,"utf8"):g.contents,g.path):g.localPath&&a.addFile(g.localPath,g.path)}),a.end();const s=P.createWriteStream(r);a.outputStream.pipe(s),a.outputStream.once("error",o),s.once("error",o),s.once("finish",()=>i(r))})}e.zip=w;function m(r,t,i={},o){const a=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let s=v(r,!0);return i.overwrite&&(s=s.then(g=>k.rimraf(t).then(()=>g))),s.then(g=>u(g,t,{sourcePathRegex:a},o))}e.extract=m;function l(r,t){return v(r).then(i=>new Promise((o,a)=>{i.on("entry",s=>{s.fileName===t&&_(i,s).then(g=>o(g),g=>a(g))}),i.once("close",()=>a(new Error(S.localize(2,null,t))))}))}function c(r,t){return l(r,t).then(i=>new Promise((o,a)=>{const s=[];i.once("error",a),i.on("data",g=>s.push(g)),i.on("end",()=>o(Buffer.concat(s)))}))}e.buffer=c}),define(fe[225],he([0,1,67,144]),function(Q,e,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function P(y){return S.buffer(y,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch(L){throw new Error(d.localize(0,null))}})}e.getManifest=P}),define(fe[226],he([0,1,15,49,4,20,2,17,30,33,13,3,29,166,145,50,67,5,16,8]),function(Q,e,S,d,P,y,k,L,h,n,D,b,I,E,u,v,_,w,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const c="scanningSystem",r="scanningUser",t="extracting",i="deleting",o="renaming";let a=class extends P.Disposable{constructor(g,C,R,p){super();this.beforeRemovingExtension=g,this.logService=C,this.environmentService=R,this.productService=p,this._devSystemExtensionsPath=null,this.systemExtensionsPath=R.builtinExtensionsPath,this.extensionsPath=R.extensionsPath,this.uninstalledPath=k.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new D.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(g){const C=[];(g===null||g===0)&&C.push(this.scanSystemExtensions().then(null,R=>Promise.reject(new h.ExtensionManagementError(this.joinErrors(R).message,c)))),(g===null||g===1)&&C.push(this.scanUserExtensions(!0).then(null,R=>Promise.reject(new h.ExtensionManagementError(this.joinErrors(R).message,r))));try{const R=await Promise.all(C);return m.flatten(R)}catch(R){throw this.joinErrors(R)}}async scanUserExtensions(g){this.logService.trace("Started scanning user extensions");let[C,R]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return R=R.filter(p=>!C[new n.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()]),g&&(R=n.groupByExtension(R,f=>f.identifier).map(f=>f.sort((T,O)=>d.rcompare(T.manifest.version,O.manifest.version))[0])),this.logService.trace("Scanned user extensions:",R.length),R}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(g,C,R){const p=g.key(),f=k.join(this.extensionsPath,`.${p}`),T=k.join(this.extensionsPath,p);try{await y.rimraf(T)}catch(H){try{await y.rimraf(T)}catch($){}throw new h.ExtensionManagementError(u.localize(0,null,T,g.id),i)}await this.extractAtLocation(g,C,f,R);try{await this.rename(g,f,T,Date.now()+2*60*1e3),this.logService.info("Renamed to",T)}catch(H){this.logService.info("Rename failed. Deleting from extracted location",f);try{y.rimraf(f)}catch($){}throw H}let O=null;try{O=await this.scanExtension(p,this.extensionsPath,1)}catch(H){}if(O)return O;throw new Error(u.localize(1,null,this.extensionsPath))}async saveMetadataForLocalExtension(g,C){this.setMetadata(g,C),C.isMachineScoped=C.isMachineScoped||void 0,C.isBuiltin=C.isBuiltin||void 0;const R=k.join(g.location.fsPath,"package.json"),p=await S.promises.readFile(R,"utf8"),{manifest:f}=await this.parseManifest(p);return f.__metadata=C,await y.writeFile(R,JSON.stringify(f,null,"	")),g}getUninstalledExtensions(){return this.withUninstalledExtensions(g=>g)}async withUninstalledExtensions(g){return this.uninstalledFileLimiter.queue(async()=>{let C;try{C=await S.promises.readFile(this.uninstalledPath,"utf8")}catch(f){if(f.code!=="ENOENT")throw f}let R={};if(C)try{R=JSON.parse(C)}catch(f){}const p=g(R);return Object.keys(R).length?await y.writeFile(this.uninstalledPath,JSON.stringify(R)):await y.rimraf(this.uninstalledPath),p})}async removeExtension(g,C){this.logService.trace(`Deleting ${C} extension from disk`,g.identifier.id,g.location.fsPath),await y.rimraf(g.location.fsPath),this.logService.info("Deleted from disk",g.identifier.id,g.location.fsPath)}async removeUninstalledExtension(g){await this.removeExtension(g,"uninstalled"),await this.withUninstalledExtensions(C=>delete C[new n.ExtensionIdentifierWithVersion(g.identifier,g.manifest.version).key()])}async extractAtLocation(g,C,R,p){this.logService.trace(`Started extracting the extension from ${C} to ${R}`);try{await y.rimraf(R)}catch(f){throw new h.ExtensionManagementError(this.joinErrors(f).message,i)}try{await _.extract(C,R,{sourcePath:"extension",overwrite:!0},p),this.logService.info(`Extracted extension to ${R}:`,g.id)}catch(f){try{await y.rimraf(R)}catch(T){}throw new h.ExtensionManagementError(f.message,f instanceof _.ExtractError&&f.type?f.type:t)}}async rename(g,C,R,p){try{await S.promises.rename(C,R)}catch(f){if(w.isWindows&&f&&f.code==="EPERM"&&Date.now()<p)return this.logService.info(`Failed renaming ${C} to ${R} with 'EPERM' error. Trying again...`,g.id),this.rename(g,C,R,p);throw new h.ExtensionManagementError(f.message||u.localize(2,null,C,R),f.code||o)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const g=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return g;const C=this.scanDevSystemExtensions(),[R,p]=await Promise.all([g,C]);return[...R,...p]}async scanExtensionsInDir(g,C){const R=new D.Limiter(10),p=await y.readdir(g);return(await Promise.all(p.map(T=>R.queue(()=>this.scanExtension(T,g,C))))).filter(T=>T&&T.identifier)}async scanExtension(g,C,R){if(R===1&&g.indexOf(".")===0)return null;const p=k.join(C,g);try{const f=await y.readdir(p),{manifest:T,metadata:O}=await this.readManifest(p),H=f.filter(q=>/^readme(\.txt|\.md|)$/i.test(q))[0],$=H?b.URI.file(k.join(p,H)):void 0,x=f.filter(q=>/^changelog(\.txt|\.md|)$/i.test(q))[0],J=x?b.URI.file(k.join(p,x)):void 0,Ee={id:n.getGalleryExtensionId(T.publisher,T.name)},ve={type:R,identifier:Ee,manifest:T,location:b.URI.file(p),readmeUrl:$,changelogUrl:J,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:R===0};return O&&this.setMetadata(ve,O),ve}catch(f){return this.logService.trace(f),null}}async scanDefaultSystemExtensions(){const g=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",g.length),g}async scanDevSystemExtensions(){const g=this.getDevSystemExtensionsList();if(g.length){const C=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",C.length),C.filter(R=>g.some(p=>n.areSameExtensions(R.identifier,{id:p})))}else return[]}setMetadata(g,C){g.publisherDisplayName=C.publisherDisplayName||null,g.publisherId=C.publisherId||null,g.identifier.uuid=C.id,g.isMachineScoped=!!C.isMachineScoped,g.isBuiltin=g.type===0||!!C.isBuiltin}async removeUninstalledExtensions(){const g=await this.getUninstalledExtensions(),C=await this.scanAllUserExtensions(),R=new Set;for(const T of C)g[new n.ExtensionIdentifierWithVersion(T.identifier,T.manifest.version).key()]||R.add(T.identifier.id.toLowerCase());const p=n.groupByExtension(C,T=>T.identifier);await D.Promises.settled(p.map(async T=>{const O=T.sort((H,$)=>d.rcompare(H.manifest.version,$.manifest.version))[0];R.has(O.identifier.id.toLowerCase())||await this.beforeRemovingExtension(O)}));const f=C.filter(T=>g[new n.ExtensionIdentifierWithVersion(T.identifier,T.manifest.version).key()]);await D.Promises.settled(f.map(T=>this.removeUninstalledExtension(T)))}async removeOutdatedExtensions(){const g=await this.scanAllUserExtensions(),C=[],R=n.groupByExtension(g,p=>p.identifier);C.push(...m.flatten(R.map(p=>p.sort((f,T)=>d.rcompare(f.manifest.version,T.manifest.version)).slice(1)))),await D.Promises.settled(C.map(p=>this.removeExtension(p,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(g=>g.name)}joinErrors(g){const C=Array.isArray(g)?g:[g];return C.length===1?C[0]instanceof Error?C[0]:new Error(C[0]):C.reduce((R,p)=>new Error(`${R.message}${R.message?",":""}${p instanceof Error?p.message:p}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=k.normalize(k.join(l.FileAccess.asFileUri("",Q).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(g){const C=[S.promises.readFile(k.join(g,"package.json"),"utf8").then(T=>this.parseManifest(T)),S.promises.readFile(k.join(g,"package.nls.json"),"utf8").then(void 0,T=>T.code!=="ENOENT"?Promise.reject(T):"{}").then(T=>JSON.parse(T))],[{manifest:R,metadata:p},f]=await Promise.all(C);return{manifest:E.localizeManifest(R,f),metadata:p}}parseManifest(g){return new Promise((C,R)=>{try{const p=JSON.parse(g),f=p.__metadata||null;C({manifest:p,metadata:f})}catch(p){R(new Error(u.localize(3,null)))}})}};a=Oe([Ge(1,L.ILogService),Ge(2,I.INativeEnvironmentService),Ge(3,v.IProductService)],a),e.ExtensionsScanner=a}),define(fe[102],he([0,1,15,143,2,20,4,16,67,30,33,29,13,6,49,3,26,5,17,176,40,43,57,21,23,83,7,8,27,225,181,226,182]),function(Q,e,S,d,P,y,k,L,h,n,D,b,I,E,u,v,_,w,m,l,c,r,t,i,o,a,s,g,C,R,p,f,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const O="unsetUninstalled",H="downloading",$="validating",x="local",J="unknown";let Ee=class extends k.Disposable{constructor(q,j,F,A,M,U){super();this.environmentService=q,this.galleryService=j,this.logService=F,this.downloadService=A,this.telemetryService=M,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new E.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new E.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new E.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new E.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const W=this._register(U.createInstance(T.ExtensionsLifecycle));this.extensionsScanner=this._register(U.createInstance(f.ExtensionsScanner,ne=>W.postUninstall(ne))),this.manifestCache=this._register(new l.ExtensionsManifestCache(q,this)),this.extensionsDownloader=this._register(U.createInstance(p.ExtensionsDownloader)),this._register(k.toDisposable(()=>{this.installingExtensions.forEach(ne=>ne.cancel()),this.uninstallingExtensions.forEach(ne=>ne.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(q){this.logService.trace("ExtensionManagementService#zip",q.identifier.id);const j=await this.collectFiles(q),F=await h.zip(i.joinPath(this.environmentService.tmpDir,o.generateUuid()).fsPath,j);return v.URI.file(F)}async unzip(q){return this.logService.trace("ExtensionManagementService#unzip",q.toString()),(await this.install(q)).identifier}async getManifest(q){const j=await this.downloadVsix(q),F=P.resolve(j.fsPath);return R.getManifest(F)}async collectFiles(q){const j=async A=>{let M=await y.readdir(A);M=M.map(ne=>P.join(A,ne));const U=await Promise.all(M.map(ne=>S.promises.stat(ne)));let W=Promise.resolve([]);return U.forEach((ne,ae)=>{const ce=M[ae];ne.isFile()&&(W=W.then(de=>[...de,ce])),ne.isDirectory()&&(W=W.then(de=>j(ce).then(Pe=>[...de,...Pe])))}),W};return(await j(q.location.fsPath)).map(A=>({path:`extension/${P.relative(q.location.fsPath,A)}`,localPath:A}))}async install(q,j={}){return this.logService.trace("ExtensionManagementService#install",q.toString()),I.createCancelablePromise(async F=>{const A=await this.downloadVsix(q),M=P.resolve(A.fsPath),U=await R.getManifest(M),W={id:D.getGalleryExtensionId(U.publisher,U.name)};let ne=1;if(U.engines&&U.engines.vscode&&!t.isEngineValid(U.engines.vscode,_.default.version))throw new Error(d.localize(0,null,W.id,_.default.version));const ae=new D.ExtensionIdentifierWithVersion(W,U.version),de=(await this.getInstalled(1)).find(Te=>D.areSameExtensions(W,Te.identifier));if(de)if(j.isMachineScoped=j.isMachineScoped||de.isMachineScoped,j.isBuiltin=j.isBuiltin||de.isBuiltin,ne=2,ae.equals(new D.ExtensionIdentifierWithVersion(de.identifier,de.manifest.version)))try{await this.extensionsScanner.removeExtension(de,"existing")}catch(Te){throw new Error(d.localize(1,null,U.displayName||U.name))}else u.gt(de.manifest.version,U.version)&&await this.uninstallExtension(de);else{const Te=await this.unsetUninstalledAndGetLocal(ae);if(Te)try{await this.extensionsScanner.removeExtension(Te,"existing")}catch(Me){throw new Error(d.localize(2,null,U.displayName||U.name))}}this.logService.info("Installing the extension:",W.id),this._onInstallExtension.fire({identifier:W,zipPath:M});let Pe;try{Pe=await this.getGalleryMetadata(D.getGalleryExtensionId(U.publisher,U.name))}catch(Te){}try{const Te=await this.installFromZipPath(ae,M,Object.assign(Object.assign({},Pe||{}),j),j,ne,F);return this.logService.info("Successfully installed the extension:",W.id),Te}catch(Te){throw this.logService.error("Failed to install the extension:",W.id,Te.message),Te}})}async downloadVsix(q){if(q.scheme===g.Schemas.file)return q;if(!this.downloadService)throw new Error("Download service is not available");const j=i.joinPath(this.environmentService.tmpDir,o.generateUuid());return await this.downloadService.download(q,j),j}async installFromZipPath(q,j,F,A,M,U){try{const W=await this.installExtension({zipPath:j,identifierWithVersion:q,metadata:F},U);try{await this.installDependenciesAndPackExtensions(W,void 0,A)}catch(ne){L.isNonEmptyArray(W.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",W.identifier.id,ne.message),L.isNonEmptyArray(W.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",W.identifier.id,ne.message)}return this._onDidInstallExtension.fire({identifier:q,zipPath:j,local:W,operation:M}),W}catch(W){throw this._onDidInstallExtension.fire({identifier:q,zipPath:j,operation:M,error:W}),W}}async canInstall(q){return!0}async installFromGallery(q,j={}){if(!this.galleryService.isEnabled())throw new Error(d.localize(3,null));try{q=await this.checkAndGetCompatibleVersion(q)}catch(M){const U=M&&M.code?M.code:J;throw this.logService.error("Failed to install extension:",q.identifier.id,M?M.message:U),this.reportTelemetry(this.getTelemetryEvent(1),D.getGalleryExtensionTelemetryData(q),void 0,M),M instanceof Error&&(M.name=U),M}const F=new D.ExtensionIdentifierWithVersion(q.identifier,q.version).key();let A=this.installingExtensions.get(F);return A||(A=I.createCancelablePromise(M=>this.doInstallFromGallery(q,j,M)),this.installingExtensions.set(F,A),A.finally(()=>this.installingExtensions.delete(F))),A}async doInstallFromGallery(q,j,F){const A=new Date().getTime();let M=1;this.logService.info("Installing extension:",q.identifier.id),this._onInstallExtension.fire({identifier:q.identifier,gallery:q});try{const W=(await this.getInstalled(1)).find(ce=>D.areSameExtensions(ce.identifier,q.identifier));W&&(M=2);const ne=await this.downloadInstallableExtension(q,M);ne.metadata.isMachineScoped=j.isMachineScoped||(W==null?void 0:W.isMachineScoped),ne.metadata.isBuiltin=j.isBuiltin||(W==null?void 0:W.isBuiltin);const ae=await this.installExtension(ne,F);try{await this.extensionsDownloader.delete(v.URI.file(ne.zipPath))}catch(ce){}if(!j.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(ae,W,j)}catch(ce){try{await this.uninstall(ae)}catch(de){}throw ce}return W&&u.neq(W.manifest.version,q.version)&&await this.setUninstalled(W),this.logService.info("Extensions installed successfully:",q.identifier.id),this._onDidInstallExtension.fire({identifier:q.identifier,gallery:q,local:ae,operation:M}),this.reportTelemetry(this.getTelemetryEvent(M),D.getGalleryExtensionTelemetryData(q),new Date().getTime()-A,void 0),ae}catch(U){const W=U&&U.code?U.code:J;throw this.logService.error("Failed to install extension:",q.identifier.id,U?U.message:W),this._onDidInstallExtension.fire({identifier:q.identifier,gallery:q,operation:M,error:W}),this.reportTelemetry(this.getTelemetryEvent(M),D.getGalleryExtensionTelemetryData(q),new Date().getTime()-A,U),U instanceof Error&&(U.name=W),U}}async checkAndGetCompatibleVersion(q){if(await this.isMalicious(q))throw new n.ExtensionManagementError(d.localize(4,null),n.INSTALL_ERROR_MALICIOUS);const j=await this.galleryService.getCompatibleExtension(q);if(!j)throw new n.ExtensionManagementError(d.localize(5,null,q.identifier.id,_.default.version),n.INSTALL_ERROR_INCOMPATIBLE);return j}async reinstallFromGallery(q){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",q.identifier.id),!this.galleryService.isEnabled())throw new Error(d.localize(6,null));const j=await this.findGalleryExtension(q);if(!j)throw new Error(d.localize(7,null));await this.setUninstalled(q);try{await this.extensionsScanner.removeUninstalledExtension(q)}catch(F){throw new Error(d.localize(8,null,c.toErrorMessage(F)))}await this.installFromGallery(j)}getTelemetryEvent(q){return q===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(q){const j=await this.getExtensionsReport();return D.getMaliciousExtensionsSet(j).has(q.identifier.id)}async downloadInstallableExtension(q,j){const F={id:q.identifier.uuid,publisherId:q.publisherId,publisherDisplayName:q.publisherDisplayName};let A;try{this.logService.trace("Started downloading extension:",q.identifier.id);const M=await this.extensionsDownloader.downloadExtension(q,j);this.logService.info("Downloaded extension:",q.identifier.id,A),A=M.fsPath}catch(M){throw new n.ExtensionManagementError(this.joinErrors(M).message,H)}try{const M=await R.getManifest(A);return{zipPath:A,identifierWithVersion:new D.ExtensionIdentifierWithVersion(q.identifier,M.version),metadata:F}}catch(M){throw new n.ExtensionManagementError(this.joinErrors(M).message,$)}}async installExtension(q,j){try{const F=await this.unsetUninstalledAndGetLocal(q.identifierWithVersion);if(F)return q.metadata?this.extensionsScanner.saveMetadataForLocalExtension(F,q.metadata):F}catch(F){throw w.isMacintosh?new n.ExtensionManagementError(d.localize(9,null),O):new n.ExtensionManagementError(d.localize(10,null),O)}return this.extractAndInstall(q,j)}async unsetUninstalledAndGetLocal(q){return await this.isUninstalled(q)?(this.logService.trace("Removing the extension from uninstalled list:",q.id),await this.unsetUninstalled(q),this.logService.info("Removed the extension from uninstalled list:",q.id),(await this.getInstalled(1)).find(A=>new D.ExtensionIdentifierWithVersion(A.identifier,A.manifest.version).equals(q))||null):null}async extractAndInstall({zipPath:q,identifierWithVersion:j,metadata:F},A){let M=await this.extensionsScanner.extractUserExtension(j,q,A);return this.logService.info("Installation completed.",j.id),F&&(M=await this.extensionsScanner.saveMetadataForLocalExtension(M,F)),M}async installDependenciesAndPackExtensions(q,j,F){if(!!this.galleryService.isEnabled()){const A=q.manifest.extensionDependencies||[];if(q.manifest.extensionPack)for(const M of q.manifest.extensionPack)j&&j.manifest.extensionPack&&j.manifest.extensionPack.some(U=>D.areSameExtensions({id:U},{id:M}))||A.every(U=>!D.areSameExtensions({id:U},{id:M}))&&A.push(M);if(A.length){const M=await this.getInstalled(),U=A.filter(W=>M.every(({identifier:ne})=>!D.areSameExtensions(ne,{id:W})));if(U.length){const ne=(await this.galleryService.query({names:U,pageSize:A.length},C.CancellationToken.None)).firstPage;try{await I.Promises.settled(ne.map(ae=>this.installFromGallery(ae,F)))}catch(ae){try{await this.rollback(ne)}catch(ce){}throw ae}}}}}async rollback(q){const F=(await this.getInstalled(1)).filter(A=>q.some(M=>new D.ExtensionIdentifierWithVersion(A.identifier,A.manifest.version).equals(new D.ExtensionIdentifierWithVersion(M.identifier,M.version))));await I.Promises.settled(F.map(A=>this.uninstall(A)))}async uninstall(q,j={}){this.logService.trace("ExtensionManagementService#uninstall",q.identifier.id);const F=await this.getInstalled(1),A=F.find(M=>D.areSameExtensions(M.identifier,q.identifier));if(!A)throw new Error(d.localize(11,null,q.manifest.displayName||q.manifest.name));try{await this.checkForDependenciesAndUninstall(A,F,j)}catch(M){throw this.joinErrors(M)}}async updateMetadata(q,j){return this.logService.trace("ExtensionManagementService#updateMetadata",q.identifier.id),q=await this.extensionsScanner.saveMetadataForLocalExtension(q,Object.assign(Object.assign({},q.manifest.__metadata||{}),j)),this.manifestCache.invalidate(),q}async updateExtensionScope(q,j){return this.logService.trace("ExtensionManagementService#updateExtensionScope",q.identifier.id),q=await this.extensionsScanner.saveMetadataForLocalExtension(q,Object.assign(Object.assign({},q.manifest.__metadata||{}),{isMachineScoped:j})),this.manifestCache.invalidate(),q}async getGalleryMetadata(q){const j=await this.findGalleryExtensionByName(q);return j?{id:j.identifier.uuid,publisherDisplayName:j.publisherDisplayName,publisherId:j.publisherId}:void 0}async findGalleryExtension(q){if(q.identifier.uuid){const j=await this.findGalleryExtensionById(q.identifier.uuid);return j||this.findGalleryExtensionByName(q.identifier.id)}return this.findGalleryExtensionByName(q.identifier.id)}async findGalleryExtensionById(q){return(await this.galleryService.query({ids:[q],pageSize:1},C.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(q){return(await this.galleryService.query({names:[q],pageSize:1},C.CancellationToken.None)).firstPage[0]}joinErrors(q){const j=Array.isArray(q)?q:[q];return j.length===1?j[0]instanceof Error?j[0]:new Error(j[0]):j.reduce((F,A)=>new Error(`${F.message}${F.message?",":""}${A instanceof Error?A.message:A}`),new Error(""))}async checkForDependenciesAndUninstall(q,j,F){try{await this.preUninstallExtension(q);const A=F.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(q,j);await this.uninstallExtensions(q,A,j,F)}catch(A){throw await this.postUninstallExtension(q,new n.ExtensionManagementError(A instanceof Error?A.message:A,x)),A}await this.postUninstallExtension(q)}async uninstallExtensions(q,j,F,A){const M=[q,...j];if(!A.donotCheckDependents)for(const U of M)this.checkForDependents(U,M,F,q);await I.Promises.settled([this.uninstallExtension(q),...j.map(U=>this.doUninstall(U))])}checkForDependents(q,j,F,A){const M=this.getDependents(q,F);if(M.length){const U=M.filter(W=>j.indexOf(W)===-1);if(U.length)throw new Error(this.getDependentsErrorMessage(q,U,A))}}getDependentsErrorMessage(q,j,F){return F===q?j.length===1?d.localize(12,null,F.manifest.displayName||F.manifest.name,j[0].manifest.displayName||j[0].manifest.name):j.length===2?d.localize(13,null,F.manifest.displayName||F.manifest.name,j[0].manifest.displayName||j[0].manifest.name,j[1].manifest.displayName||j[1].manifest.name):d.localize(14,null,F.manifest.displayName||F.manifest.name,j[0].manifest.displayName||j[0].manifest.name,j[1].manifest.displayName||j[1].manifest.name):j.length===1?d.localize(15,null,F.manifest.displayName||F.manifest.name,q.manifest.displayName||q.manifest.name,j[0].manifest.displayName||j[0].manifest.name):j.length===2?d.localize(16,null,F.manifest.displayName||F.manifest.name,q.manifest.displayName||q.manifest.name,j[0].manifest.displayName||j[0].manifest.name,j[1].manifest.displayName||j[1].manifest.name):d.localize(17,null,F.manifest.displayName||F.manifest.name,q.manifest.displayName||q.manifest.name,j[0].manifest.displayName||j[0].manifest.name,j[1].manifest.displayName||j[1].manifest.name)}getAllPackExtensionsToUninstall(q,j,F=[]){if(F.indexOf(q)!==-1)return[];F.push(q);const A=q.manifest.extensionPack?q.manifest.extensionPack:[];if(A.length){const M=j.filter(W=>!W.isBuiltin&&A.some(ne=>D.areSameExtensions({id:ne},W.identifier))),U=[];for(const W of M)U.push(...this.getAllPackExtensionsToUninstall(W,j,F));return[...M,...U]}return[]}getDependents(q,j){return j.filter(F=>F.manifest.extensionDependencies&&F.manifest.extensionDependencies.some(A=>D.areSameExtensions({id:A},q.identifier)))}async doUninstall(q){try{await this.preUninstallExtension(q),await this.uninstallExtension(q)}catch(j){throw await this.postUninstallExtension(q,new n.ExtensionManagementError(j instanceof Error?j.message:j,x)),j}await this.postUninstallExtension(q)}async preUninstallExtension(q){if(!await y.exists(q.location.fsPath))throw new Error(d.localize(18,null));this.logService.info("Uninstalling extension:",q.identifier.id),this._onUninstallExtension.fire(q.identifier)}async uninstallExtension(q){let j=this.uninstallingExtensions.get(q.identifier.id);return j||(j=I.createCancelablePromise(async()=>{const F=await this.extensionsScanner.scanUserExtensions(!1);await this.setUninstalled(...F.filter(A=>D.areSameExtensions(A.identifier,q.identifier)))}),this.uninstallingExtensions.set(q.identifier.id,j),j.finally(()=>this.uninstallingExtensions.delete(q.identifier.id))),j}async postUninstallExtension(q,j){if(j)this.logService.error("Failed to uninstall extension:",q.identifier.id,j.message);else if(this.logService.info("Successfully uninstalled extension:",q.identifier.id),q.identifier.uuid)try{await this.galleryService.reportStatistic(q.manifest.publisher,q.manifest.name,q.manifest.version,"uninstall")}catch(A){}this.reportTelemetry("extensionGallery:uninstall",D.getLocalExtensionTelemetryData(q),void 0,j);const F=j?j instanceof n.ExtensionManagementError?j.code:J:void 0;this._onDidUninstallExtension.fire({identifier:q.identifier,error:F})}getInstalled(q=null){return this.extensionsScanner.scanExtensions(q)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(q){return(await this.filterUninstalled(q)).length===1}filterUninstalled(...q){return this.extensionsScanner.withUninstalledExtensions(j=>{const F=[];for(const A of q)j[A.key()]&&F.push(A.key());return F})}setUninstalled(...q){const j=q.map(F=>new D.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version));return this.extensionsScanner.withUninstalledExtensions(F=>(j.forEach(A=>F[A.key()]=!0),F))}unsetUninstalled(q){return this.extensionsScanner.withUninstalledExtensions(j=>delete j[q.key()])}getExtensionsReport(){const q=new Date().getTime();return(!this.reportedExtensions||q-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=q),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const q=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${q.length} reported extensions from service`),q}catch(q){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(q,j,F,A){const M=A?A instanceof n.ExtensionManagementError?A.code:J:void 0;this.telemetryService.publicLogError(q,Object.assign(Object.assign({},j),{success:!A,duration:F,errorcode:M}))}};Ee=Oe([Ge(0,b.INativeEnvironmentService),Ge(1,n.IExtensionGalleryService),Ge(2,m.ILogService),Ge(3,s.optional(a.IDownloadService)),Ge(4,r.ITelemetryService),Ge(5,s.IInstantiationService)],Ee),e.ExtensionManagementService=Ee}),define(fe[51],he([0,1,61,76,227,6,37,2,22,23,4,18,78,12,5]),function(Q,e,S,d,P,y,k,L,h,n,D,b,I,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(C){this.socket=C}dispose(){this.socket.destroy()}onData(C){const R=p=>C(b.VSBuffer.wrap(p));return this.socket.on("data",R),{dispose:()=>this.socket.off("data",R)}}onClose(C){return this.socket.on("close",C),{dispose:()=>this.socket.off("close",C)}}onEnd(C){return this.socket.on("end",C),{dispose:()=>this.socket.off("end",C)}}write(C){if(!this.socket.destroyed)try{this.socket.write(C.buffer)}catch(R){if(R.code==="EPIPE")return;E.onUnexpectedError(R)}}end(){this.socket.end()}drain(){return new Promise((C,R)=>{if(this.socket.bufferSize===0){C();return}const p=()=>{this.socket.off("close",p),this.socket.off("end",p),this.socket.off("error",p),this.socket.off("timeout",p),this.socket.off("drain",p),C()};this.socket.on("close",p),this.socket.on("end",p),this.socket.on("error",p),this.socket.on("timeout",p),this.socket.on("drain",p)})}}e.NodeSocket=v;var _;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize"})(_||(_={}));var w;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(w||(w={}));class m extends D.Disposable{constructor(C,R,p,f){super();this._onDidZlibFlush=this._register(new y.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new y.Emitter),this._onClose=this._register(new y.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=C,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=R,this._recordInflateBytes=f,R?(this._zlibInflate=P.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",T=>{console.error(T),E.onUnexpectedError(T),this._onClose.fire()}),this._zlibInflate.on("data",T=>{this._pendingInflateData.push(T)}),p&&(this._zlibInflate.write(p.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=P.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",T=>{console.error(T),E.onUnexpectedError(T),this._onClose.fire()}),this._zlibDeflate.on("data",T=>{this._pendingDeflateData.push(T)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new I.ChunkStream,this._register(this.socket.onData(T=>this._acceptChunk(T))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?b.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):b.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(C){return this._onData.event(C)}onClose(C){return this._onClose.event(C)}onEnd(C){return this.socket.onEnd(C)}write(C){this._totalOutgoingDataBytes+=C.byteLength,this._zlibDeflate?(this._zlibDeflate.write(C.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let R=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,R=R.slice(0,R.length-4),this._isEnded||this._write(b.VSBuffer.wrap(R),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(C,!1)}_write(C,R){let p=2;C.byteLength<126?p+=0:C.byteLength<2**16?p+=2:p+=8;const f=b.VSBuffer.alloc(p);if(R?f.writeUInt8(194,0):f.writeUInt8(130,0),C.byteLength<126)f.writeUInt8(C.byteLength,1);else if(C.byteLength<2**16){f.writeUInt8(126,1);let T=1;f.writeUInt8(C.byteLength>>>8&255,++T),f.writeUInt8(C.byteLength>>>0&255,++T)}else{f.writeUInt8(127,1);let T=1;f.writeUInt8(0,++T),f.writeUInt8(0,++T),f.writeUInt8(0,++T),f.writeUInt8(0,++T),f.writeUInt8(C.byteLength>>>24&255,++T),f.writeUInt8(C.byteLength>>>16&255,++T),f.writeUInt8(C.byteLength>>>8&255,++T),f.writeUInt8(C.byteLength>>>0&255,++T)}this._totalOutgoingWireBytes+=f.byteLength+C.byteLength,this.socket.write(b.VSBuffer.concat([f,C]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(C){if(C.byteLength!==0){for(this._totalIncomingWireBytes+=C.byteLength,this._incomingData.acceptChunk(C);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const R=this._incomingData.peek(this._state.readLen),f=(R.readUInt8(0)&128)>>>7,T=R.readUInt8(1),O=(T&128)>>>7,H=T&127;this._state.state=2,this._state.readLen=2+(O?4:0)+(H===126?2:0)+(H===127?8:0),this._state.fin=f,this._state.mask=0}else if(this._state.state===2){const R=this._incomingData.read(this._state.readLen),p=R.readUInt8(1),f=(p&128)>>>7;let T=p&127,O=1;T===126?T=R.readUInt8(++O)*2**8+R.readUInt8(++O):T===127&&(T=R.readUInt8(++O)*0+R.readUInt8(++O)*0+R.readUInt8(++O)*0+R.readUInt8(++O)*0+R.readUInt8(++O)*2**24+R.readUInt8(++O)*2**16+R.readUInt8(++O)*2**8+R.readUInt8(++O));let H=0;f&&(H=R.readUInt8(++O)*2**24+R.readUInt8(++O)*2**16+R.readUInt8(++O)*2**8+R.readUInt8(++O)),this._state.state=3,this._state.readLen=T,this._state.mask=H}else if(this._state.state===3){const R=this._incomingData.read(this._state.readLen);l(R,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(R.buffer)),this._zlibInflate.write(R.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const p=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=p.length,this._onData.fire(b.VSBuffer.wrap(p))})):(this._totalIncomingDataBytes+=R.byteLength,this._onData.fire(R))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await y.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=m;function l(g,C){if(C!==0){let R=g.byteLength>>>2;for(let $=0;$<R;$++){const x=g.readUInt32BE($*4);g.writeUInt32BE(x^C,$*4)}let p=R*4,f=g.byteLength-p;const T=C>>>24&255,O=C>>>16&255,H=C>>>8&255;f>=1&&g.writeUInt8(g.readUInt8(p)^T,p),f>=2&&g.writeUInt8(g.readUInt8(p+1)^O,p+1),f>=3&&g.writeUInt8(g.readUInt8(p+2)^H,p+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function r(){const g=n.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;let C;return e.XDG_RUNTIME_DIR?C=L.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${g}.sock`):C=L.join(h.tmpdir(),`vscode-ipc-${g}.sock`),i(C),C}e.createRandomIPCHandle=r;function t(g,C,R){const p=S.createHash("md5").update(g).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${p}-${R}-${C}-sock`;let f;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?f=L.join(e.XDG_RUNTIME_DIR,`vscode-${p.substr(0,8)}-${R}-${C}.sock`):f=L.join(g,`${R}-${C}.sock`),i(f),f}e.createStaticIPCHandle=t;function i(g){const C=c[u.platform];typeof C=="number"&&g.length>=C&&console.warn(`WARNING: IPC handle "${g}" is longer than ${C} chars, try a shorter --user-data-dir`)}class o extends k.IPCServer{constructor(C){super(o.toClientConnectionEvent(C));this.server=C}static toClientConnectionEvent(C){const R=y.Event.fromNodeEventEmitter(C,"connection");return y.Event.map(R,p=>({protocol:new I.Protocol(new v(p)),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(p,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function a(g){return new Promise((C,R)=>{const p=d.createServer();p.on("error",R),p.listen(g,()=>{p.removeListener("error",R),C(new o(p))})})}e.serve=a;function s(g,C){return new Promise((R,p)=>{const f=d.createConnection(g,()=>{f.removeListener("error",p),R(I.Client.fromSocket(new v(f),C))});f.once("error",p)})}e.connect=s}),define(fe[103],he([0,1,227,63,4,11,12,192,34,17,18]),function(Q,e,S,d,P,y,k,L,h,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let b=class extends P.Disposable{constructor(E,u){super();this.logService=u,this.configure(E.getValue()),this._register(E.onDidChangeConfiguration(()=>this.configure(E.getValue()),this))}configure(E){this.proxyUrl=E.http&&E.http.proxy,this.strictSSL=!!(E.http&&E.http.proxyStrictSSL),this.authorization=E.http&&E.http.proxyAuthorization}async request(E,u){this.logService.trace("RequestService#request",E.url);const{proxyUrl:v,strictSSL:_}=this,w=E.agent?E.agent:await L.getProxyAgent(E.url||"",{proxyUrl:v,strictSSL:_});return E.agent=w,E.strictSSL=_,this.authorization&&(E.headers=Object.assign(Object.assign({},E.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(E,u)}async getNodeRequest(E){return(d.parse(E.url).protocol==="https:"?await new Promise((_,w)=>{Q(["https"],_,w)}):await new Promise((_,w)=>{Q(["http"],_,w)})).request}_request(E,u){return new Promise(async(v,_)=>{let w;const m=d.parse(E.url),l=E.getRawRequest?E.getRawRequest(E):await this.getNodeRequest(E),c={hostname:m.hostname,port:m.port?parseInt(m.port):m.protocol==="https:"?443:80,protocol:m.protocol,path:m.path,method:E.type||"GET",headers:E.headers,agent:E.agent,rejectUnauthorized:y.isBoolean(E.strictSSL)?E.strictSSL:!0};E.user&&E.password&&(c.auth=E.user+":"+E.password),w=l(c,r=>{const t=y.isNumber(E.followRedirects)?E.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&t>0&&r.headers.location)this._request(Object.assign(Object.assign({},E),{url:r.headers.location,followRedirects:t-1}),u).then(v,_);else{let i=r;r.headers["content-encoding"]==="gzip"&&(i=r.pipe(S.createGunzip())),v({res:r,stream:D.streamToBufferReadableStream(i)})}}),w.on("error",_),E.timeout&&w.setTimeout(E.timeout),E.data&&typeof E.data=="string"&&w.write(E.data),w.end(),u.onCancellationRequested(()=>{w.abort(),_(k.canceled())})})}async resolveProxy(E){}};b=Oe([Ge(0,h.IConfigurationService),Ge(1,n.ILogService)],b),e.RequestService=b}),define(fe[104],he([0,1,32,96,38,8,2,18,6,51,178,5]),function(Q,e,S,d,P,y,k,L,h,n,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function I(w={},m,l,c){const r=await d.getNLSConfiguration(m,l.userDataPath),t=await D.resolveShellEnv(c,l.args,process.env),i=l.isBuilt?k.join(l.appRoot,"bin"):k.join(l.appRoot,"resources","server","bin-dev"),o=process.env;let a=w.PATH||t.PATH||o.PATH;a?a=i+k.delimiter+a:a=i;const s=Object.assign(Object.assign(Object.assign(Object.assign({},o),t),{VSCODE_AMD_ENTRYPOINT:"vs/server/remoteExtensionHostProcess",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_EXTHOST_WILL_SEND_SOCKET:"true",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_LOG_STACK:"false",VSCODE_NLS_CONFIG:JSON.stringify(r,void 0,0)}),w);return l.args["without-browser-env-var"]||(s.BROWSER=k.join(i,"helpers",b.isWindows?"browser.cmd":"browser.sh")),v(s,"PATH",a),_(s),s}e.buildUserEnvironment=I;class E{constructor(m,l,c,r,t,i){this.socket=m,this.socketDrain=l,this.initialDataChunk=c,this.skipWebSocketFrames=r,this.permessageDeflate=t,this.inflateBytes=i}toIExtHostSocketMessage(){return{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:this.skipWebSocketFrames,permessageDeflate:this.permessageDeflate,inflateBytes:this.inflateBytes.buffer.toString("base64")}}}class u{constructor(m,l,c,r,t,i){this._environmentService=m,this._logService=l,this._reconnectionToken=c,this._onClose=new h.Emitter,this.onClose=this._onClose.event,this._disposed=!1,this._remoteAddress=r,this._extensionHostProcess=null,this._connectionData=u._toConnectionData(t,i),this._connectionData.socket.pause(),this._log("New connection established.")}_log(m){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] ${m}`)}_logError(m){this._logService.error(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] ${m}`)}static _toConnectionData(m,l){return m instanceof n.NodeSocket?new E(m.socket,m.drain(),l,!0,!1,L.VSBuffer.alloc(0)):new E(m.socket.socket,m.drain(),l,!1,m.permessageDeflate,m.recordedInflateBytes)}async _sendSocketToExtensionHost(m,l){await l.socketDrain;const c=l.toIExtHostSocketMessage();m.send(c,l.socket)}shortenReconnectionGraceTimeIfNecessary(){if(!!this._extensionHostProcess){const m={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this._extensionHostProcess.send(m)}}acceptReconnection(m,l,c){this._remoteAddress=m,this._log("The client has reconnected.");const r=u._toConnectionData(l,c);if(r.socket.pause(),!this._extensionHostProcess){this._connectionData=r;return}this._sendSocketToExtensionHost(this._extensionHostProcess,r)}_cleanResources(){this._disposed||(this._disposed=!0,this._connectionData&&(this._connectionData.socket.end(),this._connectionData=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(m){try{let l=[];m.port&&!process.pkg&&(l=[`--inspect${m.break?"-brk":""}=0.0.0.0:${m.port}`]);const r={env:await I(m.env,m.language,this._environmentService,this._logService),execArgv:l,silent:!0},t=["--type=extensionHost",`--uriTransformerPath=${P.uriTransformerPath}`],i=this._environmentService.args["use-host-proxy"];i!==void 0&&t.push(`--useHostProxy=${i}`),this._extensionHostProcess=S.fork(y.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,t,r);const o=this._extensionHostProcess.pid;this._log(`<${o}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const a=h.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),s=h.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");a(C=>console.log("EXTHOST-STDOUT::::::::"+C)),s(C=>console.log("EXTHOST-STDERR::::::::"+C)),this._extensionHostProcess.on("message",C=>{C&&C.type==="__$console"&&(console.log("EXTHOST-LOG:::::"),console.log(C.arguments))}),this._extensionHostProcess.on("error",C=>{this._logError(`<${o}> Extension Host Process had an error`),this._logService.error(C),this._cleanResources()}),this._extensionHostProcess.on("exit",(C,R)=>{this._log(`<${o}> Extension Host Process exited with code: ${C}, signal: ${R}.`),this._cleanResources()});const g=C=>{C.type==="VSCODE_EXTHOST_IPC_READY"&&(this._extensionHostProcess.removeListener("message",g),this._sendSocketToExtensionHost(this._extensionHostProcess,this._connectionData),this._connectionData=null)};this._extensionHostProcess.on("message",g)}catch(l){console.error("ExtensionHostConnection errored"),l&&console.error(l)}}}e.ExtensionHostConnection=u;function v(w,m,l){const c=Object.keys(w).filter(t=>t.toLowerCase()===m.toLowerCase()),r=c.length>0?c[0]:m;w[r]=l}function _(w){for(let m of Object.keys(w))w[m]===null&&delete w[m]}}),define(fe[228],he([0,1,29,59,17,58,91,34,62,103,64,43,30,93,102,86,26,4,88,60,8,24,50,90,101,65,87,48,89,12,3,2]),function(Q,e,S,d,P,y,k,L,h,n,D,b,I,E,u,v,_,w,m,l,c,r,t,i,o,a,s,g,C,R,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class T extends w.Disposable{constructor(x,J){super();this.args=x,this.remoteDataFolder=J,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){await(await this.initServices()).invokeFunction(async J=>{const Ee=J.get(P.ILogService),ve=J.get(I.IExtensionManagementCLIService);try{await this.doRun(ve)}catch(q){throw Ee.error(q),console.error(R.getErrorMessage(q)),q}})}async initServices(){const x=new d.ServiceCollection,J=new a.ServerEnvironmentService(this.args);x.set(S.IEnvironmentService,J),x.set(S.INativeEnvironmentService,J);const Ee=new P.LogService(new i.SpdLogLogger(o.RemoteExtensionLogFileName,f.join(J.logsPath,`${o.RemoteExtensionLogFileName}.log`),!0,P.getLogLevel(J)));x.set(P.ILogService,Ee),Ee.trace(`Remote configuration data at ${this.remoteDataFolder}`),Ee.trace("process arguments:",this.args),x.set(t.IProductService,Object.assign({_serviceBrand:void 0},_.default));const ve=this._register(new m.FileService(Ee));x.set(r.IFileService,ve),ve.registerProvider(c.Schemas.file,this._register(new l.DiskFileSystemProvider(Ee)));const q=this._register(new k.ConfigurationService(J.settingsResource,ve));return await q.initialize(),x.set(L.IConfigurationService,q),x.set(h.IRequestService,new y.SyncDescriptor(n.RequestService)),x.set(b.ITelemetryService,D.NullTelemetryService),x.set(I.IExtensionGalleryService,new y.SyncDescriptor(E.ExtensionGalleryService)),x.set(I.IExtensionManagementService,new y.SyncDescriptor(u.ExtensionManagementService)),x.set(I.IExtensionManagementCLIService,new y.SyncDescriptor(s.ExtensionManagementCLIService)),x.set(g.ILocalizationsService,new y.SyncDescriptor(C.LocalizationsService)),new v.InstantiationService(x)}async doRun(x){if(this.args["list-extensions"])return x.listExtensions(!!this.args["show-versions"],this.args.category);if(this.args["install-extension"]||this.args["install-builtin-extension"])return x.installExtensions(this.asExtensionIdOrVSIX(this.args["install-extension"]||[]),this.args["install-builtin-extension"]||[],!!this.args["do-not-sync"],!!this.args.force);if(this.args["uninstall-extension"])return x.uninstallExtensions(this.asExtensionIdOrVSIX(this.args["uninstall-extension"]),!!this.args.force);if(this.args["locate-extension"])return x.locateExtension(this.args["locate-extension"])}asExtensionIdOrVSIX(x){return x.map(J=>/\.vsix$/i.test(J)?p.URI.file(f.isAbsolute(J)?J:f.join(process.cwd(),J)):J)}}function O($){setTimeout(()=>process.exit($),0)}async function H($,x){const J=new T($,x);try{await J.run(),O(0)}catch(Ee){O(1)}finally{J.dispose()}}e.run=H}),define(fe[229],he([0,1,51,240,15,221,3,204,17]),function(Q,e,S,d,P,y,k,L,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class n{constructor(I,E,u){this._commands=I,this.logService=E,this._ipcHandlePath=u,this._server=d.createServer((v,_)=>this.onRequest(v,_)),this.setup().catch(v=>(E.error(v),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",I=>this.logService.error(I))}catch(I){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(I,E){const u=[];I.setEncoding("utf8"),I.on("data",v=>u.push(v)),I.on("end",()=>{const v=JSON.parse(u.join(""));switch(v.type){case"open":this.open(v,E);break;case"openExternal":this.openExternal(v,E);break;case"status":this.getStatus(v,E);break;case"command":this.runCommand(v,E).catch(this.logService.error);break;case"extensionManagement":this.manageExtensions(v,E).catch(this.logService.error);break;default:E.writeHead(404),E.write(`Unknown message type: ${v.type}`,_=>{_&&this.logService.error(_)}),E.end();break}})}open(I,E){let{fileURIs:u,folderURIs:v,forceNewWindow:_,diffMode:w,addMode:m,forceReuseWindow:l,gotoLineMode:c,waitMarkerFilePath:r}=I;const t=[];if(Array.isArray(v))for(const i of v)try{t.push({folderUri:k.URI.parse(i)})}catch(o){}if(Array.isArray(u))for(const i of u)try{L.hasWorkspaceFileExtension(i)?t.push({workspaceUri:k.URI.parse(i)}):t.push({fileUri:k.URI.parse(i)})}catch(o){}if(t.length){const i=r?k.URI.file(r):void 0,a={forceNewWindow:_,diffMode:w,addMode:m,gotoLineMode:c,forceReuseWindow:l,preferNewWindow:!l&&!i&&!m,waitMarkerFileURI:i};this._commands.executeCommand("_files.windowOpen",t,a)}E.writeHead(200),E.end()}async openExternal(I,E){for(const u of I.uris){const v=k.URI.parse(u),_=v.scheme==="file"?v:u;await this._commands.executeCommand("_remoteCLI.openExternal",_)}E.writeHead(200),E.end()}async manageExtensions(I,E){console.log("server: manageExtensions");try{const u=w=>w==null?void 0:w.map(m=>/\.vsix$/i.test(m)?k.URI.parse(m):m),v={list:I.list,install:u(I.install),uninstall:u(I.uninstall),force:I.force},_=await this._commands.executeCommand("_remoteCLI.manageExtensions",v,{allowTunneling:!0});E.writeHead(200),E.write(_)}catch(u){E.writeHead(500),E.write(String(u))}E.end()}async getStatus(I,E){try{const u=await this._commands.executeCommand("_issues.getSystemStatus");E.writeHead(200),E.write(u),E.end()}catch(u){E.writeHead(500),E.write(String(u),v=>{v&&this.logService.error(v)}),E.end()}}async runCommand(I,E){try{const{command:u,args:v}=I,_=await this._commands.executeCommand(u,...v);E.writeHead(200),E.write(JSON.stringify(_),w=>{w&&this.logService.error(w)}),E.end()}catch(u){E.writeHead(500),E.write(String(u),v=>{v&&this.logService.error(v)}),E.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&P.existsSync(this._ipcHandlePath)&&P.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=n;let D=class extends n{constructor(I,E){super(I,E,S.createRandomIPCHandle())}};D=Oe([Ge(0,y.IExtHostCommands),Ge(1,h.ILogService)],D),e.CLIServer=D}),define(fe[230],he([0,1,6,3,22,2,26,5,210,203,4,201,211,214,38,100,208,229,51,19,104,13,95,81]),function(Q,e,S,d,P,y,k,L,h,n,D,b,I,E,u,v,_,w,m,l,c,r,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;const o=1024*1024;class a extends E.AbstractVariableResolverService{constructor(f,T,O,H){super({getFolderUri:$=>{const x=T.filter(J=>J.name===$);if(x&&x.length>0)return x[0].uri},getWorkspaceFolderCount:()=>T.length,getConfigurationValue:($,x)=>H[`config:${x}`],getExecPath:()=>f.VSCODE_EXEC_PATH,getAppRoot:()=>f.VSCODE_CWD,getFilePath:()=>{if(O)return y.normalize(O.fsPath)},getSelectedText:()=>H.selectedText,getLineNumber:()=>H.lineNumber},void 0,f)}}class s{constructor(f,T){this._logService=f,this._environmentService=T,this._terminals=new Map,this._workspaceLayoutInfos=new Map,this._terminals=new Map}async call(f,T,O){switch(T){case"$createTerminalProcess":{const H=u.createRemoteURITransformer(f.remoteAuthority),$=O;return this._createTerminalProcess(H,$)}case"$startTerminalProcess":{const H=O;return this._startTerminalProcess(H)}case"$sendInputToTerminalProcess":{const H=O;return this._sendInputToTerminalProcess(H)}case"$sendCharCountToTerminalProcess":{const H=O;return this._sendCharCountToTerminalProcess(H)}case"$shutdownTerminalProcess":{const H=O;return this._shutdownTerminalProcess(H)}case"$resizeTerminalProcess":{const H=O;return this._resizeTerminalProcess(H)}case"$getTerminalInitialCwd":{const H=O;return this._getTerminalInitialCwd(H)}case"$getTerminalCwd":{const H=O;return this._getTerminalCwd(H)}case"$sendCommandResultToTerminalProcess":{const H=O;return this._sendCommandResultToTerminalProcess(H)}case"$orphanQuestionReply":{const H=O;return this._orphanQuestionReply(H)}case"$listTerminals":{const H=O;return this._listTerminals(H)}case"$getTerminalLayoutInfo":{const H=O;return this._getTerminalLayoutInfo(H)}case"$setTerminalLayoutInfo":{const H=O;return this._setTerminalLayoutInfo(H)}}throw new Error(`IPC Command ${T} not found`)}async _createTerminalProcess(f,T){const O={name:T.shellLaunchConfig.name,executable:T.shellLaunchConfig.executable,args:T.shellLaunchConfig.args,cwd:typeof T.shellLaunchConfig.cwd=="string"||typeof T.shellLaunchConfig.cwd=="undefined"?T.shellLaunchConfig.cwd:d.URI.revive(f.transformIncoming(T.shellLaunchConfig.cwd)),env:T.shellLaunchConfig.env,flowControl:T.configuration["terminal.flowControl"]},H=await c.buildUserEnvironment(T.resolverEnv,L.language,this._environmentService,this._logService),$=de=>({uri:d.URI.revive(f.transformIncoming(de.uri)),name:de.name,index:de.index,toResource:()=>{throw new Error("Not implemented")}}),x=T.workspaceFolders.map($),J=T.activeWorkspaceFolder?$(T.activeWorkspaceFolder):void 0,Ee=T.activeFileResource?d.URI.revive(f.transformIncoming(T.activeFileResource)):void 0,ve=new a(H,x,Ee,T.resolvedVariables),q=h.createVariableResolver(J,ve),j=L.isWindows?"terminal.integrated.env.windows":L.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux";if(!O.executable)O.executable=await this._getDefaultShell(!1,T.configuration,q,T.isWorkspaceShellAllowed,H),O.args=this._getDefaultShellArgs(!1,T.configuration,q,T.isWorkspaceShellAllowed);else if(q&&(O.executable=q(O.executable),O.args))if(Array.isArray(O.args)){const de=[];for(const Pe of O.args)de.push(q(Pe));O.args=de}else O.args=q(O.args);const F=h.getCwd(O,P.homedir(),q,J==null?void 0:J.uri,T.configuration["terminal.integrated.cwd"],this._logService);O.cwd=F;const A=T.configuration[j],M=T.configuration["terminal.integrated.inheritEnv"]?H:await this._getNonInheritedEnv(H),U=h.createTerminalEnvironment(O,A,q,T.isWorkspaceShellAllowed,k.default.version,T.configuration["terminal.integrated.detectLocale"],M);if(!O.strictEnv){const de=[];for(const[Me,je]of T.envVariableCollections)de.push([Me,{map:v.deserializeEnvironmentVariableCollection(je)}]);const Pe=new Map(de);new _.MergedEnvironmentVariableCollection(Pe).applyToProcessEnvironment(U)}this._logService.debug("Terminal process launching on remote agent",{shellLaunchConfig:O,initialCwd:F,cols:T.cols,rows:T.rows,env:U});const W=m.createRandomIPCHandle();U.VSCODE_IPC_HOOK_CLI=W;const ne=s._nextTerminalId++,ae=new n.TerminalProcess(O,F,T.cols,T.rows,U,H,!1,this._logService),ce=new C(ne,ae,T.workspaceId,T.workspaceName,T.shouldPersistTerminal,T.cols,T.rows,f,W,this._logService,()=>{ce.dispose(),this._terminals.delete(ne)});return this._terminals.set(ne,ce),{terminalId:ne,resolvedShellLaunchConfig:O}}async _startTerminalProcess(f){const T=this._terminals.get(f.id);if(!T)return{message:"Missing terminal"};const O=await T.start();if(O)return O}async _getDefaultShell(f,T,O,H,$){const x=J=>T[J];return h.getDefaultShell(x,H,await i.getSystemShell(L.platform),$.hasOwnProperty("PROCESSOR_ARCHITEW6432"),$.windir,O,this._logService,f)}_getDefaultShellArgs(f,T,O,H){const $=x=>T[x];return h.getDefaultShellArgs($,H,f,O,this._logService)}_getNonInheritedEnv(f){return I.getMainProcessParentEnv(f)}_getTerminalOrThrow(f){const T=this._terminals.get(f);if(!T)throw new Error("Missing terminal");return T}_sendInputToTerminalProcess(f){this._getTerminalOrThrow(f.id).input(f.data)}_sendCharCountToTerminalProcess(f){this._getTerminalOrThrow(f.id).acknowledgeCharCount(f.charCount)}_shutdownTerminalProcess(f){this._getTerminalOrThrow(f.id).shutdown(f.immediate)}_resizeTerminalProcess(f){this._getTerminalOrThrow(f.id).resize(f.cols,f.rows)}_getTerminalInitialCwd(f){return this._getTerminalOrThrow(f.id).getInitialCwd()}_getTerminalCwd(f){return this._getTerminalOrThrow(f.id).getCwd()}_sendCommandResultToTerminalProcess(f){this._getTerminalOrThrow(f.id).sendCommandResult(f.reqId,f.isError,f.payload)}_orphanQuestionReply(f){this._getTerminalOrThrow(f.id).orphanQuestionReply()}async _listTerminals(f){if(f.isInitialization)for(const[,$]of this._terminals)$.reduceGraceTime();const T=Array.from(this._terminals.entries()).filter(([$,x])=>x.shouldPersistTerminal);this._logService.info(`Listing ${T.length} persistent terminals, ${this._terminals.size} total terminals`);const O=T.map(async([$,x])=>this._terminalToDto($,x));return(await Promise.all(O)).filter($=>$.isOrphan)}async _terminalToDto(f,T){const[O,H]=await Promise.all([T.getCwd(),T.isOrphaned()]);return{id:f,title:T.title,pid:T.pid,workspaceId:T.workspaceId,workspaceName:T.workspaceName,cwd:O,isOrphan:H}}_setTerminalLayoutInfo(f){this._workspaceLayoutInfos.set(f.workspaceId,f)}async _getTerminalLayoutInfo(f){const T=this._workspaceLayoutInfos.get(f.workspaceId);if(T){const H=(await Promise.all(T.tabs.map(async $=>this._expandTerminalTab($)))).filter($=>$.terminals.length>0);return this._logService.info(`Terminal layout retrieved: ${JSON.stringify(H.map($=>$.terminals.length))}`),{tabs:H}}}async _expandTerminalTab(f){const O=(await Promise.all(f.terminals.map(H=>this._expandTerminalInstance(H)))).filter(H=>H.terminal!==null);return{isActive:f.isActive,activePersistentTerminalId:f.activePersistentTerminalId,terminals:O}}async _expandTerminalInstance(f){const T=this._terminals.get(f.terminal),O=T&&await this._terminalToDto(f.terminal,T);return{terminal:O!=null?O:null,relativeSize:f.relativeSize}}listen(f,T,O){switch(T){case"$onTerminalProcessEvent":{const H=O;return this._onTerminalProcessEvent(H)}default:break}throw new Error("Not supported")}_onTerminalProcessEvent(f){const T=this._terminals.get(f.id);if(!T)throw new Error("Missing terminal");return T.events}}e.RemoteTerminalChannel=s,s._nextTerminalId=1;class g{constructor(f,T){this._entries=[{cols:f,rows:T,data:[]}],this._totalDataLength=0}recordResize(f,T){if(this._entries.length>0&&this._entries[this._entries.length-1].data.length===0&&this._entries.pop(),this._entries.length>0){const O=this._entries[this._entries.length-1];if(O.cols===f&&O.rows===T)return;if(O.cols===0&&O.rows===0){O.cols=f,O.rows=T;return}}this._entries.push({cols:f,rows:T,data:[]})}recordData(f){for(this._entries[this._entries.length-1].data.push(f),this._totalDataLength+=f.length;this._totalDataLength>o;){const O=this._entries[0],H=this._totalDataLength-o;H>=O.data[0].length?(this._totalDataLength-=O.data[0].length,O.data.shift(),O.data.length===0&&this._entries.shift()):(O.data[0]=O.data[0].substr(H),this._totalDataLength-=H)}}generateReplayEvent(){return this._entries.forEach(f=>{f.data.length>0&&(f.data=[f.data.join("")])}),{type:"replay",events:this._entries.map(f=>{var T;return{cols:f.cols,rows:f.rows,data:(T=f.data[0])!==null&&T!==void 0?T:""}})}}}class C extends D.Disposable{constructor(f,T,O,H,$,x,J,Ee,ve,q,j){super();this._id=f,this._terminalProcess=T,this.workspaceId=O,this.workspaceName=H,this.shouldPersistTerminal=$,this._uriTransformer=Ee,this._logService=q,this._onExit=j,this._lastReqId=0,this._pendingCommands=new Map,this._orphanRequestQueue=new r.Queue,this._title="",this._pid=-1,this._recorder=new g(x,J),this._seenFirstListener=!1,this._orphanQuestionBarrier=null,this._orphanQuestionReplyTime=0,this._disconnectRunner1=this._register(new r.RunOnceScheduler(()=>{this._logService.info(`The reconnection grace time of ${t.printTime(108e5)} has expired, so the terminal process with pid ${this._pid} will be shutdown.`),this.shutdown(!0)},108e5)),this._disconnectRunner2=this._register(new r.RunOnceScheduler(()=>{this._logService.info(`The short reconnection grace time of ${t.printTime(3e5)} has expired, so the terminal process with pid ${this._pid} will be shutdown.`),this.shutdown(!0)},3e5)),this._events=this._register(new S.Emitter({onListenerDidAdd:()=>{this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this._seenFirstListener&&this._triggerReplay(),this._seenFirstListener=!0},onLastListenerRemove:()=>{this.shouldPersistTerminal?this._disconnectRunner1.schedule():this.shutdown(!0)}})),this.events=this._events.event,this._bufferer=new b.TerminalDataBufferer((A,M)=>{const U={type:"data",data:M};this._events.fire(U)}),this._register(this._terminalProcess.onProcessReady(A=>{this._pid=A.pid;const M={type:"ready",pid:A.pid,cwd:A.cwd};this._events.fire(M)})),this._register(this._terminalProcess.onProcessTitleChanged(A=>{this._title=A;const M={type:"titleChanged",title:A};this._events.fire(M)})),this._register(this._bufferer.startBuffering(this._id,this._terminalProcess.onProcessData)),this._register(this._terminalProcess.onProcessData(A=>{this._recorder.recordData(A)})),this._register(this._terminalProcess.onProcessExit(A=>{this._bufferer.stopBuffering(this._id);const M={type:"exit",exitCode:A};this._events.fire(M),this._onExit()}));const F={executeCommand:(A,...M)=>this._executeCommand(A,M)};this._register(new w.CLIServerBase(F,this._logService,ve))}get pid(){return this._pid}get title(){return this._title}start(){return this._terminalProcess.start()}shutdown(f){return this._terminalProcess.shutdown(f)}input(f){return this._terminalProcess.input(f)}acknowledgeCharCount(f){return this._terminalProcess.acknowledgeDataEvent(f)}resize(f,T){return this._recorder.recordResize(f,T),this._terminalProcess.resize(f,T)}getInitialCwd(){return this._terminalProcess.getInitialCwd()}getCwd(){return this._terminalProcess.getCwd()}_triggerReplay(){const f=this._recorder.generateReplayEvent();let T=0;for(const O of f.events)T+=O.data.length;this._logService.info(`Replaying ${T} chars and ${f.events.length} size events.`),this._events.fire(f)}_executeCommand(f,T){let O,H;const $=new Promise((ve,q)=>{O=ve,H=q}),x=++this._lastReqId;this._pendingCommands.set(x,{resolve:O,reject:H});const J=l.cloneAndChange(T,ve=>{if(ve&&ve.$mid===1)return this._uriTransformer.transformOutgoing(ve);if(ve&&ve instanceof d.URI)return this._uriTransformer.transformOutgoingURI(ve)}),Ee={type:"execCommand",reqId:x,commandId:f,commandArgs:J};return this._events.fire(Ee),$}sendCommandResult(f,T,O){const H=this._pendingCommands.get(f);if(!!H){this._pendingCommands.delete(f);const $=l.cloneAndChange(O,x=>{if(x&&x.$mid===1)return this._uriTransformer.transformIncoming(x)});T?H.reject($):H.resolve($)}}async orphanQuestionReply(){if(this._orphanQuestionReplyTime=Date.now(),this._orphanQuestionBarrier){const f=this._orphanQuestionBarrier;this._orphanQuestionBarrier=null,f.open()}}reduceGraceTime(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&this._disconnectRunner2.schedule()}async isOrphaned(){return await this._orphanRequestQueue.queue(async()=>this._isOrphaned())}async _isOrphaned(){if(this._disconnectRunner1.isScheduled()||this._disconnectRunner2.isScheduled())return!0;if(!this._orphanQuestionBarrier){this._orphanQuestionBarrier=new R(4e3),this._orphanQuestionReplyTime=0;const f={type:"orphan?"};this._events.fire(f)}return await this._orphanQuestionBarrier.wait(),Date.now()-this._orphanQuestionReplyTime>500}}class R extends r.Barrier{constructor(f){super();this._timeout=setTimeout(()=>this.open(),f)}open(){clearTimeout(this._timeout),super.open()}}}),define(fe[231],he([0,1,61,15,76,63,22,46,232,18,4,23,20,122,5,78,51,104,95,38,17,8,26,29,59,58,91,34,62,103,64,43,30,93,102,86,83,163,48,89,199,198,195,75,88,60,24,50,37,6,223,205,224,191,165,200,162,184,206,3,28,65,2,217,230,113,101,87,90]),function(Q,e,S,d,P,y,k,L,h,n,D,b,I,E,u,v,_,w,m,l,c,r,t,i,o,a,s,g,C,R,p,f,T,O,H,$,x,J,Ee,ve,q,j,F,A,M,U,W,ne,ae,ce,de,Pe,Te,Me,je,$e,Ye,et,Je,we,Se,Ce,ke,Le,ze,He,Ve,Qe,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.RemoteExtensionHostAgentServer=void 0;const ge=5*60*1e3,me=`

*
* Visual Studio Code Server
*
* Reminder: You may only use this software with Visual Studio family products,
* as described in the license https://aka.ms/vscode-remote/license
*

`,Fe="monacoworkbench";class z extends ae.IPCServer{constructor(){const le=new ce.Emitter;super(le.event);this._onDidConnectEmitter=le}acceptConnection(le,ye){this._onDidConnectEmitter.fire({protocol:le,onDidClientDisconnect:ye})}}function X(De){return De<10?`0${De}`:String(De)}function ee(){const De=new Date;return`${X(De.getHours())}:${X(De.getMinutes())}:${X(De.getSeconds())}`}class V extends c.AbstractLogger{constructor(le=c.DEFAULT_LOG_LEVEL){super();this.setLevel(le),this.useColors=Boolean(process.stdout.isTTY)}trace(le,...ye){this.getLevel()<=c.LogLevel.Trace&&(this.useColors?console.log(`[90m[${ee()}][0m`,le,...ye):console.log(`[${ee()}]`,le,...ye))}debug(le,...ye){this.getLevel()<=c.LogLevel.Debug&&(this.useColors?console.log(`[90m[${ee()}][0m`,le,...ye):console.log(`[${ee()}]`,le,...ye))}info(le,...ye){this.getLevel()<=c.LogLevel.Info&&(this.useColors?console.log(`[90m[${ee()}][0m`,le,...ye):console.log(`[${ee()}]`,le,...ye))}warn(le,...ye){this.getLevel()<=c.LogLevel.Warning&&(this.useColors?console.warn(`[93m[${ee()}][0m`,le,...ye):console.warn(`[${ee()}]`,le,...ye))}error(le,...ye){this.getLevel()<=c.LogLevel.Error&&(this.useColors?console.error(`[91m[${ee()}][0m`,le,...ye):console.error(`[${ee()}]`,le,...ye))}critical(le,...ye){this.getLevel()<=c.LogLevel.Critical&&(this.useColors?console.error(`[90m[${ee()}][0m`,le,...ye):console.error(`[${ee()}]`,le,...ye))}dispose(){}flush(){}}class K extends D.Disposable{constructor(le,ye,be,Ae,se){super();this._environmentService=le,this._connectionToken=ye,this._connectionTokenIsMandatory=be;const oe=ue(this._environmentService);oe.trace(`Remote configuration data at ${se}`),oe.trace("process arguments:",this._environmentService.args),oe.info(me),this._logService=new c.MultiplexLogService([new V(c.getLogLevel(this._environmentService)),oe]),this._socketServer=new z,this._uriTransformerCache=Object.create(null),this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null),Ae?this._webClientServer=new Je.WebClientServer(this._connectionToken,this._environmentService,this._logService):this._webClientServer=null,this._logService.info("Extension host agent started.")}async initialize(){const le=await this._createServices();return setTimeout(()=>this._cleanupOlderLogs(this._environmentService.logsPath).then(null,ye=>this._logService.error(ye)),1e4),le}async _createServices(){const le=new o.ServiceCollection;this._socketServer.registerChannel(Ye.ExtensionHostDebugBroadcastChannel.ChannelName,new Ye.ExtensionHostDebugBroadcastChannel);const ye=new ae.StaticRouter(G=>G.clientId==="renderer");this._socketServer.registerChannel("logger",new et.LogLevelChannel(this._logService)),le.set(i.IEnvironmentService,this._environmentService),le.set(i.INativeEnvironmentService,this._environmentService),le.set(c.ILogService,this._logService),le.set(ne.IProductService,Object.assign({_serviceBrand:void 0},t.default));const be=this._register(new M.FileService(this._logService));le.set(W.IFileService,be),be.registerProvider(r.Schemas.file,this._register(new U.DiskFileSystemProvider(this._logService))),le.set(g.IConfigurationService,new a.SyncDescriptor(s.ConfigurationService,[this._environmentService.machineSettingsResource,be])),le.set(C.IRequestService,new a.SyncDescriptor(R.RequestService));let Ae=p.NullAppender;if(!this._environmentService.args["disable-telemetry"]&&t.default.enableTelemetry){t.default.aiConfig&&t.default.aiConfig.asimovKey&&(Ae=new q.AppInsightsAppender(Fe,null,t.default.aiConfig.asimovKey),this._register(D.toDisposable(()=>Ae.flush())));const G=await A.getMachineId(),_e={appender:Ae,commonProperties:F.resolveCommonProperties(be,k.release(),process.arch,t.default.commit,t.default.version+"-remote",G,t.default.msftInternalDomains,this._environmentService.installSourcePath,"remoteAgent"),piiPaths:[this._environmentService.appRoot]};le.set(f.ITelemetryService,new a.SyncDescriptor(j.TelemetryService,[_e]))}else le.set(f.ITelemetryService,p.NullTelemetryService);le.set(T.IExtensionGalleryService,new a.SyncDescriptor(O.ExtensionGalleryService));const se=this._socketServer.getChannel("download",ye);le.set(x.IDownloadService,new J.DownloadServiceChannelClient(se,()=>this._getUriTransformer("renderer"))),le.set(T.IExtensionManagementService,new a.SyncDescriptor(H.ExtensionManagementService));const oe=new $.InstantiationService(le);le.set(Ee.ILocalizationsService,oe.createInstance(ve.LocalizationsService));const Y=oe.createInstance(Qe.ExtensionManagementCLIService);return le.set(T.IExtensionManagementCLIService,Y),oe.invokeFunction(G=>{const _e=new de.RemoteAgentEnvironmentChannel(this._connectionToken,this._environmentService,Y,this._logService,G.get(f.ITelemetryService),Ae);this._socketServer.registerChannel("remoteextensionsenvironment",_e),this._socketServer.registerChannel(Le.REMOTE_TERMINAL_CHANNEL_NAME,new ze.RemoteTerminalChannel(this._logService,this._environmentService));const Ie=new Pe.RemoteAgentFileSystemChannel(this._logService,this._environmentService);this._socketServer.registerChannel(Te.REMOTE_FILE_SYSTEM_CHANNEL_NAME,Ie),this._socketServer.registerChannel("request",new Me.RequestChannel(G.get(C.IRequestService)));const Be=G.get(T.IExtensionManagementService),Re=new je.ExtensionManagementChannel(Be,qe=>this._getUriTransformer(qe.remoteAuthority));return this._socketServer.registerChannel("extensions",Re),Be.removeDeprecatedExtensions(),this._register(new $e.default(G.get(f.ITelemetryService))),{telemetryService:G.get(f.ITelemetryService)}})}_getUriTransformer(le){return this._uriTransformerCache[le]||(this._uriTransformerCache[le]=l.createRemoteURITransformer(le)),this._uriTransformerCache[le]}async handleRequest(le,ye){if(le.method!=="GET")return Je.serveError(le,ye,405,`Unsupported method ${le.method}`);if(!le.url)return Je.serveError(le,ye,400,"Bad request.");const be=y.parse(le.url,!0),Ae=be.pathname;if(!Ae)return Je.serveError(le,ye,400,"Bad request.");if(Ae==="/version")return ye.writeHead(200,{"Content-Type":"text/plain"}),ye.end(t.default.commit||"");if(Ae==="/delay-shutdown")return this._delayShutdown(),ye.writeHead(200),ye.end("OK");if(Ae==="/vscode-remote-resource"){if(be.query.tkn!==this._connectionToken)return Je.serveError(le,ye,403,"Forbidden.");const se=be.query.path;if(typeof se!="string")return Je.serveError(le,ye,400,"Bad request.");let oe;try{oe=we.URI.from({scheme:r.Schemas.file,path:se}).fsPath}catch(G){return Je.serveError(le,ye,400,"Bad request.")}const Y=Object.create(null);return this._environmentService.isBuilt&&(Se.isEqualOrParent(oe,this._environmentService.builtinExtensionsPath,!u.isLinux)||Se.isEqualOrParent(oe,this._environmentService.extensionsPath,!u.isLinux))&&(Y["Cache-Control"]="public, max-age=31536000"),Je.serveFile(this._logService,le,ye,oe,Y)}if(this._webClientServer){this._webClientServer.handle(le,ye,be);return}return ye.writeHead(404,{"Content-Type":"text/plain"}),ye.end("Not found")}handleUpgrade(le,ye){let be=b.generateUuid(),Ae=!1,se=!1;if(le.url){const Be=y.parse(le.url,!0).query;typeof Be.reconnectionToken=="string"&&(be=Be.reconnectionToken),Be.reconnection==="true"&&(Ae=!0),Be.skipWebSocketFrames==="true"&&(se=!0)}if(le.headers.upgrade!=="websocket"){ye.end("HTTP/1.1 400 Bad Request");return}const oe=le.headers["sec-websocket-key"],Y=S.createHash("sha1");Y.update(oe+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const G=Y.digest("base64"),_e=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${G}`];let Ie=!1;if(!se&&le.headers["sec-websocket-extensions"]){const Be=Array.isArray(le.headers["sec-websocket-extensions"])?le.headers["sec-websocket-extensions"]:[le.headers["sec-websocket-extensions"]];for(const Re of Be)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(Re)){if(/\b(permessage-deflate)\b/.test(Re)){Ie=!0,_e.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(Re)){Ie=!0,_e.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}ye.write(_e.join(`\r
`)+`\r
\r
`),ye.setTimeout(0),se?this._handleWebSocketConnection(new _.NodeSocket(ye),Ae,be):this._handleWebSocketConnection(new _.WebSocketNodeSocket(new _.NodeSocket(ye),Ie,null,!0),Ae,be)}handleServerError(le){this._logService.error("Error occurred in server"),this._logService.error(le)}async _cleanupOlderLogs(le){const ye=ke.basename(le),be=ke.dirname(le),oe=(await I.readdir(be)).filter(G=>/^\d{8}T\d{6}$/.test(G)).sort().filter(G=>G!==ye),Y=oe.slice(0,Math.max(0,oe.length-9));await Promise.all(Y.map(G=>I.rimraf(ke.join(be,G))))}_getRemoteAddress(le){let ye;return le instanceof _.NodeSocket?ye=le.socket:ye=le.socket.socket,ye.remoteAddress||"<unknown>"}async _rejectWebSocketConnection(le,ye,be){const Ae=ye.getSocket();this._logService.error(`${le} ${be}.`);const se={type:"error",reason:be};ye.sendControl(n.VSBuffer.fromString(JSON.stringify(se))),ye.dispose(),await Ae.drain(),Ae.dispose()}_handleWebSocketConnection(le,ye,be){const Ae=this._getRemoteAddress(le),se=`[${Ae}][${be.substr(0,8)}]`,oe=new v.PersistentProtocol(le);let Y;try{const Re=Q.__$__nodeRequire("vsda");Y=new Re.validator}catch(Re){}let G;(function(Re){Re[Re.WaitingForAuth=0]="WaitingForAuth",Re[Re.WaitingForConnectionType=1]="WaitingForConnectionType",Re[Re.Done=2]="Done",Re[Re.Error=3]="Error"})(G||(G={}));let _e=0;const Ie=Re=>{_e=3,Be.dispose(),this._rejectWebSocketConnection(se,oe,Re)},Be=oe.onControlMessage(Re=>{if(_e===0){let qe;try{qe=JSON.parse(Re.toString())}catch(tt){return Ie("Malformed first message")}if(qe.type!=="auth")return Ie("Invalid first message");if(this._connectionTokenIsMandatory&&qe.auth!==this._connectionToken)return Ie("Unauthorized client refused: auth mismatch");let Xe="VS Code Headless is cool";if(Y)try{Xe=Y.createNewMessage(Xe)}catch(tt){}const Ue={type:"sign",data:Xe};oe.sendControl(n.VSBuffer.fromString(JSON.stringify(Ue))),_e=1}else if(_e===1){let qe;try{qe=JSON.parse(Re.toString())}catch(it){return Ie("Malformed second message")}if(qe.type!=="connectionType")return Ie("Invalid second message");if(typeof qe.signedData!="string")return Ie("Invalid second message field type");const Xe=qe.commit,Ue=t.default.commit;if(Xe&&Ue&&Xe!==Ue)return Ie("Client refused: version mismatch");let tt=!1;if(qe.signedData===this._connectionToken)tt=!0;else if(Y)try{tt=Y.validate(qe.signedData)==="ok"}catch(it){}if(!tt){if(this._environmentService.isBuilt)return Ie("Unauthorized client refused");this._logService.error(`${se} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(let it in this._managementConnections)this._managementConnections[it].shortenReconnectionGraceTimeIfNecessary();for(let it in this._extHostConnections)this._extHostConnections[it].shortenReconnectionGraceTimeIfNecessary();_e=2,Be.dispose(),this._handleConnectionType(Ae,se,oe,le,ye,be,qe)}})}async _handleConnectionType(le,ye,be,Ae,se,oe,Y){const G=Y.desiredConnectionType===1?`${ye}[ManagementConnection]`:Y.desiredConnectionType===2?`${ye}[ExtensionHostConnection]`:ye;if(Y.desiredConnectionType===1)if(se){if(!this._managementConnections[oe])return this._rejectWebSocketConnection(G,be,"Unknown reconnection token");be.sendControl(n.VSBuffer.fromString(JSON.stringify({type:"ok"})));const _e=be.readEntireBuffer();be.dispose(),this._managementConnections[oe].acceptReconnection(le,Ae,_e)}else{if(this._managementConnections[oe])return this._rejectWebSocketConnection(G,be,"Duplicate reconnection token");be.sendControl(n.VSBuffer.fromString(JSON.stringify({type:"ok"})));const _e=new m.ManagementConnection(this._logService,oe,le,be);this._socketServer.acceptConnection(_e.protocol,_e.onClose),this._managementConnections[oe]=_e,_e.onClose(()=>{delete this._managementConnections[oe]})}else if(Y.desiredConnectionType===2){const _e=Y.args||{language:"en"},Ie=await this._updateWithFreeDebugPort(_e);if(Ie.port&&this._logService.trace(`${G} - startParams debug port ${Ie.port}`),this._logService.trace(`${G} - startParams language: ${Ie.language}`),this._logService.trace(`${G} - startParams env: ${JSON.stringify(Ie.env)}`),se){if(!this._extHostConnections[oe])return this._rejectWebSocketConnection(G,be,"Unknown reconnection token");be.sendControl(n.VSBuffer.fromString(JSON.stringify(Ie.port?{debugPort:Ie.port}:{})));const Be=be.readEntireBuffer();be.dispose(),this._extHostConnections[oe].acceptReconnection(le,Ae,Be)}else{if(this._extHostConnections[oe])return this._rejectWebSocketConnection(G,be,"Duplicate reconnection token");be.sendControl(n.VSBuffer.fromString(JSON.stringify(Ie.port?{debugPort:Ie.port}:{})));const Be=be.readEntireBuffer();be.dispose();const Re=new w.ExtensionHostConnection(this._environmentService,this._logService,oe,le,Ae,Be);this._extHostConnections[oe]=Re,Re.onClose(()=>{delete this._extHostConnections[oe],this._onDidCloseExtHostConnection()}),Re.start(Ie)}}else if(Y.desiredConnectionType===3){const _e=Y.args;this._createTunnel(be,_e)}else return this._rejectWebSocketConnection(G,be,"Unknown initial data received")}async _createTunnel(le,ye){const be=le.getSocket().socket,Ae=le.readEntireBuffer();le.dispose(),be.pause();const se=await this._connectTunnelSocket(ye.port);Ae.byteLength>0&&se.write(Ae.buffer),se.on("end",()=>be.end()),se.on("close",()=>be.end()),se.on("error",()=>be.destroy()),be.on("end",()=>se.end()),be.on("close",()=>se.end()),be.on("error",()=>se.destroy()),se.pipe(be),be.pipe(se)}_connectTunnelSocket(le){return new Promise((ye,be)=>{const Ae=P.createConnection({port:le},()=>{Ae.removeListener("error",be),Ae.pause(),ye(Ae)});Ae.once("error",be)})}_updateWithFreeDebugPort(le){return typeof le.port=="number"?E.findFreePort(le.port,10,5e3).then(ye=>(le.port=ye,le)):(le.debugId=void 0,le.port=void 0,le.break=void 0,Promise.resolve(le))}async _onDidCloseExtHostConnection(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown()))}_waitThenShutdown(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._environmentService.args["remote-auto-shutdown-without-delay"]?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},ge))}_shutdown(){if(!!Object.keys(this._extHostConnections).length){console.log("New EH opened, aborting shutdown"),this._logService.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),this.shutdownTimer=void 0)}}e.RemoteExtensionHostAgentServer=K;function te(De){if(De["connection-secret"]){De.connectionToken&&(console.warn("Please do not use the argument connectionToken at the same time as connection-secret."),process.exit(1));let le=d.readFileSync(De["connection-secret"]).toString();return le=le.replace(/\r?\n$/,""),/^[0-9A-Za-z\-]+$/.test(le)||(console.warn(`The secret defined in ${De["connection-secret"]} does not adhere to the characters 0-9, a-z, A-Z or -.`),process.exit(1)),{connectionToken:le,connectionTokenIsMandatory:!0}}else return{connectionToken:De.connectionToken||b.generateUuid(),connectionTokenIsMandatory:!1}}async function ie(De,le,ye){const be=new Ce.ServerEnvironmentService(le);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const Xe=ke.join(process.env.HOMEDRIVE,"node_modules"),Ue=ke.dirname(ke.join(process.env.HOMEDRIVE,process.env.HOMEPATH)),tt=ke.join(Ue,"node_modules");if(d.existsSync(Xe)||d.existsSync(tt)){const it=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${Xe}
* ${tt}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;ue(be).warn(it),console.warn(it),process.exit(0)}}const{connectionToken:Ae,connectionTokenIsMandatory:se}=te(le),oe=d.existsSync(r.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html",Q).fsPath);oe&&De&&typeof De!="string"&&console.log(`Web UI available at http://localhost${De.port===80?"":`:${De.port}`}/?tkn=${Ae}`);const Y=new K(be,Ae,se,oe,ye),G=await Y.initialize(),{telemetryService:_e}=G;L.mark("code/server/ready");const Ie=h.performance.now(),Be=global.vscodeServerStartTime,Re=global.vscodeServerListenTime,qe=global.vscodeServerCodeLoadedTime;if(_e.publicLog2("serverStart",{startTime:Be,startedTime:Re,codeLoadedTime:qe,readyTime:Ie}),le["print-startup-performance"]){const Xe=He.LoaderStats.get();let Ue="";Ue+=`

### Load AMD-module
`,Ue+=He.LoaderStats.toMarkdownTable(["Module","Duration"],Xe.amdLoad),Ue+=`

### Load commonjs-module
`,Ue+=He.LoaderStats.toMarkdownTable(["Module","Duration"],Xe.nodeRequire),Ue+=`

### Invoke AMD-module factory
`,Ue+=He.LoaderStats.toMarkdownTable(["Module","Duration"],Xe.amdInvoke),Ue+=`

### Invoke commonjs-module
`,Ue+=He.LoaderStats.toMarkdownTable(["Module","Duration"],Xe.nodeEval),Ue+=`Start-up time: ${Re-Be}
`,Ue+=`Code loading time: ${qe-Be}
`,Ue+=`Initialized time: ${Ie-Be}
`,Ue+=`
`,console.log(Ue)}return Y}e.createServer=ie;const ue=function(){let De;return function(ye){return De||(De=new c.LogService(new re.SpdLogLogger(Ve.RemoteExtensionLogFileName,ke.join(ye.logsPath,`${Ve.RemoteExtensionLogFileName}.log`),!0,c.getLogLevel(ye)))),De}}()}),define(fe[241],he([0,1,22,15,8,228,231,56,2,232,65,46]),function(Q,e,S,d,P,y,k,L,h,n,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,b.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=n.performance.now();const I={onMultipleValues:(i,o)=>{console.error(`Option ${i} can only be defined once. Using value ${o}.`)},onUnknownOption:i=>{console.error(`Ignoring option ${i}: not supported for server.`)}},E=L.parseArgs(process.argv.slice(2),D.serverOptions,I),u=process.env.VSCODE_AGENT_FOLDER||h.join(S.homedir(),".vscode-remote"),v=h.join(u,"data"),_=h.join(v,"User"),w=h.join(_,"globalStorage"),m=h.join(v,"Machine");E["user-data-dir"]=v;const l=h.dirname(P.FileAccess.asFileUri("",Q).fsPath),c=h.join(l,"extensions");E["builtin-extensions-dir"]=c,E["extensions-dir"]=E["extensions-dir"]||h.join(u,"extensions"),[u,E["extensions-dir"],v,_,m,w].forEach(i=>{try{d.existsSync(i)||d.mkdirSync(i)}catch(o){console.error(o)}});function r(){y.run(E,u)}e.spawnCli=r;function t(i){return k.createServer(i,E,u)}e.createServer=t})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f30a9b73e8ffc278e71575118b6bf568f04587c8/core/vs/server/remoteExtensionHostAgent.js.map
